/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: adctest.c 2416 2012-09-07 08:06:20Z ertl-hiro $
 */

/* 
 *  ADCƥȤ
 *  ľ³Ȥʤޤ
 *  )SCAN⡼ɤξ硢CH0CH4μߵ
 *  Ѳ뤿ᡢ22'ϥǡǤޤ
 *  DMAѤȥϥ󥰥åפ礬ޤ
 *   _________________________              ____________________ 
 *  |          |ADC0          |            |  ŎێގގÎ |
 *  |          |              |            |                    |
 *  |          |     CH0(PA0) |____________| 2                  |
 *  |          |              |            |                    |
 *  |          |              |            |                    |
 *  |          |     CH4(PA4) |____________| 2'                 |
 *  |          |              |            |                    |
 *  |          |              |            |                    |
 *  |          |           GND|____________| 1,1'               |
 *  |          |              |            |                    |
 *  |                     3.3V|____________| 3,3'               |
 *  |_LONGAN NANO ____________|            |____________________|
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <string.h>
#include <sil.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include <target_syssvc.h>
#include "device.h"
#include "adctest.h"

/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))


#define NUM_ADCBUF   96		/* 1ms */
volatile uint32_t uhADCxConvertedValue[NUM_ADCBUF];

/*
 *  ADCѴλХå
 */
static void HAL_ADC_ConvCpltCallback2(ADC_Handle_t* hadc)
{
#ifndef USE_ADCDMA
	if (hadc->NumCurrentConversionRank != 0){
		hadc->NumCurrentConversionRank--;
	}
	uhADCxConvertedValue[hadc->NumCurrentConversionRank] = adc_getvalue(hadc);
	if(hadc->NumCurrentConversionRank == 0){
		adc_end_int(hadc);
		isig_sem(ADCDMA_SEM);
	}
#else
	hadc->status = ADC_STATUS_EOC;
	isig_sem(ADCDMA_SEM);
#endif
}

/*
 *  ᥤ󥿥
 */
void main_task(intptr_t exinf)
{
	ADC_Init_t     aInit;
	ADC_ChannelConf_t sConfig;
	ADC_Handle_t *hadc;
	ER_UINT	ercd;
	SYSTIM tim1, tim2;
	int i;

	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

	/*
	 *  ꥢݡȤν
	 *
	 *  ƥƱꥢݡȤȤʤɡꥢ
	 *  ݡȤץѤߤξˤϤE_OBJ顼ˤʤ뤬پ
	 *  ʤ
	 */
	ercd = serial_opn_por(TASK_PORTID);
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `serial_opn_por'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(serial_ctl_por(TASK_PORTID,
							(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	/*
	 *  ADC
	 */
	aInit.ClockPrescaler = ADC_CLOCK_SYNC_PCLK_DIV8;
	aInit.Resolution   = ADC_RESOLUTION_12B;
	aInit.ContinuousConvMode = ADC_CONTINUOUS_ENABLE;
#ifdef ADCx2_CHANNEL
	aInit.ScanConvMode = ADC_SCANMODE_ENABLE;
	aInit.NumConversion = 2;
#else
	aInit.ScanConvMode = ADC_SCANMODE_DISABLE;
	aInit.NumConversion = 1;
#ifndef USE_ADCDMA
	aInit.ContinuousConvMode = ADC_CONTINUOUS_DISABLE;
#endif
#endif
	aInit.ScanConvMode = ADC_SCANMODE_ENABLE;
	aInit.DiscontinuousConvMode = ADC_DISCONTINUOUS_DISABLE;
	aInit.NumDiscConversion = 0;
	aInit.ExternalTrigConvEdge = ADC_EXTERNALTRIGCONVEDGE_NONE;
	aInit.ExternalTrigConv = ADC_EXTERNALTRIGCONV_REG_T0_CH0;
	aInit.DataAlign = ADC_DATAALIGN_RIGHT;

	if((hadc = adc_init(ADC1_PORTID, &aInit)) == NULL){
		/* Initialization Error */
		syslog_0(LOG_NOTICE, "## adc_init ERROR ##");
	}
	hadc->xfercallback = HAL_ADC_ConvCpltCallback2;

	/*
	 *  ͥ0
	 */
	sConfig.Channel = ADCx_CHANNEL;
	sConfig.Rank = 1;
	sConfig.GpioBase = ADCx_CHANNEL_GPIO_PORT;
	sConfig.GpioPin  = ADCx_CHANNEL_PINNO;
//  sConfig.SamplingTime = ADC_SAMPLETIME_3CYCLES;
	sConfig.SamplingTime = ADC_SAMPLETIME_480CYCLES;
	if(adc_setupchannel(hadc, &sConfig) != E_OK){
		/* Channel Configuration Error */
		syslog_0(LOG_NOTICE, "## adc_setupchannel ERROR ##");
	}
#ifdef ADCx2_CHANNEL
	/*
	 *  ͥ1
	 */
	sConfig.Channel = ADCx2_CHANNEL;
	sConfig.Rank = 2;
	sConfig.GpioBase = ADCx2_CHANNEL_GPIO_PORT;
	sConfig.GpioPin  = ADCx2_CHANNEL_PINNO;
	if(adc_setupchannel(hadc, &sConfig) != E_OK){
		/* Channel Configuration Error */
		syslog_0(LOG_NOTICE, "## adc_setupchannel ERROR ##");
	}
#endif

	for(i = 0 ; i < 1000 ; i++){
		memset((void*)uhADCxConvertedValue, 0, NUM_ADCBUF*4);
		get_tim(&tim1);
#ifdef USE_ADCDMA
		if((ercd = adc_start_dma(hadc, (uint32_t*)&uhADCxConvertedValue[0], NUM_ADCBUF)) != E_OK){
#else
		if((ercd = adc_start_int(hadc)) != E_OK){
#endif
			/* Start Conversation Error */
			syslog_1(LOG_ERROR, "adc_start ERROR(%d)", ercd);
			slp_tsk();
		}
		while((hadc->status & ADC_STATUS_SMASK) == ADC_STATUS_BUSY){
			twai_sem(ADCDMA_SEM, 10);
		}
		get_tim(&tim2);
#ifdef USE_ADCDMA
		adc_end_dma(hadc);
#else
		adc_end_int(hadc);
#endif
		syslog_5(LOG_NOTICE, "## valuet(%d) (%d)(%d)(%d)(%d) ##", tim2-tim1, uhADCxConvertedValue[0], uhADCxConvertedValue[1], uhADCxConvertedValue[2], uhADCxConvertedValue[3]);
		dly_tsk(200);

	}
	syslog_2(LOG_NOTICE, "## STOP[%08x] (%d) ##", &uhADCxConvertedValue, hadc->status);
	slp_tsk();
//	SVC_PERROR(ext_ker());
}
