/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: qspitest.c 2416 2012-09-07 08:06:20Z ertl-hiro $
 */

/* 
 *  եɽƥȥץ
 *  QSPIޥɤǡshinonome_font.binQSPI-FLASH0Ϥ˽ߤޤ
 *QSPIޥɤϡhelp qspiǻѤǤ륳ޥɤɽޤ
 *  
 *  ¹ԤȡLCD˴ñʴɽޤ
 *
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <target_syssvc.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include <stdlib.h>
#include "device.h"
#include "storagedevice.h"
#include "flash_file.h"
#include "glcd_disp.h"
#include "mscdiskio.h"
#include "sample1.h"

/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))

#define FMC_BANK2_BASE  ((uint32_t)(0x60000000 | 0x04000000))
#define QFILE_HEAD_SIZE 32
#define BUFFERSIZE      512

/*
 * MX25L512 Registers  
 */ 
/* Status Register */
#define MX25L512_SR_WIP                      ((uint8_t)0x01)    /* Write in progress */
#define MX25L512_SR_WREN                     ((uint8_t)0x02)    /* Write enable latch */
#define MX25L512_SR_BLOCKPR                  ((uint8_t)0x5C)    /* Block protected against program and erase operations */
#define MX25L512_SR_PRBOTTOM                 ((uint8_t)0x20)    /* Protected memory area defined by BLOCKPR starts from top or bottom */
#define MX25L512_SR_QUADEN                   ((uint8_t)0x40)    /* Quad IO mode enabled if =1 */
#define MX25L512_SR_SRWREN                   ((uint8_t)0x80)    /* Status register write enable/disable */

/* Configuration Register */
#define MX25L512_CR_ODS                      ((uint8_t)0x07)    /* Output driver strength */
#define MX25L512_CR_ODS_30                   ((uint8_t)0x07)    /* Output driver strength 30 ohms (default)*/
#define MX25L512_CR_ODS_15                   ((uint8_t)0x06)    /* Output driver strength 15 ohms */
#define MX25L512_CR_ODS_20                   ((uint8_t)0x05)    /* Output driver strength 20 ohms */
#define MX25L512_CR_ODS_45                   ((uint8_t)0x03)    /* Output driver strength 45 ohms */
#define MX25L512_CR_ODS_60                   ((uint8_t)0x02)    /* Output driver strength 60 ohms */
#define MX25L512_CR_ODS_90                   ((uint8_t)0x01)    /* Output driver strength 90 ohms */
#define MX25L512_CR_TB                       ((uint8_t)0x08)    /* Top/Bottom bit used to configure the block protect area */
#define MX25L512_CR_PBE                      ((uint8_t)0x10)    /* Preamble Bit Enable */
#define MX25L512_CR_4BYTE                    ((uint8_t)0x20)    /* 3-bytes or 4-bytes addressing */
#define MX25L512_CR_NB_DUMMY                 ((uint8_t)0xC0)    /* Number of dummy clock cycles */

#define MX25L512_DUMMY_CYCLES_READ_QUAD      3

static ER qspi_init_MX25L51245G(void *hqspi);
static ER QSPI_WriteEnable(void *h, uint32_t Timeout);
static ER QSPI_AutoPollingMemReady(void *h, uint32_t Timeout);

const QSPI_Init_t qspi_config_MX25L51245G = {
	QSPI_STIG_RDID_JEDECID_MACRONIX,
	0,
	1,									/* ClockPrescaler */
	16,									/* FifoThreshold */
	QSPI_SAMPLE_SHIFTING_HALFCYCLE,		/* SampleShifting */
	QSPI_CS_HIGH_TIME_1_CYCLE,			/* ChipSelectHighTime */
	QSPI_CLOCK_MODE_0,					/* ClockMode */
	QSPI_FLASH_ID_1,					/* FlashID */
	QSPI_DUALFLASH_DISABLE,				/* DualFlash */
	QSPI_DDR_MODE_DISABLE,				/* ddrmode */
	QSPI_DDR_HHC_ANALOG_DELAY,			/* ddrholdhalfcycle */
	QSPI_SIOO_INST_EVERY_CMD,			/* sioomode */
	QSPI_ADDRESS_32_BITS,				/* addr_size */
	QSPI_INSTRUCTION_4_LINES,			/* inst_type */
	QSPI_DATA_4_LINES,					/* inst_data_xfer_type */
	QSPI_STIG_OPCODE_4QUAD_READ,		/* read_op_code */
	QSPI_ADDRESS_4_LINES,				/* read_addr_xfer_type */
	QSPI_DATA_4_LINES,					/* read_data_xfer_type */
	10,									/* read_dummy_cycles */
	QSPI_STIG_OPCODE_4BYTE_WRITE,		/* write_op_code */
	QSPI_ADDRESS_4_LINES,				/* write_addr_xfer_type */
	QSPI_DATA_4_LINES,					/* write_data_xfer_type */
	0,									/* write_dummy_cycles */
	1,									/* erase_count */
	{(4*1024)},
	{QSPI_STIG_OPCODE_4BYTE_SEC_ERASE},
	QSPI_ADDRESS_4_LINES,				/* erase_addr_xfer_type */
	0,									/* erase_sector_idx */
	(1<<23),
	qspi_init_MX25L51245G,
	QSPI_WriteEnable,
	QSPI_AutoPollingMemReady,
	"MX25L51245G"
};

static const uint8_t string1[] = {
	0xE3,0x83,0x8F,0xE3,0x83,0xAD,0xE3,0x83,0xBC,0xE4,0xB8,0x96, 0xE7,0x95,0x8C,' ', '!', 0
};

static uint32_t heap_area[16*1024];

uint32_t heap_param[2] = {
	(uint32_t)heap_area,
	(16*4*1024)
};

LCD_Handler_t        LcdHandle;
LCD_DrawProp_t       DrawProp;

uint8_t device_state[256];

#if 1	/* ROI DEBUG */
void sw_handle(int arg)
{
	syslog_1(LOG_NOTICE, "## sw int(%d) ##", arg);
}
#endif	/* ROI DEBUG */

/*
 *  READ DUMMY CYCLE
 */
static ER
QSPI_DummyCyclesCfg(QSPI_Handle_t *hqspi)
{
	QSPI_Command_t  sCommand;
	uint8_t reg[4], reg2[4];
	ER ercd = E_OK;

	/*
	 *  READ STATUS REGISTER
	 */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_4_LINES;
	sCommand.Instruction       = QSPI_STIG_OPCODE_RD_STAT_REG;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_4_LINES;
	sCommand.DummyCycles       = 0;
	sCommand.NbData            = 1;
	if((ercd = qspi_command(hqspi, &sCommand, hqspi->timeout)) != E_OK)
		return ercd;
	if((ercd = qspi_receive(hqspi, (uint32_t *)&(reg[0]), hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  READ CONFIGURATION REGISTER
	 */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_4_LINES;
	sCommand.Instruction       = QSPI_STIG_OPCODE_READ_CFG_REG;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_4_LINES;
	sCommand.DummyCycles       = 0;
	sCommand.NbData            = 1;
	if((ercd = qspi_command(hqspi, &sCommand, hqspi->timeout)) != E_OK)
		return ercd;
	if((ercd = qspi_receive(hqspi, (uint32_t *)&reg2[0], hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  ENABLE WRITE
	 */
	if((ercd = QSPI_WriteEnable(hqspi, hqspi->timeout)) != E_OK)
		return ercd;


	/*
	 *  ߡ
	 */
	reg2[0] &= ~MX25L512_CR_NB_DUMMY;
	reg2[0] |= (MX25L512_DUMMY_CYCLES_READ_QUAD << 6);
	reg[1] = reg2[0];

	/*
	 *  UPDATE CONFIGURATION REGISTER ߡ
	 */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_4_LINES;
	sCommand.Instruction       = QSPI_STIG_OPCODE_WR_STAT_REG;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_4_LINES;
	sCommand.DummyCycles       = 0;
	sCommand.NbData            = 2;
	if((ercd = qspi_command(hqspi, &sCommand, hqspi->timeout)) != E_OK)
		return ercd;
	ercd = qspi_transmit(hqspi, (uint32_t *)&reg[0], hqspi->timeout);

	/*
	 *  STATUS/CONFIGURATIONѤ40msԤ
	 */
	dly_tsk( 40 );

	return ercd;
}

/*
 * This function put QSPI memory in QPI mode (quad I/O).
 */
static ER
QSPI_EnterMemory_QPI(QSPI_Handle_t *hqspi)
{
	QSPI_Command_t     sCommand;
	QSPI_AutoPolling_t sConfig;
	ER ercd = E_OK;

	/*
	 * QSPI⡼
	 */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_1_LINE;
	sCommand.Instruction       = QSPI_STIG_OPCODE_ENTER_QUAD_CMD;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_NONE;
	sCommand.DummyCycles       = 0;
	if((ercd = qspi_command(hqspi, &sCommand, hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  QUADEN bit=1 and WIP bit=0Ԥ
	 */
	sConfig.Match           = MX25L512_SR_QUADEN;
	sConfig.Mask            = MX25L512_SR_QUADEN|MX25L512_SR_WIP;
	sConfig.MatchMode       = QSPI_MATCH_MODE_AND;
	sConfig.StatusBytesSize = 1;
	sConfig.Interval        = 0x10;
	sConfig.AutomaticStop   = QSPI_AUTOMATIC_STOP_ENABLE;

	sCommand.InstructionMode   = QSPI_INSTRUCTION_4_LINES;
	sCommand.Instruction       = QSPI_STIG_OPCODE_RD_STAT_REG;
	sCommand.DataMode          = QSPI_DATA_4_LINES;
	return qspi_autopolling(hqspi, &sCommand, &sConfig, hqspi->timeout);
}

/*
 *  QSPI 4Хȥɥ쥹
 */
static ER
QSPI_EnterFourBytesAddress(QSPI_Handle_t *hqspi)
{
	QSPI_Command_t sCommand;
	ER ercd = E_OK;

	/* Enable write operations */
	if((ercd = QSPI_WriteEnable(hqspi, hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  4Хȥ⡼
	 */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_4_LINES;
	sCommand.Instruction       = QSPI_STIG_OPCODE_ENTER_4BYTE_MODE;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_NONE;
	sCommand.DummyCycles       = 0;
	if((ercd = qspi_command(hqspi, &sCommand, hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  꽪λԤ
	 */
	return QSPI_AutoPollingMemReady(hqspi, hqspi->timeout);
}

/*
 *  This function configure the Output driver strength on memory side.
 */
static ER
QSPI_OutDrvStrengthCfg( QSPI_Handle_t *hqspi)
{
	QSPI_Command_t  sCommand;
	uint8_t reg[4], reg2[4];
	ER ercd = E_OK;

	/*
	 *  STATUS REGISTERɹ
	 */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_4_LINES;
	sCommand.Instruction       = QSPI_STIG_OPCODE_RD_STAT_REG;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_4_LINES;
	sCommand.DummyCycles       = 0;
	sCommand.NbData            = 1;
	if((ercd = qspi_command(hqspi, &sCommand, hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  STATUS REGISTER
	 */
	if((ercd = qspi_receive(hqspi, (uint32_t *)&reg[0], hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  CONFIGURATION REGISTERɹ
	 */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_4_LINES;
	sCommand.Instruction       = QSPI_STIG_OPCODE_READ_CFG_REG;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_4_LINES;
	sCommand.DummyCycles       = 0;
	sCommand.NbData            = 1;
	if((ercd = qspi_command(hqspi, &sCommand, hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  CONFIGURATION REGISTER
	 */
	if((ercd = qspi_receive(hqspi, (uint32_t *)&reg2[0], hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  ENABLE WRITE
	 */
	if((ercd = QSPI_WriteEnable(hqspi, hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  Set Output Strength of the QSPI memory 15 ohms
	 */
	reg2[0] &= ~MX25L512_CR_ODS;
	reg2[0] |= MX25L512_CR_ODS_15;
	reg[1] = reg2[0];

	/*
	 *  UPDATE CONFIGURATION REGISTER
	 */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_4_LINES;
	sCommand.Instruction       = QSPI_STIG_OPCODE_WR_STAT_REG;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_4_LINES;
	sCommand.DummyCycles       = 0;
	sCommand.NbData            = 2;
	if((ercd = qspi_command(hqspi, &sCommand, hqspi->timeout)) != E_OK)
		return ercd;

	/*
	 *  쥸
	 */
	return qspi_transmit(hqspi, (uint32_t *)&reg[0], hqspi->timeout);
}

/*
 *  MX25L51245Gؿ
 */
static ER
qspi_init_MX25L51245G(void *h)
{
	QSPI_Handle_t  *hqspi = h;
	ER ercd;

	/*
	 *  Put QSPI memory in QPI mode
	 */
	if((ercd =  QSPI_EnterMemory_QPI(hqspi)) !=E_OK )
		return ercd;

	/*
	 *  Set the QSPI memory in 4-bytes address mode
	 */
	if((ercd = QSPI_EnterFourBytesAddress(hqspi)) != E_OK)
		return ercd;

	/*
	 *  Configuration of the dummy cycles on QSPI memory side
	 */
	if((ercd = QSPI_DummyCyclesCfg(hqspi)) != E_OK)
		return ercd;

	/*
	 *  Configuration of the Output driver strength on memory side
	 */
	return QSPI_OutDrvStrengthCfg(hqspi);
}

/*
 *  QSPI WRITE ENABLEؿ
 */
static ER
QSPI_WriteEnable(void *h, uint32_t Timeout)
{
	QSPI_Handle_t      *hqspi = h;
	QSPI_Command_t     sCommand;
	QSPI_AutoPolling_t sConfig;
	ER ercd = E_OK;

	/*
	 *  ENABLE WRITE
	 */
	sCommand.InstructionMode   = hqspi->Init.inst_type;
	sCommand.Instruction       = QSPI_STIG_OPCODE_WREN;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = QSPI_DATA_NONE;
	sCommand.DummyCycles       = 0;
	if((ercd = qspi_command(hqspi, &sCommand, Timeout)) != E_OK)
		return ercd;

	/*
	 *  WRITE ENABLE STATUSԤ
	 */
	sConfig.Match           = 0x02;
	sConfig.Mask            = 0x02;
	sConfig.MatchMode       = QSPI_MATCH_MODE_AND;
	sConfig.StatusBytesSize = 1;
	sConfig.Interval        = 0x10;
	sConfig.AutomaticStop   = QSPI_AUTOMATIC_STOP_ENABLE;

	sCommand.Instruction    = QSPI_STIG_OPCODE_RD_STAT_REG;
	sCommand.DataMode       = hqspi->Init.inst_data_xfer_type;
	return qspi_autopolling(hqspi, &sCommand, &sConfig, Timeout);
}

/*
 *  Ԥؿ
 */
static ER
QSPI_AutoPollingMemReady(void *h, uint32_t Timeout)
{
	QSPI_Handle_t *hqspi = h;
	QSPI_Command_t     sCommand;
	QSPI_AutoPolling_t sConfig;

	/*
	 *  WRITE IN PROGRESSλԤ
	 */
	sCommand.InstructionMode   = hqspi->Init.inst_type;
	sCommand.Instruction       = QSPI_STIG_OPCODE_RD_STAT_REG;
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;
	sCommand.DataMode          = hqspi->Init.inst_data_xfer_type;
	sCommand.DummyCycles       = 0;

	sConfig.Match           = 0x00;
	sConfig.Mask            = 0x01;
	sConfig.MatchMode       = QSPI_MATCH_MODE_AND;
	sConfig.StatusBytesSize = 1;
	sConfig.Interval        = 0x10;
	sConfig.AutomaticStop   = QSPI_AUTOMATIC_STOP_ENABLE;

	return qspi_autopolling(hqspi, &sCommand, &sConfig, Timeout);
}

/*
 *  μФ
 */
static uint32_t get_fat_time(void)
{
	int    reqtime = 0;
	struct tm2 timedate;

	rtc_get_time(&timedate);
	reqtime  = ((timedate.tm_year-10)<<25)+(timedate.tm_mon<<21)+(timedate.tm_mday<<16);
	reqtime += (timedate.tm_hour<<11)+(timedate.tm_min<<5)+(timedate.tm_sec/2);
	return reqtime;
}

/*
 *  USB HOST USER CALLBACKؿ
 */
static void USBH_UserProcess(USBH_HandleTypeDef *phost, TUSBH_Device_t *pdevice, uint8_t id)
{
	device_state[pdevice->type] = id;
	if(pdevice->pClass != NULL){
		syslog_3(LOG_NOTICE, "## CLASS[%s](%d)(%d) ##", pdevice->pClass->Name, pdevice->type, id);
	}
}


/*
 *  ᥤ󥿥
 */
void main_task(intptr_t exinf)
{
	StorageDevice_t *psdev;
	USB_OTG_Init_t USB_Data_Init;
	USB_OTG_Handle_t *husb;
	QSPI_Handle_t *hqspi;
	USBH_HandleTypeDef *husbh;
	ER_UINT	ercd;
	const QSPI_Init_t *pini = &qspi_config_MX25L51245G;
	uint32_t fsize, i, headlen, addr = 0;
	int32_t  esize = (2*1024)*1024;
	uint8_t  *p;

	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

	/*
	 *  ꥢݡȤν
	 *
	 *  ƥƱꥢݡȤȤʤɡꥢ
	 *  ݡȤץѤߤξˤϤE_OBJ顼ˤʤ뤬پ
	 *  ʤ
	 */
	ercd = serial_opn_por(TASK_PORTID);
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `serial_opn_por'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(serial_ctl_por(TASK_PORTID,
							(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	hqspi = qspi_init(QSPI1_PORTID, (QSPI_Init_t *)pini);
	syslog_1(LOG_NOTICE, "## QSPI SIZE[%08x] ##", pini->device_size);
	if(hqspi == NULL){
		syslog_0(LOG_ERROR, "## QSPI INIT ERROR ##");
		slp_tsk();
	}
	hqspi->semid = QSPI1_SEM;
	flash_file_init(hqspi);
	qspi_info_init((intptr_t)hqspi);

	/*
	 *  QSPI-FLASHΥե륤᡼μ
	 */
	p = malloc(QFILE_HEAD_SIZE);
	while(esize > 4){
		ercd = qspi_read(hqspi, (void *)p, addr, QFILE_HEAD_SIZE);
		fsize = (p[0] << 24) | (p[1] << 16) | (p[2] << 8) | p[3];
		if(ercd != E_OK || (fsize & 3) != 0 || fsize < 16 || fsize > esize)
			break;
		for(i = 0 ; i < 28 ; i++){
			if(p[i+4] == 0)
				break;
		}
		if(i >= 28)
			break;
		if(i < 12)
			headlen = 16;
		else
			headlen = 32;
		if(create_flash_file((const char *)(p+4), addr+headlen, fsize-headlen) < 0)
			break;
		addr += fsize;
		esize -= fsize;
	}
	free((void *)p);

	/* Configure LCD */
	LcdHandle.fmc_base    = FMC_BANK2_BASE;
	LcdHandle.rst_clk     = RCC_AHB1ENR_GPIOHEN;	/* RESET CLOCK BIT */
	LcdHandle.te_clk      = RCC_AHB1ENR_GPIOCEN;	/* LCD TE CLOCK BIT */
	LcdHandle.bl_clk      = RCC_AHB1ENR_GPIOHEN;	/* LCD BL CTRL CLOCK BIT */
	LcdHandle.rst_base    = TADR_GPIOH_BASE;		/* RESET PORT */
	LcdHandle.te_base     = TADR_GPIOC_BASE;		/* LCD TE PORT */
	LcdHandle.bl_base     = TADR_GPIOH_BASE;		/* LCD BL CTRL PORT */
	LcdHandle.gpio_speed  = GPIO_SPEED_FAST;		/* GPIO SPEED */
	LcdHandle.rst_pull    = GPIO_NOPULL;			/* RESET PULL TYPE */
	LcdHandle.bl_pull     = GPIO_PULLUP;			/* LCD BL CTRL PULL TYPE */
	LcdHandle.rst_pin     = 7;						/* RESET PIN */
	LcdHandle.te_pin      = 8;						/* LCD TE PIN */
	LcdHandle.bl_pin      = 11;						/* LCD BL CTRL PIN */
	LcdHandle.bl_active   = 1;

	BSP_LCD_Init();
	DrawProp.hlcd      = &LcdHandle;
	DrawProp.pFont     = &Shinonome_Font12;

	BSP_LCD_LayerDefaultInit(0, 0);

	/* Clear the Background Layer */
	BSP_LCD_Clear(LCD_COLOR_WHITE);

	/* Set the Text Color */
	BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
	BSP_LCD_FillRect(0, 0, BSP_LCD_GetXSize(), 68);
	BSP_LCD_SetTextColor(LCD_COLOR_WHITE);
	BSP_LCD_SetBackColor(LCD_COLOR_BLUE);
	BSP_LCD_SetFont(&Shinonome_Font12);
	BSP_LCD_DisplayStringAt(0, 0, (uint8_t *)"KANJI EXAMPLE", CENTER_MODE);

	BSP_LCD_SetFont(&Embedded_Font9);
	BSP_LCD_DisplayStringAt(0, 20, (uint8_t *)"Display Shinonome Kanji          ", CENTER_MODE);
	BSP_LCD_DisplayStringAt(0, 32, (uint8_t *)"Use touch screen +/- to change Volume    ", CENTER_MODE);
	BSP_LCD_DisplayStringAt(0, 44, (uint8_t *)"Use touch screen +/- to change Frequency ", CENTER_MODE);
	BSP_LCD_DisplayStringAt(0, 56, (uint8_t *)"Touch upper part of the screen to Pause/Resume    ", CENTER_MODE);

	/* Set the LCD Text Color */
	BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
	BSP_LCD_DrawRect(10, 75, BSP_LCD_GetXSize() - 20, BSP_LCD_GetYSize() - 80);
	BSP_LCD_DrawRect(11, 76, BSP_LCD_GetXSize() - 22, BSP_LCD_GetYSize() - 82);

	BSP_LCD_SetBackColor(LCD_COLOR_WHITE);
	DrawProp.pFont = &Shinonome_Font16;
	lcd_DisplayStringAt(&DrawProp, 0, 90, (uint8_t *)string1, CENTER_MODE);
	DrawProp.pFont = &Shinonome_Font12;
	lcd_DisplayStringAt(&DrawProp, 0, 110, (uint8_t *)string1, CENTER_MODE);

	/*
	 *  USB OTG
	 */
    USB_Data_Init.usb_otg_mode = USB_OTG_MODE;
	USB_Data_Init.host_channels = 11;	/* HOST */
	USB_Data_Init.dev_endpoints = 4;		/* DEV */
	USB_Data_Init.use_dedicated_ep1 = 0;	/* DEV */
#if USB_PORTID == USB1_PORTID
	USB_Data_Init.dma_enable = 0;
	USB_Data_Init.phy_itface = USB_PHY_EMBEDDED; 
#else	/* USE_USBFS */
	USB_Data_Init.dma_enable = 1;
	USB_Data_Init.phy_itface = USB_PHY_ULPI; 
	USB_Data_Init.speed = USB_SPEED_HIGH;
#endif	/* USE_USBFS */
	USB_Data_Init.low_power_enable = 0;
	USB_Data_Init.sof_enable = 0;
	USB_Data_Init.speed = USB_SPEED_FULL;
#if USB_OTG_MODE != USB_OTG_MODE_HOST
	USB_Data_Init.vbus_sensing_enable = 1;	/* HOST/DEV */
#else
	USB_Data_Init.vbus_sensing_enable = 0;	/* HOST */
#endif
	USB_Data_Init.lpm_enable = 0;
	USB_Data_Init.use_external_vbus = 0;
	husb = usbo_init(USB_PORTID, &USB_Data_Init);
#if 1	/* ROI DEBUG */
	if(husb == NULL){
		syslog_0(LOG_NOTICE, "## usbo_init error STOP ##");
		slp_tsk();
	}
#endif	/* ROI DEBUG */

	husbh = (USBH_HandleTypeDef *)malloc(sizeof(USBH_HandleTypeDef));
	husbh->pSysData = husb;
	tusbhInit(husbh, USBH_UserProcess, 0);
	psdev = SDMGetStorageDevice(MSC_DEVNO);
	psdev->_sdev_local[1] = husbh;
	SDeviceHead._get_datetime = get_fat_time;

	/*
	 *  USB HOST
	 */
	tusbhStart(husbh);


//	ercd = qspi_mode_init(hqspi);
//	syslog_1(LOG_NOTICE, "## MODE INIT ercd(%d) ##", ercd);
//	if(ercd != E_OK)
//		slp_tsk();


	syslog_0(LOG_NOTICE, "EXECUTE QSPI COMMAND-TASK STOP");
	slp_tsk();
}
