/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: hid_mouse.c 2416 2017-05-28 11:13:03Z roi $
 */

/* 
 *  USB HOST MOUSEǡ
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <sil.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "device.h"
#include "hid_appli.h"

/*
 *  HID MOUSE
 *  parameter1:  phandle  HIDϥɥ
 *  return       TUSBH_ERCODE
 */
TUSBH_ERCODE
HidMouseInit(void *phandle)
{
	syslog_0(LOG_NOTICE, "## HidMouseInit ##");
	return TUSBH_E_OK;
}

/*
 *  HID MOUSE
 *  parameter1:  phandle  HIDϥɥ
 *  parameter2:  pinfo    MOUSE꥿פؤΥݥ
 *  parameter3:  buffer   USB HOSTΥǡ
 *  parameter4:  length   USB HOSTǡĹ
 *  return       TUSBH_ERCODE
 */
TUSBH_ERCODE
HidMouseInfo(void *phandle, MOUSE_Info_t *pinfo, uint8_t *buffer, uint16_t length)
{
	if(length > 0){
		pinfo->x = (int8_t )buffer[1];
		pinfo->y = (int8_t )buffer[2];
		pinfo->z = (int8_t )buffer[3];
		pinfo->button_left=(uint8_t)(buffer[0] & 1);
		pinfo->button_right=(uint8_t)((buffer[0] >> 1) & 1);
		pinfo->button_middle=(uint8_t)((buffer[0] >> 2) & 1);
		return TUSBH_E_OK;
	}
	else
		return TUSBH_E_TMOUT;
}

