/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2018 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: sample1.h 2417 2018-09-28 17:49:39Z roi $
 */

/*
 *		ץץ(1)Υإåե
 */

/*
 *  åȰ¸
 */
#include "target_test.h"

#include "device.h"
#include "i2c.h"
#include "stlcd_otm8009a.h"
#include "stts_ft06x06.h"
#include "staudio_wm8994.h"
#include "glcd_disp.h"

/*
 *  ƥͥ٤
 */

#define MAIN_PRIORITY	5		/* ᥤ󥿥ͥ */
								/* HIGH_PRIORITY⤯뤳 */

#define HIGH_PRIORITY	9		/* ¹Լ¹Ԥ륿ͥ */
#define MID_PRIORITY	10
#define LOW_PRIORITY	11

/*
 *  åȤ˰¸ǽΤ
 */

#ifndef TASK_PORTID
#define	TASK_PORTID		1			/* ʸϤ륷ꥢݡID */
#endif /* TASK_PORTID */

#ifndef STACK_SIZE
#define	STACK_SIZE		4096		/* Υå */
#endif /* STACK_SIZE */

#ifndef LOOP_REF
#define LOOP_REF		ULONG_C(1000000)	/* ®ٷ¬ѤΥ롼ײ */
#endif /* LOOP_REF */

#define INHNO_LTDC      IRQ_VECTOR_LTDC
#define INTNO_LTDC      IRQ_VECTOR_LTDC
#define INTPRI_LTDC     -7        /* ͥ */
#define INTATR_LTDC     0         /* ° */

#define INHNO_DSI       IRQ_VECTOR_DSI
#define INTNO_DSI       IRQ_VECTOR_DSI
#define INTPRI_DSI      -7        /* ͥ */
#define INTATR_DSI      0         /* ° */

#define INHNO_I2C1EV    IRQ_VECTOR_I2C1_EV	/* ߥϥɥֹ */
#define INTNO_I2C1EV    IRQ_VECTOR_I2C1_EV	/* ֹ */
#define INTPRI_I2C1EV   -5				/* ͥ */
#define INTATR_I2C1EV   0				/* ° */

#define INHNO_I2C1ER    IRQ_VECTOR_I2C1_ER	/* ߥϥɥֹ */
#define INTNO_I2C1ER    IRQ_VECTOR_I2C1_ER	/* ֹ */
#define INTPRI_I2C1ER   -5				/* ͥ */
#define INTATR_I2C1ER   0				/* ° */

#define INHNO_I2C4EV    IRQ_VECTOR_I2C4_EV	/* ߥϥɥֹ */
#define INTNO_I2C4EV    IRQ_VECTOR_I2C4_EV	/* ֹ */
#define INTPRI_I2C4EV   -5				/* ͥ */
#define INTATR_I2C4EV   0				/* ° */

#define INHNO_I2C4ER    IRQ_VECTOR_I2C4_ER	/* ߥϥɥֹ */
#define INTNO_I2C4ER    IRQ_VECTOR_I2C4_ER	/* ֹ */
#define INTPRI_I2C4ER   -5				/* ͥ */
#define INTATR_I2C4ER   0				/* ° */

#define INHNO_DFSDM1F0  IRQ_DFSDM1_FLT0	/* ߥϥɥֹ */
#define INTNO_DFSDM1F0  IRQ_DFSDM1_FLT0	/* ֹ */
#define INTPRI_DFSDM1F0 -10				/* ͥ */
#define INTATR_DFSDM1F0 0				/* ° */

#define INHNO_DFSDM1F1  IRQ_DFSDM1_FLT1	/* ߥϥɥֹ */
#define INTNO_DFSDM1F1  IRQ_DFSDM1_FLT1	/* ֹ */
#define INTPRI_DFSDM1F1 -10				/* ͥ */
#define INTATR_DFSDM1F1 0				/* ° */

#define INHNO_DFSDM1F2  IRQ_DFSDM1_FLT2	/* ߥϥɥֹ */
#define INTNO_DFSDM1F2  IRQ_DFSDM1_FLT2	/* ֹ */
#define INTPRI_DFSDM1F2 -10				/* ͥ */
#define INTATR_DFSDM1F2 0				/* ° */

#define INHNO_DFSDM1F3  IRQ_DFSDM1_FLT3	/* ߥϥɥֹ */
#define INTNO_DFSDM1F3  IRQ_DFSDM1_FLT3	/* ֹ */
#define INTPRI_DFSDM1F3 -10				/* ͥ */
#define INTATR_DFSDM1F3 0				/* ° */


#define INHNO_DMAS21    IRQ_VECTOR_DMA2_STREAM1	/* ߥϥɥֹ */
#define INTNO_DMAS21    IRQ_VECTOR_DMA2_STREAM1	/* ֹ */
#define INTPRI_DMAS21   -4			/* ͥ */
#define INTATR_DMAS21   0				/* ° */

#define INHNO_DMAS23    IRQ_VECTOR_DMA2_STREAM3	/* ߥϥɥֹ */
#define INTNO_DMAS23    IRQ_VECTOR_DMA2_STREAM3	/* ֹ */
#define INTPRI_DMAS23   -4			/* ͥ */
#define INTATR_DMAS23   0				/* ° */

#define INHNO_DMAS24    IRQ_VECTOR_DMA2_STREAM4	/* ߥϥɥֹ */
#define INTNO_DMAS24    IRQ_VECTOR_DMA2_STREAM4	/* ֹ */
#define INTPRI_DMAS24   -4			/* ͥ */
#define INTATR_DMAS24   0				/* ° */

#define INHNO_DMAS26    IRQ_VECTOR_DMA2_STREAM6	/* ߥϥɥֹ */
#define INTNO_DMAS26    IRQ_VECTOR_DMA2_STREAM6	/* ֹ */
#define INTPRI_DMAS26   -4			/* ͥ */
#define INTATR_DMAS26   0				/* ° */

#define INHNO_DMAS27    IRQ_VECTOR_DMA2_STREAM7	/* ߥϥɥֹ */
#define INTNO_DMAS27    IRQ_VECTOR_DMA2_STREAM7	/* ֹ */
#define INTPRI_DMAS27   -4			/* ͥ */
#define INTATR_DMAS27   0				/* ° */

#define pHLCD           (&LcdHandle)
#define pDRAWPROP       (&DrawProp[0])

#define LCD_DEFAULT_FONT        Font24



#define BSP_TS_Init(a, b)       touchscreen_init(&TouchScreen_Handle, (a), (b), TS_ORIENTATION_LANDSCAPE)
#define BSP_TS_GetState(a)      touchscreen_getstate(&TouchScreen_Handle, (a))
#define BSP_TS_Get_GestureId(a) touchscreen_get_gestureid(&TouchScreen_Handle, (a))
#define BSP_TS_ITConfig()       0
#define BSP_TS_ResetTouchData   touchscreen_reset_data

#define TS_OK  E_OK

#define BSP_AUDIO_OUT_Init(a, b, c)     staudio_out_init(&Audio_Handle, (a), (b), (c), 128)
#define BSP_AUDIO_OUT_DeInit()          staudio_out_deinit(&Audio_Handle)
#define BSP_AUDIO_OUT_Play(a, b)        staudio_out_play(&Audio_Handle, (a), (b))
#define BSP_AUDIO_OUT_Pause()           staudio_out_pause(&Audio_Handle)
#define BSP_AUDIO_OUT_Resume()          staudio_out_resume(&Audio_Handle)
#define BSP_AUDIO_OUT_Stop(a)           staudio_out_stop(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetVolume(a)      staudio_out_setvolume(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetFrequency(a)   staudio_out_setfrequency(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetAudioFrameSlot(a) staudio_out_setframeslot(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetMute(a)        staudio_out_setmute(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetOutputMode(a)  staudio_out_setoutputmode(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_ChangeBuffer(a, b)   staudio_out_changebuffer(&Audio_Handle, (a), (b))

#define BSP_AUDIO_IN_InitEx(a, b, c, d) staudio_in_init(&Audio_Handle, (a), (b), (c), (d))
#define BSP_AUDIO_IN_DeInit()           staudio_in_deinit(&Audio_Handle)
#define BSP_AUDIO_IN_Record(a, b)       staudio_in_record(&Audio_Handle, (a), (b))
#define BSP_AUDIO_IN_Stop(a)            staudio_in_stop(&Audio_Handle, (a))
#define BSP_AUDIO_IN_Pause()            staudio_in_pause(&Audio_Handle)
#define BSP_AUDIO_IN_Resume()           staudio_in_resume(&Audio_Handle)

#define HAL_Delay(a)                    dly_tsk(a)

/*
 *  STM32F769I_Discovery board LED
 */
typedef enum
{
 LED1 = 0,
 LED_RED = LED1,
 LED2 = 1,
 LED_GREEN = LED2
} Led_TypeDef;

/*
 *  STM32F769I_Discovery board ܥ
  */
typedef enum
{
  BUTTON_WAKEUP = 0,
} Button_TypeDef;

typedef struct
{
  void   (*DemoFunc)(void);
  uint8_t DemoName[50]; 
  uint32_t DemoIndex;
}BSP_DemoTypedef;

/*
 *  GPIO Bit SET and Bit RESET enumeration 
 */
typedef enum
{
  GPIO_PIN_RESET = 0,
  GPIO_PIN_SET
}GPIO_PinState;

enum {
	RESET = 0,
	SET = 1
} FunctionalState;

typedef enum {
  AUDIO_ERROR_NON = 0,
  AUDIO_ERROR_NOTREADY,
  AUDIO_ERROR_IO,
  AUDIO_ERROR_EOF,
}AUDIO_ErrorTypeDef;

#define COUNT_OF_EXAMPLE(x)    (sizeof(x)/sizeof(BSP_DemoTypedef))

#ifdef USE_FULL_ASSERT
/* Assert activated */
#define BSP_TEST_APPLI_ASSERT(__error_condition__)    do { if(__error_condition__) \
                                                           {  while(1);  \
                                                           } \
                                                          } while(0)
#else
/* Assert not activated : macro has no effect */
#define BSP_TEST_APPLI_ASSERT(__error_condition__)    do { if(__error_condition__) \
                                                           {  ;  \
                                                           } \
                                                         } while(0)
#endif /* USE_FULL_ASSERT */

/* The Audio file is flashed with ST-Link Utility @ flash address =  AUDIO_SRC_FILE_ADDRESS */
#define AUDIO_SRC_FILE_ADDRESS       0x08080000   /* Audio file address in flash */
#define AUDIO_FILE_SIZE              0x80000

#ifndef TOPPERS_MACRO_ONLY

extern LCD_Handler_t        LcdHandle;
extern TouchScreen_Handle_t TouchScreen_Handle;
extern STAUDIO_Handle_t     Audio_Handle;
extern LCD_DrawProp_t       DrawProp[];

/*
 *  ؿΥץȥ
 */
extern void	task(intptr_t exinf);
extern void	main_task(intptr_t exinf);
extern void	tex_routine(TEXPTN texptn, intptr_t exinf);
#ifdef CPUEXC1
extern void	cpuexc_handler(void *p_excinf);
#endif /* CPUEXC1 */
extern void	cyclic_handler(intptr_t exinf);
extern void	alarm_handler(intptr_t exinf);
extern void sw_handle(void);
extern void ltdc_handler(void);
extern void dsi_handler(void);
extern void dfsdm1fl0_handler(void);
extern void dfsdm1fl1_handler(void);
extern void dfsdm1fl2_handler(void);
extern void dfsdm1fl3_handler(void);

extern void BSP_LED_On(Led_TypeDef Led);
extern void BSP_LED_Off(Led_TypeDef Led);
extern void BSP_LED_Toggle(Led_TypeDef Led);
extern uint32_t BSP_PB_GetState(Button_TypeDef Button);

extern void BSP_AUDIO_OUT_TransferComplete_CallBack(AUDIO_Handle_t *hsai);
extern void BSP_AUDIO_OUT_HalfTransfer_CallBack(AUDIO_Handle_t *hsai);
extern void BSP_AUDIO_IN_TransferComplete_CallBack(void *handle);
extern void BSP_AUDIO_IN_HalfTransfer_CallBack(void *handle);
extern void BSP_AUDIO_OUT_Error_CallBack(void);
extern void BSP_AUDIO_IN_Error_CallBack(void);

/* Exported variables --------------------------------------------------------*/
extern const unsigned char stlogo[];
extern uint32_t SdmmcTest;
extern uint32_t SdramTest;
extern char     cbuff[260];

/* Exported functions ------------------------------------------------------- */
uint8_t TouchScreen_GetTouchPosition(void);
void Touchscreen_DrawBackground_Circles(uint8_t state);
void     Touchscreen_demo1 (void);
void     Touchscreen_demo2 (void);
void AudioPlay_demo (void);
void AudioLoopback_demo (void);
uint8_t AUDIO_Process(void);
void LCD_demo (void);
void SD_demo (void);
void QSPI_demo (void);
void EEPROM_demo (void);
uint8_t CheckForUserInput(void);
void Error_Handler(void);
void SDRAM_demo(void);
void SDRAM_DMA_demo (void);
void Log_demo(void);


#endif /* TOPPERS_MACRO_ONLY */
