/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: lcdshield.h 2416 2019-12-20 18:00:43Z roi $
 */

/*
 *  LCDץΥإåե
 */

/*
 *  åȰ¸
 */
#include "target_test.h"
#include "glcd_disp.h"

/*
 *  ƥͥ٤
 */

#define MAIN_PRIORITY	9		/* ᥤ󥿥ͥ */
#define HIGH_PRIORITY	6		/* STICKͥ */

/*
 *  åȤ˰¸ǽΤ
 */

#ifndef TASK_PORTID
#define	TASK_PORTID		1			/* ʸϤ륷ꥢݡID */
#endif /* TASK_PORTID */

#ifndef STACK_SIZE
#define	STACK_SIZE		4096		/* Υå */
#endif /* STACK_SIZE */

#define SPISDCARD_PORTID    0

#define INHNO_SPI   IRQ_VECTOR_SPI1	/* ߥϥɥֹ */
#define INTNO_SPI   IRQ_VECTOR_SPI1	/* ֹ */
#define INTPRI_SPI  -4			/* ͥ */
#define INTATR_SPI  0			/* ° */

#define RXDMA_SID     DMA2STM2_SID
#define INHNO_DMARX   IRQ_VECTOR_DMA2_STREAM2	/* ߥϥɥֹ */
#define INTNO_DMARX   IRQ_VECTOR_DMA2_STREAM2	/* ֹ */
#define INTPRI_DMARX  -4          /* ͥ */
#define INTATR_DMARX  TA_EDGE     /* ° */

#define TXDMA_SID     DMA2STM3_SID
#define INHNO_DMATX   IRQ_VECTOR_DMA2_STREAM3	/* ߥϥɥֹ */
#define INTNO_DMATX   IRQ_VECTOR_DMA2_STREAM3	/* ֹ */
#define INTPRI_DMATX  -4          /* ͥ */
#define INTATR_DMATX  TA_EDGE     /* ° */

#define ADC_PORTID    ADC3_PORTID

#define INHNO_ADC     IRQ_VECTOR_ADC3	/* ߥϥɥֹ */
#define INTNO_ADC     IRQ_VECTOR_ADC3	/* ֹ */
#define INTPRI_ADC    -5			/* ͥ */
#define INTATR_ADC    0				/* ° */

#define ADCDMA_SID    DMA2STM0_SID
#define INHNO_DMAADC  IRQ_VECTOR_DMA2_STREAM0	/* ߥϥɥֹ */
#define INTNO_DMAADC  IRQ_VECTOR_DMA2_STREAM0	/* ֹ */
#define INTPRI_DMAADC -4			/* ͥ */
#define INTATR_DMAADC 0				/* ° */

#define ADC_CHANNEL   ADC_CHANNEL_5

#define ADC_CHANNEL_GPIO_PORT   TADR_GPIOF_BASE
#define ADC_CHANNEL_PINNO       3

#define NUM_JSPOSITION 6

#define JS_OFF      0x01
#define JS_ON       0x02
#define JS_UP       0x04
#define JS_DOWN     0x08
#define JS_LEFT     0x10
#define JS_RIGHT    0x20
#define JS_MASK     0x3F

#define CS_PORT     10
#define RST_PORT    9
#define RS_PORT     8
#define CS2_PORT    4

#define cs_set(sw)  digitalWrite(CS_PORT, sw)
#define rs_set(sw)  digitalWrite(RS_PORT, sw)
#define rst_set(sw) digitalWrite(RST_PORT, sw)
#define cs2_set(sw) digitalWrite(CS2_PORT, sw)

#ifndef TOPPERS_MACRO_ONLY
/*
 *  ؿΥץȥ
 */
extern void	main_task(intptr_t exinf);
extern void stick_task(intptr_t exinf);

extern void sw_int(void);
extern void device_info_init(intptr_t exinf);


#endif /* TOPPERS_MACRO_ONLY */
