/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: openamptest.c 2416 2019-12-20 17:58:56Z ertl-hiro $
 */

/* 
 *  OpenAMPΥƥȥץ
 *  ROM¹ԥ⡼ɤǼ¹Ԥ뤳
 *  asp.exeasp.elf˽
 *  STLinuxSDɤ
 *  Cube-M4-examples/STM32MP157C-DK2/Examples/UART˲
 *  UART_TwoBoards_ComITǥ쥯ȥ򥳥ԡƥǥ쥯ȥ̾
 *  aspѹasp/lib/firmwareasp.elf򥳥ԡ
 *  STLinuxư塢aspǥ쥯ȥ./fw_cortex_m4.sh start
 *  ץ¹ԤʲΥޥɥƥȤޤ
 *   > stty -onlcr -echo -F /dev/ttyRPMSG0
 *   > cat /dev/ttyRPMSG0 &
 *   > stty -onlcr -echo -F /dev/ttyRPMSG1
 *   > cat /dev/ttyRPMSG1 &
 *   > echo "Hello Virtual UART0" >/dev/ttyRPMSG0
 *   > echo "Hello Virtual UART1" >/dev/ttyRPMSG1
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include <target_syssvc.h>
#include "kernel_cfg.h"
#include "device.h"
#include "metal/device.h"
#include "openamptest.h"

/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))


/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
#define SHM_DEVICE_NAME         "STM32_SHM"
#define MAX_BUFFER_SIZE RPMSG_BUFFER_SIZE
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
/** @addtogroup Exported_types
  * @{
  */
typedef enum
{
  RESET = 0,
  SET = !RESET
} FlagStatus, ITStatus;

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

static uint32_t heap_area[HEAP_SIZE/sizeof(uint32_t)];


uint32_t heap_param[2] = {
	(uint32_t)heap_area,
	HEAP_SIZE
};


IPCC_HandleTypeDef hipcc;

/* USER CODE BEGIN PV */
VIRT_UART_HandleTypeDef huart0;
VIRT_UART_HandleTypeDef huart1;

volatile FlagStatus VirtUart0RxMsg = RESET;
uint8_t VirtUart0ChannelBuffRx[MAX_BUFFER_SIZE];
uint16_t VirtUart0ChannelRxSize = 0;

volatile FlagStatus VirtUart1RxMsg = RESET;
uint8_t VirtUart1ChannelBuffRx[MAX_BUFFER_SIZE];
uint16_t VirtUart1ChannelRxSize = 0;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
static void MX_IPCC_Init(void);
/* USER CODE BEGIN PFP */
void VIRT_UART0_RxCpltCallback(VIRT_UART_HandleTypeDef *huart);
void VIRT_UART1_RxCpltCallback(VIRT_UART_HandleTypeDef *huart);
/* USER CODE END PFP */

#if defined (__LOG_TRACE_IO_)
char system_log_buf[SYSTEM_TRACE_BUF_SZ];

void log_buff(int ch)
{
  /* Place your implementation of fputc here */
  /* e.g. write a character to the USART1 and Loop until the end of transmission */
 static int offset = 0;

	if (offset + 1 >= SYSTEM_TRACE_BUF_SZ)
		offset = 0;

	system_log_buf[offset] = ch;
	system_log_buf[offset++ + 1] = '\0';
}

#endif

/*
 *  桼åߴؿ
 */
void sw_handle(intptr_t exinf)
{
	syslog_1(LOG_NOTICE, "## sw int(%d) ##", (int)exinf);
}


/**
  * @brief  This function is executed in case of error occurrence.
  * @param  file: The file name as string.
  * @param  line: The line in file as a number.
  * @retval None
  */
void Error_Handler(void)
{
	/* USER CODE BEGIN Error_Handler_Debug */
	syslog_0(LOG_ERROR, "Error_Handler");
	slp_tsk();
  /* USER CODE END Error_Handler_Debug */
}

/**
  * @brief IPPC Initialization Function
  * @param None
  * @retval None
  */
static void MX_IPCC_Init(void)
{
#if 1	/* ROI MODIFIED */
	hipcc.Init.controlID = IPCC2_CONTROLID;
	hipcc.Init.inttx     = -1;
	hipcc.Init.intrx     = INTNO_IPCCRX;
#endif	/* ROI MODIFIED */
  if (HAL_IPCC_Init(&hipcc) != HAL_OK)
  {
     Error_Handler();
  }
}

/* USER CODE BEGIN 4 */
void VIRT_UART0_RxCpltCallback(VIRT_UART_HandleTypeDef *huart)
{

    syslog_1(LOG_NOTICE, "Msg received on VIRTUAL UART0 channel:  %s", (char *) huart->pRxBuffPtr);

    /* copy received msg in a variable to sent it back to master processor in main infinite loop*/
    VirtUart0ChannelRxSize = huart->RxXferSize < MAX_BUFFER_SIZE? huart->RxXferSize : MAX_BUFFER_SIZE-1;
    memcpy(VirtUart0ChannelBuffRx, huart->pRxBuffPtr, VirtUart0ChannelRxSize);
    VirtUart0RxMsg = SET;
}

void VIRT_UART1_RxCpltCallback(VIRT_UART_HandleTypeDef *huart)
{

    syslog_1(LOG_NOTICE, "Msg received on VIRTUAL UART1 channel:  %s", (char *) huart->pRxBuffPtr);

    /* copy received msg in a variable to sent it back to master processor in main infinite loop*/
    VirtUart1ChannelRxSize = huart->RxXferSize < MAX_BUFFER_SIZE? huart->RxXferSize : MAX_BUFFER_SIZE-1;
    memcpy(VirtUart1ChannelBuffRx, huart->pRxBuffPtr, VirtUart1ChannelRxSize);
    VirtUart1RxMsg = SET;
}
/* USER CODE END 4 */

void __assert_func(const char * file, int l, const char *func, const char *e)
{
	syslog_4(LOG_ERROR, "#### assert file[%s] line(%d) func[%s] e[%s] ####", file, l, func, e);
	slp_tsk();
}


/*
 *  ᥤ󥿥
 */
void main_task(intptr_t exinf)
{
	ER_UINT	ercd;

	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

	/*
	 *  ꥢݡȤν
	 *
	 *  ƥƱꥢݡȤȤʤɡꥢ
	 *  ݡȤץѤߤξˤϤE_OBJ顼ˤʤ뤬پ
	 *  ʤ
	 */
	ercd = serial_opn_por(TASK_PORTID);
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `serial_opn_por'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(serial_ctl_por(TASK_PORTID,
							(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	/* IPCC initialisation */
	MX_IPCC_Init();
	/* OpenAmp initialisation ---------------------------------*/
	MX_OPENAMP_Init(RPMSG_REMOTE, NULL);

	/* USER CODE BEGIN SysInit */

	/* USER CODE END SysInit */

	/* Initialize all configured peripherals */

	/* USER CODE BEGIN 2 */
	/*
	 * Create Virtual UART device
	 * defined by a rpmsg channel attached to the remote device
	 */
	syslog_0(LOG_NOTICE, "Virtual UART0 OpenAMP-rpmsg channel creation");
	dly_tsk(200);
	if(VIRT_UART_Init(&huart0) != VIRT_UART_OK){
		syslog_0(LOG_ERROR, "VIRT_UART_Init UART0 failed.");
		Error_Handler();
	}

	syslog_0(LOG_NOTICE, "Virtual UART1 OpenAMP-rpmsg channel creation");
	dly_tsk(200);
	if(VIRT_UART_Init(&huart1) != VIRT_UART_OK){
		syslog_0(LOG_ERROR, "VIRT_UART_Init UART1 failed.");
		Error_Handler();
	}

	syslog_0(LOG_NOTICE, "Virtual UART0 Register");
	dly_tsk(200);
	/*Need to register callback for message reception by channels*/
	if(VIRT_UART_RegisterCallback(&huart0, VIRT_UART_RXCPLT_CB_ID, VIRT_UART0_RxCpltCallback) != VIRT_UART_OK){
		Error_Handler();
	}
	syslog_0(LOG_NOTICE, "Virtual UART1 Register");
	dly_tsk(200);
	if(VIRT_UART_RegisterCallback(&huart1, VIRT_UART_RXCPLT_CB_ID, VIRT_UART1_RxCpltCallback) != VIRT_UART_OK){
		Error_Handler();
	}
	/* USER CODE END 2 */

	/* Infinite loop */
	/* USER CODE BEGIN WHILE */
	while(1){

		OPENAMP_check_for_message();

		/* USER CODE END WHILE */
		if (VirtUart0RxMsg) {
			VirtUart0RxMsg = RESET;
			VIRT_UART_Transmit(&huart0, VirtUart0ChannelBuffRx, VirtUart0ChannelRxSize);
		}

		if(VirtUart1RxMsg){
			VirtUart1RxMsg = RESET;
			VIRT_UART_Transmit(&huart1, VirtUart1ChannelBuffRx, VirtUart1ChannelRxSize);
		}
		/* USER CODE BEGIN 3 */
	}
	/* USER CODE END 3 */

	syslog(LOG_NOTICE, "Sample program ends.");
	slp_tsk();
//	SVC_PERROR(ext_ker());
}
