/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ble_remote.h 2416 2012-09-07 08:06:20Z ertl-hiro $
 */

/*
 *	WDOG¹ԥƥȤΥإåե
 */

/*
 *  åȰ¸
 */
#include "target_test.h"

/*
 *  ƥͥ٤
 */
#define MAIN_PRIORITY	9		/* ᥤ󥿥ͥ */
#define COMM_PRIORITY   6		/* ̿ͥ */

/*
 *  åȤ˰¸ǽΤ
 */

#ifndef TASK_PORTID
#define	TASK_PORTID		1			/* ʸϤ륷ꥢݡID */
#endif /* TASK_PORTID */

#ifndef STACK_SIZE
#define	STACK_SIZE		4096		/* Υå */
#endif /* STACK_SIZE */

#ifndef PORTID
#define PORTID          1
#endif

#if PORTID == 1
#define I2C_PORTID I2C1_PORTID
#define INHNO_I2CEV   IRQ_VECTOR_I2C1_EV	/* ߥϥɥֹ */
#define INTNO_I2CEV   IRQ_VECTOR_I2C1_EV	/* ֹ */
#define INHNO_I2CER   IRQ_VECTOR_I2C1_ER	/* ߥϥɥֹ */
#define INTNO_I2CER   IRQ_VECTOR_I2C1_ER	/* ֹ */
#else
#define I2C_PORTID I2C3_PORTID
#define INHNO_I2CEV   IRQ_VECTOR_I2C3_EV	/* ߥϥɥֹ */
#define INTNO_I2CEV   IRQ_VECTOR_I2C3_EV	/* ֹ */
#define INHNO_I2CER   IRQ_VECTOR_I2C3_ER	/* ߥϥɥֹ */
#define INTNO_I2CER   IRQ_VECTOR_I2C3_ER	/* ֹ */
#endif

#define INHNO_ADC     IRQ_VECTOR_ADC1	/* ߥϥɥֹ */
#define INTNO_ADC     IRQ_VECTOR_ADC1	/* ֹ */
#define INTPRI_ADC    -1          /* ͥ */
#define INTATR_ADC    0           /* ° */

#define INTPRI_I2CEV  -5			/* ͥ */
#define INTATR_I2CEV  0				/* ° */
#define INTPRI_I2CER  -5			/* ͥ */
#define INTATR_I2CER  0				/* ° */

#define TC1_STBY_PIN  13
#define TC1_IN1_PIN   0
#define TC1_IN2_PIN   1
#define TC2_STBY_PIN  TC1_STBY_PIN                                /* 14 */
#define TC2_IN1_PIN   8
#define TC2_IN2_PIN   9

#define ADC_CHANNEL           ADC_CHANNEL_12
#define ADC_CHANNEL_GPIO_PORT TADR_GPIOA_BASE
#define ADC_CHANNEL_PINNO     7

#define COM_MAX_DATA_LEN      34

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǡ
 */
extern volatile char    *pcommand;
extern volatile uint8_t command_length;
extern volatile uint8_t command_dev;

/*
 *  ؿΥץȥ
 */
extern void	main_task(intptr_t exinf);
extern void comm_task(intptr_t exinf);
extern void	cyclic_handler(intptr_t exinf);
extern void sw_handle(void);

extern void APP_DeviceName(const char *name);
extern void NUS_APP_SetParam(void *prxq, void *func);
extern uint8_t NUS_APP_GetConnect(void);
extern uint16_t NUS_APP_SetTxData(uint8_t *pdata, uint16_t len);

#endif /* TOPPERS_MACRO_ONLY */
