/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2021 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: protocal.c 698 2021-01-22 22:57:55Z roi $
 */
/*
 *  BLE MOTOR Middleware
 */

#include <kernel.h>
#include <string.h>
#include "protocol.h"
#include <stdio.h>
#include "device.h"
#include "i2c.h"

/*
 *  С
 */
#define	BLEREM_PRVER	0x0001		/* BLE REMOTEΥСֹ */

#define HEEPROM_ADDR    (EEPROM_ADDR<<1)
#define HUS_SENSOR_ADDR (US_SENSOR_ADDR<<1)

/*
 *  ޥɥǥѥåѤι¤
 */
typedef struct _COMMAND_t {
	const char   *command;			/* ޥʸ */
	int          (*func)(char *res, char *cmd, uint16_t *plen);	/* ¹Դؿ */
} COMMAND_t;

static int info_func(char *res, char *cmd, uint16_t *plen);
static int gdev_func(char *res, char *cmd, uint16_t *plen);
static int ver_func(char *res, char *cmd, uint16_t *plen);
static int gmtr_func(char *res, char *cmd, uint16_t *plen);
static int gsys_func(char *res, char *cmd, uint16_t *plen);
static int sinf_func(char *res, char *cmd, uint16_t *plen);
static int sdev_func(char *res, char *cmd, uint16_t *plen);
static int smtr_func(char *res, char *cmd, uint16_t *plen);
static int suss_func(char *res, char *cmd, uint16_t *plen);

/*
 *  ǥХޥɥơ֥
 */
static const COMMAND_t command_info[] = {
	{"GI",		info_func},
	{"GD",		gdev_func},
	{"GV",		ver_func},
	{"GM",		gmtr_func},
	{"GS",		gsys_func},
	{"SI",		sinf_func},
	{"SD",		sdev_func},
	{"SM",		smtr_func},
	{"SU",		suss_func}
};

#define NUM_COMMAND  (sizeof(command_info)/sizeof(COMMAND_t))

static I2C_Handle_t *hi2c;
static int8_t  t_duty[NUM_MOTORS][2];
static int8_t  s_duty[NUM_MOTORS][2];

static char *
int2char(char *d, int len)
{
	int  i;
	uint8_t buf[16];

	if(len == 0){
		*d++ = '0';
		return d;
	}
	for(i = 0 ; i < 16 && len != 0 ; i++){
		buf[i] = (len % 10) + '0';
		len /= 10;
	}
	while(i > 0){
		*d++ = buf[--i];
	}
	return d;
}

static int
a2i(char *str, char **p)
{
	int sign = 1;
	int num = 0;

	if(*str == 'S' || *str == 's'){
		*p = str+2;
		return 127;
	}
	if(*str == '-'){
		sign = -1;
		str++;
	}
	while(*str >= '0' && *str <= '9'){
		num = num * 10 + *str++ - '0';
	}
	*p = str+1;
	return num * sign;
}

/*
 *  I2Cϥɥ
 *  param1:  h I2Cϥɥ
 */
void
set_hi2c(void *h)
{
	hi2c = h;
}

/*
 *  EEPROM˥ǡ
 */
uint32_t
eeprom_write(uint16_t addr, uint8_t const *pdata, uint8_t size)
{
    uint32_t err_code;

	if(size > EEPROM_WRITE_MAX_BYTES)
		return EEPROM_INVALID_LENGTH;
	if((addr / EEPROM_WRITE_MAX_BYTES) != ((addr + size - 1) / EEPROM_WRITE_MAX_BYTES))
		return EEPROM_INVALID_ADDR;

	err_code = i2c_memwrite(hi2c, HEEPROM_ADDR, addr, I2C_MEMADD_SIZE_16BIT, (uint8_t *)pdata, size);
	return err_code;
}

/*
 *  EEPROMǡɤ߹
 */
uint32_t
eeprom_read(uint16_t addr, uint8_t *pdata, uint16_t size)
{
	uint32_t err_code;

	err_code = i2c_memread(hi2c, HEEPROM_ADDR, addr, I2C_MEMADD_SIZE_16BIT, pdata, size);
    return err_code;
}


/*
 *  ⡼
 */
void
motor_init(void)
{
	uint32_t mid;

	for(mid = 0 ; mid < NUM_MOTORS ; mid++){
		t_duty[mid][0] = t_duty[mid][1] = 0;
		s_duty[mid][0] = s_duty[mid][1] = 0;
		motor_stby_set(mid, 0);
		motor_duty_set(mid, s_duty[mid][0], s_duty[mid][1]);
	}
}


/*
 *  ⡼٥Ƚ
 */
uint32_t
motor_event(void)
{
	EEPROM_t *pf = get_eeprom();
	uint32_t next_time = 0;
	int8_t   ss_duty[2];
	uint32_t mid;

	for(mid = 0 ; mid < NUM_MOTORS ; mid++){
		if(s_duty[mid][0] != t_duty[mid][0] || s_duty[mid][1] != t_duty[mid][1]){
			uint8_t id  = pf->t_mselect ^ mid;
			uint8_t pno = pf->t_m_pulse[mid];
			if(s_duty[mid][0] > 0 && s_duty[mid][0] <= 100 && t_duty[mid][1] > 0){
				ss_duty[0] = 0;
				ss_duty[1] = s_duty[mid][1];
				next_time = pf->t_m_time;
			}
			else if(s_duty[mid][1] > 0 && s_duty[mid][1] <= 100 && t_duty[mid][0] > 0){
				ss_duty[0] = s_duty[mid][0];
				ss_duty[1] = 0;
				next_time = pf->t_m_time;
			}
			else{
				ss_duty[0] = s_duty[mid][0];
				ss_duty[1] = s_duty[mid][1];
			}
			motor_stby_set(id, 1);
			motor_duty_set(id, ss_duty[0 ^ pno], ss_duty[1 ^ pno]);
			t_duty[mid][0] = ss_duty[0];
			t_duty[mid][1] = ss_duty[1];
			if(ss_duty[0] == 0 && ss_duty[1] == 0)
				motor_stby_set(id, 0);
		}
	}
	return next_time;
}


/*
 *  Ķȥ󥵡󥹳
 */
int
uss_start(void)
{
    uint32_t err_code;
	uint8_t buffer[2];

	err_code = i2c_memread(hi2c, HUS_SENSOR_ADDR, US_SENSOR_START_CMD, I2C_MEMADD_SIZE_8BIT, buffer, 1);
	if(err_code == 0)
		return buffer[0];
	else
		return -1;
}


/*
 *  Ķȥ󥵡̼
 */
int
uss_get_result(uint8_t uss_value)
{
    uint32_t err_code;
	uint8_t buffer[2], datah;
	int result = 0;

	if(uss_value != 0){
		buffer[0] = 0;
		err_code = i2c_memread(hi2c, HUS_SENSOR_ADDR, US_SENSOR_DATAH_CMD, I2C_MEMADD_SIZE_8BIT, buffer, 1);
		datah = buffer[0];

		buffer[0] = 0;
		err_code = i2c_memread(hi2c, HUS_SENSOR_ADDR, US_SENSOR_DATAL_CMD, I2C_MEMADD_SIZE_8BIT, buffer, 1);
		result = datah*256 + buffer[0];
		(void)(err_code);
	}
	return result;
}


/*
 *  Ķȥ󥵡ΥݡȺ
 */
int
uss_make_event(char *res, uint32_t uss_value1, uint32_t uss_value2, uint16_t *plen)
{
	char *p = res;

	*p++ = 'R';
	*p++ = 'U';
	*p++ = ':';
	*p++ = '0'+uss_value1;
	*p++ = ',';
	p = int2char(p, uss_value2);
	*p = 0;
	*plen = p - res;
	return 0;
}


/*
 *  ޥɲϤȼ¹
 */
int
ble_dispatch(char *res, char *cmd, uint16_t *plen)
{
	const COMMAND_t *pc;
	char  *p = &cmd[2];
	uint16_t len;
	int i;

	if(cmd == NULL || plen == NULL)
		return EVENT_IDOL;
	len = *plen;
	if(len < 2)
		return EVENT_IDOL;
	if(cmd[len-1] < 0x20)
		len--;
	if(cmd[len-1] < 0x20)
		len--;
	if(len < 2)
		return EVENT_IDOL;

	cmd[len] = 0;
	*plen = len;
	for(i = 0, pc = command_info ; i < NUM_COMMAND ; i++, pc++){
		if(cmd[0] >= 'a' && cmd[0] < 'z')
			cmd[0] -= 0x20;
		if(cmd[1] >= 'a' && cmd[1] < 'z')
			cmd[1] -= 0x20;
		if(pc->command[0] == cmd[0] && pc->command[1] == cmd[1]){
			*plen -= 2;
			if(*plen > 0 && *p == ':'){
				p++;
				*plen -= 1;
			}
			return pc->func(res, p, plen);
		}
	}
	return EVENT_IDOL;
}

/*
 *  쥹ݥ󥹡ե᡼
 */
static int
info_func(char *res, char *cmd, uint16_t *plen)
{
	EEPROM_t *pf = get_eeprom();
	char *p = res;

	*p++ = 'R';
	*p++ = 'I';
	*p++ = ':';
	p = int2char(p, pf->t_mselect);
	*p++ = ',';
	p = int2char(p, pf->t_m_pulse[MOTOR1_ID]);
	*p++ = ',';
	p = int2char(p, pf->t_m_pulse[MOTOR2_ID]);
	*p++ = ',';
	p = int2char(p, pf->t_m_bias[MOTOR1_ID]);
	*p++ = ',';
	p = int2char(p, pf->t_m_bias[MOTOR2_ID]);
	*p = 0;
	*plen = p - res;
	return EVENT_SEND_RESPONSE;
}

/*
 *  쥹ݥ󥹡ǥХ̾
 */
static int
gdev_func(char *res, char *cmd, uint16_t *plen)
{
	EEPROM_t *pf = get_eeprom();
	char *p = res;
	uint32_t i;

	*p++ = 'R';
	*p++ = 'D';
	*p++ = ':';
	for(i = 0 ; i < 32 && pf->devicename[i] != 0 ; i++){
		*p++ = pf->devicename[i];
	}
	*p = 0;
	*plen = p - res;
	return EVENT_SEND_RESPONSE;
}

/*
 *  쥹ݥ󥹡С
 */
static int
ver_func(char *res, char *cmd, uint16_t *plen)
{
	char *p = res;

	*p++ = 'R';
	*p++ = 'V';
	*p++ = ':';
	p = int2char(p, ((BLEREM_PRVER>>12) & 0xf));
	*p++ = '.';
	p = int2char(p, ((BLEREM_PRVER>>4) & 0xff));
	*p++ = '.';
	p = int2char(p, (BLEREM_PRVER & 0xf));
	*p = 0;
	*plen = p - res;
	return EVENT_SEND_RESPONSE;
}

/*
 *  ⡼
 */
static int
gmtr_func(char *res, char *cmd, uint16_t *plen)
{
	char *p = res;
	uint32_t mid;
	int8_t   val = 0;

	*p++ = 'R';
	*p++ = 'M';
	*p++ = ':';
	for(mid = 0 ; mid < NUM_MOTORS ; mid++){
		if(t_duty[mid][0] == 100 && t_duty[mid][1] == 100)
			*p++ = 'S';
		else{
			if(t_duty[mid][0] == 0 && t_duty[mid][1] == 0)
				val = 0;
			else if(t_duty[mid][0] > 0)
				val = t_duty[mid][0];
			else{
				*p++ = '-';
				val = t_duty[mid][1];
			}
			p = int2char(p, val);
		}
		if((mid+1) < NUM_MOTORS)
			*p++ = ',';
	}
	*p = 0;
	*plen = p - res;
	return EVENT_SEND_RESPONSE;
}

/*
 *  ƥ
 */
static int
gsys_func(char *res, char *cmd, uint16_t *plen)
{
	char *p = res;

	*p++ = 'R';
	*p++ = 'S';
	*p++ = ':';
	p = int2char(p, get_systime());
	*p++ = ',';
	p = int2char(p, get_batterylevel());
	*p++ = ',';
	p = int2char(p, get_syserror());
	*p = 0;
	*plen = p - res;
	return EVENT_SEND_RESPONSE;
}

/*
 *  ⡼¹
 */
static int
sinf_func(char *res, char *cmd, uint16_t *plen)
{
	EEPROM_t *pf = get_eeprom();
	uint8_t len = *plen;
	uint32_t i = 0, val;
	char *p = cmd;
	char **pp = &p;

	if(i < len){
		if(cmd[0] != ','){
			val = a2i(cmd, pp);
			if(val == 0 || val == 1)
				pf->t_mselect = val;
			for(; i < len ; i++){
				res[i] = *cmd++;
				if(res[i] == ',')
					break;
			}
		}
		else
			res[i++] = *cmd++;
	}
	if(i < len){
		if(cmd[0] != ','){
			val = a2i(cmd, pp);
			if(val == 0 || val == 1)
				pf->t_m_pulse[MOTOR1_ID] = val;
			for(; i < len ; i++){
				res[i] = *cmd++;
				if(res[i] == ',')
					break;
			}
		}
		else
			res[i++] = *cmd++;
	}
	if(i < len){
		if(cmd[0] != ','){
			val = a2i(cmd, pp);
			if(val == 0 || val == 1)
				pf->t_m_pulse[MOTOR2_ID] = val;
			for(; i < len ; i++){
				res[i] = *cmd++;
				if(res[i] == ',')
					break;
			}
		}
		else
			res[i++] = *cmd++;
	}
	if(i < len){
		if(cmd[0] != ','){
			val = a2i(cmd, pp);
			if(val <= 10000 && val >= 100)
				pf->t_m_bias[MOTOR1_ID] = val;
			for(; i < len ; i++){
				res[i] = *cmd++;
				if(res[i] == ',')
					break;
			}
		}
		else
			res[i++] = *cmd++;
	}
	if(i < len){
		if(cmd[0] != ','){
			val = a2i(cmd, pp);
			if(val <= 10000 && val >= 100)
				pf->t_m_bias[MOTOR2_ID] = val;
			for(; i < len && res[i] != ',' ; i++)
				res[i] = *cmd++;
		}
		for(; i < len ; i++){
			res[i] = *cmd++;
		}
	}
	res[i] = 0;
	*plen = i;
	return EVENT_WRITE_FLASH;
}

/*
 *  ǥХ̾
 */
static int
sdev_func(char *res, char *cmd, uint16_t *plen)
{
	EEPROM_t *pf = get_eeprom();
	uint8_t len = *plen;
	uint32_t i;

	if(len < 6)
		return EVENT_IDOL;
	if(cmd[0] != 'B' || cmd[1] != 'L' ||
			cmd[2] != 'E' || cmd[3] != '_')
		return EVENT_IDOL;
	for(i = 0 ; i < 32 && i < len ; i++){
		pf->devicename[i] = res[i] = *cmd++;
	}
	pf->devicename[i] = res[i] = 0;
	*plen = i;
	return EVENT_WRITE_FLASH;
}

/*
 *  ⡼
 */
static int
smtr_func(char *res, char *cmd, uint16_t *plen)
{
	EEPROM_t *pf = get_eeprom();
	uint8_t  len = *plen;
	int32_t  val;
	uint32_t mid;
	char *p = cmd;
	char **pp = &p;

	memcpy(s_duty, t_duty, NUM_MOTORS*2);
	for(mid = 0 ; mid < NUM_MOTORS ; mid++){
		if((len - (*pp - cmd)) > 0){
			if(p[0] == ',' || p[0] == ' ')
				p++;
			else{
				val = a2i(p, pp);
				if(val == 127)
					s_duty[mid][0] = s_duty[mid][1] = 100;
				else if(val <= 100 && val >= -100){
					val = (val * pf->t_m_bias[mid]) / 10000;
					if(val == 0)
						s_duty[mid][0] = s_duty[mid][1] = 0;
					else if(val > 0){
						s_duty[mid][0] = val;
						s_duty[mid][1] = 0;
					}
					else{
						s_duty[mid][0] = 0;
						s_duty[mid][1] = -val;
					}
				}
				p = *pp;
			}
		}
	}
	return EVENT_MOTOR_EVENT;
}

/*
 *  Ķȥ󥵡(mi-02)ͼ
 */
static int
suss_func(char *res, char *cmd, uint16_t *plen)
{
	EEPROM_t *pf = get_eeprom();
	int32_t  val1 = 0;
	int32_t  val2;
	char *p = cmd;
	char **pp = &p;

	val1 = a2i(p, pp);
	val2 = a2i(p, pp);
	if(val1 < pf->u_s_interval)
		val1 = 0;
	if(val2 < pf->u_s_time)
		val2 = pf->u_s_time;
	uss_event_request(val1, val2);
	*res = 0;
	*plen = 0;
	return EVENT_IDOL;
}

