/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2020 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: protocal.c 698 2020-10-18 16:20:40Z roi $
 */
/*
 *  BLE MOTOR Middleware
 */

#ifndef _PROTOCOL_H_
#define _PROTOCOL_H_

#define EVENT_IDOL              0
#define EVENT_SEND_RESPONSE     1
#define EVENT_WRITE_FLASH       2
#define EVENT_MOTOR_EVENT       3
#define EVENT_IDOL_ERROR        10

#define DEVICE_BLE              0
#define DEVICE_UART             1

#define NUM_MOTORS              2
#define MOTOR1_ID               0
#define MOTOR2_ID               1
#ifndef NUM_STBYS
#define NUM_STBYS               NUM_MOTORS
#endif

#define DUTY_PERIOD             1000L		/* 1000Hz **/
#define DEFAULT_BIAS            10000		/* 1.0 */
#define DEFAULT_MOTOR_TIME      600			/* 600ms */
#define DEFAULT_MIN_USS_INT     1500		/* 1.5sec */
#define DEFAULT_MIN_USS_TIME    100			/* 100ms */
#define DEAFULT_MIN_USS_REPORT  20			/* 20mm */

#define EEPROM_ADDR             0x50
#define EEPROM_INFO_ADDRESS     0
#define EEPROM_ADDRESS_LEN_BYTES 2
#define EEPROM_WRITE_MAX_BYTES  32
#define US_SENSOR_ADDR          0x2C
#define US_SENSOR_START_CMD     0x33
#define US_SENSOR_DATAH_CMD     0x0F
#define US_SENSOR_DATAL_CMD     0x0E

#define EEPROM_INVALID_LENGTH   0x8210
#define EEPROM_INVALID_ADDR     0x8211

#define EVENT_MOTOR             0x00000001
#define EVENT_USS               0x00000002

#define BLECOM_ERROR_EEPROM     1
#define BLECOM_ERROR_TWI        2
#define BLECOM_ERROR_USS        3
#define BLECOM_ERROR_TIME       4
#define BLECOM_ERROR_PWM        5
#define BLECOM_ERROR_SYS        8

/*
 *  FLASH-ROMѤι¤
 */
typedef struct _EEPROM {
	uint8_t   magic[2];			/* ޥå */
	char      devicename[32];	/* ǥХ̾ */
	uint8_t   t_mselect;		/* TC78H653FTG-MOTOR-SELECT */
	uint8_t   dummy1;
	uint8_t   t_m_pulse[NUM_MOTORS];	/* motor PULSE */
	uint16_t  t_m_bias[NUM_MOTORS];		/* motor bias */
	uint16_t  t_m_time;					/* motor wait time */
	uint16_t  u_s_time;					/* us sensor wait time */
	uint16_t  u_s_interval;				/* us sensor interval time */
	uint16_t  u_s_report_des;			/* us sensor report destance */
	char      dummy[14];
} EEPROM_t;


extern EEPROM_t *get_eeprom(void);
extern uint8_t get_syserror(void);
extern uint32_t get_systime(void);
extern uint32_t get_batterylevel(void);
extern void motor_duty_set(uint8_t id, int32_t value1, int32_t value2);
extern void motor_stby_set(uint8_t id, uint8_t mode);
extern void uss_event_request(uint32_t interval, uint32_t time);

extern int ble_dispatch(char *res, char *cmd, uint16_t *plen);
extern void set_hi2c(void *h);
extern uint32_t eeprom_write(uint16_t addr, uint8_t const *pdata, uint8_t size);
extern uint32_t eeprom_read(uint16_t addr, uint8_t * pdata, uint16_t size);
extern void motor_init(void);
extern uint32_t motor_event(void);
extern int uss_start(void);
extern int uss_get_result(uint8_t uss_value);
extern int uss_make_event(char *res, uint32_t uss_value1, uint32_t uss_value2, uint16_t *plen);

#endif	/* _PROTOCOL_H_ */

