
/**
  ******************************************************************************
  *  @file    p2p_stm.h
  * @author  MCD Application Team
  * @brief   Header for p2p_stm.c module
  ******************************************************************************
  * @attention
 *
 * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
 * All rights reserved.</center></h2>
 *
 * This software component is licensed by ST under Ultimate Liberty license
 * SLA0044, the "License"; You may not use this file except in compliance with
 * the License. You may obtain a copy of the License at:
 *                             www.st.com/SLA0044
 *
 ******************************************************************************
 */


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __NUS_STM_H
#define __NUS_STM_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/


/* Exported types ------------------------------------------------------------*/
typedef enum
{
  NUS_STM__NOTIFY_ENABLED_EVT,
  NUS_STM_NOTIFY_DISABLED_EVT,
  NUS_STM_READ_EVT,
  NUS_STM_WRITE_EVT,
  NUS_STM_BOOT_REQUEST_EVT,
} NUS_STM_Opcode_evt_t;

typedef struct
{
  uint8_t * pPayload;
  uint8_t     Length;
}NUS_STM_Data_t;

typedef struct
{
  NUS_STM_Opcode_evt_t      P2P_Evt_Opcode;
  NUS_STM_Data_t            DataTransfered;
  uint16_t                  ConnectionHandle;
  uint8_t                   ServiceInstance;
}NUS_STM_App_Notification_evt_t;

/* Exported constants --------------------------------------------------------*/
#ifndef BLE_NUS_MAX_DATA_LEN
#define OPCODE_LENGTH        1
#define HANDLE_LENGTH        2

#define BLE_NUS_MAX_DATA_LEN (CFG_BLE_MAX_ATT_MTU - OPCODE_LENGTH - HANDLE_LENGTH)
#endif

/* External variables --------------------------------------------------------*/
/* Exported macros -----------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
#if 0
void P2PS_STM_Init( void );
#endif
void Nus_STM_App_Notification(NUS_STM_App_Notification_evt_t *pNotification);
tBleStatus Nus_STM_App_Update_Char(uint16_t UUID,  uint8_t *pPayload, uint16_t len);


#ifdef __cplusplus
}
#endif

#endif /*__NUS_STM_H */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
