/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2018 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: BLECharacteristic.h 001 2018-10-23 17:48:50Z roi $
 */

/*
The MIT License (MIT)

Copyright (c) 2014 Sandeep Mistry

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef _BLE_CHARACTERISTIC_H_
#define _BLE_CHARACTERISTIC_H_

#ifdef __cplusplus
 extern "C" {
#endif

#include "BLEAttribute.h"

enum BLECharacteristicEvent {
	BLEWritten = 0,
	BLESubscribed = 1,
	BLEUnsubscribed = 2
};

typedef struct _BLECharacteristic BLECharacteristic;
typedef void (*BLECharacteristicEventHandler)(BLECentral* central, BLECharacteristic *pcharc);

struct _BLECharacteristic{
	BLEAttribute          _attr;
	unsigned char         _properties;
	unsigned char         _valueSize;
	unsigned char*        _value;
	unsigned char         _valueLength;
	bool_t                _fixedLength;

	bool_t                _notify;
	bool_t                _written;
	bool_t                _subscribed;

	void*                 _pblePeripheral;
	bool_t (*characteristicValueChanged)(nRF8001* nRF8001, BLECharacteristic *pcharc);
	bool_t (*canNotifyCharacteristic)(nRF8001* nRF8001, BLECharacteristic *pcharc);
	bool_t (*canIndicateCharacteristic)(nRF8001* nRF8001, BLECharacteristic *pcharc);

	BLECharacteristicEventHandler  _eventHandlers[3];
};

#define BLECharacteristic_getproperties(c)   (c)->_properties
#define BLECharacteristic_getvalueSize(c)    (c)->_valueSize
#define BLECharacteristic_getvalue(c)        (c)->_value
#define BLECharacteristic_getvalueLength(c)  (c)->_valueLength
#define BLECharacteristic_getfixedLength(c)  (c)->_fixedLength
#define BLECharacteristic_getsubscribed(c)   (c)->_subscribed


extern void BLEService_setup(BLEService* pserv, const char *uuid);
extern void BLECharacteristic_setup(BLECharacteristic* pcharc, const char *uuid, unsigned char properties, unsigned char *value, unsigned char len);
extern bool_t BLECharacteristic_setValue1(BLECharacteristic *pcharc, const unsigned char value[], unsigned char length);
extern bool_t BLECharacteristic_setValue2(BLECharacteristic *pcharc, const char* value);
extern bool_t BLECharacteristic_notified(BLECharacteristic *pcharc);
extern bool_t BLECharacteristic_written(BLECharacteristic *pcharc);
extern void BLECharacteristic_setValue(BLECharacteristic *pcharc, BLECentral* central, const unsigned char value[], unsigned char length);
extern void BLECharacteristic_setSubscribed(BLECharacteristic *pcharc, BLECentral* central, bool_t subscribed);
extern bool_t BLECharacteristic_canNotify(BLECharacteristic *pcharc);
extern bool_t BLECharacteristic_canIndicate(BLECharacteristic *pcharc);
extern void BLECharacteristic_setEventHandler(BLECharacteristic *pcharc, uint8_t event, void *eventHandler);

#ifdef __cplusplus
}
#endif

#endif	/* _BLE_CHARACTERISTIC_H_ */
