/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2003-2015 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2017-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: monitor.h,v 2.1 2019/01/11 21:34:17 roi Exp $
 */

#ifndef _MONITOR_H_
#define	_MONITOR_H_

#ifdef __cplusplus
extern "C" {
#endif

/* 
 *  ˥ץץΥإåե
 */
#include <kernel.h>
#include "syssvc/logtask.h"

/*
 *  ͥ٤
 */
#define MONITOR_PRIORITY	4

/*
 *  åȤ˰¸ǽΤ
 */

#ifndef CONSOLE_PORTID
#if defined(LOGTASK_PORTID) && defined(SIO_PORTID)
#define	CONSOLE_PORTID		LOGTASK_PORTID	/* ʸϤ륷ꥢݡID */
#else  /* LOGTASK_PORTID */
#define	CONSOLE_PORTID		1				/* ʸϤ륷ꥢݡID */
#endif /* LOGTASK_PORTID */
#endif /* TASK_PORTID */

/*
 *  ˥Υ
 */
#if defined(TOPPERS_CORTEX_M0PLUS) || defined(TOPPERS_HIFIVE1)
#define	MONITOR_STACK_SIZE	1536	/* Υå */
#else
#define	MONITOR_STACK_SIZE	2046	/* Υå */
#endif
#define	MAX_COMMAND_LENGTH	80		/* ˥κ祳ޥĹ */
#define	NUM_LOG_DISP		3		/* ɽƥ */
#ifndef MONITOR_PORTID
#define MONITOR_PORTID      CONSOLE_PORTID
#endif

/*
 *  С
 */
#define	TMONITOR_PRVER	0x1020		/* ͥΥСֹ */

/*
 *  Ƥ
 */
#define	KEY_BS			(8)			/* Хåڡ */
#define	KEY_DEL			(127)		/*  */
#define KEY_NL			(10)		/* 1 */
#define	KEY_CR			(13)		/* 2 */
#define	KEY_EXT			(1)			/* λ */

/*
 *  ǡ
 */
#define	DATA_BYTE		1			/* ХȥǡʣХȡ*/
#define	DATA_HALF		2			/* ϡեǡʣХȡ*/
#define	DATA_WORD		4			/* ɥǡʣХȡ*/

/*
 *  ΰ°
 */
#define	NONE_AREA		0			/* ΰγƤΤʤΰ */
#define	PORT_AREA		1			/* ϡɥΥݡΰ */
#define	MEMORY_AREA		2			/* ΰ衡*/

#define	MREAD_ONLY		1			/* ɤ߹ */
#define	MWRITE_ONLY		2			/* 񤭹 */
#define	MREAD_WRITE		(MREAD_ONLY+MWRITE_ONLY)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ޥɥǥѥåѤι¤
 */
typedef struct _COMMAND_INFO {
	const char   *command;			/* ޥʸ */
	int_t        (*func)(int argc, char **argv);	/* ¹Դؿ */
} COMMAND_INFO;

typedef struct _COMMAND_LINK COMMAND_LINK;
struct _COMMAND_LINK {
	COMMAND_LINK *pcnext;
	int          num_command;
	const char   *command;			/* 祳ޥʸ */
	int_t        (*func)(int argc, char **argv);	/* ¹Դؿ */
	const char   *help;				/* إʸ */
    const COMMAND_INFO *pcinfo;
};

/*
 *  
 */
#define putecho(a)      putchar(a)
#define printecho(a)    printf(a)

/*
 *  ؿΥץȥ
 */

extern bool_t  need_monitor(void);
extern void	   monitor(intptr_t exinf);
extern int     setup_command(COMMAND_LINK *pcmd);
extern bool_t  monitor_break(void);
extern bool_t  compare_word(const char *s, char *d, int_t mode);
extern char    getMemoryType(ulong_t address, int_t mode);
extern int_t   MemoryRead(ulong_t address, intptr_t p, int_t type);
extern int_t   MemoryWrite(ulong_t address, intptr_t p, int_t type);
extern ulong_t MonAlignAddress(ulong_t address);
extern int_t   MemoryRead(ulong_t address, intptr_t p, int_t type);
extern int_t   MemoryWrite(ulong_t address, intptr_t p, int_t type);
extern ulong_t get_exception_pc(void * p_excinf);
extern void    display_registers(ID tskid);
extern ulong_t display_assembler(ulong_t pc);

/*
 *  Υ饯Ƚ
 */
Inline bool_t
test_next_char(char c)
{
	if(c == ' ' || c == '\t')
		return true;
	else
		return false;
}

/*
 *  ʸ󤫤Ф
 *  ͤFALSEʤ̤ͤǤ뤳Ȥ򼨤
 */
Inline bool_t
get_value(char *s, ulong_t *v, int_t card)
{
	char c;
	int  no = 0;

	*v = 0;
	if(s[no] == 0)
		return false;
	else if(s[no] == ' ' || s[no] == '\t'
               || s[no] == ',' || s[no] == '.'){
		no++;
		return false;
	}
	else{
		while(s[no]){
			c = s[no];
			no++;
			if(c >= '0' && c <= '9')
				c -= '0';
			else if(c >= 'A' && c <= 'Z')
				c -= 'A' - 10;
			else if(c >= 'a' && c <= 'z')
				c -= 'a' - 10;
			else
				break;
			*v = *v * card + c;
		}
		return true;
	}
}

#endif /* TOPPERS_MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif /* _MONITOR_H_ */

