/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: spi.h 698 2019-04-22 17:53:42Z roi $
 */
/*
 * 
 *  FE310 SPIfoCXhCo̊O錾
 *
 */

#ifndef _SPI_H_
#define _SPI_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  SPI|[g`
 */
#define SPI1_PORTID             1	/* SPI1͎gps */
#define SPI2_PORTID             2
#define SPI3_PORTID             3
#define NUM_SPIPORT             3

/*
 *  SPIԒ`
 */
#define SPI_STATUS_RESET        0x00	/* SPIgp */
#define SPI_STATUS_READY        0x01	/* SPIfB */
#define SPI_STATUS_ERROR        0x02	/* SPIG[ */
#define SPI_STATUS_BUSY         0x04	/* SPI */

/*
 *  SPIG[`
 */
#define SPI_ERROR_NONE          0x00000000	/* No error */
#define SPI_ERROR_TIMEOUT       0x00000020

/*
 *  SPI][h
 */
#define SPI_XMODE_TX            0x00000000	/* M[h */
#define SPI_XMODE_RX            0x00000001	/* M[h */
#define SPI_XMODE_TXRX          0x00000002	/* M[h */

/*
 *  SPI]NbNɐ`
 */
#define SPI_POLARITY_LOW        0x00000000
#define SPI_POLARITY_HIGH       SPI_SCK_POL

/*
 *  SPINbNʑ`
 */
#define SPI_PHASE_1EDGE         0x00000000
#define SPI_PHASE_2EDGE         SPI_SCK_PHA

/*
 *  SPI MSB/LSB`
 */
#define SPI_DATA_MSB            SPI_FMT_ENDIAN_MSB
#define SPI_DATA_LSB            SPI_FMT_ENDIAN_LSB

/*
 *  SPI CS[h`
 */
#define SPI_CSM_AUTO            SPI_CSMODE_AUTO
#define SPI_CSM_HOLD            SPI_CSMODE_HOLD
#define SPI_CSM_OFF             SPI_CSMODE_OFF

/*
 *  SPICݒ
 */
#define SPI_DIRECTION_2LINES    ((uint32_t)0x00000000)
#define SPI_DIRECTION_1LINE     SPI_FMT_DIR_TX

/*
 *  SPIvgRݒ
 */
#define SPI_PROTOCOL_4LINES     SPI_PROTO_Q
#define SPI_PROTOCOL_2LINES     SPI_PROTO_D
#define SPI_PROTOCOL_1LINE      SPI_PROTO_S


/*
 *  SPIn[hEFAݒ\
 */

typedef struct _SPI_PortControlBlock{
	uint32_t              base;
	uint32_t              giobase;
	uint32_t              gpio1pin;
	uint32_t              gpio2pin;
	uint32_t              gpio3pin;
} SPI_PortControlBlock;

/*
 *  SPI ݒ菉ݒ\
 */
typedef struct
{
	uint32_t              Direction;		/* SPI] */
    uint32_t              DataSize;			/* SPI]f[^TCY */
	uint32_t              CLKPolarity;		/* SPI]NbN̋ɐ */
	uint32_t              CLKPhase;			/* SPINbNʑ */
	uint32_t              CSMode;
	uint32_t              Protocol;
	uint8_t               SCKDelay;			/* SPI CS to SCK delay */
	uint8_t               CSDelay;			/* SPI SCK to CS delay */
	uint8_t               MinScInActTime;	/* SPI Minimum CS Inactive time */
	uint8_t               MaxifTime;		/* SPI Maximum interface delay */
	uint32_t              Prescaler;		/* SPINbNݒ */
	uint32_t              SignBit;			/* SPI MSB/LSBݒ */
	int                   semid;			/* SPI ʐMpZ}tHl */
	int                   semlock;			/* SPI bNZ}tHl */
}SPI_Init_t;

/*
 *  SPInh
 */
typedef struct _SPI_Handle_t SPI_Handle_t;
struct _SPI_Handle_t
{
	uint32_t              base;				/* SPI registers base address */
	SPI_Init_t            Init;				/* SPI communication parameters */
	ID                    port;				/* SPI port ID */
	uint8_t               *pTxBuffPtr;		/* Pointer to SPI Tx transfer Buffer */
	uint16_t              TxXferSize;		/* SPI Tx transfer size */
	uint16_t              TxXferCount;		/* SPI Tx Transfer Counter */
	uint8_t               *pRxBuffPtr;		/* Pointer to SPI Rx transfer Buffer */
	uint16_t              RxXferSize;		/* SPI Rx transfer size */
	uint16_t              RxXferCount;		/* SPI Rx Transfer Counter */
	uint32_t              xmode;
	void                  (*xfercallback)(SPI_Handle_t * hspi);	/* ]IR[obN֐ */
	volatile uint32_t     status;			/* SPI communication state */
	volatile uint32_t     ErrorCode;		/* SPI Error code */
};



extern SPI_Handle_t *spi_init(ID port, SPI_Init_t *spii);
extern ER spi_deinit(SPI_Handle_t *hspi);
extern ER spi_reset(SPI_Handle_t *hspi);
extern ER spi_transmit(SPI_Handle_t *hspi, uint8_t *pdata, uint16_t length);
extern ER spi_receive(SPI_Handle_t *hspi, uint8_t *pdata, uint16_t length);
extern ER spi_transrecv(SPI_Handle_t *hspi, uint8_t *ptxData, uint8_t *prxData, uint16_t length);
extern ER spi_wait(SPI_Handle_t *hspi, uint32_t timeout);
extern void spi_handler(SPI_Handle_t *hspi);
extern void spi_isr(intptr_t exinf);

#ifdef __cplusplus
}
#endif

#endif	/* _SPI_H_ */

