/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: adc.h 698 2020-10-29 09:21:18Z roi $
 */
/*
 *
 *  GD32VF103 ADCǥХɥ饤Фγ
 *
 */

#ifndef _ADC_H_
#define _ADC_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  ADCݡ
 */
#define ADC1_PORTID             1
#define ADC2_PORTID             2
#define NUM_ADCPORT             2

/*
 *  ADCåץꥹ(ClockPrescaler)
 */ 
#define ADC_CLOCK_SYNC_PCLK_DIV2        0x00000000
#define ADC_CLOCK_SYNC_PCLK_DIV4        RCU_CFG0_ADCPSC_0
#define ADC_CLOCK_SYNC_PCLK_DIV8        RCU_CFG0_ADCPSC_1
#define ADC_CLOCK_SYNC_PCLK_DIV16       RCU_CFG0_ADCPSC

/*
 *  ADC꥾塼(Resolution)
 */
#define ADC_RESOLUTION_12B              0x00000000
#define ADC_RESOLUTION_10B              ADC_OVSCR_DRES_0
#define ADC_RESOLUTION_8B               ADC_OVSCR_DRES_1
#define ADC_RESOLUTION_6B               ADC_OVSCR_DRES
/*
 *  ADCǡ饤(DataAlign)
 */ 
#define ADC_DATAALIGN_RIGHT             0x00000000
#define ADC_DATAALIGN_LEFT              ADC_CTL1_DAL

/*
 *  ADC󥳥С⡼(ScanConvMode)
 */
#define ADC_SCANMODE_DISABLE            0x00000000
#define ADC_SCANMODE_ENABLE             ADC_CTL0_SM

/*
 *  ADC³⡼(ContinuousConvMode)
 */
#define ADC_CONTINUOUS_DISABLE          0x00000000
#define ADC_CONTINUOUS_ENABLE           ADC_CTL1_CTN

/*
 *  ADC ³⡼(DiscontinuousConvMode)
 */
#define ADC_DISCONTINUOUS_DISABLE       0x00000000
#define ADC_DISCONTINUOUS_ENABLE        ADC_CTL0_DISRC

/*
 *  ADCȥꥬ(ExternalTrigConv)
 */
#define ADC_EXTERNALTRIGCONV_INS_T0_CH0 0x00000000
#define ADC_EXTERNALTRIGCONV_INS_T0_CH1 0x00001000
#define ADC_EXTERNALTRIGCONV_INS_T0_CH2 0x00002000
#define ADC_EXTERNALTRIGCONV_INS_T1_CH1 0x00003000
#define ADC_EXTERNALTRIGCONV_INS_T2_TRG 0x00004000
#define ADC_EXTERNALTRIGCONV_INS_T3_CH3 0x00005000
#define ADC_EXTERNALTRIGCONV_INS_EXT15  0x00006000
#define ADC_EXTERNALTRIGCONV_INS_SWRCST 0x00007000
#define ADC_EXTERNALTRIGCONV_REG_T0_CH0 0x00000000
#define ADC_EXTERNALTRIGCONV_REG_T0_CH1 0x00020000
#define ADC_EXTERNALTRIGCONV_REG_T0_CH2 0x00040000
#define ADC_EXTERNALTRIGCONV_REG_T1_CH1 0x00060000
#define ADC_EXTERNALTRIGCONV_REG_T2_TRG 0x00080000
#define ADC_EXTERNALTRIGCONV_REG_T3_CH3 0x000A0000
#define ADC_EXTERNALTRIGCONV_REG_EXT11  0x000C0000
#define ADC_EXTERNALTRIGCONV_REG_SWRCST 0x000E0000
#define ADC_SOFTWARE_START              0x80000000

/*
 *  ADCȥꥬå()
 */
#define ADC_EXTERNALTRIGCONVEDGE_NONE       0x00000000
#define ADC_EXTERNALTRIGCONVEDGE_REGULAR    ADC_CTL1_ETERC
#define ADC_EXTERNALTRIGCONVEDGE_INSERT     ADC_CTL1_ETEIC

/*
 *  ADCͥ
 */
#define ADC_CHANNEL_0                   0x00000000
#define ADC_CHANNEL_1                   0x00000001
#define ADC_CHANNEL_2                   0x00000002
#define ADC_CHANNEL_3                   0x00000003
#define ADC_CHANNEL_4                   0x00000004
#define ADC_CHANNEL_5                   0x00000005
#define ADC_CHANNEL_6                   0x00000006
#define ADC_CHANNEL_7                   0x00000007
#define ADC_CHANNEL_8                   0x00000008
#define ADC_CHANNEL_9                   0x00000009
#define ADC_CHANNEL_10                  0x0000000A
#define ADC_CHANNEL_11                  0x0000000B
#define ADC_CHANNEL_12                  0x0000000C
#define ADC_CHANNEL_13                  0x0000000D
#define ADC_CHANNEL_14                  0x0000000E
#define ADC_CHANNEL_15                  0x0000000F
#define ADC_CHANNEL_16                  0x00000010
#define ADC_CHANNEL_17                  0x00000011


/*
 *  ADCץ󥰻
 */
#define ADC_SAMPLETIME_15CYCLES         0x00000000
#define ADC_SAMPLETIME_75CYCLES         0x00000001
#define ADC_SAMPLETIME_135CYCLES        0x00000002
#define ADC_SAMPLETIME_285CYCLES        0x00000003
#define ADC_SAMPLETIME_415CYCLES        0x00000004
#define ADC_SAMPLETIME_555CYCLES        0x00000005
#define ADC_SAMPLETIME_715CYCLES        0x00000006
#define ADC_SAMPLETIME_480CYCLES        0x00000007


/*
 *  ADCʥåɥå⡼
 */
#define ADC_ANALOGWATCHDOG_NONE               0x00000000
#define ADC_ANALOGWATCHDOG_SINGLE_REG         (ADC_CTL0_WDSC | ADC_CTL0_RWDEN)
#define ADC_ANALOGWATCHDOG_SINGLE_INJEC       (ADC_CTL0_WDSC | ADC_CTL0_IWDEN)
#define ADC_ANALOGWATCHDOG_SINGLE_REGINJEC    (ADC_CTL0_WDSC | ADC_CTL0_RWDEN | ADC_CTL0_IWDEN)
#define ADC_ANALOGWATCHDOG_ALL_REG            ADC_CTL0_RWDEN
#define ADC_ANALOGWATCHDOG_ALL_INJEC          ADC_CTL0_IWDEN
#define ADC_ANALOGWATCHDOG_ALL_REGINJEC       (ADC_CTL0_RWDEN | ADC_CTL0_IWDEN)

/*
 *  ADCʥåɥåߥ⡼
 */
#define ADC_ANALOGWATCHDOG_ITMODE_DISABLE     0x00000000
#define ADC_ANALOGWATCHDOG_ITMODE_ENABLE      ADC_CTL0_WDEIE

/*
 *  ADCϡɥ깽¤
 */
typedef struct _ADC_PortControlBlock{
	uint32_t              base;
	uint32_t              adcclockbase;
	uint32_t              adcclockbit;
	uint32_t              adcresetbase;
	uint32_t              adcresetbit;
	int32_t               dmachannel;
} ADC_PortControlBlock;

/*
 *  ADCν¤
 */
typedef struct
{
	uint32_t              ClockPrescaler;				/* ADCåץꥹ */
	uint32_t              Resolution;					/* ADCΥ꥾塼 */
	uint32_t              DataAlign;					/* ADC̥ǡ饤 */
	uint32_t              ScanConvMode;					/* ADC󥳥С⡼ */
	uint32_t              ContinuousConvMode;			/* ADC³⡼ */
	uint32_t              NumConversion;				/* ADCС */
	uint32_t              DiscontinuousConvMode;		/* ADC³⡼ */
	uint32_t              NumDiscConversion;			/* ADC³Ѵ */
	uint32_t              ExternalTrigConv;				/* ADCȥꥬ */
	uint32_t              ExternalTrigConvEdge;			/* ADCȥꥬå */
	int32_t               DMAChannel;					/* ADC-DMAͥ */
}ADC_Init_t;

/*
 *  ADCϥɥ鹽¤
 */ 
typedef struct __ADC_Handle_t ADC_Handle_t;
struct __ADC_Handle_t
{
	uint32_t              base;							/* ADC١ɥ쥹 */
	ADC_Init_t            Init;							/* ADCǡ */
	volatile uint32_t     NumCurrentConversionRank;		/* ADCߤΥС */
	DMA_Handle_t          *hdmarx;						/* ADCDMAϥɥؤΥݥ */
	ADC_PortControlBlock  *apcb;						/* ADCѥϡɥΰ */
	void                  (*xfercallback)(ADC_Handle_t * hadc);		/* ADC žλХå */
	void                  (*xferhalfcallback)(ADC_Handle_t * hadc);	/* ADC ȾʬžХå */
	void                  (*outofwincallback)(ADC_Handle_t * hadc);	/* ADC ʥåɥåХå */
	void                  (*errorcallback)(ADC_Handle_t * hadc);	/* ADC 顼Хå */
	volatile uint32_t     status;						/* ADCơ */
	volatile uint32_t     ErrorCode;					/* ADC顼 */
};

/*
 *  ͥ깽¤
 */
typedef struct
{
	uint32_t              Channel;						/* ADCֹͥ */
	uint32_t              Rank;							/* ADCֹ(1-18) */
	uint32_t              SamplingTime;					/* ADCץ󥰻 */
	uint32_t              GpioBase;						/* ADC-GPIO١ɥ쥹 */
	uint32_t              GpioPin;						/* ADC-GPIOԥֹ */
}ADC_ChannelConf_t;

/*
 *  ADCʥåɥå깽¤
 */
typedef struct
{
	uint32_t              WatchdogMode;					/* ADCʥåɥå⡼ */
	uint32_t              HighThreshold;				/* ADCåۡɾ */
	uint32_t              LowThreshold;					/* ADCåۡɲ */
	uint32_t              Channel;						/* ADCбֹͥ */
	uint32_t              ITMode;						/* ADCʥåɥå */
}ADC_AnalogWDGConf_t;

/*
 *  ADCΥơ
 */
#define ADC_STATUS_RESET        0x00    /* ADC ̤Ѿ */
#define ADC_STATUS_READY        0x01    /* ADC ǥ */
#define ADC_STATUS_BUSY         0x02    /* ADC ӥ */
#define ADC_STATUS_EOC          0x10    /* ADC λ */
#define ADC_STATUS_BUSY_EOC     0x12    /* ADC ӥλȯ */ 
#define ADC_STATUS_AWD          0x20    /* ADC ʥåɥåȯ */
#define ADC_STATUS_SMASK        0x0F

/*
 *  ADC顼
 */
#define ADC_ERROR_NONE          0x00	/* No error             */
#define ADC_ERROR_OVR           0x01	/* OVR error            */
#define ADC_ERROR_DMA           0x02	/* DMA transfer error   */


extern ADC_Handle_t *adc_init(ID portid, ADC_Init_t *pini);
extern ER adc_deinit(ADC_Handle_t *hadc);
extern ER adc_start_int(ADC_Handle_t* hadc);
extern ER adc_end_int(ADC_Handle_t* hadc);
extern ER adc_start_dma(ADC_Handle_t* hadc, uint32_t* pdata, uint32_t length);
extern ER adc_end_dma(ADC_Handle_t* hadc);
extern ER adc_setupchannel(ADC_Handle_t* hadc, ADC_ChannelConf_t* sConfig);
extern ER adc_setupwatchdog(ADC_Handle_t* hadc, ADC_AnalogWDGConf_t* AnalogWDGConfig);
extern uint32_t adc_getvalue(ADC_Handle_t* hadc);

extern void adc_handler(ADC_Handle_t* hadc);
extern void adc_int_handler(void);

#ifdef __cplusplus
}
#endif

#endif	/* _ADC_H_ */

