/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: device.h 699 2020-10-30 18:41:24Z roi $
 */
/*
 *  GD32VF103ѥǥХɥ饤Фγ
 */

#ifndef _DEVICE_H_
#define _DEVICE_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  TOPPERS BASE PLATFORM
 */
#define TOPPERS_BASE_PLATFORM_GD32VF103
#define SPI_DRIVER_NOSTART

/*
 *  С
 */
#define	TPLATFORM_PRVER 0x1042		/* ץåȥեΥСֹ */

/*
 * ԥ
 */

#define PINPOSITION0    0
#define PINPOSITION1    1
#define PINPOSITION2    2
#define PINPOSITION3    3
#define PINPOSITION4    4
#define PINPOSITION5    5
#define PINPOSITION6    6
#define PINPOSITION7    7
#define PINPOSITION8    8
#define PINPOSITION9    9
#define PINPOSITION10   10
#define PINPOSITION11   11
#define PINPOSITION12   12
#define PINPOSITION13	13
#define PINPOSITION14	14
#define PINPOSITION15	15

#define GPIO_PIN_0      (1<<PINPOSITION0)
#define GPIO_PIN_1      (1<<PINPOSITION1)
#define GPIO_PIN_2      (1<<PINPOSITION2)
#define GPIO_PIN_3      (1<<PINPOSITION3)
#define GPIO_PIN_4      (1<<PINPOSITION4)
#define GPIO_PIN_5      (1<<PINPOSITION5)
#define GPIO_PIN_6      (1<<PINPOSITION6)
#define GPIO_PIN_7      (1<<PINPOSITION7)
#define GPIO_PIN_8      (1<<PINPOSITION8)
#define GPIO_PIN_9      (1<<PINPOSITION9)
#define GPIO_PIN_10     (1<<PINPOSITION10)
#define GPIO_PIN_11     (1<<PINPOSITION11)
#define GPIO_PIN_12     (1<<PINPOSITION12)
#define GPIO_PIN_13     (1<<PINPOSITION13)
#define GPIO_PIN_14     (1<<PINPOSITION14)
#define GPIO_PIN_15     (1<<PINPOSITION15)

/*
 *  GPIOץåȥץ⡼
 */
#define GPIO_MODE_BC        0x20U
#define GPIO_MODE_BOP       0x40U

/*
 *  GPIO⡼ɥѥ᡼
 */
#define GPIO_MODE_ANALOG    0x00000000U	/* Analog Mode  */
#define GPIO_MODE_AF        0x00000018U	/* Alternate Function Mode(output) */
#define GPIO_MODE_INPUT     0x00000020U	/* Input Floating Mode */
#define GPIO_MODE_OUTPUT    0x00000010U	/* Output Mode */

/*
 *  GPIO-EXTI⡼ɥѥ᡼
 */
#define GPIO_MODE_IT_RISING             0x00110020	/* Interrupt Mode with Rising edge trigger detection */
#define GPIO_MODE_IT_FALLING            0x00210020	/* Interrupt Mode with Falling edge trigger detection */
#define GPIO_MODE_IT_RISING_FALLING     0x00310020	/* Interrupt Mode with Rising/Falling edge trigger detection */
#define GPIO_MODE_EV_RISING             0x00120020	/* Interrupt Mode with Rising edge trigger detection */
#define GPIO_MODE_EV_FALLING            0x00220020	/* Interrupt Mode with Falling edge trigger detection */
#define GPIO_MODE_EV_RISING_FALLING     0x00320020	/* Interrupt Mode with Rising/Falling edge trigger detection */

/*
 *  GPIOȥץåѥ᡼
 */
#define GPIO_OTYPE_PP       0x00000000U
#define GPIO_OTYPE_OD       0x00000004U

/*
 *  GPIOϥԡ
 */
#define GPIO_OSPEED_INPUT   0x00000000U	/* input mode */
#define GPIO_OSPEED_10MHZ   0x00000001U	/* output max speed 10MHz */
#define GPIO_OSPEED_2MHZ    0x00000002U	/* output max speed 2MHz */
#define GPIO_OSPEED_50MHZ   0x00000003U	/* output max speed 50MHz */

/*
 *  GPIOץ륢åץѥ᡼
 */
#define GPIO_NOPULL         0x00000000	/* No Pull-up or Pull-down activation  */
#define GPIO_PULLUP         0x00000001	/* Pull-up activation                  */
#define GPIO_PULLDOWN       0x00000002	/* Pull-down activation                */

/*
 *  GPIO
 */
typedef struct
{
    uint32_t    mode;		/* specifies the operating mode for the selected pins. */
	uint32_t    pull;		/* specifies the Pull-up or Pull-Down */
	uint32_t    otype;		/* output type */
	uint32_t    speed;		/* speed for the selected pins. */
}GPIO_Init_t;

typedef struct {
	uint32_t    base;
	uint32_t    pinmap;
} GPIO_Init_Table;


extern void gpio_setup(uint32_t base, GPIO_Init_t *init, uint32_t pin);


/*
 *  DMAͥID
 */
#define DMA1CH0_ID              (0)
#define DMA1CH1_ID              (1)
#define DMA1CH2_ID              (2)
#define DMA1CH3_ID              (3)
#define DMA1CH4_ID              (4)
#define DMA1CH5_ID              (5)
#define DMA1CH6_ID              (6)
#define DMA2CH0_ID              (7+0)
#define DMA2CH1_ID              (7+1)
#define DMA2CH2_ID              (7+2)
#define DMA2CH3_ID              (7+3)
#define DMA2CH4_ID              (7+4)

/*
 *  DMAơ
 */
#define DMA_STATUS_BUSY         0x00000001	/* BUSY */
#define DMA_STATUS_READY_HMEM0  0x00000002	/* DMA Mem0 Half process success */
#define DMA_STATUS_READY_HMEM1  0x00000004	/* DMA Mem1 Half process success */
#define DMA_STATUS_READY_MEM0   0x00000008	/* DMA Mem0 process success      */
#define DMA_STATUS_READY_ERROR  0x00000100	/* DMA Error end */

/*
 *  DMA顼
 */ 
#define DMA_ERROR_NONE          0x00000000	/* No error */
#define DMA_ERROR_TE            0x00000001	/* Transfer error */
#define DMA_ERROR_FE            0x00000002	/* FIFO error */
#define DMA_ERROR_DME           0x00000004	/* Direct Mode error */
#define DMA_ERROR_TIMEOUT       0x00000020	/* Timeout error */

/*
 *  DMAž
 */
#define DMA_PERIPH_TO_MEMORY    0x00000000		/* Peripheral to memory direction */
#define DMA_MEMORY_TO_PERIPH    DMA_CHXCTL_DIR	/* Memory to peripheral direction */
#define DMA_MEMORY_TO_MEMORY    DMA_CHXCTL_M2M	/* Memory to memory direction     */

/*
 *  DMAڥեå⡼
 */
#define DMA_PINC_ENABLE         DMA_CHXCTL_PNAGA /* Peripheral increment mode enable  */
#define DMA_PINC_DISABLE        0x00000000		 /* Peripheral increment mode disable */

/*
 *  DMAå⡼
 */ 
#define DMA_MINC_ENABLE         DMA_CHXCTL_MNAGA /* Memory increment mode enable  */
#define DMA_MINC_DISABLE        0x00000000		 /* Memory increment mode disable */

/*
 *  DMAڥե롦ǡ
 */
#define DMA_PDATAALIGN_BYTE     0x00000000			/* Peripheral data alignment: Byte */
#define DMA_PDATAALIGN_HALFWORD DMA_CHXCTL_PWIDTH_0	/* Peripheral data alignment: HalfWord */
#define DMA_PDATAALIGN_WORD     DMA_CHXCTL_PWIDTH_1	/* Peripheral data alignment: Word */

/*
 *  DMAꡦǡ
 */
#define DMA_MDATAALIGN_BYTE     0x00000000			/* Memory data alignment: Byte */
#define DMA_MDATAALIGN_HALFWORD DMA_CHXCTL_MWIDTH_0	/* Memory data alignment: HalfWord */
#define DMA_MDATAALIGN_WORD     DMA_CHXCTL_MWIDTH_1	/* Memory data alignment: Word */

/*
 *  DMA⡼
 */
#define DMA_NORMAL              0x00000000			/* Normal mode */
#define DMA_CIRCULAR            DMA_CHXCTL_CMEN		/* Circular mode */

/*
 *  DMAͥ٥٥
 */
#define DMA_PRIORITY_LOW        0x00000000			/* Priority level: Low */
#define DMA_PRIORITY_MEDIUM     DMA_CHXCTL_PRIO_0	/* Priority level: Medium */
#define DMA_PRIORITY_HIGH       DMA_CHXCTL_PRIO_1	/* Priority level: High */
#define DMA_PRIORITY_VERY_HIGH  DMA_CHXCTL_PRIO		/* Priority level: Very High */

/*
 *  DMA¤
 */
typedef struct
{
	uint32_t              Direction;	/* Specifies if the data will be transferred from memory to peripheral */
	uint32_t              PeriphInc;	/* Specifies whether the Peripheral address register should be incremented or not. */
	uint32_t              MemInc;		/* Specifies whether the memory address register should be incremented or not. */
	uint32_t              PeriphDataAlignment;	/* Specifies the Peripheral data width. */
	uint32_t              MemDataAlignment;		/* Specifies the Memory data width. */
	uint32_t              Mode;			/* Specifies the operation mode of the DMAy Streamx. */
	uint32_t              Priority;		/* Specifies the software priority for the DMAy Streamx. */
}DMA_Init_t;

/*
 *  DMAϥɥ鹽¤
 */
typedef struct __DMA_Handle_t DMA_Handle_t;
struct __DMA_Handle_t
{
	uint32_t              base;			/* DMA base address */
	uint32_t              cbase;		/* DMA channel base address */
	DMA_Init_t            Init;			/* DMA communication parameters */
	uint16_t              chid;			/* channel dma id */
	uint16_t              chid2;		/* channel dma id2 */
	volatile uint32_t     status;		/* DMA status */
	void                  (*xfercallback)(DMA_Handle_t * hdma);		/* DMA transfer complete callback */
	void                  (*xferhalfcallback)(DMA_Handle_t * hdma);	/* DMA Half transfer complete callback */
	void                  (*errorcallback)(DMA_Handle_t * hdma);	/* DMA transfer error callback */
	volatile uint32_t     ErrorCode;	/* DMA Error code */
	void                  *localdata;	/* DMA local data */
};

extern ER dma_init(DMA_Handle_t *hdma);
extern ER dma_deinit(DMA_Handle_t *hdma);
extern ER dma_start(DMA_Handle_t *hdma, uint32_t SrcAddress, uint32_t DstAddress, uint32_t DataLength);
extern ER dma_end(DMA_Handle_t *hdma);
extern uintptr_t dma_channel_base(int32_t chid);
extern void dma_inthandler(DMA_Handle_t *hdma);
extern void channel_dma_isr(intptr_t exinf);


/*
 *  WINDOW-WDOGɥ饤
 */
#define WDOG1_PORTID        1
#define NUM_WDOGPORT        1

/*
 *  WINDOW-WDOG
 */
#define INHNO_WWDG  IRQ_VECTOR_WWDGT	/* ߥϥɥֹ */
#define INTNO_WWDG  IRQ_VECTOR_WWDGT	/* ֹ */
#define INTPRI_WWDG -1          /* ͥ */
#define INTATR_WWDG TA_EDGE     /* ° */

#define WWDGT_CFG_PSC_DIV1  0x0000			/* the time base of WWDGT = (PCLK1/4096)/1 */
#define WWDGT_CFG_PSC_DIV2  WWDGT_CFG_PSC_0	/* the time base of WWDGT = (PCLK1/4096)/2 */
#define WWDGT_CFG_PSC_DIV4  WWDGT_CFG_PSC_1	/* the time base of WWDGT = (PCLK1/4096)/4 */
#define WWDGT_CFG_PSC_DIV8  WWDGT_CFG_PSC	/* the time base of WWDGT = (PCLK1/4096)/8 */

typedef struct __WDOG_Init_t
{
	uint8_t               Window;			/* WDOG Window 0x00-0x7F */
	uint8_t               Counter;			/* WDOG 󥫥 0x00-0x7F */
	uint16_t              MCounter;			/* WDOG More Counter */
	uint32_t              PreScaler;		/* WDOG ץ쥹顼 */
} WDOG_Init_t;

extern ER wdog_init(ID portid, WDOG_Init_t *hwini);
extern ER wdog_deinit(ID portid);
extern ER wdog_reset(ID portod);
extern void wdog_handler(void);


/*
 *  Ѥι¤Τ
 */
struct tm2 {
  int	tm_sec;			/*  */
  int	tm_min;			/* ʬ */
  int	tm_hour;		/*  */
  int	tm_mday;		/*  */
  int	tm_mon;			/*  */
  int	tm_year;		/* ǯ */
  int	tm_wday;		/*  */
  int	tm_yday;		/* ǯ */
  int	tm_isdst;
};

extern void rtc_init(intptr_t exinf);
extern ER rtc_set_time(struct tm2 *ptm);
extern ER rtc_get_time(struct tm2 *ptm);
extern ER rtc_setalarm(struct tm2 *ptm, void *func);
extern void rtc_handler(void);

/*
 *  USBΥ
 */
#define ENABLE_FS_BASE1 (TADR_RCU_BASE+TOFF_RCU_APB2EN)
#define ENABLE_FS_VAL1  RCU_APB2EN_PAEN
#define ENABLE_FS_BASE2 (TADR_RCU_BASE+TOFF_RCU_APB2EN)
#define ENABLE_FS_VAL2  RCU_APB2EN_AFEN
#define TADR_FS_G1_BASE TADR_GPIOA_BASE
#define FS_DM_PINNO     11
#define FS_DP_PINNO     12


/*
 *  LED³ӥå
 */
#define LED01           (1<<0)
#define LED02           (1<<1)
#define LED03           (1<<2)

#define LED_MASK        (LED01 | LED02 | LED03)

/*
 *  LEDȥåξ֥ޥ
 */
#define ON              1     /* LED䥹åON             */
#define OFF             0     /* LED䥹åOFF            */

/*
 *  DIPSW
 */
#define DSW1             0x01
#define DSW2             0x02
#define DSW3             0x04
#define DSW4             0x08

/*
 *  LED³ݡȽ
 */ 
extern void led_init(intptr_t exinf);

/*
 *  LED³ݡɤ߽Ф
 */
extern uint_t led_in(void);

/*
 *  LED³ݡȽ񤭹
 */ 
extern void led_out(unsigned int led_data);

/*
 *  LEDȥåθꡦɤ߹ߴؿ
 */
extern void set_led_state(unsigned int led, unsigned char state);

#define NUM_EXTI_FUNC   16

extern void (*exti_func[NUM_EXTI_FUNC])(intptr_t exinf);


#define INHNO_EXTI3     IRQ_VECTOR_EXTI3	/* ߥϥɥֹ */
#define INTNO_EXTI3     IRQ_VECTOR_EXTI3	/* ֹ */
#define INTPRI_EXTI3    -2			/* ͥ */
#define INTATR_EXTI3    0			/* ° */

/*
 *  PSW³ӥå
 */
#define PSW1             0x00000001
#define PSW_MASK         (PSW1)
#define PSW_CHK_INTERVAL 10


/*
 *  PUSHå³ݡȽ
 */
extern void switch_push_init(intptr_t exinf);

/*
 *  PUSHåХåؿ
 */
extern void setup_sw_func(intptr_t exinf);

/*
 *  PUSHåӥ
 */
extern void exti3_handler(void);


/*
 *  DIPSWμФ
 */
uint_t switch_dip_sense(void);


extern void device_info_init(intptr_t exinf);

extern uint_t dipsw_value;

#ifdef __cplusplus
}
#endif

#endif

