/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: spi.c 698 2020-10-21 13:38:18Z roi $
 */
/*
 *
 *  GD32VF103 SPIɥ饤дؿ
 *  ()2LINESDMAѤȡ٤ˡ
 *        1LINEDMAѤȡ٤˥ϥ󥰥åפ礬롥
 *
 */
#include "kernel_impl.h"
#include <t_syslog.h>
#include <t_stdlib.h>
#include <string.h>
#include <target_syssvc.h>
#include "device.h"
#include "spi.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))


/*
 *  SPIOݡID֥åФΥޥ
 */
#define INDEX_SPI(spiid)        ((uint_t)((spiid) - 1))


#define SPI_TIMEOUT_VALUE  (10*1000)

static const SPI_PortControlBlock spi_pcb[NUM_SPIPORT] = {
  {	TADR_SPI0_BASE,
	(TADR_RCU_BASE+TOFF_RCU_APB2EN), RCU_APB2EN_AFEN, RCU_APB2EN_PAEN,
	(TADR_RCU_BASE+TOFF_RCU_APB2EN), RCU_APB2EN_SPI0EN,
	(TADR_RCU_BASE+TOFF_RCU_APB2RST), RCU_APB2RST_SPI0RST,
	TADR_GPIOA_BASE, TADR_GPIOA_BASE, TADR_GPIOA_BASE,
	5, 6, 7, 4,
	DMA1CH2_ID, DMA1CH1_ID },

  {	TADR_SPI1_BASE,
	(TADR_RCU_BASE+TOFF_RCU_APB2EN), RCU_APB2EN_AFEN, RCU_APB2EN_PBEN,
	(TADR_RCU_BASE+TOFF_RCU_APB1EN), RCU_APB1EN_SPI1EN,
	(TADR_RCU_BASE+TOFF_RCU_APB1RST), RCU_APB1RST_SPI1RST,
	TADR_GPIOB_BASE, TADR_GPIOB_BASE, TADR_GPIOB_BASE,
	13, 14, 15, -1,
	DMA1CH4_ID, DMA1CH3_ID },

  {	TADR_SPI2_BASE,
	(TADR_RCU_BASE+TOFF_RCU_APB2EN), RCU_APB2EN_AFEN, RCU_APB2EN_PBEN,
	(TADR_RCU_BASE+TOFF_RCU_APB1EN), RCU_APB1EN_SPI2EN,
	(TADR_RCU_BASE+TOFF_RCU_APB1RST), RCU_APB1RST_SPI2RST,
	TADR_GPIOB_BASE, TADR_GPIOB_BASE, TADR_GPIOB_BASE,
	3, 4, 5, 15,
	DMA2CH1_ID, DMA2CH0_ID }
};

static SPI_Handle_t SpiHandle[NUM_SPIPORT];
static DMA_Handle_t hdma_tx[NUM_SPIPORT];
static DMA_Handle_t hdma_rx[NUM_SPIPORT];


/*
 *  SPIѲԤؿ
 *  parameter1  hspi: SPIϥɥؤΥݥ
 *  parameter2  Flag: åԤSPIե饰
 *  parameter3  Status: Ԥ
 *  parameter4  Timeout: ॢȻ(ޥ)
 *  return ER
 */
static ER
spi_waitflag(SPI_Handle_t *hspi, uint32_t Flag, bool_t Status, uint32_t Timeout)
{
	uint32_t tick = 0;

	while(((sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_STAT)) & Flag) == Flag) == Status){
		if(Timeout == 0 || tick > Timeout){
			/*
			 *  ȥ顼ե饰ꥻå
			 */
			sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), (SPI_CTL1_TBEIE | SPI_CTL1_RBNEIE | SPI_CTL1_ERRIE));

			/*
			 *  SPI
			 */
			sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_SPIEN);

			/*
			 *  CRC黻̵
			 */
			if(hspi->Init.CRC == SPI_CRC_ENABLE){
				sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_CRCEN);
				sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_CRCEN);
			}

			hspi->status= SPI_STATUS_READY;
			return E_TMOUT;
		}
		tick++;
		sil_dly_nse(1000);
	}
	return E_OK;
}

/*
 *  SPI DMAХåؿ
 */
static void
spi_dmatransmit_func(DMA_Handle_t *hdma)
{
	SPI_Handle_t* hspi = (SPI_Handle_t*)hdma->localdata;

	/*
	 *  TXEե饰åԤ
	 */
	if(spi_waitflag(hspi, SPI_STAT_TBE, false, SPI_TIMEOUT_VALUE) != E_OK){
		hspi->ErrorCode |= SPI_ERROR_TIMEOUT;
	}

	/*
	 *  TX DMA
	 */
	sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMATEN);

	hspi->status = SPI_STATUS_READY;
	hspi->TxXferCount += hspi->TxXferSize;

	if(hspi->Init.semid != 0)
		isig_sem(hspi->Init.semid);
}

/*
 *  SPI DMAХåؿ
 */
static void
spi_dmareceive_func(DMA_Handle_t *hdma)
{
	SPI_Handle_t *hspi = (SPI_Handle_t *)hdma->localdata;
	volatile uint32_t tmp;

	/*
	 *  RX DMA
	 */
	sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMAREN);

	/*
	 *  TX DMA
	 */
	sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMATEN);

	/*
	 *  CRC黻
	 */
	if(hspi->Init.CRC == SPI_CRC_ENABLE){
		/*
		 *  λԤ
		 */
		if(spi_waitflag(hspi, SPI_STAT_RBNE, false, SPI_TIMEOUT_VALUE) != E_OK){
			hspi->ErrorCode |= SPI_ERROR_TIMEOUT;
		}

		/*
		 *  CRCɤ߼Τ
		 */
		tmp = sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_DATA));
		((void)(tmp));

		/*
		 *  RXNEꥻåԤ
		 */
		if(spi_waitflag(hspi, SPI_STAT_RBNE, true, SPI_TIMEOUT_VALUE) != E_OK){
			hspi->ErrorCode |= SPI_ERROR_TIMEOUT;
		}
	}

	if((hspi->Init.Mode == SPI_MODE_MASTER) &&
		(hspi->Init.Direction == SPI_DIRECTION_1LINE || hspi->Init.Direction == SPI_DIRECTION_2LINES_RXONLY)){
		/*
		 *  SPI
		 */
		sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_SPIEN);
	}
	hspi->status = SPI_STATUS_READY;
	hspi->RxXferCount += hspi->RxXferSize;

	if(hspi->Init.semid != 0)
		isig_sem(hspi->Init.semid);
}

/*
 *  SPI DMAХåؿ
 */
static void
spi_dmatransrecv_func(DMA_Handle_t *hdma)
{
	SPI_Handle_t *hspi = (SPI_Handle_t *)hdma->localdata;
	volatile uint32_t tmp;

	/*
	 *  CRC黻
	 */
	if(hspi->Init.CRC == SPI_CRC_ENABLE){
		/*
		 *  λԤ
		 */
		if(spi_waitflag(hspi, SPI_STAT_RBNE, false, SPI_TIMEOUT_VALUE) != E_OK){
			hspi->ErrorCode |= SPI_ERROR_TIMEOUT;
		}
		/*
		 *  CRCɤ߼Τ
		 */
 		tmp = sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_DATA));
		((void)(tmp));
	}

	/*
	 *  TXEե饰åԤ
	 */
	if(spi_waitflag(hspi, SPI_STAT_TBE, false, SPI_TIMEOUT_VALUE) != E_OK){
		hspi->ErrorCode |= SPI_ERROR_TIMEOUT;
	}

	/*
	 *  TX DMA
	 */
	sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMATEN);

	/*
	 *  SPI BUSYλԤ
	 *  SPIưǧSTAT쥸λȤǤʤᡢ10usθԤȤ
	 */
	sil_dly_nse(100*1000);

	/*
	 *  RX DMA
	 */
	sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMAREN);

	hspi->status = SPI_STATUS_READY;
	hspi->TxXferCount += hspi->TxXferSize;
	hspi->RxXferCount += hspi->RxXferSize;

	if(hspi->Init.semid != 0)
		isig_sem(hspi->Init.semid);
}

/*
 *  SPI DMA顼Хåؿ
 */
static
void spi_dmaerror_func(DMA_Handle_t *hdma)
{
	SPI_Handle_t *hspi = (SPI_Handle_t *)hdma->localdata;

	hspi->TxXferCount = 0;
	hspi->RxXferCount = 0;
	hspi->status= SPI_STATUS_READY;
	hspi->ErrorCode |= SPI_ERROR_DMA;
	syslog_2(LOG_ERROR, "SPI DMA Error handle[%08x] ErrorCode[%08x] !", hdma, hdma->ErrorCode);
	sil_dly_nse(1000*500);	/* 顼ϥ󥰥åײ0.5msecԤ */
}


/*
 *  SPIžλԤ
 */
ER
spi_inwait(SPI_Handle_t *hspi, uint32_t timeout)
{
	ER ercd = E_OK;
	int tick = timeout;

	while((hspi->status & SPI_STATUS_BUSY) != 0 && tick > 0){
		if(hspi->Init.semid != 0){
	 		ercd = twai_sem(hspi->Init.semid, 50);
		}
		else
			dly_tsk(1);
		tick--;
	}
	if(hspi->hdmarx != NULL)
		dma_end(hspi->hdmarx);
	if(hspi->hdmatx != NULL)
		dma_end(hspi->hdmatx);
	if(hspi->ErrorCode != 0)
		ercd = E_OBJ;
	else if(tick == 0){
		hspi->ErrorCode |= SPI_ERROR_TIMEOUT;
		hspi->status     = SPI_STATUS_READY;
		ercd = E_TMOUT;
	}
	return ercd;
}


/*
 *  SPI
 *  parameter1  port: SPIݡֹ
 *  parameter2  spii: SPI깽¤ΤؤΥݥ
 *  return SPIϥɥؤΥݥ󥿡NULLǥ顼
 */
SPI_Handle_t *
spi_init(ID port, SPI_Init_t *spii)
{
	GPIO_Init_t GPIO_Init_Data;
	SPI_Handle_t *hspi;
	const SPI_PortControlBlock *spcb;
	DMA_Handle_t *hdma;
	uint32_t no;
	volatile uint32_t tmpreg;

	if(port < SPI1_PORTID || port > NUM_SPIPORT)
		return NULL;
	if(spii == NULL)
		return NULL;

	no = INDEX_SPI(port);
	hspi = &SpiHandle[no];
	if(hspi->status != SPI_STATUS_RESET)
		return NULL;
	spcb = &spi_pcb[no];
	memcpy(&hspi->Init, spii, sizeof(SPI_Init_t));
	hspi->base = spcb->base;
	hspi->no   = no;

	if(spii->TxDMAChannel >= 0 && spii->TxDMAChannel != spcb->dmatxrequest)
		return NULL;
	if(spii->RxDMAChannel >= 0 && spii->RxDMAChannel != spcb->dmarxrequest)
		return NULL;
	if(spii->TxDMAChannel >= 0 && spii->RxDMAChannel >= 0){
		syslog_0(LOG_ERROR, "spi_init:2LINES DMA Hang up sametimes !");
		return NULL;
	}

	/*
	 *  SPI å
	 */
	sil_orw_mem((uint32_t *)spcb->gioclockbase, spcb->gioclockbit1);
	tmpreg = sil_rew_mem((uint32_t *)spcb->gioclockbase);
	sil_orw_mem((uint32_t *)spcb->gioclockbase, spcb->gioclockbit2);
	tmpreg = sil_rew_mem((uint32_t *)spcb->gioclockbase);
	sil_orw_mem((uint32_t *)spcb->spiclockbase, spcb->spiclockbit);
	tmpreg = sil_rew_mem((uint32_t *)spcb->spiclockbase);
    ((void)(tmpreg));

	/*
	 *  SPI GPIOԥ
	 */
	GPIO_Init_Data.mode      = GPIO_MODE_AF;
	GPIO_Init_Data.pull      = GPIO_NOPULL;
	GPIO_Init_Data.otype     = GPIO_OTYPE_PP;
	GPIO_Init_Data.speed     = GPIO_OSPEED_50MHZ;
	gpio_setup(spcb->giobase1, &GPIO_Init_Data, spcb->sckpin);
	gpio_setup(spcb->giobase3, &GPIO_Init_Data, spcb->mosipin);

	GPIO_Init_Data.mode      = GPIO_MODE_INPUT;
	GPIO_Init_Data.pull      = GPIO_NOPULL;
	GPIO_Init_Data.otype     = GPIO_OTYPE_OD;
	gpio_setup(spcb->giobase2, &GPIO_Init_Data, spcb->misopin);

	/*
	 *  SPIDMA
	 */
	hdma = &hdma_tx[no];
	if((hdma->cbase = dma_channel_base(spii->TxDMAChannel)) != 0){
		hdma->Init.Direction = DMA_MEMORY_TO_PERIPH;
		hdma->Init.PeriphInc = DMA_PINC_DISABLE;
		hdma->Init.MemInc    = DMA_MINC_ENABLE;
		if(spii->DataSize != SPI_DATASIZE_8BIT){
			hdma->Init.PeriphDataAlignment = DMA_PDATAALIGN_HALFWORD;
			hdma->Init.MemDataAlignment    = DMA_MDATAALIGN_HALFWORD;
		}
		else{
			hdma->Init.PeriphDataAlignment = DMA_PDATAALIGN_BYTE;
			hdma->Init.MemDataAlignment    = DMA_MDATAALIGN_BYTE;
		}
		hdma->Init.Mode      = DMA_NORMAL;
		hdma->Init.Priority  = DMA_PRIORITY_LOW;

		dma_init(hdma);
		hspi->hdmatx         = hdma;
		hdma->localdata      = hspi;
	}
	else
		hspi->hdmatx         = NULL;

	/*
	 *  SPIѼDMA
	 */
	hdma = &hdma_rx[no];
	if((hdma->cbase = dma_channel_base(spii->RxDMAChannel)) != 0){
		hdma->Init.Direction = DMA_PERIPH_TO_MEMORY;
		hdma->Init.PeriphInc = DMA_PINC_DISABLE;
		hdma->Init.MemInc    = DMA_MINC_ENABLE;
		if(spii->DataSize != SPI_DATASIZE_8BIT){
			hdma->Init.PeriphDataAlignment = DMA_PDATAALIGN_HALFWORD;
			hdma->Init.MemDataAlignment    = DMA_MDATAALIGN_HALFWORD;
		}
		else{
			hdma->Init.PeriphDataAlignment = DMA_PDATAALIGN_BYTE;
			hdma->Init.MemDataAlignment    = DMA_MDATAALIGN_BYTE;
		}
		hdma->Init.Mode      = DMA_NORMAL;
		hdma->Init.Priority  = DMA_PRIORITY_HIGH;

		dma_init(hdma);
		hspi->hdmarx         = hdma;
		hdma->localdata      = hspi;
	}
	else
		hspi->hdmarx         = NULL;

	/*
	 *  SPIǥ֥
	 */
	sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_SPIEN);

	/*
	 *  SPI CTL0쥸
	 */
	sil_wrw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), (hspi->Init.Mode | hspi->Init.Direction | \
							hspi->Init.CLKPolarity | hspi->Init.CLKPhase | (hspi->Init.NSS & SPI_CTL0_SWNSSEN) | \
							hspi->Init.Prescaler | hspi->Init.SignBit | hspi->Init.DataSize | hspi->Init.CRC));

	/*
	 *  SPI CTL1쥸
	 */
	sil_modw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), (SPI_CTL1_TMOD | SPI_CTL1_NSSP), \
							((hspi->Init.TIMode | hspi->Init.NSSPMode) & (SPI_CTL1_TMOD | SPI_CTL1_NSSP)));

	hspi->ErrorCode = SPI_ERROR_NONE;
	hspi->status = SPI_STATUS_READY;
	return hspi;
}

/*
 *  SPIλ
 *  parameter1  hspi: SPIϥɥؤΥݥ
 *  return ER
 */
ER
spi_deinit(SPI_Handle_t *hspi)
{
	const SPI_PortControlBlock *spcb;

	if(hspi == NULL)
		return E_PAR;

	if(hspi->hdmatx != NULL){
		dma_deinit(hspi->hdmatx);
		hspi->hdmatx = NULL;
	}
	if(hspi->hdmarx != NULL){
		dma_deinit(hspi->hdmarx);
		hspi->hdmarx = NULL;
	}
	spcb = &spi_pcb[hspi->no];

	sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_SPIEN);

	/*
	 *  SPIꥻå
	 */
	sil_orw_mem((uint32_t *)spcb->spiresetbase, spcb->spiresetbit);
	sil_andw_mem((uint32_t *)spcb->spiresetbase, spcb->spiresetbit);

	hspi->ErrorCode = SPI_ERROR_NONE;
	hspi->status = SPI_STATUS_RESET;
	return E_OK;
}

/*
 *  SPI⥸塼Υꥻå
 *  parameter1  hspi: SPIϥɥؤΥݥ
 *  return ER
 */
ER
spi_reset(SPI_Handle_t *hspi)
{
	const SPI_PortControlBlock *spcb;

	if(hspi == NULL)
		return E_PAR;

	/*
	 *  SPIꥻå
	 */
	spcb = &spi_pcb[hspi->no];
	sil_orw_mem((uint32_t *)spcb->spiresetbase, spcb->spiresetbit);
	sil_andw_mem((uint32_t *)spcb->spiresetbase, spcb->spiresetbit);

	/*
	 *  SPIǥ֥
	 */
	sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_SPIEN);

	/*
	 *  SPI CTL0쥸
	 */
	sil_wrw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), (hspi->Init.Mode | hspi->Init.Direction | \
							hspi->Init.CLKPolarity | hspi->Init.CLKPhase | (hspi->Init.NSS & SPI_CTL0_SWNSSEN) | \
							hspi->Init.Prescaler | hspi->Init.SignBit | hspi->Init.DataSize | hspi->Init.CRC));

	/*
	 *  SPI CTL1쥸
	 */
	sil_modw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), (SPI_CTL1_TMOD | SPI_CTL1_NSSP), \
							((hspi->Init.TIMode | hspi->Init.NSSPMode) & (SPI_CTL1_TMOD | SPI_CTL1_NSSP)));

	hspi->ErrorCode = SPI_ERROR_NONE;
	hspi->status = SPI_STATUS_READY;
	return E_OK;
}

/*
 *  SPI¹Դؿ
 *  parameter1  hspi: SPIϥɥؤΥݥ
 *  parameter2  pdata: ХåեؤΥݥ
 *  parameter3  length: 
 *  return ER
 */
ER
spi_transmit(SPI_Handle_t *hspi, uint8_t *pdata, uint16_t length)
{
	ER ercd = E_OK;

	if(hspi == NULL || pdata == NULL || length == 0)
		return E_PAR;

	if(hspi->Init.semlock != 0)
		wai_sem(hspi->Init.semlock);
	if(hspi->status != SPI_STATUS_READY){
		if(hspi->Init.semlock != 0)
			sig_sem(hspi->Init.semlock);
		return E_OBJ;
	}

	/* Configure communication */
	hspi->xmode       = SPI_XMODE_TX;
	hspi->status      = SPI_STATUS_BUSY;
	hspi->ErrorCode   = SPI_ERROR_NONE;

	hspi->pTxBuffPtr  = pdata;
	hspi->TxXferSize  = length;
	hspi->TxXferCount = 0;
	hspi->RxXferSize  = 0;
	hspi->RxXferCount = 0;

    /*
	 *  1饤̿
	 */
	if(hspi->Init.Direction == SPI_DIRECTION_1LINE){
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_BDOEN);
	}

	/*
	 *  ȥ
	 */
	if(hspi->hdmatx != NULL){	/* DMA⡼ */
		/*
		 *  DMAȥ
		 */
		hspi->hdmatx->xferhalfcallback = NULL;
		hspi->hdmatx->xfercallback = spi_dmatransmit_func;
		hspi->hdmatx->errorcallback = spi_dmaerror_func;

		/*
		 *  DMA
		 */
		dma_start(hspi->hdmatx, (uint32_t)hspi->pTxBuffPtr, (uint32_t)(hspi->base+TOFF_SPI_DATA), hspi->TxXferSize);
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMATEN);
	}
	else{		/* ߥ⡼ */
		if(hspi->Init.Direction != SPI_DIRECTION_1LINE)
			sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_RBNEIE);
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_TBEIE);
	}

	/*  SPIͭ */
	if((sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0)) & SPI_CTL0_SPIEN) == 0)
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_SPIEN);

	/*
	 *  顼
	 */
	sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_ERRIE);

#if SPI_WAIT_TIME != 0
	ercd = spi_inwait(hspi, SPI_WAIT_TIME * length);

	if(hspi->Init.semlock != 0)
		sig_sem(hspi->Init.semlock);
#endif
	return ercd;
}

/*
 *  SPI¹Դؿ
 *  parameter1  hspi: SPIϥɥؤΥݥ
 *  parameter2  pdata: ХåեؤΥݥ
 *  parameter3  length: 
 *  return ER
 */
ER
spi_receive(SPI_Handle_t *hspi, uint8_t *pdata, uint16_t length)
{
	ER ercd = E_OK;

	if(hspi == NULL || pdata == NULL || length == 0)
		return E_PAR;

	if(hspi->Init.semlock != 0)
		wai_sem(hspi->Init.semlock);
	if(hspi->status != SPI_STATUS_READY){
		if(hspi->Init.semlock != 0)
			sig_sem(hspi->Init.semlock);
		return E_OBJ;
	}

    /*
	 *  ž
	 */
	hspi->xmode       = SPI_XMODE_RX;
    hspi->status      = SPI_STATUS_BUSY;
    hspi->ErrorCode   = SPI_ERROR_NONE;
    hspi->pRxBuffPtr  = pdata;
    hspi->RxXferSize  = length;
    hspi->RxXferCount = 0;
    hspi->TxXferSize  = 0;
    hspi->TxXferCount = 0;

    /*
	 *  1饤̿
	 */
    if(hspi->Init.Direction == SPI_DIRECTION_1LINE){
		sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_BDOEN);
    }
    else if(hspi->Init.Direction == SPI_DIRECTION_2LINES){
	    hspi->status = SPI_STATUS_READY;
		if(hspi->Init.semlock != 0)
			sig_sem(hspi->Init.semlock);
		if(hspi->Init.Mode == SPI_MODE_MASTER){
			/*
			 *  Ԥ
			 */
			memset(pdata, 0xff, length);
			return spi_transrecv(hspi, pdata, pdata, length);
		}
		else
			return E_PAR;
    }

	/*
	 *  CRC⡼ɤʤͭ
	 */
    if(hspi->Init.CRC == SPI_CRC_ENABLE){
		sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_CRCEN);
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_CRCEN);
    }

	/*
	 *  ȥ
	 */
	if(hspi->hdmarx != NULL){	/* DMA⡼ */
	    /*
		 *  DMAХåؿ
		 */
		if((hspi->Init.Mode == SPI_MODE_MASTER)
			 && (hspi->Init.Direction == SPI_DIRECTION_1LINE || hspi->Init.Direction == SPI_DIRECTION_2LINES_RXONLY)){
	    	hspi->hdmarx->xfercallback = spi_dmareceive_func;
		}
		else{
			hspi->hdmarx->xfercallback = spi_dmatransrecv_func;
		}
    	hspi->hdmarx->xferhalfcallback = NULL;
    	hspi->hdmarx->errorcallback = spi_dmaerror_func;

		/*
		 *  DMA
		 */
	    dma_start(hspi->hdmarx, (uint32_t)(hspi->base+SPI_DATA_DATA), (uint32_t)hspi->pRxBuffPtr, hspi->RxXferSize);
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMAREN);
	}
	else{		/* ߥ⡼ */
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_RBNEIE);
		if(hspi->Init.Direction == SPI_DIRECTION_2LINES)
			sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_TBEIE);
	}

	/*  SPIͭ */
	if((sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0)) & SPI_CTL0_SPIEN) == 0)
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_SPIEN);

	/*
	 *  顼
	 */
	sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_ERRIE);

#if SPI_WAIT_TIME != 0
	ercd = spi_inwait(hspi, SPI_WAIT_TIME * length);

	if(hspi->Init.semlock != 0)
		sig_sem(hspi->Init.semlock);
#endif
	return ercd;
}

/*
 *  SPI¹Դؿ
 *  parameter1  hspi: SPIϥɥؤΥݥ
 *  parameter2  ptxdata: ХåեؤΥݥ
 *  parameter3  prxdata: ХåեؤΥݥ
 *  parameter4  length: 
 *  return ER
 */
ER
spi_transrecv(SPI_Handle_t *hspi, uint8_t *ptxdata, uint8_t *prxdata, uint16_t length)
{
	ER ercd = E_OK;

	if(hspi == NULL || prxdata == NULL || length == 0)
		return E_PAR;
	if(hspi->Init.Direction != SPI_DIRECTION_2LINES && hspi->Init.Mode != SPI_MODE_MASTER)
		return E_PAR;

	if(hspi->Init.semlock != 0)
		wai_sem(hspi->Init.semlock);
	if(hspi->status != SPI_STATUS_READY){
		if(hspi->Init.semlock != 0)
			sig_sem(hspi->Init.semlock);
		return E_OBJ;
	}

	hspi->xmode = SPI_XMODE_TXRX;
	hspi->status = SPI_STATUS_BUSY;

	/*
	 *  ž
	 */
	hspi->ErrorCode   = SPI_ERROR_NONE;
	hspi->pTxBuffPtr  = (uint8_t*)ptxdata;
	hspi->TxXferSize  = length;
	hspi->TxXferCount = 0;
	hspi->pRxBuffPtr  = (uint8_t*)prxdata;
	hspi->RxXferSize  = length;
	hspi->RxXferCount = 0;

	/*
	 *  CRC⡼ɤʤͭ
	 */
	if(hspi->Init.CRC == SPI_CRC_ENABLE){
		sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_CRCEN);
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_CRCEN);
	}

	/*
	 *  DMAȥ
	 */
	if(hspi->hdmarx != NULL){	/* DMA⡼ */
		/*
		 *  DMAХåؿ
		 */
		if((hspi->Init.Mode == SPI_MODE_MASTER)
			 && (hspi->Init.Direction == SPI_DIRECTION_1LINE || hspi->Init.Direction == SPI_DIRECTION_2LINES_RXONLY)){
			hspi->hdmarx->xfercallback = spi_dmareceive_func;
		}
		else{
			hspi->hdmarx->xfercallback = spi_dmatransrecv_func;
		}
		hspi->hdmarx->xferhalfcallback = NULL;
		hspi->hdmarx->errorcallback = spi_dmaerror_func;

		/*
		 *  DMA
		 */
		dma_start(hspi->hdmarx, (uint32_t)(hspi->base+TOFF_SPI_DATA), (uint32_t)hspi->pRxBuffPtr, hspi->RxXferSize);
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMAREN);
	}
	else		/* ߥ⡼ */
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_RBNEIE);

	/*
	 *  ȥ
	 */
	if(hspi->hdmatx != NULL){	/* DMA⡼ */
		/*
		 *  DMAХå
		 */
		hspi->hdmatx->xfercallback = NULL;
		hspi->hdmatx->errorcallback = spi_dmaerror_func;

		/*
		 *  DMA
		 */
		dma_start(hspi->hdmatx, (uint32_t)hspi->pTxBuffPtr, (uint32_t)(hspi->base+TOFF_SPI_DATA), hspi->TxXferSize);
	}
	else		/* ߥ⡼ */
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_TBEIE);

	/*
	 *  SPI顼
	 */
	sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_ERRIE);

	/*  SPIͭ */
	if((sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0)) & SPI_CTL0_SPIEN) == 0)
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL0), SPI_CTL0_SPIEN);

	/*
	 *  SPIDMA
	 */
	if(hspi->hdmatx != NULL)
		sil_orw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_DMATEN);

#if SPI_WAIT_TIME != 0
	ercd = spi_inwait(hspi, SPI_WAIT_TIME * length);

	if(hspi->Init.semlock != 0)
		sig_sem(hspi->Init.semlock);
#endif
	return ercd;
}

/*
 *  SPIžλԤ
 */
ER
spi_wait(SPI_Handle_t *hspi, uint32_t timeout)
{
	ER ercd = E_OK;

#if SPI_WAIT_TIME == 0
	if(hspi == NULL)
		return E_PAR;
	ercd = spi_inwait(hspi, timeout);
	if(hspi->Init.semlock != 0)
		sig_sem(hspi->Init.semlock);
#endif
	return ercd;
}

/*
 *  SPIߥӥ롼
 */
void
spi_handler(SPI_Handle_t *hspi)
{
	uint32_t ctl1 = sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1));
	uint32_t stat = sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_STAT));
	volatile uint32_t tmp3 = 0;

	/*
	 *  ߥ顼Ƚ
	 */
	if((ctl1 & SPI_CTL1_ERRIE) != 0){
		/*
		 *  SPI CRC顼Ƚ
		 */
		if((stat & SPI_STAT_CRCERR) != 0){
			hspi->ErrorCode |= SPI_ERROR_CRC;
			sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_STAT), SPI_STAT_CRCERR);
		}
		/*
		 *  SPI ե졼󥨥顼Ƚ
		 */
		if((stat & SPI_STAT_CONFERR) != 0){
			hspi->ErrorCode |= SPI_ERROR_CONF;
			sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_STAT), SPI_STAT_CONFERR);
		}
		/*
		 *  SPI СȽ
		 */
		if((stat & SPI_STAT_RXORERR) != 0){
			if(hspi->xmode != SPI_XMODE_TX){
				hspi->ErrorCode |= SPI_ERROR_OVR;
				tmp3 = sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_DATA));
			}
			else	/* ʤ */
	            sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_ERRIE);
			sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_STAT), SPI_STAT_RXORERR);
		}
		/*
		 *  顼ȯϥǥ᤹
		 */
		if(hspi->ErrorCode != SPI_ERROR_NONE){
            sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_ERRIE);
			hspi->status = SPI_STATUS_READY;
			syslog_2(LOG_ERROR, "spi hanndler error[%08x] ErrorCode[%08x] !", hspi, hspi->ErrorCode);
		}
	}

	/*
	 *  NON-DMAȽ
	 */
	if((ctl1 & SPI_CTL1_RBNEIE) != 0 && (stat & SPI_STAT_RBNE) != 0){
		tmp3 = sil_rew_mem((uint32_t *)(hspi->base+TOFF_SPI_DATA));
		if(hspi->RxXferSize == 0){	/* 2LINES TX */
			hspi->RxXferCount++;
			if(hspi->TxXferSize <= hspi->RxXferCount){
				sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_RBNEIE);
				hspi->status= SPI_STATUS_READY;
				if(hspi->Init.semid != 0)
					isig_sem(hspi->Init.semid);
			}
		}
		else{	/* 1LINE RX or 2LINES RX/TX */
			if(hspi->RxXferSize > hspi->RxXferCount)
				hspi->pRxBuffPtr[hspi->RxXferCount++] = (uint8_t)tmp3;
			if(hspi->RxXferSize <= hspi->RxXferCount){
				sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_RBNEIE);
				hspi->status= SPI_STATUS_READY;
				if(hspi->Init.semid != 0)
					isig_sem(hspi->Init.semid);
			}
		}
	}

	/*
	 *  NON-DMAȽ
	 */
	if((ctl1 & SPI_CTL1_TBEIE) != 0 && (stat & SPI_STAT_TBE) != 0){
		if(hspi->TxXferSize == 0){		/* 2LINES RX */
			sil_wrw_mem((uint32_t *)(hspi->base+TOFF_SPI_DATA), 0xFF);
			hspi->TxXferCount++;
			if(hspi->RxXferSize <= hspi->TxXferCount){
				sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_TBEIE);
			}
		}
		else{	/* 1LINE TX or 2LINES RX/TX */
			if(hspi->TxXferSize > hspi->TxXferCount){
				tmp3 = hspi->pTxBuffPtr[hspi->TxXferCount++];
				sil_wrw_mem((uint32_t *)(hspi->base+TOFF_SPI_DATA), tmp3);
			}
			if(hspi->TxXferSize <= hspi->TxXferCount){
				sil_andw_mem((uint32_t *)(hspi->base+TOFF_SPI_CTL1), SPI_CTL1_TBEIE);
				if((ctl1 & SPI_CTL1_RBNEIE) == 0){
					hspi->status= SPI_STATUS_READY;
					if(hspi->Init.semid != 0)
						isig_sem(hspi->Init.semid);
				}
			}
		}
	}
}


/*
 *  SPIߥӥ롼
 */
void spi_isr(intptr_t exinf)
{
 	spi_handler(&SpiHandle[INDEX_SPI((uint32_t)exinf)]);
}

