/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: dvp.h 698 2019-11-28 22:10:08Z roi $
 */
/*
 * 
 *  K210 DVPǥХɥ饤Фγ
 *
 */

#ifndef _DVP_H_
#define _DVP_H_

#include <kernel.h>
#include <target_syssvc.h>

#ifdef __cplusplus
extern "C" {
#endif

#define TADR_DVP_BASE       (DVP_BASE_ADDR)
#define TOFF_DVP_CFG            0x0000	/* (RW) DVP Config Register */
  #define DVP_CFG_START_INT_ENABLE      0x00000001
  #define DVP_CFG_FINISH_INT_ENABLE     0x00000002
  #define DVP_CFG_AI_OUTPUT_ENABLE      0x00000004
  #define DVP_CFG_DISPLAY_OUTPUT_ENABLE 0x00000008
  #define DVP_CFG_AUTO_ENABLE           0x00000010
  #define DVP_CFG_BURST_SIZE_4BEATS     0x00000100
  #define DVP_CFG_FORMAT_MASK           0x00000600
  #define DVP_CFG_RGB_FORMAT            0x00000000
  #define DVP_CFG_YUV_FORMAT            0x00000200
  #define DVP_CFG_Y_FORMAT              0x00000600
  #define DVP_CFG_HREF_BURST_NUM_MASK   0x000FF000
  #define DVP_CFG_LINE_NUM_MASK         0x3FF00000
#define TOFF_DVP_R_ADDR         0x0004	/* (RW) RED ADDRESS */
#define TOFF_DVP_G_ADDR         0x0008	/* (RW) GREEN ADDRESS */
#define TOFF_DVP_B_ADDR         0x000C	/* (RW) BLUE ADDRESS */
#define TOFF_DVP_CMOS_CFG       0x0010	/* (RW) DVP CMOS Config Register */
  #define DVP_CMOS_CLK_DIV_MASK         0x000000FF
  #define DVP_CMOS_CLK_DIV(x)           ((x) << 0)
  #define DVP_CMOS_CLK_ENABLE           0x00000100
  #define DVP_CMOS_RESET                0x00010000
  #define DVP_CMOS_POWER_DOWN           0x01000000
#define TOFF_DVP_SCCB_CFG       0x0014	/* (RW) DVP SCCB Config Register */
  #define DVP_SCCB_BYTE_NUM_MASK        0x00000003
  #define DVP_SCCB_BYTE_NUM_2           0x00000001
  #define DVP_SCCB_BYTE_NUM_3           0x00000002
  #define DVP_SCCB_BYTE_NUM_4           0x00000003
  #define DVP_SCCB_SCL_LCNT_MASK        0x0000FF00
  #define DVP_SCCB_SCL_HCNT_MASK        0x00FF0000
  #define DVP_SCCB_RDATA_BYTE_MASK      0xFF000000
#define TOFF_DVP_SCCB_CTL       0x0018	/* (RW) DVP SCCB Control Register */
  #define DVP_SCCB_WRITE_DATA_ENABLE    0x00000001
  #define DVP_SCCB_DEVICE_ADDRESS       0x000000FF
  #define DVP_SCCB_REG_ADDRESS          0x0000FF00
  #define DVP_SCCB_WDATA_BYTE0          0x00FF0000
  #define DVP_SCCB_WDATA_BYTE1          0xFF000000
#define TOFF_DVP_AXI            0x001C	/* (RW) DVP AXI Register */
  #define DVP_AXI_GM_MLEN_MASK          0x000000FF
  #define DVP_AXI_GM_MLEN_1BYTE         0x00000000
  #define DVP_AXI_GM_MLEN_4BYTE         0x00000003
#define TOFF_DVP_STS            0x0020	/* (RW) DVP STS Register */
  #define DVP_STS_FRAME_START           0x00000001
  #define DVP_STS_FRAME_START_WE        0x00000002
  #define DVP_STS_FRAME_FINISH          0x00000100
  #define DVP_STS_FRAME_FINISH_WE       0x00000200
  #define DVP_STS_DVP_EN                0x00010000
  #define DVP_STS_DVP_EN_WE             0x00020000
  #define DVP_STS_SCCB_EN               0x01000000
  #define DVP_STS_SCCB_EN_WE            0x02000000
#define TOFF_DVP_RGB_ADDR       0x0028	/* (RW) DVP RGB ADDRESS */


/*
 *  BURST⡼
 */
#define DVP_BURST_ENABLE        DVP_CFG_BURST_SIZE_4BEATS
#define DVP_BURST_DISABLE       0

/*
 *  AUTO⡼
 */
#define DVP_AUTOMODE_ENABLE     DVP_CFG_AUTO_ENABLE
#define DVP_AUTOMODE_DISABLE    0

/*
 *  DVP᡼եޥå
 */
#define DVP_FORMAT_RGB          DVP_CFG_RGB_FORMAT
#define DVP_FORMAT_YUY          DVP_CFG_YUV_FORMAT
#define DVP_FORMAT_Y            DVP_CFG_Y_FORMAT

/*
 *  DVP
 */
#define DVP_STATE_INIT          0
#define DVP_STATE_READY         1
#define DVP_STATE_ACTIVATE      2
#define DVP_STATE_STARTED       3
#define DVP_STATE_FINISH        4


#define INHNO_DVP     IRQ_VECTOR_DVP	/* ߥϥɥֹ */
#define INTNO_DVP     IRQ_VECTOR_DVP	/* ֹ */
#define INTPRI_DVP    -3		/* ͥ */
#define INTATR_DVP    0			/* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  DVP 깽¤
 */
typedef struct
{
	uint32_t              Freq;				/* DVP ȿ */
	uint32_t              RedAddr;			/* DVP Readɥ쥹 */
	uint32_t              GreenAddr;		/* DVP Greenɥ쥹 */
    uint32_t              BlueAddr;			/* DVP Blueɥ쥹 */
	uint32_t              RGBAddr;			/* DVP RGBɥ쥹 */

	uint32_t              Format;			/* DVP ᡼եޥå */
	uint32_t              BurstMode;		/* DVP ֡ȥ⡼ */
	uint32_t              AutoMode;			/* DVP ȥ⡼ */
	uint32_t              GMMlen;			/* DVP GM MLEN */
	uint16_t              Width;			/* DVP  */
	uint16_t              Height;			/* DVP ⤵ */
	uint8_t               num_sccb_reg;		/* DVP SCCB쥸Ĺ */
	int8_t                CMosPClkPin;		/* DVP PCLKԥ */
	int8_t                CMosXClkPin;		/* DVP XCLKԥ */
	int8_t                CMosHRefPin;		/* DVP HREFԥ */
	int8_t                CMosPwDnPin;		/* DVP ѥ */
	int8_t                CMosVSyncPin;		/* DVP VSYNCԥ */
	int8_t                CMosRstPin;		/* DVP ꥻåȥԥ */
	int8_t                SccbSClkPin;		/* DVP SCCB SCLKԥ */
	int8_t                SccbSdaPin;		/* DVP SCCB SDAԥ */
	uint8_t               dummy;
	uint16_t              IntNo;			/* DVP ֹ */
	int                   semlock;			/* SPI åޥե */
}DVP_Init_t;

/*
 *  SPIϥɥ
 */
typedef struct _DVP_Handle_t
{
	unsigned long         base;				/* DVP registers base address */
	DVP_Init_t            Init;				/* DVP communication parameters */
	ID                    semid;			/* DVP semaphore id */
	volatile uint16_t     state;			/* DVP state */
	volatile uint16_t     ErrorCode;		/* DVP Error code */
}DVP_Handle_t;


extern ER dvp_init(DVP_Handle_t *hdvp);
extern ER dvp_deinit(DVP_Handle_t *hdvp);
extern ER dvp_activate(DVP_Handle_t *hdvp, bool_t run);
extern ER dvp_set_image_format(DVP_Handle_t *hdvp);
extern ER dvp_set_image_size(DVP_Handle_t *hdvp);
extern uint32_t dvp_sccb_set_clk_rate(DVP_Handle_t *hdvp, uint32_t clk_rate);
extern ER dvp_dcmi_reset(DVP_Handle_t *hdvp, bool_t reset);
extern ER dvp_dcmi_powerdown(DVP_Handle_t *hdvp, bool_t down);
extern void dvp_sccb_send_data(DVP_Handle_t *hdvp, uint8_t dev_addr, uint16_t reg_addr, uint8_t reg_data);
extern uint8_t dvp_sccb_receive_data(DVP_Handle_t *hdvp, uint8_t dev_addr, uint16_t reg_addr);
extern void dvp_handler(void);

#endif /* TOPPERS_MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif	/* _DVP_H_ */

