/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: i2c.h 698 2019-11-26 17:44:42Z roi $
 */
/*
 * 
 *  K210 I2CǥХɥ饤Фγ
 *
 */

#ifndef _I2C_H_
#define _I2C_H_

#ifdef __cplusplus
 extern "C" {
#endif


/*
 *  I2Cݡ
 */
#define I2C1_PORTID             1
#define I2C2_PORTID             2
#define I2C3_PORTID             3
#define NUM_I2CPORT             3

#define I2C_MAX_NUM NUM_I2CPORT

/*
 *  I2Cɥå󥰥⡼
 */
#define I2C_ADDRESSINGMODE_7BIT  0
#define I2C_ADDRESSINGMODE_10BIT I2C_CON_10BITADDR_SLAVE

/*
 *  I2Cꥢɥ쥹⡼
 */
#define I2C_MEMADD_SIZE_NONE    0x00000000
#define I2C_MEMADD_SIZE_8BIT    0x00000001
#define I2C_MEMADD_SIZE_16BIT   0x00000002

/*
 *  I2C
 */
#define I2C_STATUS_RESET    0x00			/* I2C ꥻåȾ */
#define I2C_STATUS_READY    0x01			/* I2C ǥ */
#define I2C_STATUS_BUSY     0x02			/* I2C ӥ */
#define I2C_STATUS_BUSY_TX  0x52			/* I2C  */
#define I2C_STATUS_BUSY_RX  0x62			/* I2C  */
#define I2C_STATUS_TIMEOUT  0x80

/*
 *  I2C顼
 */
#define I2C_ERROR_NONE      0x00000000		/* No error              */
#define I2C_ERROR_TIMEOUT   0x02000000		/* Timeout error         */


/*
 *  SPIϡɥ깽¤
 */

typedef struct _I2C_PortControlBlock{
	unsigned long         base;
	uint32_t              clkenable;
	uint8_t               thresholdshift;
	uint8_t               sclfunc;
	uint8_t               sdafunc;
	uint8_t               dummy;
} I2C_PortControlBlock;

/*
 *  I2Cե奮졼¤
 */
typedef struct
{
	uint32_t              ClockSpeed;		/* I2C å */
	uint32_t              OwnAddress1;		/* I2C ǽΥǥХμʬΥɥ쥹 */
	uint32_t              AddressingMode;	/* I2C ɥå󥰥⡼ */
	int32_t               SclPin;			/* I2C SCL PINNO */
	int32_t               SdaPin;			/* I2C SDA PINNO*/
	int                   semid;			/* I2C ̿ѥޥե */
	int                   semlock;			/* I2C åޥե */
}I2C_Init_t;


/*
 *  I2Cϥɥ
 */
typedef struct __I2C_Handle_t I2C_Handle_t;
struct __I2C_Handle_t {
	unsigned long              base;
	I2C_Init_t                 Init;		/* I2Cѥ᡼ */
	uint8_t                    aBuffer[4];	/* I2C ̿ɥ쥹ΰ */
	uint16_t                   aXferSize;	/* I2C ̿ɥ쥹 */
	uint16_t                   aXferCount;	/* I2C ̿ɥ쥹 */
	uint8_t                    *pBuffPtr;	/* I2C ̿ХåեؤΥݥ */
	uint16_t                   XferSize;	/* I2C ̿ */
	volatile uint16_t          XferCount;	/* I2C ̿ */
	void                  (*writecallback)(I2C_Handle_t * hi2c);	/* λХåؿ */
	void                  (*readcallback)(I2C_Handle_t * hi2c);		/* λХåؿ */
	void                  (*errorcallback)(I2C_Handle_t * hi2c);	/* 顼Хåؿ */
	volatile uint32_t          tXferCount;	/* I2C ž */
	ID                         i2cid;		/* I2C ID */
	volatile uint32_t          status;		/* I2C ¹Ծ */
	volatile uint32_t          ErrorCode;	/* I2C Error code */
};

extern I2C_Handle_t *i2c_init(ID port, I2C_Init_t *ii2c);
extern ER i2c_deinit (I2C_Handle_t *hi2c);
extern ER i2c_slavewrite(I2C_Handle_t *hi2c, uint8_t *pData, uint16_t Size);
extern ER i2c_slaveread(I2C_Handle_t *hi2c, uint8_t *pData, uint16_t Size);
extern ER i2c_memwrite(I2C_Handle_t *hi2c, uint16_t DevAddress, uint16_t MemAddress, uint16_t MemAddSize, uint8_t *pData, uint16_t Size);
extern ER i2c_memread(I2C_Handle_t *hi2c, uint16_t DevAddress, uint16_t MemAddress, uint16_t MemAddSize, uint8_t *pData, uint16_t Size);
extern void i2c_isr(intptr_t exinf);


#ifdef __cplusplus
}
#endif

#endif	/* _I2C_H_ */

