/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2017 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: dfsdm.h 698 2017-03-19 18:40:55Z roi $
 */
/*
 * 
 *  STM32F7xx DFSDMǥХɥ饤Фγ
 *
 */

#ifndef _DFSDM_H_
#define _DFSDM_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  DFSDM CHANNEL
 */
#define DFSDM_CHANNEL_STATE_RESET   0x00000000	/* DFSDM CHANNELꥻåȾ */
#define DFSDM_CHANNEL_STATE_READY   0x00000001	/* DFSDM CHANNELǥ */
#define DFSDM_CHANNEL_STATE_ERROR   0x00080000	/* DFSDM CHANNEL顼 */

/*
 *  DFSDM CHANNEL
 */
typedef struct
{
	uint32_t                OutClockActivation;		/* ȥץåȥå̵ͭ */
	uint32_t                OutClockSelection;		/* ȥץåȥå */
	uint32_t                OutClockDivider;		/* ȥץåȥåǥХ */
	uint32_t                InputMultiplexer;		/* ϡꥢޤ쥸 */
	uint32_t                InputDataPacking;		/* ϡǡԥå */
	uint32_t                InputPins;				/* ϡԥ */
	uint32_t                SerialType;				/* ꥢ̡SPI or Manchester modes. */
	uint32_t                SerialSpiClock;			/* SPIå(external or internal with different sampling point) */
	uint32_t                AwdFilterOrder;			/* ʥåɥå 󥯥ե륿 */
	uint32_t                AwdOversampling;		/* ʥåɥå oversampliСץ RATIO */
	int32_t                 Offset;					/* DFSDMͥ륪եå */
	uint32_t                RightBitShift;			/* DFSDMͥ뱦ӥåȥե */
}DFSDM_Channel_Init_t;

/*
 *  DFSDM CHANNELϥɥ
 */
typedef struct DFSDM_Channel_struct DFSDM_Channel_Handle_t;
struct DFSDM_Channel_struct
{
	uint32_t                base;					/* DFSDMͥ١ɥ쥹 */
	DFSDM_Channel_Init_t    Init;					/* DFSDMǡ */
	void                    (*ckabcallback)(DFSDM_Channel_Handle_t * hdfsc);	/* Channel CkabХåؿ */
	void                    (*scdcallback)(DFSDM_Channel_Handle_t * hdfsc);		/* Channel ScdХåؿ */
	volatile uint32_t       state;					/* DFSDMͥ */
};

/*
 *  DFSDMե륿
 */
#define DFSDM_FILTER_STATE_RESET    0x00000000	/* DFSDMե륿ꥻåȾ */
#define DFSDM_FILTER_STATE_READY    0x00000001	/* DFSDMե륿ǥ */
#define DFSDM_FILTER_STATE_REG      0x00000002	/* DFSDMե륿쥮顼Ѵ */
#define DFSDM_FILTER_STATE_INJ      0x00000003	/* DFSDMե륿󥸥Ѵ */
#define DFSDM_FILTER_STATE_REG_INJ  0x00000004	/* DFSDMե륿쥮顼󥸥Ѵ */
#define DFSDM_FILTER_STATE_ERROR    0x00080000	/* DFSDMե륿顼 */

/*
 *  DFSDMե륿顼e
 */
#define DFSDM_FILTER_ERROR_NONE             0x00000000	/* 顼ʤ */
#define DFSDM_FILTER_ERROR_REGULAR_OVERRUN  0x00000001	/* 쥮顼ѴХ󥨥顼 */
#define DFSDM_FILTER_ERROR_INJECTED_OVERRUN 0x00000002	/* 󥸥ѴС󥨥顼 */
#define DFSDM_FILTER_ERROR_DMA              0x00000003	/* DMA顼 */

/*
 *  DFSDMե륿
 */
typedef struct
{
	uint32_t                RegTrigger;				/* 쥮顼Ѵsoftware or synchronous. */
	uint32_t                RegFastMode;			/* 쥮顼Ѵfast mode Enable/disable fast mode */
	uint32_t                RegDmaMode;				/* 쥮顼ѴDMA Enable/disable */
	uint32_t                InjTrigger;				/* 󥸥ѴTrigger: software, external or synchronous. */
	uint32_t                InjScanMode;			/* 󥸥Ѵscanning mode Enable/disable */
	uint32_t                InjDmaMode;				/* 󥸥ѴDMA Enable/disable */
	uint32_t                InjExtTrigger;			/* 󥸥ѴExternal trigger */
	uint32_t                InjExtTriggerEdge;		/* 󥸥ѴExternal trigger edge: rising, falling or both. */
	uint32_t                FilterSincOrder;		/* Sinc filter order. */
	uint32_t                FilterOversampling;		/* Filter oversampling ratio. */
	uint32_t                FilterIntOversampling;	/* Integrator oversampling ratio. */
}DFSDM_Filter_Init_t;

/*
 *  DFSDMե륿ϥɥ
 */
typedef struct DFSDM_Filter_struct DFSDM_Filter_Handle_t;
struct DFSDM_Filter_struct
{
	uint32_t                base;					/* DFSDMե륿١ɥ쥹 */
	DFSDM_Filter_Init_t     Init;					/* DFSDMե륿ǡ */
	DMA_Handle_t            *hdmaReg;				/* 쥮顼ѴDMAϥɥؤΥݥ */
	DMA_Handle_t            *hdmaInj;				/* 󥸥ѴDMAϥɥؤΥݥ */
	uint32_t                RegularContMode;		/* 쥮顼Ѵcontinuous mode */
	uint32_t                InjectedChannelsNbr;	/* 󥸥ѴNumber of channels */
	uint32_t                InjConvRemaining;		/* 󥸥Ѵremaining */
	void                    (*regconvcallback)(DFSDM_Filter_Handle_t * hdfsf);		/* RegConvХåؿ */
	void                    (*regconvhalfcallback)(DFSDM_Filter_Handle_t * hdfsf);	/* RegConv halfХåؿ */
	void                    (*injconvcallback)(DFSDM_Filter_Handle_t * hdfsf);		/* InjConvХåؿ */
	void                    (*injconvhalfcallback)(DFSDM_Filter_Handle_t * hdfsf);	/* InjConv halfХåؿ */
	void                    (*awdconvcallback)(DFSDM_Filter_Handle_t * hdfsf);		/* Analog WdХåؿ */
	void                    (*errorcallback)(DFSDM_Filter_Handle_t * hdfsf);		/* 顼Хåؿ */
	volatile uint32_t       state;					/* DFSDMե륿 */
	volatile uint32_t       errorcode;				/* DFSDMե륿顼 */
};

/*
 *  DFSDMե륿 analog watchdog parameters
 */
typedef struct
{
	uint32_t                DataSource;				/* ǡdigital filter or from channel watchdog filter. */
	uint32_t                Channel;				/* ͥ. */
	int32_t                 HighThreshold;			/* ϥå */
	int32_t                 LowThreshold;			/* å */
	uint32_t                HighBreakSignal;		/* ϥåɡ֥졼ʥ */
	uint32_t                LowBreakSignal;			/* åɡ֥졼ʥ */
} DFSDM_Filter_AwdParamTypeDef;


/*
 *  DFSDM֥͡롦ǥ֥
 */
#define DFSDM_DISABLE               0x00000000
#define DFSDM_ENABLE                0x00000001
#define DFSDM_MASK                  (~DFSDM_ENABLE)

/*
 *  DFSDMͥ OutClockSelection
 */
#define DFSDM_CHANNEL_OUTPUT_CLOCK_SYSTEM   0x00000000				/* ouput clock is system clock */
#define DFSDM_CHANNEL_OUTPUT_CLOCK_AUDIO    DFSDM_CHCFGR1_CKOUTSRC  /* ouput clock is audio clock */

/*
 *  DFSDMͥ InputMultiplexer
 */
#define DFSDM_CHANNEL_EXTERNAL_INPUTS       0x00000000				/* ץå */
#define DFSDM_CHANNEL_INTERNAL_REGISTER     DFSDM_CHCFGR1_DATMPX_1	/* 쥸 */

/*
 *  DFSDMͥ InputDataPacking
 */
#define DFSDM_CHANNEL_STANDARD_MODE         0x00000000				/* Standard data packing mode */
#define DFSDM_CHANNEL_INTERLEAVED_MODE      DFSDM_CHCFGR1_DATPACK_0	/* Interleaved data packing mode */
#define DFSDM_CHANNEL_DUAL_MODE             DFSDM_CHCFGR1_DATPACK_1	/* Dual data packing mode */

/*
 *  DFSDMͥ InputPins
 */
#define DFSDM_CHANNEL_SAME_CHANNEL_PINS     0x00000000				/* ץåȥԥpins on same channel */
#define DFSDM_CHANNEL_FOLLOWING_CHANNEL_PINS DFSDM_CHCFGR1_CHINSEL	/* ץåȥԥfollowing channel */

/*
 *  DFSDMͥ SerialType
 */
#define DFSDM_CHANNEL_SPI_RISING            0x00000000				/* SPI with rising edge */
#define DFSDM_CHANNEL_SPI_FALLING           DFSDM_CHCFGR1_SITP_0	/* SPI with falling edge */
#define DFSDM_CHANNEL_MANCHESTER_RISING     DFSDM_CHCFGR1_SITP_1	/* Manchester with rising edge */
#define DFSDM_CHANNEL_MANCHESTER_FALLING    DFSDM_CHCFGR1_SITP		/* Manchester with falling edge */

/*
 *  DFSDMͥ SerialSpi clock selection
 */
#define DFSDM_CHANNEL_SPI_CLOCK_EXTERNAL    0x00000000				/* SPIå */
#define DFSDM_CHANNEL_SPI_CLOCK_INTERNAL    DFSDM_CHCFGR1_SPICKSEL_0			/* SPIå */
#define DFSDM_CHANNEL_SPI_CLOCK_INTERNAL_DIV2_FALLING DFSDM_CHCFGR1_SPICKSEL_1	/* SPIå divided by 2, falling edge */
#define DFSDM_CHANNEL_SPI_CLOCK_INTERNAL_DIV2_RISING  DFSDM_CHCFGR1_SPICKSEL	/* SPIå divided by 2, rising edge */

/*
 *  DFSDMͥ analog watchdog filter order
 */
#define DFSDM_CHANNEL_FASTSINC_ORDER        0x00000000				/* FastSinc filter type */
#define DFSDM_CHANNEL_SINC1_ORDER           DFSDM_CHAWSCDR_AWFORD_0	/* Sinc 1 filter type */
#define DFSDM_CHANNEL_SINC2_ORDER           DFSDM_CHAWSCDR_AWFORD_1	/* Sinc 2 filter type */
#define DFSDM_CHANNEL_SINC3_ORDER           DFSDM_CHAWSCDR_AWFORD	/* Sinc 3 filter type */


/*
 *  DFSDMե륿 Regular/Injected conversion trigger
 */
#define DFSDM_FILTER_SW_TRIGGER             0x00000000			/* Software trigger */
#define DFSDM_FILTER_SYNC_TRIGGER           0x00000001			/* Synchronous with DFSDM_FLT0 */
#define DFSDM_FILTER_EXT_TRIGGER            0x00000002			/* External trigger (only for injected conversion) */

/*
 *  DFSDMե륿 external trigger(DFSDM filter 0, 1, 2 and 3)
 */
#define DFSDM_FILTER_EXT_TRIG_TIM1_TRGO     0x00000000
#define DFSDM_FILTER_EXT_TRIG_TIM1_TRGO2    DFSDM_FLTCR1_JEXTSEL_0
#define DFSDM_FILTER_EXT_TRIG_TIM8_TRGO     DFSDM_FLTCR1_JEXTSEL_1
#define DFSDM_FILTER_EXT_TRIG_TIM8_TRGO2    (DFSDM_FLTCR1_JEXTSEL_0 | DFSDM_FLTCR1_JEXTSEL_1)
#define DFSDM_FILTER_EXT_TRIG_TIM3_TRGO     DFSDM_FLTCR1_JEXTSEL_2
#define DFSDM_FILTER_EXT_TRIG_TIM4_TRGO     (DFSDM_FLTCR1_JEXTSEL_0 | DFSDM_FLTCR1_JEXTSEL_2)
#define DFSDM_FILTER_EXT_TRIG_TIM10_OC1     (DFSDM_FLTCR1_JEXTSEL_1 | DFSDM_FLTCR1_JEXTSEL_2)
#define DFSDM_FILTER_EXT_TRIG_TIM6_TRGO     (DFSDM_FLTCR1_JEXTSEL_0 | DFSDM_FLTCR1_JEXTSEL_1 | DFSDM_FLTCR1_JEXTSEL_2)
#define DFSDM_FILTER_EXT_TRIG_TIM7_TRGO     DFSDM_FLTCR1_JEXTSEL_3
#define DFSDM_FILTER_EXT_TRIG_EXTI11        (DFSDM_FLTCR1_JEXTSEL_3 | DFSDM_FLTCR1_JEXTSEL_4)
#define DFSDM_FILTER_EXT_TRIG_EXTI15        (DFSDM_FLTCR1_JEXTSEL_0 | DFSDM_FLTCR1_JEXTSEL_3 | DFSDM_FLTCR1_JEXTSEL_4)							/* For DFSDM filter 0, 1, 2 and 3 */
#define DFSDM_FILTER_EXT_TRIG_LPTIM1_OUT    (DFSDM_FLTCR1_JEXTSEL_1 | DFSDM_FLTCR1_JEXTSEL_3 | DFSDM_FLTCR1_JEXTSEL_4)

/*
 *  DFSDMե륿 external trigger edge
 */
#define DFSDM_FILTER_EXT_TRIG_RISING_EDGE   DFSDM_FLTCR1_JEXTEN_0	/*  Ω夬ꥨå */
#define DFSDM_FILTER_EXT_TRIG_FALLING_EDGE  DFSDM_FLTCR1_JEXTEN_1	/*  Ωꥨå */
#define DFSDM_FILTER_EXT_TRIG_BOTH_EDGES    DFSDM_FLTCR1_JEXTEN		/*  ξå */

/*
 *  DFSDMե륿 sinc order
 */
#define DFSDM_FILTER_FASTSINC_ORDER         0x00000000							/* FastSinc filter type */
#define DFSDM_FILTER_SINC1_ORDER            DFSDM_FLTFCR_FORD_0					/* Sinc 1 filter type */
#define DFSDM_FILTER_SINC2_ORDER            DFSDM_FLTFCR_FORD_1					/* Sinc 2 filter type */
#define DFSDM_FILTER_SINC3_ORDER            (DFSDM_FLTFCR_FORD_0 | DFSDM_FLTFCR_FORD_1)	/* Sinc 3 filter type */
#define DFSDM_FILTER_SINC4_ORDER            DFSDM_FLTFCR_FORD_2					/* Sinc 4 filter type */
#define DFSDM_FILTER_SINC5_ORDER            (DFSDM_FLTFCR_FORD_0 | DFSDM_FLTFCR_FORD_2)	/* Sinc 5 filter type */

/*
 *  DFSDMե륿 AwdDataSource DataSource
 */
#define DFSDM_FILTER_AWD_FILTER_DATA        0x00000000			/* ǥե륿 */
#define DFSDM_FILTER_AWD_CHANNEL_DATA       DFSDM_FLTCR1_AWFSEL	/* ʥåɥåͥ뤫 */

/*
 *  DFSDMͥ
 */
#define DFSDM_CHANNEL_0                     0x00000001
#define DFSDM_CHANNEL_1                     0x00010002
#define DFSDM_CHANNEL_2                     0x00020004
#define DFSDM_CHANNEL_3                     0x00030008
#define DFSDM_CHANNEL_4                     0x00040010
#define DFSDM_CHANNEL_5                     0x00050020
#define DFSDM_CHANNEL_6                     0x00060040
#define DFSDM_CHANNEL_7                     0x00070080

/*
 *  DFSDMե륿 Continuous Mode
 */
#define DFSDM_CONTINUOUS_CONV_OFF           0x00000000	/* Ѵ³ʤ */
#define DFSDM_CONTINUOUS_CONV_ON            0x00000001	/* Ѵ³ */

/*
 *  DFSDMե륿 AwdThreshold
 */
#define DFSDM_AWD_HIGH_THRESHOLD            0x00000000	/* ʥåɥå ϥ쥷ۡ */
#define DFSDM_AWD_LOW_THRESHOLD             0x00000001	/* ʥåɥå 쥷ۡ */


extern void dfsdm_clockconfig(ID port, uint32_t AudioFreq);
extern ER dfsdm_channel_init(DFSDM_Channel_Handle_t *hdfsc);
extern ER dfsdm_channel_deinit(DFSDM_Channel_Handle_t *hdfsc);

extern ER dfsdm_channelCkabStart(DFSDM_Channel_Handle_t *hdfsc);
extern ER dfsdm_channelCkabStop(DFSDM_Channel_Handle_t *hdfsc);
extern ER dfsdm_channelScdStart(DFSDM_Channel_Handle_t *hdfsc, uint32_t Threshold, uint32_t BreakSignal);
extern ER dfsdm_channelScdStop(DFSDM_Channel_Handle_t *hdfsc);
extern int16_t dfsdm_channelGetAwdValue(DFSDM_Channel_Handle_t *hdfsc);
extern ER dfsdm_channelModifyOffset(DFSDM_Channel_Handle_t *hdfsc, int32_t Offset);


extern ER dfsdm_filter_init(DFSDM_Filter_Handle_t *hdfsf);
extern ER dfsdm_filter_deinit(DFSDM_Filter_Handle_t *hdfsf);
extern ER dfsdm_filter_config_reg(DFSDM_Filter_Handle_t *hdfsf, uint32_t Channel, uint32_t ContinuousMode);
extern ER dfsdm_filter_config_inj(DFSDM_Filter_Handle_t *hdfsf, uint32_t Channel);

extern ER dfsdm_filterRegularStart(DFSDM_Filter_Handle_t *hdfsf, int32_t *pData, uint32_t Length);
extern ER dfsdm_filterRegularMsbStart(DFSDM_Filter_Handle_t *hdfsf, int16_t *pData, uint32_t Length);
extern ER dfsdm_filterRegularStop(DFSDM_Filter_Handle_t *hdfsf);
extern ER dfsdm_filterInjectedStart(DFSDM_Filter_Handle_t *hdfsf, int32_t *pData, uint32_t Length);
extern ER dfsdm_filterInjectedMsbStart(DFSDM_Filter_Handle_t *hdfsf, int16_t *pData, uint32_t Length);
extern ER dfsdm_filterInjectedStop(DFSDM_Filter_Handle_t *hdfsf);
extern ER dfsdm_filterAwdStart(DFSDM_Filter_Handle_t *hdfsf, DFSDM_Filter_AwdParamTypeDef* awdParam);
extern ER dfsdm_filterAwdStop(DFSDM_Filter_Handle_t *hdfsf);
extern ER dfsdm_filterExdStart(DFSDM_Filter_Handle_t *hdfsf, uint32_t Channel);
extern ER dfsdm_filterExdStop(DFSDM_Filter_Handle_t *hdfsf);

extern int32_t  dfsdm_filterGetRegularValue(DFSDM_Filter_Handle_t *hdfsf, uint32_t* Channel);
extern int32_t  dfsdm_filterGetInjectedValue(DFSDM_Filter_Handle_t *hdfsf, uint32_t* Channel);
extern int32_t  dfsdm_filterGetExdMaxValue(DFSDM_Filter_Handle_t *hdfsf, uint32_t* Channel);
extern int32_t  dfsdm_filterGetExdMinValue(DFSDM_Filter_Handle_t *hdfsf, uint32_t* Channel);
extern uint32_t dfsdm_filterGetConvTimeValue(DFSDM_Filter_Handle_t *hdfsf);

extern void dfsdm_irqhandler(DFSDM_Filter_Handle_t *hdfsf);


#ifdef __cplusplus
}
#endif

#endif	/* _DFSDM_H_ */

