/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: rtc.h 698 2019-01-22 10:12:05Z roi $
 */
/*
 * 
 * RTCpfoCXhCopfoCX֐Q̊O錾
 *
 */

#ifndef _RTC_H_
#define _RTC_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  RTCA[`
 */
#define RTC_ALARM_A     RTC_CR_ALRAE
#define RTC_ALARM_B     RTC_CR_ALRBE

/*
 *  RTCtAEB[NfB`
 */
#define ALARMDAYSEL_DATE    0x00000000
#define ALARMDAYSEL_WEEKDAY 0x40000000

/*
 *  RTC}XN`
 */
#define ALARMMASK_NONE      0x00000000
#define ALARMMASK_DATESEL   RTC_ALRMAR_MSK4
#define ALARMMASK_HOURS     RTC_ALRMAR_MSK3
#define ALARMMASK_MINUTES   RTC_ALRMAR_MSK2
#define ALARMMASK_SECONDS   RTC_ALRMAR_MSK1
#define ALARMMASK_ALL       (RTC_ALRMAR_MSK1 | RTC_ALRMAR_MSK2 | RTC_ALRMAR_MSK3 | RTC_ALRMAR_MSK4)

/*
 *  RTCTuZJhA[}b``
 */
#define ALARMSSMASK_ALL     0x00000000	/* All Alarm SS fields are masked. */
#define ALARMSSMASK_SS14_1  0x01000000	/* SS[0]}b`ŃA[ */
#define ALARMSSMASK_SS14_2  0x02000000	/* SS[1:0]}b`ŃA[ */
#define ALARMSSMASK_SS14_3  0x03000000	/* SS[2-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_4  0x04000000	/* SS[3-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_5  0x05000000	/* SS[4-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_6  0x06000000	/* SS[5-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_7  0x07000000	/* SS[6-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_8  0x08000000	/* SS[7-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_9  0x09000000	/* SS[8-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_10 0x0A000000	/* SS[9-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_11 0x0B000000	/* SS[10-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_12 0x0C000000	/* SS[11-0]}b`ŃA[ */
#define ALARMSSMASK_SS14_13 0x0D000000	/* SS[12-0]}b`ŃA[ */
#define ALARMSSMASK_SS14    0x0E000000	/* SS[13-0]}b`ŃA[ */
#define ALARMSSMASK_NONE    0x0F000000	/* SS[14-0]}b`ŃA[ */

#define RTC_ERROR_LSI   0x00000001
#define RTC_ERROR_LSE   0x00000002
#define RTC_ERROR_RTC   0x00000004

#define INHNO_RTCWUP    IRQ_VECTOR_RTC_WKUP	/* ݃nhԍ */
#define INTNO_RTCWUP    IRQ_VECTOR_RTC_WKUP	/* ݔԍ */
#define INTPRI_RTCWUP   -2          /* ݗDx */
#define INTATR_RTCWUP   TA_EDGE     /* ݑ */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ݒp̍\̂`
 */
struct tm2 {
  int	tm_sec;			/* b */
  int	tm_min;			/*  */
  int	tm_hour;		/*  */
  int	tm_mday;		/* ̓ */
  int	tm_mon;			/*  */
  int	tm_year;		/* N */
  int	tm_wday;		/* j */
  int	tm_yday;		/* N̓ */
  int	tm_isdst;
};

/*
 *  RTCA[\
 */
typedef struct
{
	uint32_t            alarm;				/* A[I */
	uint32_t            alarmmask;			/* A[}XNݒ */
	uint32_t            subsecondmask;		/* A[TuZJh}XN */
	uint32_t            dayselect;			/* A[tݒ */
	uint32_t            subsecond;			/* A[TuZJh */
	void                (*callback)(void);	/* A[R[obN */
}RTC_Alarm_t;

/*
 *  RTC-WAKEUP\
 */
typedef struct
{
	uint8_t	            wakeuptimerPrescaler;	/* WAKEUP TIMERvXP[ */
	uint8_t             asynchPrescaler;	/* 񓯊vXP[ */
	uint16_t            synchPrescaler;		/* 񓯊vXP[ */
}RTC_Wakeup_t;

extern uint32_t rtcerrorcode;

extern void rtc_init(intptr_t exinf);
extern ER rtc_set_time(struct tm2 *pt);
extern ER rtc_get_time(struct tm2 *pt);
extern ER rtc_setalarm(RTC_Alarm_t *parm, struct tm2 *ptm);
extern ER rtc_stopalarm(uint32_t Alarm);
extern ER rtc_getalarm(RTC_Alarm_t *parm, struct tm2 *ptm, uint32_t Alarm);
extern ER rtc_wakeup_init(RTC_Wakeup_t *parm, void (*func)(void));
extern ER rtc_setup_wakeuptime(uint32_t time);
extern uint32_t rtc_get_ssr(void);
extern void rtc_handler(void);
extern void rtc_info_init(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif

