/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: adc.c 698 2019-12-20 18:05:58Z roi $
 */
/*
 *
 *  STM32G4XX-ADCɥ饤дؿ
 *
 */
#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <stdio.h>
#include <string.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include <target_syssvc.h>
#include "device.h"
#include "adc.h"

/*
 *  SILؿΥޥ
 */
#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

/*
 *  ADCݡID֥åФΥޥ
 */
#define INDEX_ADC(adcid)    ((uint_t)((adcid) - 1))

#define INIT_CFGR           (ADC_CFGR_RES    | ADC_CFGR_ALIGN  | ADC_CFGR_CONT | \
							 ADC_CFGR_OVRMOD | ADC_CFGR_DISCEN | ADC_CFGR_DISCNUM | \
							 ADC_CFGR_EXTEN  | ADC_CFGR_EXTSEL)

#define INIT_CFGR_2         (ADC_CFGR_DMACFG | ADC_CFGR_AUTDLY)

#define INIT_CFGR2          (ADC_CFGR2_ROVSE | ADC_CFGR2_OVSR  | ADC_CFGR2_OVSS | \
							 ADC_CFGR2_TROVS | ADC_CFGR2_ROVSM)

#define INIT_IER            (ADC_IER_AWD3IE | ADC_IER_AWD2IE  | ADC_IER_AWD1IE | ADC_IER_JQOVFIE | \
							 ADC_IER_OVRIE  | ADC_IER_JEOSIE  | ADC_IER_JEOCIE | ADC_IER_EOSIE   | \
							 ADC_IER_EOCIE  | ADC_IER_EOSMPIE | ADC_IER_ADRDYIE)

#define INIT_ISR            (ADC_ISR_AWD3 | ADC_ISR_AWD2  | ADC_ISR_AWD1 | ADC_ISR_JQOVF | \
							 ADC_ISR_OVR  | ADC_ISR_JEOS  | ADC_ISR_JEOC | ADC_ISR_EOS   | \
							 ADC_ISR_EOC  | ADC_ISR_EOSMP | ADC_ISR_ADRDY)

#define INIT_OFR            (ADC_OFR1_OFFSET1 | ADC_OFR1_OFFSET1_CH | ADC_OFR1_OFFSET1_EN)

/*
 *  ADCॢȻ
 */
#define ADC_ENABLE_TIMEOUT            (10*1000)	/* 10ms */
#define ADC_DISABLE_TIMEOUT           (10*1000)	/* 10ms */
#define ADC_STOP_CONVERSION_TIMEOUT   (10*1000)	/* 10ms */
#define ADC_CONVERSION_TIME_MAX_CPU_CYCLES 167168	/* ADC conversion completion time-out value */

/*
 *  ADC¹Ԥ(sec)
 */
#define ADC_STAB_DELAY_US              10
/*
 *  ADC٥󥵡¹Ԥ(sec)
 */
#define ADC_TEMPSENSOR_DELAY_US        10


/*
 *  ADCС⡼
 */
#define ADC_MODE_INDEPENDENT               0x00000000							/* Independent ADC conversions mode */
#define ADC_DUALMODE_REGSIMULT_INJECSIMULT ADC_CCR_DUAL_0						/* Combined regular simultaneous + injected simultaneous mode */
#define ADC_DUALMODE_REGSIMULT_ALTERTRIG   ADC_CCR_DUAL_1						/* Combined regular simultaneous + alternate trigger mode     */
#define ADC_DUALMODE_REGINTERL_INJECSIMULT (ADC_CCR_DUAL_1 | ADC_CCR_DUAL_0)	/* Combined Interleaved mode + injected simultaneous mode     */
#define ADC_DUALMODE_INJECSIMULT           (ADC_CCR_DUAL_2 | ADC_CCR_DUAL_0)	/* Injected simultaneous mode only */
#define ADC_DUALMODE_REGSIMULT             (ADC_CCR_DUAL_2 | ADC_CCR_DUAL_1)	/* Regular simultaneous mode only */
#define ADC_DUALMODE_INTERL                (ADC_CCR_DUAL_2 | ADC_CCR_DUAL_1 | ADC_CCR_DUAL_0)	/* Interleaved mode only */
#define ADC_DUALMODE_ALTERTRIG             (ADC_CCR_DUAL_3 | ADC_CCR_DUAL_0)	/* Alternate trigger mode only */

/*
 *  ADCС󥰥롼
 */
#define ADC_REGULAR_GROUP              (ADC_ISR_EOC | ADC_ISR_EOS)				/* ADC regular group selection */
#define ADC_INJECTED_GROUP             (ADC_ISR_JEOC | ADC_ISR_JEOS)			/* ADC injected group selection */
#define ADC_REGULAR_INJECTED_GROUP     (ADC_REGULAR_GROUP | ADC_INJECTED_GROUP)	/* ADC regular and injected groups selection */ 

/*
 *  ADCݡơ֥
 */
static const ADC_PortControlBlock adc_pcb[NUM_ADCPORT] = {
  {	TADR_ADC1_BASE,
	(TADR_RCC_BASE+TOFF_RCC_AHB2ENR),  RCC_AHB2ENR_ADC12EN,
	 DMA_REQUEST_ADC1 },

  {	TADR_ADC2_BASE,
	(TADR_RCC_BASE+TOFF_RCC_AHB2ENR),  RCC_AHB2ENR_ADC12EN,
	 DMA_REQUEST_ADC2 }
};

static ADC_Handle_t  AdcHandle[NUM_ADCPORT];
static DMA_Handle_t  hdma_adc[NUM_ADCPORT];

/*
 *  ADC DMAžλХåؿ
 */
static void
adc_dmatrans_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	if(hadc->Init.ContinuousConvMode == ADC_CONTINUOUS_DISABLE)
		hadc->status = ADC_STATUS_EOC;
	else
		hadc->status = ADC_STATUS_BUSY_EOC;
	if(hadc->xfercallback != NULL)
		hadc->xfercallback(hadc);
}

/*
 *  ADC DMAϡžХåؿ
 */
static void
adc_dmahalftrans_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	if(hadc->xferhalfcallback != NULL)
		hadc->xferhalfcallback(hadc);
}

/*
 *  ADC DMA顼Хåؿ
 */
static void
adc_dmaerror_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	hadc->status = ADC_STATUS_READY;
	hadc->errorcode |= ADC_ERROR_DMA;
	if(hadc->errorcallback != NULL)
		hadc->errorcallback(hadc);
}

/*
 *  ADC֥͡Ƚ
 */
static bool_t
is_adc_enable(uint32_t base)
{
	if((sil_rew_mem((uint32_t *)(base+TOFF_ADC_CR)) & (ADC_CR_ADEN | ADC_CR_ADDIS)) == ADC_CR_ADEN && 
			(sil_rew_mem((uint32_t *)(base+TOFF_ADC_ISR)) & ADC_ISR_ADRDY) != 0)
		return true;
	else
		return false;
}

/*
 *  ADCͭ
 */
static ER
adc_enable(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;
	uint32_t tick = 0;

	if(!is_adc_enable(hadc->base)){
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADCAL | ADC_CR_JADSTP | ADC_CR_ADSTP | \
				ADC_CR_JADSTART | ADC_CR_ADSTART | ADC_CR_ADDIS | ADC_CR_ADEN)) != 0){
			hadc->status = ADC_STATUS_ERROR;
			hadc->errorcode |= ADC_ERROR_INT;
			ercd = E_SYS;
		}
		else{
			/*
			 *  ADC ENABLE
			 */
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADEN);
			sil_dly_nse(ADC_STAB_DELAY_US * 1000);
			while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR)) & ADC_ISR_ADRDY) == 0){
				if(tick > ADC_ENABLE_TIMEOUT){
					hadc->status |= ADC_STATUS_ERROR;
					hadc->errorcode = ADC_ERROR_INT;
					ercd = E_TMOUT;
					break;
				}
				tick++;
				sil_dly_nse(1000);
			}
		}
	}
	return ercd;
}

/*
 *  ADC̵
 */
static ER
adc_disable(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;
	uint32_t tick = 0;

	if(is_adc_enable(hadc->base)){
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_JADSTART | ADC_CR_ADSTART | ADC_CR_ADEN)) == ADC_CR_ADEN){
			/*
			 *  ADC DISABLE
			 */
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADDIS);
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOSMP | ADC_ISR_ADRDY));
		}
		else{
			hadc->status = ADC_STATUS_ERROR;
			hadc->errorcode |= ADC_ERROR_INT;
			return E_SYS;
		}
		while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) != 0){
			if(tick > ADC_DISABLE_TIMEOUT){
				hadc->errorcode = ADC_ERROR_INT;
				ercd = E_TMOUT;
			}
			tick++;
			sil_dly_nse(1000);
		}
	}
	return ercd;
}

/*
 * ADC DUAL REGULARС⡼
 */
static bool_t
adc_dual_regular_conversion(ADC_Handle_t* hadc)
{
	uint32_t adc_dual = sil_rew_mem((uint32_t *)(TADR_ADC12_BASE+TOFF_ADC_CCR)) & ADC_CCR_DUAL;
	if(hadc->base != TADR_ADC2_BASE)
		return true;
	if(adc_dual == ADC_MODE_INDEPENDENT || adc_dual == ADC_DUALMODE_INJECSIMULT || adc_dual == ADC_DUALMODE_ALTERTRIG)
		return true;
	else
		return false;
}

/*
 *  ADCС
 */
static ER
adc_conversionstop(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;
	uint32_t ConversionGroup = ADC_REGULAR_INJECTED_GROUP;
	uint32_t tick = 0;
	uint32_t check_cr;

	/*
	 *  ADCС󥹥Ⱦ֤ʤԤԤ
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADSTART | ADC_CR_JADSTART)) != 0){
		/*
		 *  AUTO-INJECTION⡼ɤ̤Ԥ
		 */
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_JAUTO) != 0 &&
			hadc->Init.ContinuousConvMode == ADC_CONTINUOUS_ENABLE &&
				hadc->Init.LowPowerAutoWait == ADC_LOWAUTOWAIT_ENABLE){
			/*
			 *  쥮顼С󥰥롼פѹ
			 */
			ConversionGroup = ADC_REGULAR_GROUP;

			/*
			 *  JEOSԤ
			 */
			while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR)) & ADC_ISR_JEOS) == 0){
				if(tick >= (ADC_CONVERSION_TIME_MAX_CPU_CYCLES *4)){
					hadc->status = ADC_STATUS_ERROR;
					hadc->errorcode |= ADC_ERROR_INT;
					return E_SYS;
				}
				tick++;
			}

			/*
			 * JEOSꥢ
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_JEOS);
		}

		/*
		 *  쥮顼С󥰥롼
		 */
		if(ConversionGroup != ADC_INJECTED_GROUP){
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADSTART | ADC_CR_ADDIS)) == ADC_CR_ADSTART)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADSTP);
		}

		/*
		 *  INJJECTEDС󥰥롼
		 */
		if(ConversionGroup != ADC_REGULAR_GROUP){
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_JADSTART | ADC_CR_ADDIS)) == ADC_CR_JADSTART)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_JADSTP);
		}

		switch(ConversionGroup){
		case ADC_REGULAR_INJECTED_GROUP:
			check_cr = (ADC_CR_ADSTART | ADC_CR_JADSTART);
			break;
		case ADC_INJECTED_GROUP:
			check_cr = ADC_CR_JADSTART;
			break;
		default:
			check_cr = ADC_CR_ADSTART;
			break;
		}

		/*
		 *  Ԥ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & check_cr) != 0){
			if(tick > ADC_STOP_CONVERSION_TIMEOUT){
				hadc->status = ADC_STATUS_ERROR;
				hadc->errorcode |= ADC_ERROR_INT;
				ercd = E_TMOUT;
				break;
			}
			tick++;
			sil_dly_nse(1000);
		}
	}
	return ercd;
}

/*
 *  ADC
 *  parameter1  port: ADCݡֹ
 *  parameter2  pini: ADC깽¤ΤؤΥݥ
 *  return ADCϥɥؤΥݥ󥿡NULLǥ顼
 */
ADC_Handle_t *
adc_init(ID portid, ADC_Init_t* pini)
{
	ADC_Handle_t *hadc;
	const ADC_PortControlBlock *apcb;
	DMA_Handle_t *hdma;
	uint32_t     act_adc = 0, tmp, i;

	/*
	 *  ѥ᡼å
	 */
	if(portid < 1 || portid > NUM_ADCPORT || pini == NULL)
		return NULL;

	if(pini->ScanConvMode != ADC_SCANMODE_DISABLE){
		if(pini->NumConversion < 1 || pini->NumConversion > 16)
			return NULL;
		if(pini->DiscontinuousConvMode == ADC_DISCONTINUOUS_ENABLE){
			if(pini->NumDiscConversion < 1 || pini->NumDiscConversion > 8)
				return NULL;
		}
	}
	if(pini->DiscontinuousConvMode == ADC_DISCONTINUOUS_ENABLE && pini->ContinuousConvMode == ADC_CONTINUOUS_ENABLE)
		return NULL;

	hadc = &AdcHandle[INDEX_ADC(portid)];
	memcpy(&hadc->Init, pini, sizeof(ADC_Init_t));

	apcb = &adc_pcb[INDEX_ADC(portid)];
	hadc->base = apcb->base;
	hadc->apcb = apcb;

	for(i = 0 ; i < NUM_ADCPORT ; i++){
		if(AdcHandle[i].status != ADC_STATUS_RESET)
			act_adc |= 1<<i;
	}

	/*
	 *  ADCå
	 */
	sil_orw_mem((uint32_t *)(apcb->adcclockbase), apcb->adcclockbit);
	sil_rew_mem((uint32_t *)(apcb->adcclockbase));

	/*
	 *  DMAбСDMAԤ
	 */
	hdma = &hdma_adc[INDEX_ADC(portid)];
	if(pini->DMAContinuousRequests != ADC_DMACONTINUOUS_DISABLE
		 && (hdma->cbase = dma_channel_base(pini->DMAChannel)) != 0){
		hdma->Init.Request             = apcb->dmarxrequest;
		hdma->Init.Direction           = DMA_PERIPH_TO_MEMORY;
		hdma->Init.PeriphInc           = DMA_PINC_DISABLE;
		hdma->Init.MemInc              = DMA_MINC_ENABLE;
		hdma->Init.PeriphDataAlignment = DMA_PDATAALIGN_WORD;
		hdma->Init.MemDataAlignment    = DMA_MDATAALIGN_WORD;
		hdma->Init.Mode                = DMA_CIRCULAR;
		hdma->Init.Priority            = DMA_PRIORITY_MEDIUM;

		dma_init(hdma);

		hadc->hdmarx    = hdma;
		hdma->localdata = hadc;
	}
	else
		hadc->hdmarx    = NULL;

	/*
	 *  ADC DEEP POWER
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_DEEPPWD) != 0)
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_DEEPPWD);

	/*
	 *  ADC VOLTAGE 
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADVREGEN) == 0){
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADVREGEN);
		sil_dly_nse(ADC_STAB_DELAY_US * 1000);
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADVREGEN) == 0)
			return NULL;
	}

	/*
	 *  ADC⡼ɥå
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return NULL;

	/*
	 *  ADCΥץꥹ()
	 */
	if(act_adc == 0)
		sil_modw_mem((uint32_t *)(TADR_ADC12_BASE+TOFF_ADC_CCR), (ADC_CCR_PRESC|ADC_CCR_CKMODE), hadc->Init.ClockPrescaler);

	/*
	 *  ADC
	 */
	tmp = pini->ContinuousConvMode | pini->Overrun | pini->DataAlign | pini->Resolution | pini->DiscontinuousConvMode;
	if(pini->DiscontinuousConvMode == ADC_DISCONTINUOUS_ENABLE)
		tmp |= pini->NumDiscConversion << 17;
	if(pini->ExternalTrigConv != ADC_SOFTWARE_START && pini->ExternalTrigConvEdge != ADC_EXTERNALTRIGCONVEDGE_NONE)
		tmp |= ( pini->ExternalTrigConv | pini->ExternalTrigConvEdge);
	sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), INIT_CFGR, tmp);

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADSTART | ADC_CR_JADSTART)) == 0){
		tmp = pini->LowPowerAutoWait | pini->DMAContinuousRequests;
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), INIT_CFGR_2, tmp);

		/*
		 *  ADCСץ
		 */
		if(pini->OversamplingMode == ADC_OVR_SAMPLING_ENABLE){
			if(pini->ExternalTrigConv == ADC_SOFTWARE_START || pini->ExternalTrigConvEdge == ADC_EXTERNALTRIGCONVEDGE_NONE){
				/*
				 *  ȥꥬꥨ顼
				 */
				return NULL;
			}
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), INIT_CFGR2, (ADC_CFGR2_ROVSE | 
							pini->OversamplingRatio | pini->OversamplingRightBitShift | 
							pini->OversamplingTriggeredMode | pini->OversamplingStopReset));
		}
		else	/* Сץꤷʤ */
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_ROVSE);
	}

	if(pini->ScanConvMode == ADC_SCANMODE_ENABLE)
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR1), ADC_SQR1_L, (pini->NumConversion - 1));
	else
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR1), ADC_SQR1_L);

	/*
	 *  ADC֤
	 */
	hadc->errorcode = ADC_ERROR_NONE;
	hadc->status = ADC_STATUS_READY;
	return hadc;
}

/*
 *  ADCλ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_deinit(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;
	uint32_t  act_adc_cnt = 0, i;

	if(hadc == NULL)
		return E_PAR;

	ercd = adc_conversionstop(hadc);
	if(ercd == E_OK){
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), ADC_CFGR_JQM);
		/*
		 *  ADC̵
		 */
		ercd = adc_disable(hadc);
	}

	if(ercd == E_OK){
		/*
		 *  ꥻåIER/ISR
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), INIT_IER);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), INIT_ISR);

		/*
		 *  ꥻåCR
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), (ADC_CR_ADVREGEN | ADC_CR_ADCALDIF));
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_DEEPPWD);
		/*
		 *  ꥻåCFGR/CGFR2
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), (INIT_CFGR | INIT_CFGR_2 | ADC_CFGR_AWD1CH | \
						ADC_CFGR_JAUTO | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN  | ADC_CFGR_AWD1SGL | \
						ADC_CFGR_JQM   | ADC_CFGR_JDISCEN | ADC_CFGR_DISCNUM | ADC_CFGR_DMAEN));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), (INIT_CFGR2 | ADC_CFGR2_JOVSE));

		/*
		 *  ꥻåSMPR
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR1), 0);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR2), 0);

		/*
		 *  ꥻåTR
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR1), (ADC_TR1_LT1 | ADC_TR1_HT1));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR2), (ADC_TR2_LT2 | ADC_TR2_HT2));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR3), (ADC_TR3_LT3 | ADC_TR3_HT3));

		/*
		 *  ꥻåSQR
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR1), 0);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR2), 0);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR3), 0);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR4), 0);

		/*
		 *  ꥻåOFR
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR1), (ADC_OFR1_OFFSET1_EN | ADC_OFR1_OFFSET1_CH | ADC_OFR1_OFFSET1));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR2), (ADC_OFR2_OFFSET2_EN | ADC_OFR2_OFFSET2_CH | ADC_OFR2_OFFSET2));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR3), (ADC_OFR3_OFFSET3_EN | ADC_OFR3_OFFSET3_CH | ADC_OFR3_OFFSET3));
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR4), (ADC_OFR4_OFFSET4_EN | ADC_OFR4_OFFSET4_CH | ADC_OFR4_OFFSET4));

		/*
		 *  ꥻåAWD
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD2CR), ADC_AWD2CR_AWD2CH);
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD3CR), ADC_AWD3CR_AWD3CH);

		/*
		 *  ꥻåDIFSEL
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_DIFSEL), ADC_DIFSEL_DIFSEL);

		/*
		 *  ꥻåCALFACT
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CALFACT), (ADC_CALFACT_CALFACT_D | ADC_CALFACT_CALFACT_S));

		/*
		 *  ꥻåCOMMON ADC
		 */
		for(i = 0 ; i < NUM_ADCPORT ; i++){
			if(AdcHandle[i].status != ADC_STATUS_RESET)
				act_adc_cnt++;
		}
		if(act_adc_cnt <= 1){
			/*
			 *  ꥻåCCR
			 */
			sil_andw_mem((uint32_t *)(TADR_ADC12_BASE+TOFF_ADC_CCR), (ADC_CCR_CKMODE | ADC_CCR_PRESC | ADC_CCR_VBATSEL | \
						ADC_CCR_VSENSESEL | ADC_CCR_VREFEN | ADC_CCR_MDMA | ADC_CCR_DMACFG | ADC_CCR_DELAY | ADC_CCR_DUAL));
			/*
			 *  ADCå
			 */
			sil_andw_mem((uint32_t *)(hadc->apcb->adcclockbase), hadc->apcb->adcclockbit);
		}
	}

	/*
	 *  DMA
	 */
	if(hadc->hdmarx != NULL){
		dma_deinit(hadc->hdmarx);
		hadc->hdmarx = NULL;
	}

	/*
	 *  ADCξֽ
	 */
	hadc->errorcode = ADC_ERROR_NONE;
	hadc->status = ADC_STATUS_RESET;
	return ercd;
}

/*
 *  ADC-ߥ⡼ɳϽ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_start_int(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return E_OBJ;

    /*
	 *  ADCͭ
	 */
	ercd = adc_enable(hadc);

	if(ercd == E_OK){
		/*
		 *  ¹Ծ֤˰ܹ
		 */
		hadc->status = ADC_STATUS_BUSY;
		hadc->errorcode = ADC_ERROR_NONE;

		/*
		 *  ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOS | ADC_ISR_OVR));

		/*
		 *  ADC
		 */
		if(hadc->Init.EOCSelection == ADC_EOC_SEQ_CONV)
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_EOSIE);
		else
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_EOCIE);
		if(hadc->Init.Overrun == ADC_OVR_DATA_PRESERVED)
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_OVRIE);

		/*
		 *  ADC
		 */
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_JAUTO) != 0)
			hadc->status = ADC_STATUS_BUSY_INJ;
		if(adc_dual_regular_conversion(hadc))
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADSTART);
	}
	return ercd;
}

/*
 *  ADC-ߥ⡼߽
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_end_int(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	/*
	 *  ADCС󥹥Ⱦ֤ʤԤԤ
	 */
	ercd = adc_conversionstop(hadc);

	/*
	 *  ADC߽
	 */
	if(ercd == E_OK){
		/*
		 *  ž顼
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_EOCIE | ADC_IER_EOSIE | ADC_IER_OVRIE));

		/*
		 *  ADC̵
		 */
		ercd = adc_disable(hadc);
	}
	if(ercd == E_OK)
		hadc->status = ADC_STATUS_READY;
	return ercd;
}

/*
 *  ADC-DMA⡼ɳϽ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  pdata: ΰΥݥ
 *  parameter3  length: ǡĹ
 *  return ER
 */
ER
adc_start_dma(ADC_Handle_t* hadc, uint32_t* pdata, uint32_t length)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return E_OBJ;

	if(!adc_dual_regular_conversion(hadc))
		return E_OBJ;

    /*
	 *  ADCͭ
	 */
	ercd = adc_enable(hadc);

    /*
	 *  ADC-DMAȽ
	 */
   	if(ercd == E_OK){
		/*
		 *  DMAХåؿ
		 */
		hadc->hdmarx->xfercallback = adc_dmatrans_func;
		hadc->hdmarx->xferhalfcallback = adc_dmahalftrans_func;
		hadc->hdmarx->errorcallback = adc_dmaerror_func;

		/*
		 *  ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOS | ADC_ISR_OVR));

		/*
		 *  ADCС
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_OVRIE);

		/*
		 *  ADC DMA
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), ADC_CFGR_DMAEN);

		/*
		 *  ¹Ծ֤˰ܹ
		 */
		hadc->status = ADC_STATUS_BUSY;
		hadc->errorcode = ADC_ERROR_NONE;

		/*
		 *  DMA
		 */
		dma_start(hadc->hdmarx, hadc->base+TOFF_ADC_DR, (uint32_t)pdata, length);

		/*
		 *  ADC
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADSTART);
	}
	else
		ercd = E_OBJ;
	return ercd;
}

/*
 *  ADC-DMA⡼߽
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_end_dma(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	/*
	 *  ADCС󥹥Ⱦ֤ʤԤԤ
	 */
	ercd = adc_conversionstop(hadc);

	/*
	 *  ADC߽
	 */
	if(ercd == E_OK){
		/*
		 *  ADCDMA⡼ɤ򥪥
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), ADC_CFGR_DMAEN);

		/*
		 *  DMA
		 */
		if(hadc->hdmarx != NULL)
			ercd = dma_end(hadc->hdmarx);
		if(ercd != E_OK)
			hadc->status |= ADC_STATUS_ERROR;

		/*
		 *  Сߤ
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_OVRIE);

		/*
		 *  ADC̵
		 */
		ercd = adc_disable(hadc);
	}
	if(ercd == E_OK)
		hadc->status = ADC_STATUS_READY;
	return ercd;
}

/*
 *  ADC ߥϥɥ¹Դؿ
 */
void
adc_handler(ADC_Handle_t* hadc)
{
	uint32_t isr = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR));
	uint32_t ier = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_IER));
	uint32_t cfg = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR));

	if(((isr & ier) & ADC_ISR_EOSMP) != 0){
		if(hadc->eosmpcallback != NULL)
			hadc->eosmpcallback(hadc);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_EOSMP);
	}

	/*
	 *  ɥСޤϥɥȽ
	 */
	if(((isr & ier) & (ADC_ISR_EOC | ADC_ISR_EOS)) != 0){
	    /*
		 *  Сλ֤˰ܹ
		 */
	    if(hadc->errorcode == ADC_ERROR_NONE)
			hadc->status = ADC_STATUS_EOC;

	    /*
		 *  ADC߽
		 */
	    if((cfg & ADC_CFGR_EXTEN) == 0){
			uint32_t tmp;
			if(adc_dual_regular_conversion(hadc))
				tmp = cfg;
			else
				tmp = sil_rew_mem((uint32_t *)(TADR_ADC1_BASE+TOFF_ADC_CFGR));
			if((tmp & ADC_CFGR_CONT) == 0){
			    /*
				 *  END OF SEQUENCE
				 */
				if((isr & ADC_ISR_EOS) != 0){
					/*
					 *  EOSEQѽλADSTARTξ֤ǧ
					 */
					if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) == 0){
						/*
						 *  ߥޥ
						 */
						sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_EOCIE | ADC_IER_EOSIE));
						if(hadc->status == ADC_STATUS_BUSY_INJ)
							hadc->status = ADC_STATUS_READY;
						else
							hadc->status = ADC_STATUS_BUSY_EOC;
					}
					else{	/* 󥿡ʥ륨顼 */
						hadc->status = ADC_STATUS_ERROR;
						hadc->errorcode |= ADC_ERROR_INT;
					}
				}
			}
		}

		/*
		 *  λХåؿɤ߽Ф
		 */
		if(hadc->xfercallback != NULL)
			hadc->xfercallback(hadc);

	    /*
		 *  ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOS));
	}

	/*
	 *  INJECTEDɥСȽ
	 */
	if(((isr & ier) & (ADC_ISR_JEOC | ADC_ISR_JEOS)) != 0){
	    /*
		 *  Сλ֤˰ܹ
		 */
	    if(hadc->errorcode == ADC_ERROR_NONE)
			hadc->status = ADC_STATUS_EOC_INJ;

		if((isr & ADC_ISR_JEOS) != 0){
			uint32_t tmp;
			if(adc_dual_regular_conversion(hadc))
				tmp = cfg;
			else
				tmp = sil_rew_mem((uint32_t *)(TADR_ADC1_BASE+TOFF_ADC_CFGR));
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_JSQR)) & ADC_JSQR_JEXTEN) == 0 &&
				(tmp & ADC_CFGR_JQM) == 0 && (tmp & (ADC_CFGR_JAUTO|ADC_CFGR_CONT)) != (ADC_CFGR_JAUTO|ADC_CFGR_CONT) &&
					(cfg & ADC_CFGR_EXTEN) == 0){

				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_JADSTART) == 0){
					sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_JEOCIE | ADC_IER_JEOSIE));
					if(hadc->status == ADC_STATUS_BUSY_INJ)
						hadc->status = ADC_STATUS_READY;
					else
						hadc->status = ADC_STATUS_BUSY_EOC;
				}
				else{	/* 󥿡ʥ륨顼 */
					hadc->status = ADC_STATUS_ERROR;
					hadc->errorcode |= ADC_ERROR_INT;
				}
			}
		}

		if(hadc->injectedcallback != NULL)
			hadc->injectedcallback(hadc);

	    /*
		 *  ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_JEOC | ADC_ISR_JEOS));
	}

	/*
	 *  ʥåɥåȽ
	 */
	if((isr & ADC_ISR_AWD1) != 0 && (ier & ADC_IER_AWD1IE) != 0){
		/*
		 *  åɥåȯ֤ѹ
		 */
		hadc->status = ADC_STATUS_AWD1;

		/*
		 *  åɥåߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD1);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwincallback != NULL)
			hadc->outofwincallback(hadc);
	}
	if((isr & ADC_ISR_AWD2) != 0 && (ier & ADC_IER_AWD2IE) != 0){
		/*
		 *  åɥåȯ֤ѹ
		 */
		hadc->status = ADC_STATUS_AWD2;

		/*
		 *  åɥåߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD2);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwincallback != NULL)
			hadc->outofwincallback(hadc);
	}
	if((isr & ADC_ISR_AWD3) != 0 && (ier & ADC_IER_AWD3IE) != 0){
		/*
		 *  åɥåȯ֤ѹ
		 */
		hadc->status = ADC_STATUS_AWD3;

		/*
		 *  åɥåߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD3);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwincallback != NULL)
			hadc->outofwincallback(hadc);
	}

	/*
	 *  С󥨥顼Ƚ
	 */
	if((isr & ADC_ISR_OVR) != 0 && (ier & ADC_IER_OVRIE) != 0){
		/*
		 *  Сߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_OVR);

	    /*
		 * СꡧADC_OVR_DATA_PRESERVEDޤDMAǥ顼Ԥ
		 */
	    if(hadc->Init.Overrun == ADC_OVR_DATA_PRESERVED ||
			(sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_DMAEN) != 0){

			/*
			 *  Сȯ֤ѹ
			 */
			hadc->status = ADC_STATUS_READY;
			hadc->errorcode |= ADC_ERROR_OVR;

			/*
			 *  顼Хåؿɤ߽Ф
			 */
			if(hadc->errorcallback != NULL)
				hadc->errorcallback(hadc);
	    }
	}
}

/*
 *  ADC12ߥϥɥ
 */
void
adc_int12_handler(void)
{
	if(AdcHandle[0].status != ADC_STATUS_RESET)
		adc_handler(&AdcHandle[0]);
	if(AdcHandle[1].status != ADC_STATUS_RESET)
		adc_handler(&AdcHandle[1]);
}


/*
 *  쥮顼쥸μФ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return 쥮顼쥸
 */
uint32_t
adc_getvalue(ADC_Handle_t* hadc)
{
	return sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_DR));
}

/*
 *  ADCͥ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  sConfig: ͥ깽¤ΤؤΥݥ
 *  return ER
 */
ER
adc_setupchannel(ADC_Handle_t* hadc, ADC_ChannelConf_t* sConfig)
{
	GPIO_Init_t GPIO_InitStruct;
	uint32_t clkpin, shift, ccr, tmp;

	if(hadc == NULL || sConfig == NULL)
		return E_PAR;

	clkpin = (sConfig->GpioBase - TADR_GPIOA_BASE) / 0x400;
	if(clkpin > 7 || sConfig->GpioPin >= 16)
		return E_PAR;

	if(sConfig->Rank == 0 || sConfig->Rank > 16)
		return E_PAR;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return E_OBJ;

	/*
	 *  ͥͭ
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB2ENR), (1<<clkpin));
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB2ENR));

	GPIO_InitStruct.mode = GPIO_MODE_ANALOG_AD;
	GPIO_InitStruct.pull = GPIO_NOPULL;
	gpio_setup(sConfig->GpioBase, &GPIO_InitStruct, sConfig->GpioPin);

	/*
	 *  
	 */
	if (sConfig->Rank < 5){	/* 14 */
		shift = 6 * (sConfig->Rank - 1) + 6;
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR1), (ADC_SQR2_SQ5 << shift), (sConfig->Channel << shift));
	}
	else if (sConfig->Rank < 10){	/* 59 */
		shift = 6 * (sConfig->Rank - 5);
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR2), (ADC_SQR2_SQ5 << shift), (sConfig->Channel << shift));
	}
	else if (sConfig->Rank < 15){	/* 1014 */
		shift = 6 * (sConfig->Rank - 10);
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR3), (ADC_SQR2_SQ5 << shift), (sConfig->Channel << shift));
	}
	else{	/* 1516 */
		shift = 6 * (sConfig->Rank - 15);
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR4), (ADC_SQR2_SQ5 << shift), (sConfig->Channel << shift));
	}

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADSTART | ADC_CR_JADSTART)) == 0){
		/*
		 *  ץ󥰻
		 */
		if(sConfig->Channel > ADC_CHANNEL_9){	/* ͥ1018 */
			shift = 3 * (sConfig->Channel - 10);
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR2), (ADC_SMPR2_SMP10 << shift), (sConfig->SamplingTime << shift));
		}
		else{ 	/* ͥ09 */
			shift = 3 * sConfig->Channel;
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR1), (ADC_SMPR1_SMP0 << shift), (sConfig->SamplingTime << shift));
		}
		/*
		 *  եå
		 */
		tmp = sConfig->Offset << ((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_RES) * 2);
		switch (sConfig->OffsetNumber){
		case ADC_OFFSET_1:
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR1), INIT_OFR, (ADC_OFR1_OFFSET1_EN | (sConfig->Channel << 26) | tmp));
			break;
		case ADC_OFFSET_2:
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR2), INIT_OFR, (ADC_OFR2_OFFSET2_EN | (sConfig->Channel << 26) | tmp));
			break;
		case ADC_OFFSET_3:
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR3), INIT_OFR, (ADC_OFR3_OFFSET3_EN | (sConfig->Channel << 26) | tmp));
			break;
		case ADC_OFFSET_4:
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR4), INIT_OFR, (ADC_OFR4_OFFSET4_EN | (sConfig->Channel << 26) | tmp));
			break;
		default :	/* OFFSETʤξ */
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR1)) & ADC_OFR1_OFFSET1_CH) == (sConfig->Channel << 26))
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR1), ADC_OFR1_OFFSET1_EN);
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR2)) & ADC_OFR2_OFFSET2_CH) == (sConfig->Channel << 26))
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR2), ADC_OFR2_OFFSET2_EN);
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR3)) & ADC_OFR3_OFFSET3_CH) == (sConfig->Channel << 26))
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR3), ADC_OFR3_OFFSET3_EN);
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR4)) & ADC_OFR4_OFFSET4_CH) == (sConfig->Channel << 26))
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR4), ADC_OFR4_OFFSET4_EN);
			break;
		}
	}

	/*
	 *  ADCͭǤʤ硢Differential input modeȸ̤Υ󥵡Ԥ
	 */
	if(!is_adc_enable(hadc->base)){
		if(sConfig->SingleDiff != ADC_DIFFERENTIAL_ENDED)
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_DIFSEL), (1 << sConfig->Channel));
		else{
			/* Enable differential mode */
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_DIFSEL), (1 << sConfig->Channel));

			/*
			 *  ץ󥰥ߥ󥰤ͥܣѹ
			 */
			if(sConfig->Channel >= ADC_CHANNEL_9){
				shift = 3 * (sConfig->Channel - 9);
				sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR2), (ADC_SMPR2_SMP10 << shift), (sConfig->SamplingTime << shift));
			}
			else{	/* For channels 0 to 8, SMPR1 must be configured */
				shift = 3 * (sConfig->Channel + 1);
				sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR1), (ADC_SMPR1_SMP0 << shift), (sConfig->SamplingTime << shift));
			}
		}

		/*
		 * Vbat/VrefInt/TempSensorͥ
		 */
		ccr = sil_rew_mem((uint32_t *)(TADR_ADC12_BASE+TOFF_ADC_CCR));
		if((sConfig->Channel == ADC_CHANNEL_TEMPSENSOR && (ccr & ADC_CCR_VSENSESEL) == 0) ||
			(sConfig->Channel == ADC_CHANNEL_VBAT && (ccr & ADC_CCR_VBATSEL) == 0) ||
				(sConfig->Channel == ADC_CHANNEL_VREFINT && (ccr & ADC_CCR_VREFEN) == 0)){
			/*
			 *  ͭADC硢֥顼Ȥ
			 */
			if(!is_adc_enable(TADR_ADC1_BASE) && !is_adc_enable(TADR_ADC2_BASE)){
				if(hadc->base != TADR_ADC2_BASE){
					if(sConfig->Channel == ADC_CHANNEL_TEMPSENSOR)
						sil_orw_mem((uint32_t *)(TADR_ADC12_BASE+TOFF_ADC_CCR), ADC_CCR_VSENSESEL);
					else if(sConfig->Channel == ADC_CHANNEL_VBAT)
						sil_orw_mem((uint32_t *)(TADR_ADC12_BASE+TOFF_ADC_CCR), ADC_CCR_VBATSEL);
					else if(sConfig->Channel == ADC_CHANNEL_VREFINT)
						sil_orw_mem((uint32_t *)(TADR_ADC12_BASE+TOFF_ADC_CCR), ADC_CCR_VREFEN);
				}
			}
			else{
				return E_OBJ;
			}
		}
	}
	return E_OK;
}

/*
 *  ADCʥåɥå
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  AnalogWDGConfig: ʥåɥå깽¤ΤؤΥݥ
 *  return ER
 */
ER
adc_setupwatchdog(ADC_Handle_t* hadc, ADC_AnalogWDGConf_t* AnalogWDGConfig)
{
	uint32_t cfgr, tmp1, tmp2;

	if(hadc == NULL || AnalogWDGConfig == NULL)
		return E_PAR;

	if(AnalogWDGConfig->WatchdogNumber == 0 || AnalogWDGConfig->WatchdogNumber > 3)
		return E_PAR;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADSTART | ADC_CR_JADSTART)) != 0)
		return E_OBJ;

	cfgr = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR));
	if(AnalogWDGConfig->WatchdogNumber == 1){
		/*
		 *  AWD1⡼
		 */
		cfgr &= ~(ADC_CFGR_AWD1SGL | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1CH);
		cfgr |= AnalogWDGConfig->WatchdogMode | (AnalogWDGConfig->Channel << 26);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), cfgr);

		/*
		 *  AWD1 HIGH/LOWΥåۡ
		 */
		tmp1 = AnalogWDGConfig->HighThreshold << (((cfgr & ADC_CFGR_RES) >> 3)*2);
		tmp2 = AnalogWDGConfig->LowThreshold << (((cfgr & ADC_CFGR_RES) >> 3)*2);
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR1), (tmp1 << 16) | tmp2);

		/*
		 *  AWD1 ߥꥢȳ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD1);
		if(AnalogWDGConfig->ITMode == ADC_ANALOGWATCHDOG_ITMODE_ENABLE)
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD1IE);
		else
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD1IE);
	}
	else{
		/*
		 *  AWD2,3 åٷ׻
		 */
		if((cfgr & ADC_CFGR_RES) != (ADC_CFGR_RES_1 | ADC_CFGR_RES_0)){
			tmp1 = AnalogWDGConfig->HighThreshold >> (4 - (((cfgr & ADC_CFGR_RES) >> 3)*2));
			tmp2 = AnalogWDGConfig->LowThreshold >> (4 - (((cfgr & ADC_CFGR_RES) >> 3)*2));
		}
		else{
			tmp1 = AnalogWDGConfig->HighThreshold << 2;
			tmp2 = AnalogWDGConfig->LowThreshold << 2;
		}
		if(AnalogWDGConfig->WatchdogNumber == 2){
			/*
			 *  AWD2⡼
			 */
			if(AnalogWDGConfig->WatchdogMode != ADC_ANALOGWATCHDOG_NONE)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD2CR), (1 << AnalogWDGConfig->Channel));
			else
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD2CR), (1 << AnalogWDGConfig->Channel));

			/*
			 *  AWD2 HIGH/LOWΥåۡ
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR2), (tmp1 << 16) | tmp2);

			/*
			 *  AWD2 ߥꥢȳ
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD2);
			if(AnalogWDGConfig->ITMode == ADC_ANALOGWATCHDOG_ITMODE_ENABLE)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD2IE);
			else
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD2IE);
		}
		else{
			/*
			 *  AWD3⡼
			 */
			if(AnalogWDGConfig->WatchdogMode != ADC_ANALOGWATCHDOG_NONE)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD3CR), (1 << AnalogWDGConfig->Channel));
			else
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD3CR), (1 << AnalogWDGConfig->Channel));

			/*
			 *  AWD3 HIGH/LOWΥåۡ
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_TR3), (tmp1 << 16) | tmp2);

			/*
			 *  AWD3 HIGH/LOWΥåۡ
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD3);
			if(AnalogWDGConfig->ITMode == ADC_ANALOGWATCHDOG_ITMODE_ENABLE)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD3IE);
			else
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD3IE);
		}
	}
	return E_OK;
}


