/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: usb_device.h 698 2019-12-23 18:03:23Z roi $
 */
/*
 * STM USB DEVICEpfoCXhCo̊O錾
 */

#ifndef _USB_DEVICE_H_
#define _USB_DEVICE_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  USB|[g`
 */
#define USB1_PORTID             1
#define NUM_USBPORT             1

/*
 *  Gh|CgEfoCX`l̍ő吔{P
 */
#define MAX_DEVICE_EPS          8
#define MAX_EPS_CHANNELS        (MAX_DEVICE_EPS+1)

/*
 *  USB PHY`
 */
#define USB_PHY_ULPI            1
#define USB_PHY_EMBEDDED        2

/*
 *  Gh|Cg^Cv
 */
#define EP_TYPE_CTRL            0
#define EP_TYPE_ISOC            1
#define EP_TYPE_BULK            2
#define EP_TYPE_INTR            3
#define EP_TYPE_MSK             3

/*
 *  USBXs[h
 */
#define USB_SPEED_HIGH          0
#define USB_SPEED_HIGH_IN_FULL  1
#define USB_SPEED_LOW           2
#define USB_SPEED_FULL          3

/*
 *  LPMANeBup[^
 */
#define PCD_LPM_L0_ACTIVE       0x00		/* on */
#define PCD_LPM_L1_ACTIVE       0x01		/* LPM L1 sleep */
#define PCD_LPM_L2              0x02		/* suspend */
#define PCD_LPM_L3              0x03		/* off */

/*
 *  Gh|Cg
 */
#define PCD_SNG_BUF             0U
#define PCD_DBL_BUF             1U

/*
 *  BCDCxg`
 */
#define USBD_BCD_CONTACT_DETECTION          0
#define USBD_BCD_STD_DOWNSTREAM_PORT        2
#define USBD_BCD_CHARGING_DOWNSTREAM_PORT   3
#define USBD_BCD_DEDICATED_CHARGING_PORT    4
#define USBD_BCD_DISCOVERY_COMPLETED        1
#define USBD_BCD_ERROR                      -1


/*
 *  USBfoCXݒ`
 */
typedef struct
{
	uint32_t              dev_endpoints;			/* foCXGh|Cg(1-8) */
	uint32_t              speed;					/* USBRAXs[h */
	uint32_t              phy_itface;				/* PHYC^[tFCXI */
	uint32_t              sof_enable;				/* SOF݂̗Lݒ(0 or 1) */
    uint32_t              low_power_enable;			/* LOW POWER[hLݒ(0 or 1) */
    uint32_t              lpm_enable;				/* Link Power ManagementLݒ(0 or 1) */
	uint32_t              battery_charging_enable;	/* obe`[WLݒ(0 or 1) */ 
}USB_DEV_Init_t;

/*
 *  Gh|Cg`
 */
typedef struct
{
    uint8_t               num;					/* Gh|Cgԍ(0-7) */
	uint8_t               is_in : 1;			/* Gh|CgX`[(0 or 1) */
	uint8_t               is_stall : 1;			/* Gh|CgX`[(0 or 1) */
	uint8_t               type : 2;				/* Gh|Cg^Cv */
	uint8_t               doublebuffer : 1;		/* Gh|CgF_uobt@w */
	uint16_t              pmaadress;			/* PMA Address */
	uint16_t              pmaaddr0;				/* PMA Address0 */
	uint16_t              pmaaddr1;				/* PMA Address1 */
    uint16_t              maxpacket;			/* Gh|CgőpPbgTCY(0-64KB) */
	uint8_t               *xfer_buff;			/* ]obt@|C^[ */
	uint32_t              xfer_len;				/* ݂̓] */
	uint32_t              xfer_count;			/* w]JEg */
}USB_DEV_EPTypeDef;

typedef struct _USB_DEV_Handle USB_DEV_Handle_t;

/*
 *   USBfoCXnh`
 */
struct _USB_DEV_Handle
{
	uint32_t              base;						/* USB DEVICE WX^x[XAhX */
	USB_DEV_Init_t        Init;						/* USB DEVICE ݒ */
	USB_DEV_EPTypeDef     IN_ep[MAX_DEVICE_EPS];	/* IN Gh|Cgf[^ */
	USB_DEV_EPTypeDef     OUT_ep[MAX_DEVICE_EPS];	/* OUT Gh|Cgf[^ */
	volatile uint32_t     Setup[12];				/* Setup pPbgobt@ */
	uint32_t              BESL;						/* BESLۑ̈ */
	uint8_t               lpm_state;				/* LPM  */
	uint8_t               lpm_active;				/* Link Power ManagementLݒ(0 or 1) */
	uint8_t               battery_charging_active;	/* Enable or disable Battery charging */
	volatile uint8_t      usb_address;				/* USB Address */
	void                  (*devsetupstagecallback)(USB_DEV_Handle_t * hhcd);
	void                  (*devdataoutstagecallback)(USB_DEV_Handle_t * hhcd, uint8_t epnum);
	void                  (*devdatainstagecallback)(USB_DEV_Handle_t * hhcd, uint8_t epnum);
	void                  (*devsofcallback)(USB_DEV_Handle_t * hhcd);
	void                  (*devresetcallback)(USB_DEV_Handle_t * hhcd);
	void                  (*devsuspendcallback)(USB_DEV_Handle_t * hhcd);
	void                  (*devresumecallback)(USB_DEV_Handle_t * hhcd);
	void                  (*devconnectcallback)(USB_DEV_Handle_t * hhcd);					/* */
	void                  (*devdisconnectcallback)(USB_DEV_Handle_t * hhcd);				/* */
	void                  (*devlpmcallback)(USB_DEV_Handle_t * hhcd, uint8_t msg);
	void                  (*devbcdcallback)(USB_DEV_Handle_t * hhcd, int8_t msg);
	void                  *pDev;					/* Pointer Device Stack Handler */
};

extern ER usbd_setupPMA(USB_DEV_Handle_t *husb, uint16_t ep_addr, uint16_t kind, uint32_t pmaadress);
extern ER usbd_init_lpm(USB_DEV_Handle_t *husb);
extern ER usbd_init_BCD(USB_DEV_Handle_t *husb);
extern void usbd_bcd_task(intptr_t exinf);

extern USB_DEV_Handle_t *usbd_init(int id, USB_DEV_Init_t *pini);
extern ER usbd_deinit (USB_DEV_Handle_t *husb);
extern ER usbd_devconnect(USB_DEV_Handle_t *husb);
extern ER usbd_devdisconnect(USB_DEV_Handle_t *husb);
extern ER usbd_setDevAddress(USB_DEV_Handle_t *husb, uint8_t address);
extern ER usbd_activateEndpoint(USB_DEV_Handle_t *husb, USB_DEV_EPTypeDef *ep);
extern ER usbd_deactivateEndpoint(USB_DEV_Handle_t *husb, USB_DEV_EPTypeDef *ep);
extern ER usbd_epstartreceive(USB_DEV_Handle_t *husb, USB_DEV_EPTypeDef *ep);
extern ER usbd_epstartsend(USB_DEV_Handle_t *husb, USB_DEV_EPTypeDef *ep);
extern ER usbd_epsetStall(USB_DEV_Handle_t *husb, USB_DEV_EPTypeDef *ep);
extern ER usbd_epclearStall(USB_DEV_Handle_t *husb, USB_DEV_EPTypeDef *ep);
extern void usb_device_isr(intptr_t exinf);


#ifdef __cplusplus
}
#endif

#endif

