/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: adc.c 698 2019-12-20 17:55:32Z roi $
 */
/*
 * 
 *  STM32Hxx ADCɥ饤дؿ
 *
 */
#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include <target_syssvc.h>
#include "device.h"
#include "adc.h"

/*
 *  SILؿΥޥ
 */
#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

/*
 *  ADCݡID֥åФΥޥ
 */
#define INDEX_ADC(adcid)        ((uint_t)((adcid) - 1))


#define REV_ID_Y                       0x1003	/* old IP(rev.Y) */

/*
 *  ADC¹Ԥ(sec)
 */
#define ADC_STAB_DELAY_US              3
/*
 *  ADC٥󥵡¹Ԥ(sec)
 */
#define ADC_TEMPSENSOR_DELAY_US        10

#define ADC_ENABLE_TIMEOUT             (2*1000)	/* ADC enable time-out value  */
#define ADC_DISABLE_TIMEOUT            (2*1000)	/* ADC disable time-out value */
#define ADC_STOP_CONVERSION_TIMEOUT    (5*1000)	/* ADC stop time-out value */ 
#define ADC_CONVERSION_TIME_MAX_CPU_CYCLES (210688)	/* ADC conversion completionCPU CLOCK time-out value */
/*   - maximum sampling time (830.5 adc_clk)                                  */
/*   - ADC resolution (Tsar 16 bits= 16.5 adc_clk)                            */
/*   - ADC clock with prescaler 256                                           */
/*     823 * 256 = 210688 clock cycles max                                    */
#define ADC_DELAY_TEMPSENSOR_STAB_US   (26)		/* Delay for temperature sensor stabilization time */

/*
 *  ADC쥸ե졼
 */
#define ADC_CR_BITS_PROPERTY_RS        (ADC_CR_ADCAL | ADC_CR_JADSTP | ADC_CR_ADSTP | \
										ADC_CR_JADSTART | ADC_CR_ADSTART | ADC_CR_ADDIS | ADC_CR_ADEN)

#define ADC_CFGR_FIELDS_1              (ADC_CFGR_RES   | ADC_CFGR_CONT    | ADC_CFGR_OVRMOD | \
                                        ADC_CFGR_DISCEN | ADC_CFGR_DISCNUM | \
                                        ADC_CFGR_EXTEN  | ADC_CFGR_EXTSEL)
#define ADC_CFGR_FIELDS_2              (ADC_CFGR_DMNGT | ADC_CFGR_AUTDLY)
#define ADC_CFGR_CLEAR                 (ADC_CFGR_AWD1CH  | ADC_CFGR_JAUTO    | ADC_CFGR_JAWD1EN | \
										ADC_CFGR_AWD1EN  | ADC_CFGR_AWD1SGL  | ADC_CFGR_JQM     | \
										ADC_CFGR_JDISCEN | ADC_CFGR_FIELDS_1 | ADC_CFGR_FIELDS_2)
#define ADC_CFGR2_FIELDS               (ADC_CFGR2_ROVSE | ADC_CFGR2_OVSR  | ADC_CFGR2_OVSS | \
										ADC_CFGR2_TROVS | ADC_CFGR2_ROVSM)
#define ADC_CFGR2_CLEAR                (ADC_CFGR2_JOVSE | ADC_CFGR2_FIELDS)

#define ADC_SMPR1_FIELDS               (ADC_SMPR1_SMP9 | ADC_SMPR1_SMP8 | ADC_SMPR1_SMP7 | \
										ADC_SMPR1_SMP6 | ADC_SMPR1_SMP5 | ADC_SMPR1_SMP4 | \
										ADC_SMPR1_SMP3 | ADC_SMPR1_SMP2 | ADC_SMPR1_SMP1 | \
										ADC_SMPR1_SMP0)
#define ADC_SMPR2_FIELDS               (ADC_SMPR2_SMP18 | ADC_SMPR2_SMP17 | ADC_SMPR2_SMP16 | \
										ADC_SMPR2_SMP15 | ADC_SMPR2_SMP14 | ADC_SMPR2_SMP13 | \
										ADC_SMPR2_SMP12 | ADC_SMPR2_SMP11 | ADC_SMPR2_SMP10)

#define ADC_INT_MASK                   (ADC_IER_AWD3IE  | ADC_IER_AWD2IE | ADC_IER_AWD1IE | \
										ADC_IER_JQOVFIE | ADC_IER_OVRIE  | ADC_IER_JEOSIE | \
										ADC_IER_JEOCIE  | ADC_IER_EOSIE  | ADC_IER_EOCIE  | \
										ADC_IER_EOSMPIE | ADC_IER_ADRDYIE)

#define ADC_INT_CLEAR                  (ADC_ISR_AWD3  | ADC_ISR_AWD2 | ADC_ISR_AWD1 | \
										ADC_ISR_JQOVF | ADC_ISR_OVR  | ADC_ISR_JEOS | \
										ADC_ISR_JEOC  | ADC_ISR_EOS  | ADC_ISR_EOC  | \
										ADC_ISR_EOSMP | ADC_ISR_ADRDY)

/** @defgroup ADC_LL_EC_INJ_TRIGGER_SOURCE  ADC group injected - Trigger source
  * @{
  */
#define ADC_INJ_TRIG_SOFTWARE          0x00000000
#define ADC_INJ_TRIG_EXT_TIM1_TRGO     ADC_JSQR_JEXTEN_0
#define ADC_INJ_TRIG_EXT_TIM1_CH4      (ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM2_TRGO     (ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM2_CH1      (ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM3_CH4      (ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTEN_0)                     
#define ADC_INJ_TRIG_EXT_TIM4_TRGO     (ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_EXTI_LINE15   (ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM8_CH4      (ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM1_TRGO2    (ADC_JSQR_JEXTSEL_3 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM8_TRGO     (ADC_JSQR_JEXTSEL_3 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM8_TRGO2    (ADC_JSQR_JEXTSEL_3 | ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM3_CH3      (ADC_JSQR_JEXTSEL_3 | ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM3_TRGO     (ADC_JSQR_JEXTSEL_3 | ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM3_CH1      (ADC_JSQR_JEXTSEL_3 | ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM6_TRGO     (ADC_JSQR_JEXTSEL_3 | ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_TIM15_TRGO    (ADC_JSQR_JEXTSEL_3 | ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_HRTIM_TRG2    (ADC_JSQR_JEXTSEL_4 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_HRTIM_TRG4    (ADC_JSQR_JEXTSEL_4 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_LPTIM1_OUT    (ADC_JSQR_JEXTSEL_4 | ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_LPTIM2_OUT    (ADC_JSQR_JEXTSEL_4 | ADC_JSQR_JEXTSEL_1 | ADC_JSQR_JEXTSEL_0 | ADC_JSQR_JEXTEN_0)
#define ADC_INJ_TRIG_EXT_LPTIM3_OUT    (ADC_JSQR_JEXTSEL_4 | ADC_JSQR_JEXTSEL_2 | ADC_JSQR_JEXTEN_0)

#define ADC_CHANNEL_ID_BITFIELD_MASK   (ADC_AWD2CR_AWD2CH)
#define ADC_CHANNEL_ID_MASK            (ADC_CFGR_AWD1CH | ADC_CHANNEL_ID_BITFIELD_MASK | ADC_CHANNEL_ID_INTERNAL_CH)


/*
 *  ʥåɥåͥ뻲ȥǡ
 */
#define ADC_AWD_DISABLE                0x00000000U			/* ADC analog watchdog monitoring disabled */
#define ADC_AWD_ALL_CHANNELS_REG       (ADC_AWD2CR_AWD2CH | ADC_CFGR_AWD1EN)	/* ADC analog watchdog monitoring of all channels, converted by group regular only */
#define ADC_AWD_ALL_CHANNELS_INJ       (ADC_AWD2CR_AWD2CH | ADC_CFGR_JAWD1EN)	/* ADC analog watchdog monitoring of all channels, converted by group injected only */
#define ADC_AWD_ALL_CHANNELS_REG_INJ   (ADC_AWD2CR_AWD2CH | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN)	/* ADC analog watchdog monitoring of all channels, converted by either group regular or injected */

/*
 *  ʥåɥåͥ ե졼ǡ
 */
#define ADC_AWD_CR1_REGOFFSET          (0x00000000UL)
#define ADC_AWD_CR2_REGOFFSET          (0x00100000UL)
#define ADC_AWD_CR3_REGOFFSET          (0x00200000UL)
#define ADC_AWD_CRX_REGOFFSET_MASK     (ADC_AWD_CR1_REGOFFSET | ADC_AWD_CR2_REGOFFSET | ADC_AWD_CR3_REGOFFSET)

#define ADC_AWD_CR12_REGOFFSETGAP_VAL  (0x00000024UL)

/*
 *  @defgroup ADC_LL_EC_AWD_NUMBER Analog watchdog - Analog watchdog number
 */
#define ADC_AWD_CR1_CHANNEL_MASK       (ADC_CFGR_AWD1CH | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL)
#define ADC_AWD_CR_ALL_CHANNEL_MASK    (ADC_AWD_CR1_CHANNEL_MASK | ADC_AWD2CR_AWD2CH)
#define ADC_AWD1                       (ADC_AWD_CR1_CHANNEL_MASK | ADC_AWD_CR1_REGOFFSET)	/* ADC analog watchdog number 1 */

/*
 *  С󥰥롼
 */
#define ADC_REGULAR_GROUP              ADC_CR_ADSTART				/* ADC group regular (available on all STM32 devices) */
#define ADC_INJECTED_GROUP             ADC_CR_JADSTART				/* ADC group injected (not available on all STM32 devices)*/
#define ADC_REGULAR_INJECTED_GROUP     (ADC_CR_ADSTART | ADC_CR_JADSTART)	/* ADC both groups regular and injected */



#define ADC_SMPR2_REGOFFSET            (0x02000000UL)

#define get_revision()          (sil_rew_mem((uint32_t *)(TADR_DBGMCU_BASE+TOFF_DBGMCU_IDCODE)))
#define is_dmamode(p)           ((p)->ConversionDataManagement == ADC_CONVERSIONDATA_DMA_ONESHOT || \
								 (p)->ConversionDataManagement == ADC_CONVERSIONDATA_DMA_CIRCULAR)
#define is_multimaster(p)       ((p)->base != TADR_ADC2_BASE)
#define get_multimode(p)        (sil_rew_mem((uint32_t *)((p)->cbase+TOFF_ADC_CCR)) & ADC_CCR_DUAL)
#define get_ofr_channel(c)      ((c) << 26)


/*
 *  ADCݡơ֥
 */
static const ADC_PortControlBlock adc_pcb[NUM_ADCPORT] = {
  {	TADR_ADC1_BASE, TADR_ADC12_COMMON_BASE, TADR_ADC2_BASE,
	(TADR_RCC_BASE+TOFF_RCC_AHB1ENR),  RCC_AHB1ENR_ADC12EN,
	DMA_REQUEST_ADC1 },
  {	TADR_ADC2_BASE, TADR_ADC12_COMMON_BASE, TADR_ADC1_BASE,
	(TADR_RCC_BASE+TOFF_RCC_AHB1ENR),  RCC_AHB1ENR_ADC12EN,
	DMA_REQUEST_ADC2 },
  {	TADR_ADC3_BASE, TADR_ADC3_COMMON_BASE, TADR_ADC3_BASE,
	(TADR_RCC_BASE+TOFF_RCC_AHB4ENR),  RCC_AHB4ENR_ADC3EN,
	DMA_REQUEST_ADC3 }
};

static const uint32_t rank_table[16] = {
	(0x00000000 |  6),	/* rank 1 */
	(0x00000000 | 12),	/* rank 2 */
	(0x00000000 | 18),	/* rank 3 */
	(0x00000000 | 24),	/* rank 4 */
	(0x00000100 |  0),	/* rank 5 */
	(0x00000100 |  6),	/* rank 6 */
	(0x00000100 | 12),	/* rank 7 */
	(0x00000100 | 18),	/* rank 8 */
	(0x00000100 | 24),	/* rank 9 */
	(0x00000200 |  0),	/* rank 10 */
	(0x00000200 |  6),	/* rank 11 */
	(0x00000200 | 12),	/* rank 12 */
	(0x00000200 | 18),	/* rank 13 */
	(0x00000200 | 24),	/* rank 14 */
	(0x00000300 |  0),	/* rank 15 */
	(0x00000300 |  6)	/* rank 16 */
};

static ADC_Handle_t  AdcHandle[NUM_ADCPORT];
static DMA_Handle_t  hdma_adc[NUM_ADCPORT];

extern void RCC_GetPLL2ClockFreq(uint32_t *PLL2_Clocks);
extern void RCC_GetPLL3ClockFreq(uint32_t *PLL3_Clocks);


/*
 *  ADC DMAžλХåؿ
 */
static void
adc_dmatrans_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	/* Update state machine on conversion status if not in error state */
	if((hadc->ErrorCode & (ADC_ERROR_SYS | ADC_ERROR_DMA)) == 0){
		/*
		 *  顼Ǥʤʤ饹ơȤ򹹿
		 */
		hadc->status2 |= ADC_STATUS2_REG_EOC;
		hadc->status   = ADC_STATUS_BUSY_EOC;

		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR)) & ADC_ISR_EOS) != 0){
			/*
			 *  EOSȯξ(ȥꥬե)
			 */
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_EXTEN) == ADC_SOFTWARE_START){
				/*
				 *  ³꤬ʤ
				 */
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_CONT) == 0){
					/* CONT bit is not set, no more conversions expected */
					hadc->status2 &= ~(ADC_STATUS2_REG_BUSY);
					if((hadc->status2 & ADC_STATUS2_INJ_BUSY) == 0){
						hadc->status2 |= ADC_STATUS2_READY;
						hadc->status   = ADC_STATUS_EOC;
					}
				}

			}
		}
		else{	/* NORMAL MODE */
			/* DMA³ʤнλ */
			hadc->status = ADC_STATUS_BUSY_EOC;
			if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_DMNGT_1) == 0){
				hadc->status2 &= ~(ADC_STATUS2_REG_BUSY);
				hadc->status = ADC_STATUS_EOC;
				if((hadc->status & ADC_STATUS2_INJ_BUSY) == 0){
					hadc->status2 |= ADC_STATUS2_READY;
				}
			}
		}

		if(hadc->xfercallback != NULL)
			hadc->xfercallback(hadc);
	}
	else{	/* DMA顼ȯƤ */
		if((hadc->ErrorCode & ADC_ERROR_SYS) != 0){
			if(hadc->errorcallback != NULL)
				hadc->errorcallback(hadc);
		}
	}
}

/*
 *  ADC DMAϡžХåؿ
 */
static void
adc_dmahalftrans_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	if(hadc->xferhalfcallback != NULL)
		hadc->xferhalfcallback(hadc);
}

/*
 *  ADC DMA顼Хåؿ
 */
static void
adc_dmaerror_func(DMA_Handle_t *hdma)
{
	ADC_Handle_t* hadc = ( ADC_Handle_t* )((DMA_Handle_t* )hdma)->localdata;

	hadc->status2 |= ADC_STATUS2_READY;
	hadc->status  = ADC_STATUS_READY;
	hadc->ErrorCode |= ADC_ERROR_DMA;
	if(hadc->errorcallback != NULL)
		hadc->errorcallback(hadc);
}

/*
 *  ADC BOOST⡼ɤꤹ
 */
static void
adc_boostmode(ADC_Handle_t* hadc)
{
	uint32_t freq = 0;
	uint32_t pll_clock[3];

	if((sil_rew_mem((uint32_t *)(hadc->cbase+TOFF_ADC_CCR)) & ADC_CCR_CKMODE) != 0){
		freq = SysFreHCLK;
		switch(hadc->Init.ClockPrescaler){
		case ADC_CLOCK_SYNC_PCLK_DIV1:
		case ADC_CLOCK_SYNC_PCLK_DIV2:
			freq /= (hadc->Init.ClockPrescaler >> 16);
			break;
		case ADC_CLOCK_SYNC_PCLK_DIV4:
			freq /= 4;
			break;
		default:
			break;
		}
	}
	else{
		uint32_t srcclk = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_D3CCIPR)) & RCC_D3CCIPR_ADCSEL;
		uint32_t ckpclocksource;

		switch (srcclk){
		case 0x00000000:			/* PLL2 */
			RCC_GetPLL2ClockFreq(pll_clock);
			freq = pll_clock[0];
			break;
		case RCC_D3CCIPR_ADCSEL_0:	/* PLL3 */
			RCC_GetPLL3ClockFreq(pll_clock);
			freq = pll_clock[2];
			break;
		case RCC_D3CCIPR_ADCSEL_1:	/* CLKP */
			ckpclocksource = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_D1CCIPR)) & RCC_D1CCIPR_CKPERSEL;
			if(ckpclocksource== 0x00000000)	/* HSI */
				freq = HSI_VALUE;
			else if(ckpclocksource== RCC_D1CCIPR_CKPERSEL_0)	/* CSI */
				freq = CSI_VALUE;
			else if(ckpclocksource== RCC_D1CCIPR_CKPERSEL_1)	/* HSE */
				freq = HSE_VALUE;
			else
				freq = 0;
			break;
		default:
			freq = 0;
			break;
		}

		switch(hadc->Init.ClockPrescaler){
		case ADC_CLOCK_ASYNC_DIV2:
		case ADC_CLOCK_ASYNC_DIV4:
		case ADC_CLOCK_ASYNC_DIV6:
		case ADC_CLOCK_ASYNC_DIV8:
		case ADC_CLOCK_ASYNC_DIV10:
		case ADC_CLOCK_ASYNC_DIV12:
			freq /= ((hadc->Init.ClockPrescaler >> 18) << 1);
			break;
		case ADC_CLOCK_ASYNC_DIV16:
			freq /= 16;
			break;
		case ADC_CLOCK_ASYNC_DIV32:
			freq /= 32;
			break;
		case ADC_CLOCK_ASYNC_DIV64:
			freq /= 64;
			break;
		case ADC_CLOCK_ASYNC_DIV128:
			freq /= 128;
			break;
		case ADC_CLOCK_ASYNC_DIV256:
			freq /= 256;
			break;
		default:
			break;
		}
	}

	if((get_revision() >> 16) > REV_ID_Y){
		if (freq <= 6250000)
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BOOST);
		else if(freq <= 12500000)
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BOOST, ADC_CR_BOOST_0);
		else if(freq <= 25000000)
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BOOST, ADC_CR_BOOST_1);
		else /* over 25000000 */
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BOOST, (ADC_CR_BOOST_1 | ADC_CR_BOOST_0));
	}
	else{	 /* STM32H7 silicon Rev.Y */
		if(freq > 20000000)
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BOOST_0);
		else
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BOOST_0);
	}
}

/*
 *  ADCͭ
 */
static ER
adc_enable(ADC_Handle_t* hadc)
{
	uint32_t tick = 0;

	/*
	 *  ADCǧ
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) == 0){

		/*
		 *  ¾μ¹׵᤬ʤȤǧ
		 */
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_BITS_PROPERTY_RS) != 0){
			/*
			 *  ¹׵᤬Хƥ२顼
			 */
			hadc->status   = ADC_STATUS_READY;
			hadc->ErrorCode |= ADC_ERROR_SYS;
			return E_OBJ;
		}

		/*
		 *  ADCͭ
		 */
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BITS_PROPERTY_RS, ADC_CR_ADEN);

		/*
		 *  ADCޥޤϥޥ⡼ɤǤʤϥǥԤ
		 */
		if(is_multimaster(hadc) || (get_multimode(hadc) == ADC_MULTI_INDEPENDENT)){
			while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR)) & ADC_ISR_ADRDY) == 0){
				/*
				 *  ADEN=0ξ֤ȯ١1
				 */
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) == 0)
					sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BITS_PROPERTY_RS, ADC_CR_ADEN);
				if(tick++ > ADC_ENABLE_TIMEOUT){
					/*
					 *  ॢȤʤ饷ƥ२顼
					 */
					hadc->status   = ADC_STATUS_READY;
					hadc->ErrorCode |= ADC_ERROR_SYS;
					return E_TMOUT;
				}
				sil_dly_nse(1000);
			}
		}
	}
	return E_OK;
}

/*
 *  ADC
 */
static ER
adc_disable(ADC_Handle_t* hadc)
{
	uint32_t tick;

	/*
	 *  ADC¹桢ե߳ǧ
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADEN | ADC_CR_ADDIS)) == ADC_CR_ADEN){
		/*
		 *  Ѵ롼׼¹ǤʤȤǧ
		 */
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_JADSTART | ADC_CR_ADSTART)) == 0){
			/*
			 *  ADC
			 */
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BITS_PROPERTY_RS, ADC_CR_ADDIS);
			/*
			 *  EOS/ADRDYߤ򥯥ꥢ
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOSMP | ADC_ISR_ADRDY));
		}
		else{
			/*
			 *  ߾ʤϥƥ२顼
			 */
			hadc->status   = ADC_STATUS_READY;
			hadc->ErrorCode |= ADC_ERROR_SYS;
			return E_SYS;
		}

		/*
		 *  ADCԤ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) != 0){
			if(tick++ > ADC_DISABLE_TIMEOUT){
				/*
				 *  ॢȤʤ饷ƥ२顼
				 */
				hadc->status   = ADC_STATUS_READY;
				hadc->ErrorCode |= ADC_ERROR_SYS;
				return E_TMOUT;
			}
			sil_dly_nse(1000);
		}
	}
	return E_OK;
}

/*
 *  쥮顼ڤӥ󥸥Ѵ
 */
static ER
adc_ConversionStop(ADC_Handle_t* hadc, uint32_t ConversionGroup)
{
	uint32_t tick = 0;
	uint32_t cr = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR));
	uint32_t reassigned = ConversionGroup;

	/*
	 *  С󥰥롼׼¹Ƚ
	 */
	if((cr & (ADC_CR_ADSTART | ADC_CR_JADSTART)) != 0){
		/*
		 *  ưٱ⡼ɤȤ߹碌Ϣ³ư⡼ɤξ
		 *  ̾Υ롼(ADC_CR_ADSTP)ȤʤΤJEOS=1ԤJEOS򥯥ꥢ
		 */
		if(((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_JAUTO) != 0)
			&& (hadc->Init.ContinuousConvMode == ADC_CONTINUOUS_ENABLE)
				&& (hadc->Init.LowPowerAutoWait == ADC_LOWAUTOWAIT_ENABLE)){
			reassigned = ADC_REGULAR_GROUP;

			/* Wait until JEOS=1 (maximum Timeout: 4 injected conversions) */
			while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR)) & ADC_ISR_JEOS) == 0){
				if (tick++ > (ADC_CONVERSION_TIME_MAX_CPU_CYCLES * 4)){
					/*
					 *  ॢȤʤ饷ƥ२顼
					 */
					hadc->status   = ADC_STATUS_READY;
					hadc->ErrorCode |= ADC_ERROR_SYS;
					return E_SYS;
				}
			}
			/*
			 *  JEOS򥯥ꥢ
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_JEOS);
		}

		/*
		 *  ̾Ѵ(REGULARѴ)
		 */
		if(reassigned != ADC_INJECTED_GROUP){
			cr = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR));
			/*
			 *  եȥ߲Ĥʤ
			 */
			if((cr & (ADC_CR_ADSTART | ADC_CR_ADDIS)) == ADC_CR_ADSTART)
				sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BITS_PROPERTY_RS, ADC_CR_ADSTP);
		}

		/*
		 *  ̾Ѵ(REGULARѴ)
		 */
		if(reassigned != ADC_INJECTED_GROUP){
			cr = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR));
			/*
			 *  եȥ߲Ĥʤ
			 */
			if((cr & (ADC_CR_JADSTART | ADC_CR_ADDIS)) == ADC_CR_JADSTART)
				sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BITS_PROPERTY_RS, ADC_CR_JADSTP);
		}

		/*
		 *  Ԥ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & reassigned) != 0){
			if(tick++ > ADC_STOP_CONVERSION_TIMEOUT){
				/*
				 *  ॢȤʤ饷ƥ२顼
				 */
				hadc->status   = ADC_STATUS_READY;
				hadc->ErrorCode |= ADC_ERROR_SYS;
				return E_TMOUT;
			}
			sil_dly_nse(1000);
		}
	}
	return E_OK;
}

/*
 *  ADC
 *  parameter1  port: ADCݡֹ
 *  parameter2  pini: ADC깽¤ΤؤΥݥ
 *  return ADCϥɥؤΥݥ󥿡NULLǥ顼
 */
ADC_Handle_t *
adc_init(ID portid, ADC_Init_t* pini)
{
	ADC_Handle_t *hadc;
	const ADC_PortControlBlock *apcb;
	DMA_Handle_t *hdma;
	uint32_t tmp;

	/*
	 *  ѥ᡼å
	 */
	if(portid < 1 || portid > NUM_ADCPORT)
		return NULL;

	hadc = &AdcHandle[INDEX_ADC(portid)];
	memcpy(&hadc->Init, pini, sizeof(ADC_Init_t));

	apcb = &adc_pcb[INDEX_ADC(portid)];
	hadc->base  = apcb->base;
	hadc->cbase = apcb->cbase;
	hadc->pbase = apcb->pbase;

	/*
	 *  ADCå
	 */
	sil_orw_mem((uint32_t *)(apcb->adcclockbase), apcb->adcclockbit);
	sil_rew_mem((uint32_t *)(apcb->adcclockbase));

	/*
	 *  DMAбСDMAԤ
	 */
	hdma = &hdma_adc[INDEX_ADC(portid)];
	if(is_dmamode(pini) && (hdma->base = dma_stream_base(pini->DMAChannel)) != 0){
		hdma->Init.Request  = apcb->dmarxrequest;
		hdma->Init.Direction = DMA_PERIPH_TO_MEMORY;
		hdma->Init.PeriphInc = DMA_PINC_DISABLE;
		hdma->Init.MemInc = DMA_MINC_ENABLE;
		hdma->Init.PeriphDataAlignment = DMA_PDATAALIGN_WORD;
		hdma->Init.MemDataAlignment = DMA_MDATAALIGN_WORD;
		if(pini->ConversionDataManagement != ADC_CONVERSIONDATA_DMA_CIRCULAR)
			hdma->Init.Mode = DMA_NORMAL;
		else
			hdma->Init.Mode = DMA_CIRCULAR;
		hdma->Init.Priority = DMA_PRIORITY_HIGH;
		hdma->Init.FIFOMode = DMA_FIFOMODE_DISABLE;
		hdma->Init.FIFOThreshold = DMA_FIFO_THRESHOLD_HALFFULL;
		hdma->Init.MemBurst = DMA_MBURST_SINGLE;
		hdma->Init.PeriphBurst = DMA_PBURST_SINGLE;

		dma_init(hdma);

		hadc->hdmarx    = hdma;
		hdma->localdata = hadc;
	}
	else
		hadc->hdmarx = NULL;

    /*
	 *  DEEP-POWER-DOWN⡼ɤʤꥻåȤ
	 */ 
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_DEEPPWD) != 0){
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), (ADC_CR_DEEPPWD | ADC_CR_BITS_PROPERTY_RS));
	}

	/*
	 *  ADC Voltage regulatorͭȤʤäƤʤʤʤ顢
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADVREGEN) == 0){
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BITS_PROPERTY_RS, ADC_CR_ADVREGEN);
		sil_dly_nse(10*1000);
	}
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADVREGEN) == 0)
		return NULL;

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return NULL;

	/*
	 *  ADCΥץꥹ()
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) == 0 && 
			(sil_rew_mem((uint32_t *)(hadc->pbase+TOFF_ADC_CR)) & ADC_CR_ADEN) == 0){
		sil_modw_mem((uint32_t *)(hadc->cbase+TOFF_ADC_CCR), (ADC_CCR_CKMODE | ADC_CCR_PRESC), hadc->Init.ClockPrescaler);
	}

	/*
	 *  ADC
	 *  CFG쥸
	 */
	if((get_revision() >> 16) > REV_ID_Y && hadc->Init.Resolution == ADC_RESOLUTION_8B){
		tmp = hadc->Init.ContinuousConvMode | hadc->Init.Overrun | \
		      hadc->Init.Resolution |(ADC_CFGR_RES_1|ADC_CFGR_RES_0) | hadc->Init.DiscontinuousConvMode;
	}
	else{
		tmp = hadc->Init.ContinuousConvMode | hadc->Init.Overrun | \
		      hadc->Init.Resolution | hadc->Init.DiscontinuousConvMode;
	}

	if(hadc->Init.DiscontinuousConvMode == ADC_DISCONTINUOUS_ENABLE)
		tmp |= (hadc->Init.NumDiscConversion << 17) & ADC_CFGR_DISCNUM;

    /*
	 *  External triggerξ硢ȥꥬꤹ
	 */
	if (hadc->Init.ExternalTrigConv != ADC_SOFTWARE_START)
		tmp |= (hadc->Init.ExternalTrigConv & ADC_CFGR_EXTSEL) | hadc->Init.ExternalTrigConvEdge;
	sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), ADC_CFGR_FIELDS_1, tmp);

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADSTART | ADC_CR_JADSTART)) == 0){
		/*
		 *  Conversion data management
		 */
		tmp = (hadc->Init.LowPowerAutoWait & ADC_CFGR_AUTDLY) | hadc->Init.ConversionDataManagement;
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), ADC_CFGR_FIELDS_2, tmp);

		/*
		 *  Сץ󥰥⡼
		 */
		if(hadc->Init.OversamplingMode == ADC_OVR_SAMPLING_ENABLE){
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_FIELDS,
			                (ADC_CFGR2_ROVSE | (hadc->Init.OversamplingRatio << 16) | \
			                 hadc->Init.OversamplingRightBitShift | hadc->Init.OversamplingTriggeredMode | \
			                 hadc->Init.OversamplingStopReset));

		}
		else
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_ROVSE);

		/*
		 *  LeftShift
		 */
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_LSHIFT, hadc->Init.LeftBitShift);

		/*
		 *  BOOST⡼
		 */
		adc_boostmode(hadc);
	}

	/*
	 *  С
	 */
    if(hadc->Init.ScanConvMode == ADC_SCANMODE_ENABLE)
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR1), ADC_SQR1_L, (hadc->Init.NumConversion - 1));
    else
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR1), ADC_SQR1_L);

	/*
	 *  ADC֤
	 */
	hadc->ErrorCode = ADC_ERROR_NONE;
	hadc->status = ADC_STATUS_READY;
	hadc->status2 = ADC_STATUS2_READY;
	return hadc;
}

/*
 *  ADCλ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_deinit(ADC_Handle_t* hadc)
{
	if(hadc == NULL)
		return E_PAR;

	/*
	 *  ADC
	 */
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_INT_MASK);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_INT_CLEAR);

	/*
	 *  ADCꥻå()
	 */
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_ADCALDIF);
	sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_DEEPPWD);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), ADC_CFGR_CLEAR);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR), ADC_CFGR_JQDIS);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR2), ADC_CFGR2_CLEAR);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR1), ADC_SMPR1_FIELDS);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_SMPR2), ADC_SMPR2_FIELDS);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_LTR1), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_HTR1), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_LTR2), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_HTR2), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_LTR3), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_HTR3), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR1), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR2), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR3), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_SQR4), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR1), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR2), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR3), 0x00000000);
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR4), 0x00000000);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD2CR), ADC_AWD2CR_AWD2CH);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD3CR), ADC_AWD3CR_AWD3CH);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_DIFSEL), ADC_DIFSEL_DIFSEL);
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_CALFACT), (ADC_CALFACT_CALFACT_D | ADC_CALFACT_CALFACT_S));

	/*
	 *  ADC쥸ꥻå
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) == 0 && 
			(sil_rew_mem((uint32_t *)(hadc->pbase+TOFF_ADC_CR)) & ADC_CR_ADEN) == 0){

		sil_andw_mem((uint32_t *)(hadc->cbase+TOFF_ADC_CCR), (ADC_CCR_CKMODE | ADC_CCR_PRESC | \
								ADC_CCR_VBATEN | ADC_CCR_TSEN   | ADC_CCR_VREFEN    | \
								ADC_CCR_DAMDF  | ADC_CCR_DELAY  | ADC_CCR_DUAL));
	}

	/*
	 *  DMA
	 */
	if(hadc->hdmarx != NULL){
		dma_deinit(hadc->hdmarx);
		hadc->hdmarx = NULL;
	}

	/*
	 *  ADCξֽ
	 */
	hadc->ErrorCode = ADC_ERROR_NONE;
	hadc->status = ADC_STATUS_RESET;
	return E_OK;
}

/*
 *  ADC-ߥ⡼ɳϽ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_start_int(ADC_Handle_t* hadc)
{
	uint32_t multimode;
	ER ercd;

	if(hadc == NULL)
		return E_PAR;

	/*
	 *  ¹Ծ֤˰ܹ
	 */
	hadc->status = ADC_STATUS_BUSY;
	hadc->ErrorCode = ADC_ERROR_NONE;
	multimode = get_multimode(hadc);

	/*
	 *  ADSTARTγǧ
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return E_OBJ;
	/*
	 *  ADCͭ
	 */
	if((ercd =adc_enable(hadc)) != E_OK)
		return ercd;

	/*
	 *  ADCơꥻå
	 */
	hadc->status2 &= ~(ADC_STATUS2_READY | ADC_STATUS2_REG_EOC | ADC_STATUS2_REG_OVR | ADC_STATUS2_REG_EOSMP);
	hadc->status2 |= ADC_STATUS2_REG_BUSY;
	hadc->status   = ADC_STATUS_BUSY;

	/*
	 *  ̾⡼ɤʤСޥ⡼-졼֥ӥåȤ򥯥ꥢ
	 */
	if (is_multimaster(hadc) || multimode == ADC_MULTI_INDEPENDENT)
		hadc->status2 &= ~(ADC_STATUS2_MULTI_SLAVE);

	/*
	 *  顼ꥻå
	 */
	if((hadc->status2 & ADC_STATUS2_INJ_BUSY) != 0)
		hadc->ErrorCode &= ~(ADC_ERROR_OVR | ADC_ERROR_DMA);
	else
		hadc->ErrorCode = ADC_ERROR_NONE;
 
	/*
	 *  ߥꥢ
	 */
	sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOS | ADC_ISR_OVR));

	/*
	 *  ߶ػ
	 */
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_EOCIE | ADC_IER_EOSIE | ADC_IER_OVRIE));

	/*
	 *  ADCѴλ
	 */
	switch(hadc->Init.EOCSelection){
	case ADC_EOC_SEQ_CONV:
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_EOSIE);
		break;
	default:
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_EOCIE);
		break;
	}

	/*
	 *  Сǧɬפʤ
	 */
	if(hadc->Init.Overrun == ADC_OVR_DATA_PRESERVED)
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_OVRIE);

	/*
	 *  С󡦥롼Ԥ
	 */
	if(is_multimaster(hadc) || multimode == ADC_MULTI_INDEPENDENT || \
			multimode == ADC_MULTI_DUAL_INJ_SIMULT || multimode == ADC_MULTI_DUAL_INJ_ALTERN){

        /*
		 *  ޥ졼֥⡼ɤǤʤССӥ
		 */
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_JAUTO) != 0){
			hadc->status2 &= ~ADC_STATUS2_INJ_EOC;
			hadc->status2 |= ADC_STATUS2_INJ_BUSY;
		}

		/*
		 *  EOCԤ
		 */
		switch(hadc->Init.EOCSelection){
		case ADC_EOC_SEQ_CONV: 
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_JEOCIE);
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_JEOSIE);
			break;
		default:
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_JEOSIE);
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_JEOCIE);
			break;
		}

		/*
		 *  ADSTART
		 */
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR), ADC_CR_BITS_PROPERTY_RS, ADC_CR_ADSTART);
	}
	else{
		uint32_t mbase = hadc->base;
		if(mbase == TADR_ADC2_BASE)
			mbase = hadc->pbase;
		/*
		 *  ޥ졼־
		 */
		hadc->status2 |= ADC_STATUS2_MULTI_SLAVE;

		/*
		 *  ޥ졼֥⡼ɤʤEOCԤ
		 */
		if((sil_rew_mem((uint32_t *)(mbase+TOFF_ADC_CFGR)) & ADC_CFGR_JAUTO) != 0){
			hadc->status2 &= ~ADC_STATUS2_INJ_EOC;
			hadc->status2 |= ADC_STATUS2_INJ_BUSY;

			/*
			 *  EOCԤ
			 */
			switch(hadc->Init.EOCSelection){
			case ADC_EOC_SEQ_CONV: 
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_JEOCIE);
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_JEOSIE);
				break;
			default:
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_JEOSIE);
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_JEOCIE);
				break;
			}
		}
	}
	return E_OK;
}

/*
 *  ADC-ߥ⡼߽
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_end_int(ADC_Handle_t* hadc)
{
	ER ercd;

	if(hadc == NULL)
		return E_PAR;

	/*
	 *  С󡦥롼
	 */
	if((ercd = adc_ConversionStop(hadc, ADC_REGULAR_INJECTED_GROUP)) != E_OK)
		return ercd;

	/*
	 *  ž顼
	 */
	sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_EOCIE | ADC_IER_EOSIE | ADC_IER_OVRIE));

	/*
	 *  ADC̵
	 */
	if((ercd = adc_disable(hadc)) == E_OK){
		/*
		 *  ʤСơꥻå
		 */
		hadc->status2 &= ~(ADC_STATUS2_REG_BUSY | ADC_STATUS2_INJ_BUSY);
		hadc->status2 |= ADC_STATUS2_READY;
		hadc->status   = ADC_STATUS_READY;
	}
	return ercd;
}

/*
 *  ADC-DMA⡼ɳϽ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  pdata: ΰΥݥ
 *  parameter3  length: ǡĹ
 *  return ER
 */
ER
adc_start_dma(ADC_Handle_t* hadc, uint32_t* pdata, uint32_t length)
{
	ER ercd;
	uint32_t multimode;

	if(hadc == NULL)
		return E_PAR;

	multimode = get_multimode(hadc);

	/*
	 *  ADSTART̤¹Ƚ
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) != 0)
		return E_OBJ;

	/*
	 *  ¹Բǽʥޥ⡼ɤ
	 */
	if(multimode == ADC_MULTI_INDEPENDENT ||
			multimode == ADC_MULTI_DUAL_INJ_SIMULT || multimode == ADC_MULTI_DUAL_INJ_ALTERN){
		/*
		 *  ADCͭ
		 */
		if((ercd = adc_enable(hadc)) != E_OK)
			return ercd;

		/*
		 *  ADCơꥻå
		 */
		hadc->status2 &= (~ADC_STATUS2_READY | ADC_STATUS2_REG_EOC | ADC_STATUS2_REG_OVR | ADC_STATUS2_REG_EOSMP);
		hadc->status2 |= ADC_STATUS2_REG_BUSY;
		hadc->status   = ADC_STATUS_BUSY;

		/*
		 *  ̾⡼ɤʤСޥ⡼-졼֥ӥåȤ򥯥ꥢ
		 */
		if(is_multimaster(hadc) || (multimode == ADC_MULTI_INDEPENDENT)){
			hadc->status2 &= ~(ADC_STATUS2_MULTI_SLAVE);
		}

		/*
		 *  顼ꥻå
		 */
		if((hadc->status2 & ADC_STATUS2_INJ_BUSY) != 0)
			hadc->ErrorCode &= ~(ADC_ERROR_OVR | ADC_ERROR_DMA);
		else
			hadc->ErrorCode = ADC_ERROR_NONE;

		/*
		 *  DMAХåؿ
		 */
		hadc->hdmarx->xfercallback = adc_dmatrans_func;
		hadc->hdmarx->xferhalfcallback = adc_dmahalftrans_func;
		hadc->hdmarx->errorcallback = adc_dmaerror_func;

		/*
		 *  װꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOS | ADC_ISR_OVR));

		/*
		 *  Сߤͭ
		 */
		sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_OVRIE);

		/*
		 *  DMA
		 */
		dma_start(hadc->hdmarx, hadc->base+TOFF_ADC_DR, (uint32_t)pdata, length);

		/*
		 *  ADC롼Ѵͭ
		 */
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_CR),
					ADC_CR_BITS_PROPERTY_RS, ADC_CR_ADSTART);
	}
	return E_OK;
}

/*
 *  ADC-DMA⡼߽
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return ER
 */
ER
adc_end_dma(ADC_Handle_t* hadc)
{
	ER ercd = E_OK;

	if(hadc == NULL)
		return E_PAR;

	/* 1. Stop potential conversion on going, on ADC groups regular and injected */
	if(adc_ConversionStop(hadc, ADC_REGULAR_INJECTED_GROUP) == E_OK){
		/*
		 *  DMA
		 */
		if(hadc->hdmarx->status == DMA_STATUS_BUSY){
			if(hadc->hdmarx != NULL)
				dma_end(hadc->hdmarx);
		}

		/*
		 *  Сߤޥ
		 */
		sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_OVRIE);

		/*
		 *  ADC⥸塼
		 */
		ercd = adc_disable(hadc);

		/*
		 *  ǥ֤˰ܹ
		 */
		if(ercd == E_OK){
			hadc->status2 &= ~(ADC_STATUS2_REG_BUSY | ADC_STATUS2_INJ_BUSY);
			hadc->status2 |= ADC_STATUS2_READY;
			hadc->status   = ADC_STATUS_READY;
		}
	}
	return ercd;
}

/*
 *  ADC ߥϥɥ¹Դؿ
 */
void
adc_handler(ADC_Handle_t* hadc)
{

	uint32_t isr  = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR));
	uint32_t ier  = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_IER));
	uint32_t cfgr;
	uint32_t multimode = get_multimode(hadc);
	bool_t inj_trigger_source_sw_start;
	bool_t reg_trigger_source_sw_start;

	/*
	 *  쥮顼СνλȽ
	 */
	if((isr & ADC_ISR_EOSMP) != 0 && (ier & ADC_IER_EOSMPIE) != 0){
		/*
		 *  顼ʤСEOC֤˰ܹ
		 */
		if((hadc->ErrorCode & ADC_ERROR_SYS) == 0){
			/* Set ADC state */
			hadc->status2 |= ADC_STATUS2_REG_EOSMP;
			hadc->status   = ADC_STATUS_EOC;
		}
		if(hadc->eoscallback != NULL)
			hadc->eoscallback(hadc);

		/*
		 *  쥮顼Сγߤ򥯥ꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_EOSMP);
	}

		/*
		 *  оݤΥե졼쥸Ф
		 */
		if(is_multimaster(hadc)
			|| (multimode == ADC_MULTI_INDEPENDENT)
			|| (multimode == ADC_MULTI_DUAL_INJ_SIMULT)
			|| (multimode == ADC_MULTI_DUAL_INJ_ALTERN)){
			/*
			 *  ޥޤϡѹǽʥޥ⡼ɤʤ顢١CFGR򻲾
			 */
			cfgr = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR));
		}
		else{
			/*
			 *  ǤʤϡޥCFGRѹ
			 */
			cfgr = sil_rew_mem((uint32_t *)(hadc->pbase+TOFF_ADC_CFGR));
		}

	/*
	 *  쥮顼С˥ꥣͥνλȽ
	 */
	if(((isr & ADC_ISR_EOC) != 0 && (ier & ADC_IER_EOCIE) != 0)
		 || ((isr & ADC_ISR_EOS) != 0 && (ier & ADC_IER_EOSIE) != 0)){
		/*
		 *  顼̤ȯʤнλ
		 */
		if((hadc->ErrorCode & ADC_ERROR_SYS) == 0){
			/*
			 *  EOCơ򥻥å
			 */
			hadc->status2 |= ADC_STATUS2_REG_EOC;
			hadc->status   = ADC_STATUS_EOC;
		}

		/*
		 *  եȥȥꥬξ
		 */
		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_EXTEN) == ADC_SOFTWARE_START){
			/*
			 *  ƥ˥⡼ɤǤʤEOSߤξ硢ơѹԤ
			 */
			if((cfgr & ADC_CFGR_CONT) == 0 && (isr & ADC_ISR_EOS) != 0){
				/*
				 *  ADSTARTդξ硢ߥޥǥ
				 */
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) == 0){
					sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_EOCIE | ADC_IER_EOSIE);
					hadc->status2 &= ~(ADC_STATUS2_REG_BUSY);
					hadc->status   = ADC_STATUS_READY;
					if((hadc->status2 & ADC_STATUS2_INJ_BUSY) == 0)
						hadc->status2 |= ADC_STATUS2_READY;
				}
				else{
					/*
					 *  嵭ʳϥ顼
					 */
					hadc->status   = ADC_STATUS_READY;
					hadc->ErrorCode |= ADC_ERROR_SYS;
				}
			}
		}
		/*
		 *  λХåؿɤ߽Ф
		 */
		if(hadc->xfercallback != NULL)
			hadc->xfercallback(hadc);
		/*
		 * 쥮顼žγߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_EOC | ADC_ISR_EOS));
	}

	/*
	 *  󥸥ƥåȥ˥ꥣͥνλȽ
	 */
	if(((isr & ADC_ISR_JEOC) != 0 && (ier & ADC_IER_JEOCIE) != 0)
		 ||	((isr & ADC_ISR_JEOS) != 0 && (ier & ADC_IER_JEOSIE) != 0)){
		/*
		 *  顼ǤʤСEOC֤
		 */
		if((hadc->ErrorCode & ADC_ERROR_SYS) == 0)
			hadc->status2 |= ADC_STATUS2_INJ_EOC;

		/*
		 *  ѴμФ
		 */
		inj_trigger_source_sw_start = ((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_JSQR)) & ADC_JSQR_JEXTEN) == (ADC_INJ_TRIG_SOFTWARE & ADC_JSQR_JEXTEN));
		reg_trigger_source_sw_start = ((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_EXTEN) == ADC_SOFTWARE_START);

		/*
		 *  ȥꥬޤ̾ѴǺѴȯʤ硢ߤػߤ
		 *  󥹤ߤ
		 */
		if(inj_trigger_source_sw_start ||
			((cfgr & ADC_CFGR_JAUTO) == 0 &&
				(reg_trigger_source_sw_start && (cfgr & ADC_CFGR_CONT) == 0))){
			if((isr & ADC_ISR_JEOS) != 0 && (cfgr & ADC_CFGR_JQM) == 0){
				/*
				 *  Ѵ׵̵ͭȽ
				 */
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_JADSTART) == 0){
					/*
					 *  оݤγߤػߡơ
					 */
					sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), (ADC_IER_JEOCIE | ADC_IER_JEOSIE));

					hadc->status2 &= ~(ADC_STATUS2_INJ_BUSY);
					hadc->status   = ADC_STATUS_READY;
					if((hadc->status2 & ADC_STATUS2_REG_BUSY) == 0){
						hadc->status2 |= ADC_STATUS2_READY;
					}
				}
				else{
					/*
					 *  嵭ξʳϥƥ२顼Ȥ
					 */
					hadc->status   = ADC_STATUS_READY;
					hadc->ErrorCode |= ADC_ERROR_SYS;
				}
			}
		}

		/*
		 *  󥸥ƥåȥͥߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), (ADC_ISR_JEOC | ADC_ISR_JEOS));

		/*
		 *  λХåؿɤ߽Ф
		 */
		if(hadc->xfercallback != NULL)
			hadc->xfercallback(hadc);
	}

	/*
	 *  ʥåɥå#1Ƚ
	 */
	if((isr & ADC_ISR_AWD1) != 0 && (ier & ADC_IER_AWD1IE) != 0){
		/*
		 *  åɥå#1ȯ֤ѹ
		 */
		hadc->status  |= ADC_STATUS_AWD;
		hadc->status2 |= ADC_STATUS2_AWD1;

		/*
		 *  åɥå#1ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD1);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwin1callback != NULL)
			hadc->outofwin1callback(hadc);
	}

	/*
	 *  ʥåɥå#2Ƚ
	 */
	if((isr & ADC_ISR_AWD2) != 0 && (ier & ADC_IER_AWD2IE) != 0){
		/*
		 *  åɥå#2ȯ֤ѹ
		 */
		hadc->status  |= ADC_STATUS_AWD;
		hadc->status2 |= ADC_STATUS2_AWD2;

		/*
		 *  åɥå#2ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD2);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwin2callback != NULL)
			hadc->outofwin2callback(hadc);
	}

	/*
	 *  ʥåɥå#3Ƚ
	 */
	if((isr & ADC_ISR_AWD3) != 0 && (ier & ADC_IER_AWD3IE) != 0){
		/*
		 *  åɥå#3ȯ֤ѹ
		 */
		hadc->status  |= ADC_STATUS_AWD;
		hadc->status2 |= ADC_STATUS2_AWD3;

		/*
		 *  åɥå#3ߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD3);

		/*
		 *  ɥΰ襢ȤΥХåؿɤ߽Ф
		 */
		if(hadc->outofwin3callback != NULL)
			hadc->outofwin3callback(hadc);
	}

	/*
	 *  С󥨥顼Ƚ
	 */
	if((isr & ADC_ISR_OVR) != 0 && (ier & ADC_IER_OVRIE) != 0){
		bool_t overrun_error = false;
		/*
		 *  С󥨥顼Ƚ
		 */
		if (hadc->Init.Overrun == ADC_OVR_DATA_PRESERVED){
			overrun_error = true;
		}
		else{
			/*
			 *  DMA⡼ɤξϥ顼Ƚ
			 */
			if((sil_rew_mem((uint32_t *)(hadc->cbase+TOFF_ADC_CCR)) & ADC_CCR_DAMDF) != 0)
				overrun_error = true;
		}

		/*
		 *  Сߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_OVR);
	    if(overrun_error){
			/*
			 *  Сȯ֤ѹ
			 */
			hadc->status2 |= ADC_STATUS2_REG_OVR;
			hadc->status   = ADC_STATUS_READY;
			hadc->ErrorCode |= ADC_ERROR_OVR;

			/*
			 *  顼Хåؿɤ߽Ф
			 */
			if(hadc->errorcallback != NULL)
				hadc->errorcallback(hadc);
		}
	}

	/*
	 *  󥸥ƥåȥС󥨥顼Ƚ
	 */
	if((isr & ADC_ISR_JQOVF) != 0 && (ier & ADC_IER_JQOVFIE) != 0){
		/*
		 *  󥸥ƥåȥСȯ֤ѹ
		 */
		hadc->status2 |= ADC_STATUS2_INJ_JQOVF;
		hadc->status   = ADC_STATUS_READY;
		hadc->ErrorCode |= ADC_ERROR_JQOVF;

		/*
		 *  󥸥ƥåȥСߥꥢ
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_JQOVF);

		/*
		 *  顼Хåؿɤ߽Ф
		 */
		if(hadc->errorcallback != NULL)
			hadc->errorcallback(hadc);
	}
}

/*
 *  ADCߥӥϥɥ
 */
void
adc_isr_handler(intptr_t exinf)
{
	adc_handler(&AdcHandle[INDEX_ADC(((uint_t)exinf))]);
}


/*
 *  쥮顼쥸μФ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  return 쥮顼쥸
 */
uint32_t
adc_getvalue(ADC_Handle_t* hadc)
{
	return sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_DR));
}

/*
 *  ADCͥ
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  sConfig: ͥ깽¤ΤؤΥݥ
 *  return ER
 */
ER
adc_setupchannel(ADC_Handle_t* hadc, ADC_ChannelConf_t* sConfig)
{
	GPIO_Init_t GPIO_InitStruct;
	uint32_t clkpin;
	ER ercd = E_OK;
	uint32_t offshift, toff, rank;

	if(hadc == NULL || sConfig == NULL)
		return E_PAR;

	clkpin = (sConfig->GpioBase - TADR_GPIOA_BASE) / 0x400;
	if(clkpin >= 12 || sConfig->GpioPin >= 16)
		return E_PAR;
	if(sConfig->Rank < 1 || sConfig->Rank > 16)
		return E_PAR;

	rank = rank_table[sConfig->Rank-1];

	/*
	 *  ͥͭ
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR), 1<<clkpin);
	sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR));

	GPIO_InitStruct.mode = GPIO_MODE_ANALOG;
	GPIO_InitStruct.pull = GPIO_NOPULL;
	gpio_setup(sConfig->GpioBase, &GPIO_InitStruct, sConfig->GpioPin);

	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADSTART) == 0){

		/*
		 *  ֹͥ
		 */
		if((sConfig->Channel & ADC_AWD2CR_AWD2CH) == 0){
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_PCSEL),
				 (1 << ((sConfig->Channel & ADC_CFGR_AWD1CH) >> 26)));
		}
		else{
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_PCSEL), (sConfig->Channel &ADC_AWD2CR_AWD2CH));
		}

		/*
		 *  
		 */
		toff = TOFF_ADC_SQR1 + ((rank & 0x00000300) >> 6);
		sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_SQR2_SQ5 << (rank & ADC_SQR2_SQ5)),
				(((sConfig->Channel & ADC_CFGR_AWD1CH) >> 26) << (rank & ADC_SQR2_SQ5)));

		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_JADSTART) == 0){
			/*
			 *  ץ󥰻
			 */
			toff = TOFF_ADC_SMPR1 + ((sConfig->Channel & ADC_SMPR2_REGOFFSET) >> 23);
			sil_modw_mem((uint32_t *)(hadc->base+toff),
				(ADC_SMPR1_SMP0 << ((sConfig->Channel & 0x01F00000) >> 20)),
					(sConfig->SamplingTime << ((sConfig->Channel & 0x01F00000) >> 20)));

			/*
			 *  եå
			 */
			if((get_revision() & 0xF0000000) == 0x10000000 || (sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_RES_2) == 0)
				offshift = sConfig->Offset << (((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & ADC_CFGR_RES) >> 2) * 2);
			else
				offshift = sConfig->Offset << (((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR)) & (ADC_CFGR_RES & 0xFFFFFFF3)) >> 2) * 2);

			if(sConfig->OffsetNumber < ADC_OFFSET_NONE){
				toff = TOFF_ADC_OFR1 + (sConfig->OffsetNumber << 2);
				sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_OFR1_OFFSET1_CH | ADC_OFR1_OFFSET1),
						(sConfig->Channel & ADC_CFGR_AWD1CH) | offshift);
				sil_modw_mem((uint32_t *)(hadc->base+toff), ADC_OFR1_SSATE, sConfig->OffsetSignedSaturation);
			}
			else{
		        /*
				 *  ADC OFFSETѤʤ硢OFRбͥΥ졼򥪥դ
				 */
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR1)) & ADC_OFR1_OFFSET1_CH) == get_ofr_channel(sConfig->Channel))
					sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR1), ADC_OFR1_SSATE);
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR2)) & ADC_OFR2_OFFSET2_CH) == get_ofr_channel(sConfig->Channel))
					sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR2), ADC_OFR2_SSATE);
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR3)) & ADC_OFR3_OFFSET3_CH) == get_ofr_channel(sConfig->Channel))
					sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR3), ADC_OFR3_SSATE);
				if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR4)) & ADC_OFR4_OFFSET4_CH) == get_ofr_channel(sConfig->Channel))
					sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_OFR4), ADC_OFR4_SSATE);
			}
		}

		if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) == 0){
			/*
			 *  ADC󥰥/ǥե󥷥뽪λԤ
			 */
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_DIFSEL),
				(sConfig->Channel & ADC_AWD2CR_AWD2CH),
					(sConfig->Channel & ADC_AWD2CR_AWD2CH) & (ADC_DIFSEL_DIFSEL >> (sConfig->SingleDiff & (ADC_CALFACT_CALFACT_S_4 | ADC_CALFACT_CALFACT_S_3))));

			/*
			 *  ǥե󥷥⡼
			 */
			if(sConfig->SingleDiff == ADC_DIFFERENTIAL_ENDED){
				uint32_t nb, ch;

				if((sConfig->Channel & ADC_AWD2CR_AWD2CH) == 0)
					nb = (sConfig->Channel & ADC_CFGR_AWD1CH) >> 26;
				else{
					for(nb = 0 ; nb < 20 ; nb++){
						if((sConfig->Channel & (1 << nb)) != 0)
							break;
					}
				}
				ch = (nb + 1) & 0x1F;
				if(ch <= 9UL){
					ch = (ch << 26) | (ADC_AWD2CR_AWD2CH_0 << ch) | ((3 * ch) << 20);
				}
				else{
					ch = (ch << 26) | (ADC_AWD2CR_AWD2CH_0 << ch) | (ADC_SMPR2_REGOFFSET | (((3UL * (ch - 10UL))) << 20));
				}
				toff = TOFF_ADC_SMPR1 + ((ch & ADC_SMPR2_REGOFFSET) >> 23);
				sil_modw_mem((uint32_t *)(hadc->base+toff),
					(ADC_SMPR1_SMP0 << ((ch & 0x01F00000) >> 20)),
						(sConfig->SamplingTime << ((sConfig->Channel & 0x01F00000) >> 20)));
			}

			/*
			 *  Ű󥵡Хåƥѥͥ
			 */
			if((sConfig->Channel & ADC_CHANNEL_ID_INTERNAL_CH) != 0){
				uint32_t channel = sil_rew_mem((uint32_t *)(hadc->cbase+TOFF_ADC_CCR)) & (ADC_CCR_VREFEN | ADC_CCR_TSEN | ADC_CCR_VBATEN);
				volatile uint32_t tick = ((ADC_DELAY_TEMPSENSOR_STAB_US / 10) * (SystemFrequency / (100000 * 2)));

				/*
				 *  ADC3ߤȽ
				 */
				if(hadc->base == TADR_ADC3_BASE && (sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & ADC_CR_ADEN) == 0){
					/*
					 *  ɥ󥵡
					 */
					if((sConfig->Channel == ADC_CHANNEL_TEMPSENSOR) && ((channel & ADC_CCR_TSEN) == 0)){
						sil_orw_mem((uint32_t *)(hadc->cbase+TOFF_ADC_CCR), ADC_CCR_TSEN);

						/*
						 *  CPUåԤ
						 */
						while(tick != 0){
							tick--;
						}
					}
					/*
					 *  Хåƥ
					 */
					else if ((sConfig->Channel == ADC_CHANNEL_VBAT) && ((channel & ADC_CCR_VBATEN) == 0)){
						sil_orw_mem((uint32_t *)(hadc->cbase+TOFF_ADC_CCR), ADC_CCR_VBATEN);
					}
					/*
					 *  Ű
					 */
					else if((sConfig->Channel == ADC_CHANNEL_VREFINT) && ((channel & ADC_CCR_VREFEN) == 0)){
						sil_orw_mem((uint32_t *)(hadc->cbase+TOFF_ADC_CCR), ADC_CCR_VREFEN);
					}
				}
				else{
					/*
					 *  ڤؤʤ硢ե졼󥨥顼
					 */
					hadc->status     = ADC_STATUS_READY;
					hadc->ErrorCode |= ADC_ERROR_CONFIG;
					ercd = E_OBJ;
				}
			}
		}
	}
	else
		ercd = E_OBJ;
	return ercd;
}

/*
 *  ADCʥåɥå
 *  parameter1  hadc: ADCϥɥؤΥݥ
 *  parameter2  AnalogWDGConfig: ʥåɥå깽¤ΤؤΥݥ
 *  return ER
 */
ER
adc_setupwatchdog(ADC_Handle_t* hadc, ADC_AnalogWDGConf_t* AnalogWDGConfig)
{
	uint32_t highshift, lowshift, cfgr;

	if(hadc == NULL || AnalogWDGConfig == NULL)
		return E_PAR;

	cfgr = sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CFGR));
	if((get_revision() & 0xF0000000) == 0x10000000 || (cfgr & ADC_CFGR_RES_2) == 0){
		highshift = (AnalogWDGConfig->HighThreshold << (cfgr & ADC_CFGR_RES) >> 2) * 2;
		lowshift = (AnalogWDGConfig->LowThreshold << (cfgr & ADC_CFGR_RES) >> 2) * 2;
	}
	else{
		highshift = (AnalogWDGConfig->HighThreshold << (cfgr & (ADC_CFGR_RES & 0xFFFFFFF3)) >> 2) * 2;
		lowshift = (AnalogWDGConfig->LowThreshold << (cfgr & (ADC_CFGR_RES & 0xFFFFFFF3)) >> 2) * 2;
	}

	/*
	 *  ѴǤʤ
	 */
	if((sil_rew_mem((uint32_t *)(hadc->base+TOFF_ADC_CR)) & (ADC_CR_ADSTART | ADC_CR_JADSTART)) != 0)
		return E_OBJ;

	/*
	 *  AWD1
	 */
	if(AnalogWDGConfig->WatchdogNumber == ADC_ANALOGWATCHDOG_1){
		uint32_t awdy, toff;
		/*
		 *  AWD֥͡
		 */
		awdy = (ADC_AWD1 & ADC_CHANNEL_ID_MASK) | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL;
		toff = TOFF_ADC_CFGR + ((((awdy & ADC_AWD_CRX_REGOFFSET_MASK) >> 20)
				+ ((awdy & ADC_AWD2CR_AWD2CH_0) * ADC_AWD_CR12_REGOFFSETGAP_VAL)) << 2);
		switch(AnalogWDGConfig->WatchdogMode){
		case ADC_ANALOGWATCHDOG_SINGLE_REG:
			sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_AWD1 & ADC_AWD_CR_ALL_CHANNEL_MASK),
				((AnalogWDGConfig->Channel & ADC_CHANNEL_ID_MASK) | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL) & ADC_AWD1);
			break;
		case ADC_ANALOGWATCHDOG_SINGLE_INJEC:
			sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_AWD1 & ADC_AWD_CR_ALL_CHANNEL_MASK), 
				((AnalogWDGConfig->Channel & ADC_CHANNEL_ID_MASK) | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1SGL) & ADC_AWD1);
			break;
		case ADC_ANALOGWATCHDOG_SINGLE_REGINJEC:
			sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_AWD1 & ADC_AWD_CR_ALL_CHANNEL_MASK),
				((AnalogWDGConfig->Channel & ADC_CHANNEL_ID_MASK) | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL) & ADC_AWD1);
			break;
		case ADC_ANALOGWATCHDOG_ALL_REG:
			sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_AWD1 & ADC_AWD_CR_ALL_CHANNEL_MASK),
				((ADC_AWD_ALL_CHANNELS_REG & ADC_CHANNEL_ID_MASK) | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL) & ADC_AWD1);
			break;
		case ADC_ANALOGWATCHDOG_ALL_INJEC:
			sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_AWD1 & ADC_AWD_CR_ALL_CHANNEL_MASK),
				((ADC_AWD_ALL_CHANNELS_INJ & ADC_CHANNEL_ID_MASK) | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL) & ADC_AWD1);
			break;
		case ADC_ANALOGWATCHDOG_ALL_REGINJEC:
			sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_AWD1 & ADC_AWD_CR_ALL_CHANNEL_MASK),
				((ADC_AWD_ALL_CHANNELS_REG_INJ & ADC_CHANNEL_ID_MASK) | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL) & ADC_AWD1);
			break;
		default: /* ADC_ANALOGWATCHDOG_NONE */
			sil_modw_mem((uint32_t *)(hadc->base+toff), (ADC_AWD1 & ADC_AWD_CR_ALL_CHANNEL_MASK),
				((ADC_AWD_DISABLE & ADC_CHANNEL_ID_MASK) | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL) & ADC_AWD1);
			break;
		}

		/*
		 *  AWD1쥷ۡɥե
		 */
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_LTR1),  ADC_LTR_LT , lowshift);
		sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_HTR1),  ADC_HTR_HT , highshift);

		/*
		 *  AWD1ơ
		 */
		hadc->status2 &= ~(ADC_STATUS2_AWD1);
		if((hadc->status2 & (ADC_STATUS2_AWD1 | ADC_STATUS2_AWD2 | ADC_STATUS2_AWD3)) == 0)
			hadc->status &= ~ADC_STATUS_AWD;

		/*
		 *  AWD1
		 */
		sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD1);
		if(AnalogWDGConfig->ITMode != 0)
			sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD1IE);
		else
			sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD1IE);
	}
	/*
	 *  AWD2/3
	 */
	else{
		uint32_t nb, toff;
		if((AnalogWDGConfig->Channel & ADC_CHANNEL_ID_BITFIELD_MASK) == 0)
			nb = (AnalogWDGConfig->Channel & ADC_CFGR_AWD1CH) >> 26;
		else{
			for(nb = 0 ; nb < 20 ; nb++){
				if((AnalogWDGConfig->Channel & (1 << nb)) != 0)
					break;
			}
		}
		/*
		 *  ʥСӥåȤ
		 */
		switch(AnalogWDGConfig->WatchdogMode){
		case ADC_ANALOGWATCHDOG_SINGLE_REG:
		case ADC_ANALOGWATCHDOG_SINGLE_INJEC:
		case ADC_ANALOGWATCHDOG_SINGLE_REGINJEC:
			if(AnalogWDGConfig->WatchdogNumber == ADC_ANALOGWATCHDOG_2)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD2CR), (1 << (nb & 0x1F)));
			else
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD3CR), (1 << (nb & 0x1F)));
			break;
		case ADC_ANALOGWATCHDOG_ALL_REG:
		case ADC_ANALOGWATCHDOG_ALL_INJEC:
		case ADC_ANALOGWATCHDOG_ALL_REGINJEC:
			if(AnalogWDGConfig->WatchdogNumber == ADC_ANALOGWATCHDOG_2)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD2CR), (1 << (nb & 0x1F)));
			else
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_AWD3CR), (1 << (nb & 0x1F)));
			break;
		default: /* ADC_ANALOGWATCHDOG_NONE */
			toff = TOFF_ADC_CFGR + ((((AnalogWDGConfig->WatchdogNumber & ADC_AWD_CRX_REGOFFSET_MASK) >> 20)
				+ ((AnalogWDGConfig->WatchdogNumber & ADC_AWD2CR_AWD2CH_0) * ADC_AWD_CR12_REGOFFSETGAP_VAL)) << 2);
			sil_modw_mem((uint32_t *)(hadc->base+toff), (AnalogWDGConfig->WatchdogNumber & ADC_AWD_CR_ALL_CHANNEL_MASK),
				((ADC_AWD_DISABLE & ADC_CHANNEL_ID_MASK) | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL) & ADC_AWD1);
			break;
		}

		if(AnalogWDGConfig->WatchdogNumber == ADC_ANALOGWATCHDOG_2){
			/*
			 *  AWD2쥷ۡɥե
			 */
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_LTR2),  ADC_LTR_LT , lowshift);
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_HTR2),  ADC_HTR_HT , highshift);

			/*
			 *  AWD2ơ
			 */
			hadc->status &= ~(ADC_STATUS2_AWD2);
			if((hadc->status2 & (ADC_STATUS2_AWD1 | ADC_STATUS2_AWD2 | ADC_STATUS2_AWD3)) == 0)
				hadc->status &= ~ADC_STATUS_AWD;

			/*
			 *  AWD2
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD2);
			if(AnalogWDGConfig->ITMode != 0)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD2IE);
			else
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD2IE);
		}
		else{
			/*
			 *  AWD3쥷ۡɥե
			 */
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_LTR3),  ADC_LTR_LT , lowshift);
			sil_modw_mem((uint32_t *)(hadc->base+TOFF_ADC_HTR3),  ADC_HTR_HT , highshift);

			/*
			 *  AWD3ơ
			 */
			hadc->status &= ~(ADC_STATUS2_AWD3);
			if((hadc->status2 & (ADC_STATUS2_AWD1 | ADC_STATUS2_AWD2 | ADC_STATUS2_AWD3)) == 0)
				hadc->status &= ~ADC_STATUS_AWD;

			/*
			 *  AWD3
			 */
			sil_wrw_mem((uint32_t *)(hadc->base+TOFF_ADC_ISR), ADC_ISR_AWD3);
			if(AnalogWDGConfig->ITMode != 0)
				sil_orw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD3IE);
			else
				sil_andw_mem((uint32_t *)(hadc->base+TOFF_ADC_IER), ADC_IER_AWD3IE);
		}
	}
	return E_OK;
}


