/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: adc.h 698 2019-12-20 17:55:45Z roi $
 */
/*
 * 
 *  STM32H7xx ADCǥХɥ饤Фγ
 *
 */

#ifndef _ADC_H_
#define _ADC_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  ADCݡ
 */
#define ADC1_PORTID             1
#define ADC2_PORTID             2
#define ADC3_PORTID             3
#define NUM_ADCPORT             3

/*
 *  ADCåץꥹ(ClockPrescaler)
 */ 
#define ADC_CLOCK_SYNC_PCLK_DIV1        ADC_CCR_CKMODE_0
#define ADC_CLOCK_SYNC_PCLK_DIV2        ADC_CCR_CKMODE_1
#define ADC_CLOCK_SYNC_PCLK_DIV4        (ADC_CCR_CKMODE_1 | ADC_CCR_CKMODE_0)

#define ADC_CLOCK_ASYNC_DIV1            0x00000000
#define ADC_CLOCK_ASYNC_DIV2            ADC_CCR_PRESC_0
#define ADC_CLOCK_ASYNC_DIV4            ADC_CCR_PRESC_1
#define ADC_CLOCK_ASYNC_DIV6            (ADC_CCR_PRESC_1 | ADC_CCR_PRESC_0)
#define ADC_CLOCK_ASYNC_DIV8            ADC_CCR_PRESC_2
#define ADC_CLOCK_ASYNC_DIV10           (ADC_CCR_PRESC_2 | ADC_CCR_PRESC_0)
#define ADC_CLOCK_ASYNC_DIV12           (ADC_CCR_PRESC_2 | ADC_CCR_PRESC_1)
#define ADC_CLOCK_ASYNC_DIV16           (ADC_CCR_PRESC_2 | ADC_CCR_PRESC_1 | ADC_CCR_PRESC_0)
#define ADC_CLOCK_ASYNC_DIV32           ADC_CCR_PRESC_3
#define ADC_CLOCK_ASYNC_DIV64           (ADC_CCR_PRESC_3 | ADC_CCR_PRESC_0)
#define ADC_CLOCK_ASYNC_DIV128          (ADC_CCR_PRESC_3 | ADC_CCR_PRESC_1)
#define ADC_CLOCK_ASYNC_DIV256          (ADC_CCR_PRESC_3 | ADC_CCR_PRESC_1 | ADC_CCR_PRESC_0)

/*
 *  ADC꥾塼(Resolution)
 */
#define ADC_RESOLUTION_16B              0x00000000
#define ADC_RESOLUTION_14B              ADC_CFGR_RES_0
#define ADC_RESOLUTION_12B              ADC_CFGR_RES_1
#define ADC_RESOLUTION_10B              (ADC_CFGR_RES_1 | ADC_CFGR_RES_0)
#define ADC_RESOLUTION_8B               ADC_CFGR_RES_2

/*
 *  ADCեȥե(LeftBitShift)
 */ 
#define ADC_LEFT_BIT_SHIFT_NONE         0x00000000														/* ADC no bit shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_1            ADC_CFGR2_LSHIFT_0												/* ADC 1 bit shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_2            ADC_CFGR2_LSHIFT_1												/* ADC 2 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_3            (ADC_CFGR2_LSHIFT_1 | ADC_CFGR2_LSHIFT_0)						/* ADC 3 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_4            ADC_CFGR2_LSHIFT_2												/* ADC 4 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_5            (ADC_CFGR2_LSHIFT_2 | ADC_CFGR2_LSHIFT_0)						/* ADC 5 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_6            (ADC_CFGR2_LSHIFT_2 | ADC_CFGR2_LSHIFT_1)						/* ADC 6 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_7            (ADC_CFGR2_LSHIFT_2 | ADC_CFGR2_LSHIFT_1 | ADC_CFGR2_LSHIFT_0)	/* ADC 7 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_8            (ADC_CFGR2_LSHIFT_3)											/* ADC 8 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_9            (ADC_CFGR2_LSHIFT_3 | ADC_CFGR2_LSHIFT_0)						/* ADC 9 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_10           (ADC_CFGR2_LSHIFT_3 | ADC_CFGR2_LSHIFT_1)						/* ADC 10 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_11           (ADC_CFGR2_LSHIFT_3 | ADC_CFGR2_LSHIFT_1 | ADC_CFGR2_LSHIFT_0)	/* ADC 11 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_12           (ADC_CFGR2_LSHIFT_3 | ADC_CFGR2_LSHIFT_2)						/* ADC 12 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_13           (ADC_CFGR2_LSHIFT_3 | ADC_CFGR2_LSHIFT_2 | ADC_CFGR2_LSHIFT_0)	/* ADC 13 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_14           (ADC_CFGR2_LSHIFT_3 | ADC_CFGR2_LSHIFT_2 | ADC_CFGR2_LSHIFT_1)	/* ADC 14 bits shift left applied on the final ADC convesion data */
#define ADC_LEFT_BIT_SHIFT_15           (ADC_CFGR2_LSHIFT_3 | ADC_CFGR2_LSHIFT_2 | ADC_CFGR2_LSHIFT_1 | ADC_CFGR2_LSHIFT_0)  /* ADC 15 bits shift left applied on the final ADC convesion data */

/*
 *  ADC󥳥С⡼(ScanConvMode)
 */
#define ADC_SCANMODE_DISABLE            0x00000000
#define ADC_SCANMODE_ENABLE             0x00000001

/*
 *  ADC EOC(EOCSelection)
 */
#define ADC_EOC_SINGLE_CONV             ADC_ISR_EOC		/* End of unitary conversion flag  */
#define ADC_EOC_SEQ_CONV                ADC_ISR_EOS		/* End of sequence conversions flag */
#define ADC_EOC_SEQ_DISABLE             ADC_EOC_SINGLE_CONV
#define ADC_EOC_SEQ_ENABLE              ADC_EOC_SEQ_CONV

/*
 *  ADC³⡼(ContinuousConvMode)
 */
#define ADC_CONTINUOUS_DISABLE          0x00000000
#define ADC_CONTINUOUS_ENABLE           ADC_CFGR_CONT

/*
 *  ADC DMA(DMAContinuousRequests)
 */
#define ADC_CONVERSIONDATA_DR           0x00000000			/* Regular Conversion data stored in DR register only  */
#define ADC_CONVERSIONDATA_DFSDM        ADC_CFGR_DMNGT_1	/* DFSDM mode selected */
#define ADC_CONVERSIONDATA_DMA_ONESHOT  ADC_CFGR_DMNGT_0	/* DMA one shot mode selected */
#define ADC_CONVERSIONDATA_DMA_CIRCULAR (ADC_CFGR_DMNGT_0 | ADC_CFGR_DMNGT_1)	/* DMA circular mode selected */

/*
 *  ADC ³⡼(DiscontinuousConvMode)
 */
#define ADC_DISCONTINUOUS_DISABLE       0x00000000
#define ADC_DISCONTINUOUS_ENABLE        ADC_CFGR_DISCEN

/*
 *  ADCȥꥬ(ExternalTrigConv)
 */
#define ADC_EXTERNALTRIGCONV_T1_CC1     ADC_CFGR_EXTEN_0
#define ADC_EXTERNALTRIGCONV_T1_CC2     (ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T1_CC3     (ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T2_CC2     (ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T3_TRGO    (ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T4_CC4     (ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_EXT_IT11   (ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T8_TRGO    (ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T8_TRGO2   (ADC_CFGR_EXTSEL_3 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T1_TRGO    (ADC_CFGR_EXTSEL_3 | ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T1_TRGO2   (ADC_CFGR_EXTSEL_3 | ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T2_TRGO    (ADC_CFGR_EXTSEL_3 | ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T4_TRGO    (ADC_CFGR_EXTSEL_3 | ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T6_TRGO    (ADC_CFGR_EXTSEL_3 | ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T15_TRGO   (ADC_CFGR_EXTSEL_3 | ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_T3_CC4     (ADC_CFGR_EXTSEL_3 | ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_HR1_ADCTRG1 (ADC_CFGR_EXTSEL_4 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_HR1_ADCTRG3 (ADC_CFGR_EXTSEL_4 | ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_LPTIM1_OUT (ADC_CFGR_EXTSEL_4 | ADC_CFGR_EXTSEL_1 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_LPTIM2_OUT (ADC_CFGR_EXTSEL_4 | ADC_CFGR_EXTSEL_1| ADC_CFGR_EXTSEL_0 | ADC_CFGR_EXTEN_0)
#define ADC_EXTERNALTRIGCONV_LPTIM3_OUT (ADC_CFGR_EXTSEL_4 | ADC_CFGR_EXTSEL_2 | ADC_CFGR_EXTEN_0)
#define ADC_SOFTWARE_START              0x00000000

/*
 *  ADCȥꥬå(ExternalTrigConvEdge)
 */
#define ADC_EXTERNALTRIGCONVEDGE_NONE      0x00000000
#define ADC_EXTERNALTRIGCONVEDGE_RISING    ADC_CFGR_EXTEN_0
#define ADC_EXTERNALTRIGCONVEDGE_FALLING   ADC_CFGR_EXTEN_1
#define ADC_EXTERNALTRIGCONVEDGE_RISINGFALLING  (ADC_CFGR_EXTEN_1 | ADC_CFGR_EXTEN_0)

/*
 *  ADCͥ
 */
#define ADC_CHANNEL_ID_INTERNAL_CH      (0x80000000)	/* Marker of internal channel */
#define ADC_CHANNEL_0                   ( (0 << 20) | ADC_AWD2CR_AWD2CH_0  | 0x00000000)
#define ADC_CHANNEL_1                   ( (3 << 20) | ADC_AWD2CR_AWD2CH_1  | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_2                   ( (6 << 20) | ADC_AWD2CR_AWD2CH_2  | ADC_CFGR_AWD1CH_1)
#define ADC_CHANNEL_3                   ( (9 << 20) | ADC_AWD2CR_AWD2CH_3  | ADC_CFGR_AWD1CH_1 | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_4                   ((12 << 20) | ADC_AWD2CR_AWD2CH_4  | ADC_CFGR_AWD1CH_2)
#define ADC_CHANNEL_5                   ((15 << 20) | ADC_AWD2CR_AWD2CH_5  | ADC_CFGR_AWD1CH_2 | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_6                   ((18 << 20) | ADC_AWD2CR_AWD2CH_6  | ADC_CFGR_AWD1CH_2 | ADC_CFGR_AWD1CH_1)
#define ADC_CHANNEL_7                   ((21 << 20) | ADC_AWD2CR_AWD2CH_7  | ADC_CFGR_AWD1CH_2 | ADC_CFGR_AWD1CH_1 | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_8                   ((24 << 20) | ADC_AWD2CR_AWD2CH_8  | ADC_CFGR_AWD1CH_3)
#define ADC_CHANNEL_9                   ((27 << 20) | ADC_AWD2CR_AWD2CH_9  | ADC_CFGR_AWD1CH_3 | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_10                  ( (0 << 20) | ADC_AWD2CR_AWD2CH_10 | ADC_CFGR_AWD1CH_3 | ADC_CFGR_AWD1CH_1)
#define ADC_CHANNEL_11                  ( (3 << 20) | ADC_AWD2CR_AWD2CH_11 | ADC_CFGR_AWD1CH_3 | ADC_CFGR_AWD1CH_1 | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_12                  ( (6 << 20) | ADC_AWD2CR_AWD2CH_12 | ADC_CFGR_AWD1CH_3 | ADC_CFGR_AWD1CH_2)
#define ADC_CHANNEL_13                  ( (9 << 20) | ADC_AWD2CR_AWD2CH_13 | ADC_CFGR_AWD1CH_3 | ADC_CFGR_AWD1CH_2 | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_14                  ((12 << 20) | ADC_AWD2CR_AWD2CH_14 | ADC_CFGR_AWD1CH_3 | ADC_CFGR_AWD1CH_2 | ADC_CFGR_AWD1CH_1)
#define ADC_CHANNEL_15                  ((15 << 20) | ADC_AWD2CR_AWD2CH_15 | ADC_CFGR_AWD1CH_3 | ADC_CFGR_AWD1CH_2 | ADC_CFGR_AWD1CH_1 | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_16                  ((18 << 20) | ADC_AWD2CR_AWD2CH_16 | ADC_CFGR_AWD1CH_4)
#define ADC_CHANNEL_17                  ((21 << 20) | ADC_AWD2CR_AWD2CH_17 | ADC_CFGR_AWD1CH_4 | ADC_CFGR_AWD1CH_0)
#define ADC_CHANNEL_18                  ((24 << 20) | ADC_AWD2CR_AWD2CH_18 | ADC_CFGR_AWD1CH_4 | ADC_CFGR_AWD1CH_1)
#define ADC_CHANNEL_19                  ((27 << 20) | ADC_AWD2CR_AWD2CH_19 | ADC_CFGR_AWD1CH_4 | ADC_CFGR_AWD1CH_1 | ADC_CFGR_AWD1CH_0)

#define ADC_CHANNEL_VREFINT             (ADC_CHANNEL_19 | ADC_CHANNEL_ID_INTERNAL_CH)
#define ADC_CHANNEL_TEMPSENSOR          (ADC_CHANNEL_18 | ADC_CHANNEL_ID_INTERNAL_CH)
#define ADC_CHANNEL_VBAT                (ADC_CHANNEL_17 | ADC_CHANNEL_ID_INTERNAL_CH)
#define ADC_CHANNEL_DAC1CH1_ADC2        (ADC_CHANNEL_16 | ADC_CHANNEL_ID_INTERNAL_CH)
#define ADC_CHANNEL_DAC1CH2_ADC2        (ADC_CHANNEL_17 | ADC_CHANNEL_ID_INTERNAL_CH)

/*
 *  ADCץ󥰻
 */
#define ADC_SAMPLETIME_1CYCLE_5          0x00000000									/* 1.5 ADC clock cycles */
#define ADC_SAMPLETIME_2CYCLES_5         ADC_SMPR2_SMP10_0							/* 2.5 ADC clock cycles */
#define ADC_SAMPLETIME_8CYCLES_5         ADC_SMPR2_SMP10_1							/* 8.5 ADC clock cycles */
#define ADC_SAMPLETIME_16CYCLES_5        (ADC_SMPR2_SMP10_1 | ADC_SMPR2_SMP10_0)	/* 16.5 ADC clock cycles */
#define ADC_SAMPLETIME_32CYCLES_5        ADC_SMPR2_SMP10_2							/* 32.5 ADC clock cycles */
#define ADC_SAMPLETIME_64CYCLES_5        (ADC_SMPR2_SMP10_2 | ADC_SMPR2_SMP10_0)	/* 64.5 ADC clock cycles */
#define ADC_SAMPLETIME_387CYCLES_5       (ADC_SMPR2_SMP10_2 | ADC_SMPR2_SMP10_1)	/* 387.5 ADC clock cycles */
#define ADC_SAMPLETIME_810CYCLES_5       (ADC_SMPR2_SMP10_2 | ADC_SMPR2_SMP10_1 | ADC_SMPR2_SMP10_0)	/* 810.5 ADC clock cycles */

/*
 *  ADCѥȥ
 */
#define ADC_LOWAUTOWAIT_DISABLE         0x00000000
#define ADC_LOWAUTOWAIT_ENABLE          ADC_CFGR_AUTDLY

/*
 *  ADCСǡ饤ƥ
 */
#define ADC_OVR_DATA_PRESERVED          0x00000000
#define ADC_OVR_DATA_OVERWRITTEN        ADC_CFGR_OVRMOD

/*
 *  ADCСץ󥰥⡼
 */
#define ADC_OVR_SAMPLING_DISABLE        0x00000000
#define ADC_OVR_SAMPLING_ENABLE         ADC_CFGR2_ROVSE

/*
 *  ADCСץ󥰥ȥꥬ
 */
#define ADC_TRIGGEREDMODE_SINGLE_TRIGGER    0x00000000
#define ADC_TRIGGEREDMODE_MULTI_TRIGGER     ADC_CFGR2_TROVS

/*
 *  ADCСץ󥰥饤ȥӥåȥե
 */
#define ADC_RIGHTBITSHIFT_NONE          0x00000000
#define ADC_RIGHTBITSHIFT_1             ADC_CFGR2_OVSS_0
#define ADC_RIGHTBITSHIFT_2             ADC_CFGR2_OVSS_1
#define ADC_RIGHTBITSHIFT_3             (ADC_CFGR2_OVSS_0 | ADC_CFGR2_OVSS_1)
#define ADC_RIGHTBITSHIFT_4             ADC_CFGR2_OVSS_2
#define ADC_RIGHTBITSHIFT_5             (ADC_CFGR2_OVSS_0 | ADC_CFGR2_OVSS_2)
#define ADC_RIGHTBITSHIFT_6             (ADC_CFGR2_OVSS_1 | ADC_CFGR2_OVSS_2)
#define ADC_RIGHTBITSHIFT_7             (ADC_CFGR2_OVSS_0 | ADC_CFGR2_OVSS_1 | ADC_CFGR2_OVSS_2)
#define ADC_RIGHTBITSHIFT_8             ADC_CFGR2_OVSS_3
#define ADC_RIGHTBITSHIFT_9             (ADC_CFGR2_OVSS_3 | ADC_CFGR2_OVSS_0)
#define ADC_RIGHTBITSHIFT_10            (ADC_CFGR2_OVSS_3 | ADC_CFGR2_OVSS_1)
#define ADC_RIGHTBITSHIFT_11            (ADC_CFGR2_OVSS_3 | ADC_CFGR2_OVSS_1 | ADC_CFGR2_OVSS_0)

/*
 *  ADCСץ󥰥ȥåץꥻå
 */
#define ADC_REGOVERSAMPLING_CONTINUED_MODE  ADC_CFGR2_ROVSE	/* Oversampling buffer maintained during injection sequence */
#define ADC_REGOVERSAMPLING_RESUMED_MODE    (ADC_CFGR2_ROVSM | ADC_CFGR2_ROVSE)	/* Oversampling buffer zeroed during injection sequence */


/*
 *  ADCޥ⡼
 */
#define ADC_MULTI_INDEPENDENT           0x00000000			/* ADC dual mode disabled (ADC independent mode) */
#define ADC_MULTI_DUAL_REG_SIMULT       (ADC_CCR_DUAL_2 | ADC_CCR_DUAL_1)	/* ADC dual mode enabled: group regular simultaneous */
#define ADC_MULTI_DUAL_REG_INTERL       (ADC_CCR_DUAL_2 | ADC_CCR_DUAL_1 | ADC_CCR_DUAL_0)	/* ADC dual mode enabled: Combined group regular interleaved */
#define ADC_MULTI_DUAL_INJ_SIMULT       (ADC_CCR_DUAL_2 | ADC_CCR_DUAL_0)	/* ADC dual mode enabled: group injected simultaneous */
#define ADC_MULTI_DUAL_INJ_ALTERN       (ADC_CCR_DUAL_3 | ADC_CCR_DUAL_0)	/* ADC dual mode enabled: group injected alternate trigger. Works only with external triggers (not internal SW start) */
#define ADC_MULTI_DUAL_REG_SIM_INJ_SIM  ADC_CCR_DUAL_0		/* ADC dual mode enabled: Combined group regular simultaneous + group injected simultaneous */
#define ADC_MULTI_DUAL_REG_SIM_INJ_ALT  ADC_CCR_DUAL_1		/* ADC dual mode enabled: Combined group regular simultaneous + group injected alternate trigger */
#define ADC_MULTI_DUAL_REG_INT_INJ_SIM  (ADC_CCR_DUAL_1 | ADC_CCR_DUAL_0)	/* ADC dual mode enabled: Combined group regular interleaved + group injected simultaneous */

/*
 *  ADC󥰥/ǥե󥷥뽪λ
 */
#define ADC_SINGLE_ENDED                ADC_CALFACT_CALFACT_S	/* ADC channel ending set to single ended (literal also used to set calibration mode) */
#define ADC_DIFFERENTIAL_ENDED          (ADC_CR_ADCALDIF | ADC_CALFACT_CALFACT_D)	/* ADC channel ending set to differential (literal also used to set calibration mode) */

/*
 *  ADCͥ եåֹ
 */
#define ADC_OFFSET_NONE                 (ADC_OFFSET_4 + 1)	/* ADC offset disabled: no offset correction for the selected ADC channel */
#define ADC_OFFSET_1                    0x00000000			/* ADC offset number 1: ADC channel and offset level to which the offset programmed will be applied */
#define ADC_OFFSET_2                    0x00000001			/* ADC offset number 2: ADC channel and offset level to which the offset programmed will be applied */
#define ADC_OFFSET_3                    0x00000002			/* ADC offset number 3: ADC channel and offset level to which the offset programmed will be applied */
#define ADC_OFFSET_4                    0x00000003			/* ADC offset number 4: ADC channel and offset level to which the offset programmed will be applied */

/*
 *  ADCɥ졼⡼
 */
#define ADC_OFFSET_SIGNED_SATURATION_DISABLE 0x00000000		/* ADC offset signed saturation is disabled (among ADC selected offset number 1, 2, 3 or 4) */
#define ADC_OFFSET_SIGNED_SATURATION_ENABLE  ADC_OFR1_SSATE	/* ADC offset signed saturation is enabled (among ADC selected offset number 1, 2, 3 or 4) */


/*
 *  ADCʥåɥå⡼
 */
#define ADC_ANALOGWATCHDOG_NONE              0x00000000
#define ADC_ANALOGWATCHDOG_SINGLE_REG        (ADC_CFGR_AWD1SGL | ADC_CFGR_AWD1EN)
#define ADC_ANALOGWATCHDOG_SINGLE_INJEC      (ADC_CFGR_AWD1SGL | ADC_CFGR_JAWD1EN)
#define ADC_ANALOGWATCHDOG_SINGLE_REGINJEC   (ADC_CFGR_AWD1SGL | ADC_CFGR_AWD1EN | ADC_CFGR_JAWD1EN)
#define ADC_ANALOGWATCHDOG_ALL_REG           ADC_CFGR_AWD1EN
#define ADC_ANALOGWATCHDOG_ALL_INJEC         ADC_CFGR_JAWD1EN
#define ADC_ANALOGWATCHDOG_ALL_REGINJEC      (ADC_CFGR_AWD1EN | ADC_CFGR_JAWD1EN)

/*
 *  ADCʥåɥåֹ
 */
#define ADC_ANALOGWATCHDOG_1               (ADC_CFGR_AWD1CH | ADC_CFGR_JAWD1EN | ADC_CFGR_AWD1EN | ADC_CFGR_AWD1SGL)
#define ADC_ANALOGWATCHDOG_2               (ADC_AWD2CR_AWD2CH | 0x00100000)
#define ADC_ANALOGWATCHDOG_3               (ADC_AWD2CR_AWD2CH | 0x00200000)

/*
 *  ADCϡɥ깽¤
 */
typedef struct _ADC_PortControlBlock{
	uint32_t              base;
	uint32_t              cbase;
	uint32_t              pbase;
	uint32_t              adcclockbase;
	uint32_t              adcclockbit;
	uint32_t              dmarxrequest;
} ADC_PortControlBlock;

/*
 *  ADCν¤
 */
typedef struct
{
	uint32_t              ClockPrescaler;				/* ADCåץꥹ(ADCˤƶ) */
	uint32_t              Resolution;					/* ADCΥ꥾塼 */
	uint32_t              LeftBitShift;
	uint32_t              ScanConvMode;					/* ADC󥳥С⡼ */
	uint32_t              EOCSelection;					/* ADC EOC */
	uint32_t              ContinuousConvMode;			/* ADC³⡼ */
	uint32_t              ConversionDataManagement;		/* ADC-DMA⡼ */
	uint32_t              NumConversion;				/* ADCС */
	uint32_t              DiscontinuousConvMode;		/* ADC³⡼ */
	uint32_t              NumDiscConversion;			/* ADC³Ѵ */
	uint32_t              ExternalTrigConv;				/* ADCȥꥬ */
	uint32_t              ExternalTrigConvEdge;			/* ADCȥꥬå */

	uint32_t              LowPowerAutoWait;				/* ADCѥȥ */
	uint32_t              Overrun;						/* ADCDR쥸ΥС񤭹 */
	uint32_t              OversamplingMode;				/* ADCС󥵥ץ */
	uint32_t              OversamplingRatio;			/* ADCС󥵥ץ Ratio. */
	uint32_t              OversamplingRightBitShift;	/* ADCС󥵥ץ Configures the division coefficient */
	uint32_t              OversamplingTriggeredMode;	/* ADCС󥵥ץ triggered  mode. */
	uint32_t              OversamplingStopReset;		/* ADCС󥵥ץ stop reset. */
	int32_t               DMAChannel;					/* ADC DMAͥ */
}ADC_Init_t;

/*
 *  ADCϥɥ鹽¤
 */ 
typedef struct __ADC_Handle_t ADC_Handle_t;
struct __ADC_Handle_t
{
	uint32_t              base;							/* ADC١ɥ쥹 */
	uint32_t              cbase;						/* ADC١ɥ쥹 */
	uint32_t              pbase;						/* ADCڥ١ɥ쥹 */
	ADC_Init_t            Init;							/* ADCǡ */
	volatile uint32_t     NumCurrentConversionRank;		/* ADCߤΥС */
	DMA_Handle_t          *hdmarx;						/* ADCDMAϥɥؤΥݥ */
	void                  (*xfercallback)(ADC_Handle_t * hadc);		/* ADC žλХå */
	void                  (*xferhalfcallback)(ADC_Handle_t * hadc);	/* ADC ȾʬžХå */
	void                  (*eoscallback)(ADC_Handle_t * hadc);		/* ADC ץ󥰽λХå */
	void                  (*outofwin1callback)(ADC_Handle_t * hadc);	/* ADC ʥåɥå1Хå */
	void                  (*outofwin2callback)(ADC_Handle_t * hadc);	/* ADC ʥåɥå2Хå */
	void                  (*outofwin3callback)(ADC_Handle_t * hadc);	/* ADC ʥåɥå3Хå */
	void                  (*errorcallback)(ADC_Handle_t * hadc);	/* ADC 顼Хå */
	volatile uint16_t     status;						/* ADCơ */
	volatile uint16_t     status2;						/* ADCơ */
	volatile uint32_t     ErrorCode;					/* ADC顼 */
};

/*
 *  ͥ깽¤
 */
typedef struct
{
	uint32_t              Channel;						/* ADCֹͥ */
	uint32_t              Rank;							/* ADCֹ(1-16) */
	uint32_t              SamplingTime;					/* ADCץ󥰻 */
	uint32_t              SingleDiff;					/* ADC single-ended/differential input */
	uint32_t              OffsetNumber;					/* Select the offset number */
	uint32_t              Offset;                 		/* Offset value */
	uint32_t              OffsetSignedSaturation;		/* ADC Specify whether the Signed saturation feature is used or not.*/
	uint32_t              GpioBase;						/* ADC-GPIO١ɥ쥹 */
	uint32_t              GpioPin;						/* ADC-GPIOԥֹ */
}ADC_ChannelConf_t;

/*
 *  ADCʥåɥå깽¤
 */
typedef struct
{
	uint32_t              WatchdogMode;					/* ADCʥåɥå⡼ */
	uint32_t              WatchdogNumber;				/* ADCʥåͥ */
	uint32_t              HighThreshold;				/* ADCåۡɾ */
	uint32_t              LowThreshold;					/* ADCåۡɲ */
	uint32_t              Channel;						/* ADCбֹͥ */
	uint32_t              ITMode;						/* ADCʥåɥå */
}ADC_AnalogWDGConf_t;

/*
 *  ADCΥơ
 */
#define ADC_STATUS_RESET        0x0000		/* ADC ̤Ѿ */
#define ADC_STATUS_READY        0x0001		/* ADC ǥ */
#define ADC_STATUS_BUSY         0x0002		/* ADC ӥ */
#define ADC_STATUS_EOC          0x0010		/* ADC λ */
#define ADC_STATUS_BUSY_EOC     0x0012		/* ADC ӥλȯ */ 
#define ADC_STATUS_AWD          0x0200		/* ADC ʥåɥåȯ */

/*
 *  ADCξܺپ
 */
#define ADC_STATUS2_READY       0x0001		/* ADC ǥӥå */
/*
 *  AWDȯ
 */
#define ADC_STATUS2_AWD1        0x0002		/* AWD1ȯӥå */
#define ADC_STATUS2_AWD2        0x0004		/* AWD2ȯӥå */
#define ADC_STATUS2_AWD3        0x0008		/* AWD3ȯӥå */

#define ADC_STATUS2_REG_BUSY    0x0010		/* ADC 쥮顼ӥӥå */
#define ADC_STATUS2_REG_EOC     0x0020		/* ADC 쥮顼Ѵǡͭӥå */
#define ADC_STATUS2_REG_OVR     0x0040		/* ADC С󥨥顼ӥå */
#define ADC_STATUS2_REG_EOSMP   0x0080		/* Not available on this STM32 serie: End Of Sampling flag raised  */

#define ADC_STATUS2_INJ_BUSY    0x0100		/* ADC 󥸥ӥӥå */
#define ADC_STATUS2_INJ_EOC     0x0200		/* ADC 󥸥Ѵǡͭӥå */
#define ADC_STATUS2_INJ_JQOVF   0x0400		/* ADC 󥸥󥪡С󥨥顼ӥå */

#define ADC_STATUS2_MULTI_SLAVE 0x1000		/* ADC ޥ⡼ɡ졼־֥ӥå */

/*
 *  ADC顼
 */
#define ADC_ERROR_NONE          0x0000		/* No error */
#define ADC_ERROR_OVR           0x0001		/* OVR error */
#define ADC_ERROR_JQOVF         0x0002		/* JQOVR error */
#define ADC_ERROR_DMA           0x0008		/* DMA transfer error */
#define ADC_ERROR_CONFIG        0x0010		/* Configuarion error */
#define ADC_ERROR_SYS           0x0020		/* System error */


extern ADC_Handle_t *adc_init(ID portid, ADC_Init_t *pini);
extern ER adc_deinit(ADC_Handle_t *hadc);
extern ER adc_start_int(ADC_Handle_t* hadc);
extern ER adc_end_int(ADC_Handle_t* hadc);
extern ER adc_start_dma(ADC_Handle_t* hadc, uint32_t* pdata, uint32_t length);
extern ER adc_end_dma(ADC_Handle_t* hadc);
extern ER adc_setupchannel(ADC_Handle_t* hadc, ADC_ChannelConf_t* sConfig);
extern ER adc_setupwatchdog(ADC_Handle_t* hadc, ADC_AnalogWDGConf_t* AnalogWDGConfig);
extern uint32_t adc_getvalue(ADC_Handle_t* hadc);

extern void adc_handler(ADC_Handle_t* hadc);
extern void adc_isr_handler(intptr_t exinf);

#ifdef __cplusplus
}
#endif

#endif	/* _ADC_H_ */

