/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: emac.c 699 2019-08-14 11:40:59Z roi $
 */
/*
 * 
 *  STM32H7XX:EMAC(LWIP)ɥ饤дؿ
 *
 */
#include "kernel_impl.h"
#include <t_syslog.h>
#include <t_stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sil.h>
#include <target_syssvc.h>
#include <string.h>
#include "device.h"
#include "phyreg.h"
#include "emac.h"

/*
 *  SILؿΥޥ
 */
#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

#define MIN(a, b) ((a) > (b) ? (b) : (a))

/*
 *  EMACݡID֥åФΥޥ
 */
#define INDEX_EMAC(emacid)      ((uint_t)((emacid) - 1))

/*
 *  AUTO NEGOTIATIONȽ
 */
#define is_autonego(h)          (((h)->linkvalue & EMAC_LINK_AUTONEGO) != 0)

/* MDIO  Ready Ԥ(msec) */
#define EMAC_MDIO_READY_WAIT_MSEC   50

#define MII_CLKRANGE_150_250M	(0x10)

#define ETH_MAC_US_TICK         1000000

/*
 *  MII⡼
 */
#define EMAC_CTRL_PHYSEL_MII    0x00000000		/* Select the Media Independent Interface */
#define EMAC_CTRL_PHYSEL_RGMII  SYSCFG_PMCR_EPIS_SEL_2  /* Select the Reduced Media Independent Interface */

/*
 *  DESCRIPTOR
 */
/*  TX DESC2 */
#define DESC_TXSTS_TXIOC        (1 << 31)		/* Interrupt on Completion */
#define DESC_TXSTS_TXTTSE       (1 << 30)		/* Transmit Timestamp Enable */
#define DESC_TXSTS_TXB2L        (0x3FFF << 16)	/* Buffer 2 Length */
#define DESC_TXSTS_TXVTIR       (3 << 14)		/* VLAN Tag Insertion or Replacement */
#define DESC_TXSTS_TXB1L        (0x3FFF)		/* Buffer 1 Length */

/*  TX DESC3 */
#define DESC_TXSTS_OWNBYDMA     (1 << 31)		/* OWN bit: descriptor is owned by DMA engine */
#define DESC_TXSTS_TXCTXT       (1 << 30)		/* Context Type */
#define DESC_TXSTS_TXFIRST      (1 << 29)		/* First Segment */
#define DESC_TXSTS_TXLAST       (1 << 28)		/* Last Segment */
#define DESC_TXSTS_TXCRCPAD     (3 << 26)		/* CRC Pad Control */
#define DESC_TXSTS_TXCRCDIS     (2 << 26)		/* Disable CRC */
#define DESC_TXSTS_TXCRCIN      (1 << 26)		/* CRC Insertion */
#define DESC_TXSTS_TXCRCPADIN   (0 << 26)		/* CRC and Pad Insertion */
#define DESC_TXSTS_TXSAIC       (7 << 23)		/* SA Insertion Control */
#define DESC_TXSTS_TXTHL        (15 << 19)		/* TCP Header Length */
#define DESC_TXSTS_TXTSE        (1 << 18)		/* TCP segmentation enable */
#define DESC_TXSTS_TXCIC        (3 << 15)		/* Checksum Insertion Control */
#define DESC_TXSTS_TXCICDIS     (0 << 15)		/* Disable Checksum */
#define DESC_TXSTS_TXCICIPHIN   (1 << 15)		/* IP header checksum calculation and insertion */
#define DESC_TXSTS_TXCICIPHPLIN (2 << 15)		/* IP header checksum and payload checksum calculation and insertion */
#define DESC_TXSTS_TXCICALLLIN  (3 << 15)		/* IP header checksum payload calculation and insertion, and pseudo header checksum */
#define DESC_TXSTS_TXFL         (0x00007FFF)	/* Transmit End of Ring */


/*  RX DESCRIPTERơӥå */
#define DESC_RXSTS_WOWN         (1 << 31)		/* OWN bit: descriptor is owned by DMA engine  */
#define DESC_RXSTS_WIOC         (1 << 30)		/* Interrupt Enabled on Completion  */
#define DESC_RXSTS_WBUF2V       (1 << 25)		/* Buffer 2 Address Valid */
#define DESC_RXSTS_WBUF1V       (1 << 24)		/* Buffer 1 Address Valid */

#define DESC_RXSTS_ROWN         (1 << 31)		/* OWN bit: descriptor is owned by DMA engine  */
#define DESC_RXSTS_RCTXT        (1 << 30)		/* Receive Context Descriptor  */
#define DESC_RXSTS_RFIRST       (1 << 29)		/* First descriptor of the frame */
#define DESC_RXSTS_RLAST        (1 << 28)		/* Last descriptor of the frame */
#define DESC_RXSTS_RRS2V        (1 << 27)		/* Receive Status RDES2 Valid */
#define DESC_RXSTS_RRS1V        (1 << 26)		/* Receive Status RDES1 Valid */
#define DESC_RXSTS_RRS0V        (1 << 25)		/* Receive Status RDES0 Valid */
#define DESC_RXSTS_RCRC         (1 << 24)		/* CRC Error */
#define DESC_RXSTS_RGPKT        (1 << 23)		/* Giant Packet */
#define DESC_RXSTS_RWATCHDOG    (1 << 22)		/* Receive Watchdog Timeout */
#define DESC_RXSTS_ROFERROR     (1 << 21)		/* Overflow Error */
#define DESC_RXSTS_RMIIERROR    (1 << 20)		/* Receive Error */
#define DESC_RXSTS_RDRIBBLING   (1 << 19)		/* Dribble Bit Error */
#define DESC_RXSTS_RLTF         (7 << 16)		/* Length/Type Field */
#define DESC_RXSTS_RERROR       (1 << 15)		/* Error Summary */
#define DESC_RXSTS_RPLEN        (0x00007FFF)	/* Packet Length */

/*
 *  EMAC
 */
#define ETH_MACCR_MASK          (ETH_MACCR_PRELEN  | ETH_MACCR_DC   | ETH_MACCR_BL | \
						         ETH_MACCR_DR      | ETH_MACCR_DCRS | ETH_MACCR_DO | \
								 ETH_MACCR_ECRSFD  | ETH_MACCR_LM   | ETH_MACCR_DM | \
						         ETH_MACCR_FES     | ETH_MACCR_JE   | ETH_MACCR_JD | \
						         ETH_MACCR_WD      | ETH_MACCR_ACS  | ETH_MACCR_CST | \
						         ETH_MACCR_GPSLCE  | ETH_MACCR_S2KP | ETH_MACCR_IPG | \
						         ETH_MACCR_IPC     | ETH_MACCR_SARC | ETH_MACCR_ARP)
#define ETH_MACCR_INIT          (ETH_MACCR_DM  | ETH_MACCR_FES | ETH_MACCR_ACS | \
						         ETH_MACCR_CST | ETH_MACCR_IPC | ETH_MACCR_SARC_REPADDR0)
#define ETH_MACECR_MASK         (ETH_MACECR_GPSL   | ETH_MACECR_DCRCC | ETH_MACECR_SPEN | \
						         ETH_MACECR_EIPGEN | ETH_MACECR_USP | ETH_MACECR_EIPG)
#define ETH_MACECR_INIT         (0x618)
#define ETH_MACWTR_MASK         (ETH_MACWTR_WTO    | ETH_MACWTR_PWE)
#define ETH_MACWTR_INIT         (0)
#define ETH_MACTFCR_MASK        (ETH_MACTFCR_TFE   | ETH_MACTFCR_PLT | ETH_MACTFCR_DZPQ | \
						         ETH_MACTFCR_PT)
#define ETH_MACTFCR_INIT        (0)
#define ETH_MACRFCR_MASK        (ETH_MACRFCR_RFE   | ETH_MACRFCR_UP)
#define ETH_MACRFCR_INIT        (0)
#define ETH_MTLTQOMR_MASK       (ETH_MTLTQOMR_TSF  | ETH_MTLTQOMR_TTC)
#define ETH_MTLTQOMR_INIT       (0)
#define ETH_MTLRQOMR_MASK       (ETH_MTLRQOMR_RTC  | ETH_MTLRQOMR_FUP | ETH_MTLRQOMR_FEP | \
						         ETH_MTLRQOMR_RSF  | ETH_MTLRQOMR_DISTCPEF)
#define ETH_MTLRQOMR_INIT       (ETH_MTLRQOMR_RSF)

#define ETH_DMAMR_MASK          (ETH_DMAMR_DA      | ETH_DMAMR_TXPR | ETH_DMAMR_PR)
#define ETH_DMAMR_INIT          (0)
#define ETH_DMASBMR_MASK        (ETH_DMASBMR_FB    | ETH_DMASBMR_AAL | ETH_DMASBMR_MB | \
					             ETH_DMASBMR_RB)
#define ETH_DMASBMR_INIT        (ETH_DMASBMR_FB | ETH_DMASBMR_AAL)
#define ETH_DMACCR_MASK         (ETH_DMACCR_MSS    | ETH_DMACCR_8PBL)
#define ETH_DMACCR_INIT         (536)
#define ETH_DMACTCR_MASK        (ETH_DMACTCR_OSP   | ETH_DMACTCR_TSE | ETH_DMACTCR_TPBL)
#define ETH_DMACTCR_INIT        (ETH_DMACTCR_TPBL_32PBL)
#define ETH_DMACRCR_MASK        (ETH_DMACRCR_RPBL  | ETH_DMACRCR_RPF)
#define ETH_DMACRCR_INIT        (ETH_DMACRCR_RPBL_32PBL)


#define ETH_MACPCSR_MASK        (ETH_MACPCSR_RWKPKTEN | ETH_MACPCSR_MGKPKTEN | \
                                 ETH_MACPCSR_GLBLUCAST | ETH_MACPCSR_RWKPFE)

#define ETH_MACMDIOAR_MASK      (ETH_MACMDIOAR_PA | ETH_MACMDIOAR_RDA | ETH_MACMDIOAR_MOC | \
                                 ETH_MACMDIOAR_MB)

/*
 *  EMAC-DMA
 */
#define DMA_INTER_RXSTAT_ERROR  (ETH_DMACIER_RBUE | ETH_DMACIER_RSE | ETH_DMACIER_RWTE)
#define DMA_INTR_NORMAL	        (ETH_DMACIER_NIE | ETH_DMACIER_RIE | ETH_DMACIER_TIE)
#define DMA_INTR_ABNORMAL       (ETH_DMACIER_AIE | ETH_DMACIER_TBUE  | ETH_DMACIER_ETIE | \
								 ETH_DMACIER_FBEE | ETH_DMACIER_TXSE | ETH_DMACIER_CDEE | \
                                 DMA_INTER_RXSTAT_ERROR)
#define DMA_INTR_DEFAULT_MASK	(DMA_INTR_NORMAL | DMA_INTR_ABNORMAL | ETH_DMACIER_ERIE)

/*
 *  PHY FEATURES 
 */
#define ADVERTISE_MASK1         (ADVERTISE_10HALF   | ADVERTISE_10FULL    | \
							     ADVERTISE_100HALF  | ADVERTISE_100FULL   | \
								 ADVERTISE_100BASE4 | ADVERTISE_PAUSE_CAP | ADVERTISE_PAUSE_ASYM)


/*
 *  PHY-GPIO
 */
#define GPIO_ETH_AF              0x0B
#define RMII_REF_CLK_PORT        TADR_GPIOA_BASE
#define RMII_REF_CLK_BIN         1
#define RMII_MDIO_PORT           TADR_GPIOA_BASE
#define RMII_MDIO_PIN            2
#define RMII_MDC_PORT            TADR_GPIOC_BASE
#define RMII_MDC_PIN             1
#define RMII_MII_CRS_DV_PORT     TADR_GPIOA_BASE
#define RMII_MII_CRS_DV_PIN      7
#define RMII_MII_RXD0_PORT       TADR_GPIOC_BASE
#define RMII_MII_RXD0_PIN        4
#define RMII_MII_RXD1_PORT       TADR_GPIOC_BASE
#define RMII_MII_RXD1_PIN        5
#define RMII_MII_RXER_PORT       TADR_GPIOG_BASE
#define RMII_MII_RXER_PIN        2
#define RMII_MII_TX_EN_PORT      TADR_GPIOG_BASE
#define RMII_MII_TX_EN_PIN       11
#define RMII_MII_TXD0_PORT       TADR_GPIOG_BASE
#define RMII_MII_TXD0_PIN        13
#ifndef RMII_MII_TXD1_PORT
#define RMII_MII_TXD1_PORT       TADR_GPIOB_BASE
#define RMII_MII_TXD1_PIN        13
#endif

/*
 *  EMACϡɥ깽¤
 */
typedef struct _I2C_PortControlBlock{
	uint32_t              base;
	uint32_t              phy_sel;
	uint8_t               intno;
	uint8_t               phy_addr;
} EMAC_PortControlBlock;

/*
 *  EMACݡơ֥
 */
static const EMAC_PortControlBlock emac_pcb[NUM_MACPORT] = {
  {	TADR_ETH_BASE, EMAC_CTRL_PHYSEL_RGMII, IRQ_VECTOR_ETH, 0}
};

/*
 *  EMAC ϥɥ
 */
static EMAC_Handle_t EMacHandle[NUM_MACPORT];

static uint32_t
emac_ether_clockdiv(void)
{
#if SysFreHCLK >= 20000000 && SysFreHCLK < 35000000
	/* CSR Clock Range between 20-35 MHz */
    retrun (uint32_t)ETH_MACMDIOAR_CR_DIV16;
#elif SysFreHCLK >= 35000000 && SysFreHCLK < 60000000
    /* CSR Clock Range between 35-60 MHz */
	return (uint32_t)ETH_MACMDIOAR_CR_DIV26;
#elif SysFreHCLK >= 60000000 && SysFreHCLK < 100000000
	/* CSR Clock Range between 60-100 MHz */
	return (uint32_t)ETH_MACMDIOAR_CR_DIV42;
#elif SysFreHCLK >= 100000000 && SysFreHCLK < 150000000
	/* CSR Clock Range between 100-150 MHz */
	return (uint32_t)ETH_MACMDIOAR_CR_DIV62;
#else
	/* CSR Clock Range between 150-216 MHz */
	return (uint32_t)ETH_MACMDIOAR_CR_DIV102;
#endif
}

/*
 *  MDIOREADYԤ
 *  parameter1 base  EMAC쥸Υ١ɥ쥹
 *  return     E_OKｪλ
 */
static ER
emac_mdio_wait_ready(uint32_t base)
{
	int  i;

	for(i = 0 ; i < (EMAC_MDIO_READY_WAIT_MSEC*10) ; i++) {
		if((sil_rew_mem((uint32_t *)(base+TOFF_ETH_MACMDIOAR)) & ETH_MACMDIOAR_MB) == 0)
			return E_OK;
		sil_dly_nse(100*1000);
	}
	syslog_0(LOG_ERROR, "EMAC:Error mdio timeout!");
	return E_TMOUT;
}

/*
 *  PHY쥸ؤΥǡ񤭹
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 reg   쥸ֹ
 *  parameter3 val   񤭹
 *  return     E_OKｪλ
 */
static ER
emac_mdio_write(EMAC_Handle_t *hmac, int reg, int val)
{
	uint32_t miiaddr;
	ER       ercd = E_TMOUT;

	if(hmac->Init.semid != 0)
		wai_sem(hmac->Init.semid);

	miiaddr  = sil_rew_mem((uint32_t *)(hmac->base+TOFF_ETH_MACMDIOAR)) & ~ETH_MACMDIOAR_MASK;
	miiaddr |= ((hmac->phy_addr << 21) & ETH_MACMDIOAR_PA) | \
		  ((reg << 16) & ETH_MACMDIOAR_RDA) | ETH_MACMDIOAR_MOC_WR;

	/*
	 *  READYԤ
	 */
	if(emac_mdio_wait_ready(hmac->base) == E_OK){
		/*
		 *  ǡ塢PHYɥ쥹å
		 */
		sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_MACMDIODR), val);
		sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_MACMDIOAR), (miiaddr | ETH_MACMDIOAR_MB));

		/*
		 *  READYԤ
		 */
		if (emac_mdio_wait_ready(hmac->base) == E_OK)
			ercd = E_OK;
	}

	if(hmac->Init.semid != 0)
		sig_sem(hmac->Init.semid);
	return ercd;
}

/*
 *  PHY쥸Υǡɤ߹
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 reg   쥸ֹ
 *  return     0ʾǥ쥸
 */
static int
emac_mdio_read(EMAC_Handle_t *hmac, int reg)
{
	uint32_t miiaddr;
	int     val = -1;

	if(hmac->Init.semid != 0)
		wai_sem(hmac->Init.semid);

	miiaddr  = sil_rew_mem((uint32_t *)(hmac->base+TOFF_ETH_MACMDIOAR)) & ~ETH_MACMDIOAR_MASK;
	miiaddr |= ((hmac->phy_addr << 21) & ETH_MACMDIOAR_PA) | \
		  ((reg << 16) & ETH_MACMDIOAR_RDA) | ETH_MACMDIOAR_MOC_RD;

	/*
	 *  READYԤ
	 */
	if(emac_mdio_wait_ready(hmac->base) == E_OK){
		/*
		 *  PHYɥ쥹å
		 */
		sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_MACMDIOAR), (miiaddr | ETH_MACMDIOAR_MB));

		/*
		 *  READYԤθ塢ǡ
		 */
		if(emac_mdio_wait_ready(hmac->base) == E_OK)
			val = sil_rew_mem((uint32_t *)(hmac->base+TOFF_ETH_MACMDIODR)) & 0x0000ffffUL;
	}

	if(hmac->Init.semid != 0)
		sig_sem(hmac->Init.semid);
	return val;
}

/*
 *  PHYν
 *  parameter1 hmac   EMACϥɥؤΥݥ
 *  parameter2 phyadr PHYɥ쥹(32ʾʤмư)
 *  return     E_OKｪλ
 */
static ER
emac_phy_init(EMAC_Handle_t *hmac, uint8_t phy_addr)
{
	int  val;

	if(phy_addr < 0x20){
		hmac->phy_addr = phy_addr;
		val = emac_mdio_read(hmac, MII_PHYSID1);
		if((val > 0) && (val != 0xffff))
			return E_OK;
		else{
			syslog_1(LOG_ERROR, "EMAC:emac_phy_init Error unkown phy address(%d)", phy_addr);
			return E_ID;
		}
	}

	/*
	 *  ư󥹥⡼
	 */
	for(phy_addr = 0; phy_addr < 0x20; phy_addr++){
		hmac->phy_addr = phy_addr;
		val = emac_mdio_read(hmac, MII_PHYSID1);
		if((val > 0) && (val != 0xffff))
			return E_OK;
	}
	syslog_0(LOG_ERROR, "EMAC:emac_phy_init Error unkown phy address");
	return E_ID;
}

/*
 *  PHYꥻåȤ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     E_OKｪλ
 */
static ER
emac_phy_reset(EMAC_Handle_t *hmac)
{
	int i, val;

	val = emac_mdio_read(hmac, MII_BMCR);
	val &= ~(BMCR_ISOLATE | BMCR_ANENABLE);
	val |= BMCR_RESET;
	emac_mdio_write(hmac, MII_BMCR, val);

	for(i = 0 ; i < 1000; i++){
		val = emac_mdio_read(hmac, MII_BMCR);
		if (val < 0)
			break;
		if ((val & BMCR_RESET) == 0) {
			if (val & BMCR_ISOLATE) {
				val &= (~BMCR_ISOLATE);
				emac_mdio_write(hmac, MII_BMCR, val);
			}
			return E_OK;
		}
		dly_tsk(1);
	}
	syslog_0(LOG_ERROR, "EMAC:emac_phy_reset Error spin reset timeout");
	return E_TMOUT;
}

/*
 *  PHYξ֤Ф
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     PHYξ
 */
static uint32_t
emac_phy_features(EMAC_Handle_t *hmac)
{
	uint32_t   bmsr;
	uint32_t   mode = ADVERTISE_PAUSE_CAP | ADVERTISE_PAUSE_ASYM;

	bmsr = emac_mdio_read(hmac, MII_BMSR);
	if((bmsr & BMSR_10HALF) != 0)
		mode |= ADVERTISE_10HALF;
	if((bmsr & BMSR_10FULL) != 0)
		mode |= ADVERTISE_10FULL;
	if((bmsr & BMSR_100HALF) != 0)
		mode |= ADVERTISE_100HALF;
	if((bmsr & BMSR_100FULL) != 0)
		mode |= ADVERTISE_100FULL;
	return mode;
}

/*
 *  PHY׵
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 link  PHY
 *  return     E_OKｪλ
 */
static ER
emac_phy_start(EMAC_Handle_t *hmac, uint32_t link)
{
	ER       ercd;
	uint32_t id;
	uint32_t mode, val;
	int      speed = 0, duplex = 0;

	/*
	 *  PHYꥻåȤ
	 */
	if((ercd = emac_phy_reset(hmac)) != E_OK)
		return ercd;

	/*
	 *  PHY
	 */
	hmac->phy_features = emac_phy_features(hmac);
	syslog_1(LOG_INFO, "EMAC:emac_phy_start phy featurs[%08x]", hmac->phy_features);

	/*
	 *  PHYΥåIDγǧ
	 */
	id  = (emac_mdio_read(hmac, MII_PHYSID1) << 16);
	id |= (emac_mdio_read(hmac, MII_PHYSID2) & 0xffff);

	syslog_2(LOG_INFO, "EMAC:emac_phy_start PHY-ID[OUI&Model:0x%x, Rev:0x%x]", id & ~0xf, id & 0xf);

	/*
	 *  ץ꤬С¹
	 */
	if(hmac->phy_opt_init)
		hmac->phy_opt_init(hmac);

	/*
	 *  LINKѥ᡼
	 */
	link &= ~EMAC_LINK_CONNECT;
	hmac->linkvalue = link;

	switch(link){
	case EMAC_LINK_10BASE_FULL:
		duplex = BMCR_FULLDPLX;
	case EMAC_LINK_10BASE_HALF:
		speed = BMCR_SPEED10;
		break;
	case EMAC_LINK_100BASE_FULL:
		duplex = BMCR_FULLDPLX;
	case EMAC_LINK_100BASE_HALF:
		speed = BMCR_SPEED100;
		break;
	case EMAC_LINK_AUTONEGO:
	default:
		/* Setup Auto-negotiation */
		hmac->linkvalue |= EMAC_LINK_AUTONEGO;
		mode = hmac->phy_features;
		val = emac_mdio_read(hmac, MII_ADVERTISE);
		val &= ~ADVERTISE_MASK1;
		val |= mode & ADVERTISE_MASK1;
		emac_mdio_write(hmac, MII_ADVERTISE, val);
		break;
	}

	val = emac_mdio_read(hmac, MII_BMCR);
	val &= ~(BMCR_FULLDPLX | BMCR_SPEED100 | BMCR_ANENABLE);
	val |= is_autonego(hmac) ? (BMCR_ANENABLE | BMCR_ANRESTART) : (speed | duplex);
	emac_mdio_write(hmac, MII_BMCR, val);
	return E_OK;
}

/*
 *  AUTO-NEGOTIATIONLINK֤μ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     LINK
 */
static uint32_t
emac_phy_link_autonego(EMAC_Handle_t *hmac)
{
	uint32_t  link_detect;
	uint32_t  lpa;

	lpa = emac_mdio_read(hmac, MII_LPA) & emac_mdio_read(hmac, MII_ADVERTISE);
	if(lpa & LPA_100FULL)
		link_detect = EMAC_LINK_100BASE_FULL;
	else if(lpa & LPA_100HALF)
		link_detect = EMAC_LINK_100BASE_HALF;
	else if(lpa & LPA_10FULL)
		link_detect = EMAC_LINK_10BASE_FULL;
	else
		link_detect = EMAC_LINK_10BASE_HALF;
	return link_detect;
}

/*
 *  ޥ˥奢LINK֤μ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     LINK
 */
static uint32_t
emac_phy_link_manual(EMAC_Handle_t *hmac)
{
	uint32_t    link_detect;
	int     bmcr;

	bmcr = emac_mdio_read(hmac, MII_BMCR);

	if(bmcr & BMCR_SPEED100)
		link_detect = EMAC_SPEED_100BASE;
	else
		link_detect = EMAC_SPEED_10BASE;
	link_detect |= (bmcr & BMCR_FULLDPLX) ? EMAC_DUPLEX_FULL : EMAC_DUPLEX_HALF;
	return link_detect;
}

/*
 *  DESCRIPTERΰν
 *  parameter1 hmac  EMACϥɥؤΥݥ
 */
static void
emac_bd_set(EMAC_Handle_t *hmac)
{
	uint32_t   *desc;
	uint8_t    *pdata = hmac->Init.databuffer;
	int        i;

	/*
	 *  DESCRIPTOR/BUFFERΰΤΥå򥯥ꥢ
	 */
	desc  = (uint32_t *)hmac->Init.quebuffer;

	hmac->rx_top_desc = desc;
	for(i = 0 ; i < hmac->Init.rxquecount ; i++) {
		desc[DESC_TXRX_0] = (uint32_t)pdata;
		desc[DESC_TXRX_1] = 0;
		desc[DESC_TXRX_2] = 0;
		desc[DESC_TXRX_3] = DESC_RXSTS_WBUF1V;
		desc[DESC_TXRX_BACKUPADDR0] = (uint32_t)pdata;
		desc[DESC_TXRX_BACKUPADDR1] = 0;
		pdata += hmac->Init.paketbufsize;
		desc  += DESC_TXRX_SIZE;
	}
	hmac->rx_btm_desc = desc;

	/*
	 *  RXǥץǡ
	 */
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACRDRLR), (hmac->Init.rxquecount-1));
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACRDLAR), (uint32_t)hmac->rx_top_desc);
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACRDTPR),
		(uint32_t)(hmac->rx_top_desc + ((hmac->Init.rxquecount-1) * DESC_TXRX_SIZE)));

	hmac->tx_top_desc = desc;
	for(i = 0 ; i < hmac->Init.txquecount ; i++){
		desc[DESC_TXRX_0] = (uint32_t)pdata;
		desc[DESC_TXRX_1] = 0;
		desc[DESC_TXRX_2] = 0;
		desc[DESC_TXRX_3] = 0;
		pdata += hmac->Init.paketbufsize;
		desc  += DESC_TXRX_SIZE;
	}
	hmac->tx_btm_desc = desc;

	/*
	 *  TXǥץǡ
	 */
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACTDRLR), (hmac->Init.txquecount-1));
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACTDLAR), (uint32_t)hmac->tx_top_desc);
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACTDTPR), (uint32_t)hmac->tx_top_desc);
}


/*
 *  EMACǥХν
 *  parameter1 portid EMACΥݡID
 *  parameter2 ini    ¤ΤؤΥݥ
 *  return            ϥɥؤΥݥ
 */
EMAC_Handle_t *
emac_init(ID portid, EMAC_Init_t *ini)
{
	GPIO_Init_t GPIO_Init_Data;
	const EMAC_PortControlBlock *pcb;
	EMAC_Handle_t *hmac;
	uint32_t base, no, tmp;
	uint32_t timeout = 3000;

	if(portid == 0 || portid > NUM_MACPORT)
		return NULL;
	if((ini->paketbufsize % 4) != 0)
		return NULL;

	no = INDEX_EMAC(portid);
	pcb = &emac_pcb[no];
	hmac = &EMacHandle[no];

	hmac->base     = base = pcb->base;
	hmac->intno    = pcb->intno;
	memcpy(&hmac->Init, ini, sizeof(EMAC_Init_t));

	/*
	 *  PHY GPIO å
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR), RCC_AHB4ENR_GPIOAEN);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR));
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR), RCC_AHB4ENR_GPIOCEN);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR));
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR), RCC_AHB4ENR_GPIOGEN);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR));
#ifdef RMII_MII_TXD1_CLOCK
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR), RMII_MII_TXD1_CLOCK);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR));
#endif

	/*
	 *  PHY GPIOԥ
	 */
	GPIO_Init_Data.mode      = GPIO_MODE_AF;
	GPIO_Init_Data.pull      = GPIO_OTYPE_PP;
	GPIO_Init_Data.otype     = GPIO_NOPULL;
	GPIO_Init_Data.speed     = GPIO_SPEED_HIGH;
	GPIO_Init_Data.alternate = GPIO_ETH_AF;
	gpio_setup(RMII_REF_CLK_PORT, &GPIO_Init_Data, RMII_REF_CLK_BIN);
	gpio_setup(RMII_MDIO_PORT, &GPIO_Init_Data, RMII_MDIO_PIN);
	gpio_setup(RMII_MDC_PORT, &GPIO_Init_Data, RMII_MDC_PIN);
	gpio_setup(RMII_MII_CRS_DV_PORT, &GPIO_Init_Data, RMII_MII_CRS_DV_PIN);
	gpio_setup(RMII_MII_RXD0_PORT, &GPIO_Init_Data, RMII_MII_RXD0_PIN);
	gpio_setup(RMII_MII_RXD1_PORT, &GPIO_Init_Data, RMII_MII_RXD1_PIN);
	gpio_setup(RMII_MII_RXER_PORT, &GPIO_Init_Data, RMII_MII_RXER_PIN);
	gpio_setup(RMII_MII_TX_EN_PORT, &GPIO_Init_Data, RMII_MII_TX_EN_PIN);
	gpio_setup(RMII_MII_TXD0_PORT, &GPIO_Init_Data, RMII_MII_TXD0_PIN);
	gpio_setup(RMII_MII_TXD1_PORT, &GPIO_Init_Data, RMII_MII_TXD1_PIN);

	/*
	 *  EMACå
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), RCC_AHB1ENR_ETH1MACEN);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR));
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), RCC_AHB1ENR_ETH1TXEN);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR));
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), RCC_AHB1ENR_ETH1RXEN);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR));

	dis_int(hmac->intno);
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB4ENR), RCC_APB4ENR_SYSCFGEN);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB4ENR));
	sil_modw_mem((uint32_t *)(TADR_SYSCFG_BASE+TOFF_SYSCFG_PMCR), SYSCFG_PMCR_EPIS_SEL, pcb->phy_sel);

	/*
	 *  MACꥻå
	 */
	sil_orw_mem((uint32_t *)(base+TOFF_ETH_DMAMR), ETH_DMAMR_SWR);
	while((sil_rew_mem((uint32_t *)(base+TOFF_ETH_DMAMR)) & ETH_DMAMR_SWR) != 0){
		if(timeout-- == 0)
			break;
		dly_tsk(1);
	}

	/* Get the ETHERNET MACMIIAR value */
	tmp= sil_rew_mem((uint32_t *)(base+TOFF_ETH_MACMDIOAR));
	/* Clear CSR Clock Range CR[2:0] bits */
	tmp &= ~ETH_MACMDIOAR_CR;
	tmp |= emac_ether_clockdiv();
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_MACMDIOAR), tmp);

	/* MAC LPI 1US Tic Counter Configuration */
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_MAC1USTCR), ((SysFreHCLK / ETH_MAC_US_TICK) - 1));

	/*
	 *  DESCRIPTORν
	 */
	emac_bd_set(hmac);

	if(emac_phy_init(hmac, pcb->phy_addr) != E_OK)
		return NULL;
	hmac->macid = portid;
	return hmac;
}

/*
 *  EMACλ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     E_OKｪλ
 */
ER
emac_deinit(EMAC_Handle_t *hmac)
{
	if(hmac == NULL || hmac->macid == 0 || hmac->macid > NUM_MACPORT)
		return E_OBJ;
	dis_int(hmac->intno);

	/*
	 *  EMACå
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), RCC_AHB1ENR_ETH1MACEN);
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), RCC_AHB1ENR_ETH1TXEN);
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), RCC_AHB1ENR_ETH1RXEN);

	hmac->macid = 0;
	return E_OK;
}

/*
 *  EMAC׵
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 num   ѥåȿ
 */
static void
emac_send_req(EMAC_Handle_t *hmac, int num)
{
	volatile uint32_t *desc, *top;
	uint32_t base = hmac->base;

	dis_int(hmac->intno);
	top = desc = hmac->tx_cur_desc;
	if(num > 0){
		while(--num > 0){
			desc += DESC_TXRX_SIZE;
			if(desc >= hmac->tx_btm_desc)
				desc = hmac->tx_top_desc;
			/*
			 *  Ϣ³DESCRIPTORDMA KICK
			 */
			desc[DESC_TXRX_3] |= DESC_TXSTS_OWNBYDMA;
		}
		/*
		 *  ƬDESCRIPTORDMA KICK
		 */
		top[DESC_TXRX_3] |= DESC_TXSTS_OWNBYDMA;
		desc += DESC_TXRX_SIZE;
		if(desc >= hmac->tx_btm_desc)
			desc = hmac->tx_top_desc;
		hmac->tx_cur_desc = desc;
	}
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_DMACTDTPR), (uint32_t)desc);
	ena_int(hmac->intno);
}

/*
 *  EMAC
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 pktp  ѥåȹ¤(LWIP)
 *  return     E_OKｪλ
 */
ER
emac_send(EMAC_Handle_t *hmac, struct emac_pkt *pktp)
{
	struct emac_pkt *p;
	int      num, tlen, alllen, actlen, retry;
	int      len, i;
	int      start = 1;
	ER       ercd = E_OK;
	volatile uint32_t *desc;
	uint32_t info_word = 0;
	volatile uint8_t  *pdata;
	volatile uint8_t  *s, *d;

	if(hmac == NULL || pktp == NULL)
		return E_PAR;

	desc = hmac->tx_cur_desc;
	s = pktp->payload;
	len = pktp->len;
	for(p = pktp, alllen = 0 ; p != NULL && p->len != 0 ; p = p->next)
		alllen += p->len;

	for(num = 0 ; num < hmac->Init.txquecount && pktp != NULL ; num++){
		if(len == 0)
			break;

		/*
		 *  DESCRIPTORγԤ
		 */
		if((desc[DESC_TXRX_3] & DESC_TXSTS_OWNBYDMA) != 0){
			for (retry = 0; retry < 3; retry++) {
				/* ǥץեΤȤΤԤ */
				dly_tsk(10);
				/* ٥åԤ */
				if((desc[DESC_TXRX_3] & DESC_TXSTS_OWNBYDMA) == 0)
					break;
				/* ǰΤᡢγϤ׵᤹ */
				emac_send_req(hmac, 0);
			}
			if((desc[DESC_TXRX_3] & DESC_TXSTS_OWNBYDMA) != 0){
				syslog_1(LOG_ERROR, "EMAC:emac_send retry(%d) no descriptor", retry+1);
				ercd = E_TMOUT;
				break;
			}
		}

		/*
		 *  ⡼ɤ򥻥å
		 */
		desc[DESC_TXRX_1] = 0x0;
		desc[DESC_TXRX_2] &= ~DESC_TXSTS_TXB1L;
		desc[DESC_TXRX_2] |= pktp->len;
		desc[DESC_TXRX_2] &= ~DESC_TXSTS_TXB2L;

		pdata = d = (volatile uint8_t *)(desc[DESC_TXRX_0]);
		actlen = 0;
		while(actlen < hmac->Init.paketbufsize){
			tlen = MIN(len, (hmac->Init.paketbufsize - actlen));
			for(i = 0 ; i < tlen ; i++)
				*d++ = *s++;
			actlen += tlen;
			len    -= tlen;
			if(len == 0){
				if((pktp = pktp->next) == NULL)
					break;
				if(pktp->len == 0)
					break;
				s = pktp->payload;
				len = pktp->len;
			}
		}
		syslog_4(LOG_DEBUG, "EMAC:emac_send(%d) desc[%08x] buf[%08x] actlen[%04x]", num, desc, pdata, actlen);

		info_word  = desc[DESC_TXRX_3];
		info_word &= ~(DESC_TXSTS_TXCIC | DESC_TXSTS_TXCRCPAD | DESC_TXSTS_TXCTXT | DESC_TXSTS_TXFL);
		info_word &= ~(DESC_TXSTS_TXFIRST | DESC_TXSTS_TXLAST);
		info_word |= alllen | DESC_TXSTS_TXCICALLLIN;
		if(start){
			start = 0;
			info_word |= DESC_TXSTS_TXCRCPADIN | DESC_TXSTS_TXFIRST;
		}

		/*
		 *  ΥǡǧȽλޡ
		 */
		if(pktp == NULL || pktp->len == 0){
			desc[DESC_TXRX_2] |= DESC_TXSTS_TXIOC;
			info_word |= DESC_TXSTS_TXLAST;
		}
		desc[DESC_TXRX_3]  = info_word;

		/*
		 *  DESCRIPTORع
		 */
		desc += DESC_TXRX_SIZE;
		if(desc >= hmac->tx_btm_desc)
			desc = hmac->tx_top_desc;
	}

	/* ѥåȤνüޤǥåȤƤʤȤϥ顼 */
	if((info_word & DESC_TXSTS_TXLAST) == 0){
		syslog_0(LOG_ERROR, "EMAC:emac_send last error !");
		return E_OBJ;
	}

	/* ׵᤹ */
	if(num > 0)
		emac_send_req(hmac, num);
	return ercd;
}

/*
 *  μDESCRIPTOR
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     DESCRIPTORؤΥݥ
 */
volatile static uint32_t *
emac_recv_desc_next(EMAC_Handle_t *hmac)
{
	volatile uint32_t *desc;

	desc = hmac->rx_cur_desc;
	desc[DESC_TXRX_0] = desc[DESC_TXRX_BACKUPADDR0];
	desc[DESC_TXRX_3] = DESC_RXSTS_WOWN | DESC_RXSTS_WIOC | DESC_RXSTS_WBUF1V;
	desc += DESC_TXRX_SIZE;
	if(desc >= hmac->rx_btm_desc)
		desc = hmac->rx_top_desc;
	hmac->rx_cur_desc = desc;
	return desc;
}

/*
 *  ƬѥåȤDESCRIPTORõ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     NULLǤʤСƬDESCRIPTORؤΥݥ
 */
volatile static uint32_t *
emac_recv_sop_find(EMAC_Handle_t *hmac)
{
	int      num;
	volatile uint32_t *desc = hmac->rx_cur_desc;
	volatile uint32_t *fdesc = NULL;
	uint32_t info_word;

	for(num = 0 ; num < hmac->Init.rxquecount ; num++) {
		info_word = desc[DESC_TXRX_3];

		/*
		 *  ǡʤΤȤϡλ
		 */
		if((info_word & DESC_RXSTS_ROWN) != 0)
			break;

		/*
		 * ǡ硢Start of Packet ΥåԤ
		 */
		if((info_word & DESC_RXSTS_RFIRST) != 0)
			fdesc = desc;
		if((info_word & DESC_RXSTS_RLAST) != 0){
			if(fdesc != NULL)
				return fdesc;
		}

		/*
		 * DESCRIPTOR
		 */
		if(fdesc != NULL){
			desc += DESC_TXRX_SIZE;
			if(desc >= hmac->rx_btm_desc)
				desc = hmac->rx_top_desc;
		}
		else
			desc = emac_recv_desc_next(hmac);
	}
	return NULL;
}

/*
 *  ǡĹμФ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     0ǤʤСѥåĹ
 */
int
emac_recv_length(EMAC_Handle_t *hmac)
{
	int      num, length = 0;
	volatile uint32_t *desc;
	uint32_t info_word;

	/*
	 *  ѥåȤγǧʤϽλ
	 */
	if((desc = emac_recv_sop_find(hmac)) == NULL)
		return 0;

	for(num = 0 ; num < hmac->Init.rxquecount ; num++){
		info_word = desc[DESC_TXRX_3];

		/*  ƤʤȤϡλ */
		if((info_word & DESC_RXSTS_ROWN) != 0)
			break;

		/*
		 *  End of PacketʤСλ
		 */
		if((info_word & DESC_RXSTS_RLAST) != 0){
			length = desc[DESC_TXRX_3] & DESC_RXSTS_RPLEN;
			break;
		}

		/*
		 *  DESCRIPTOR
		 */
		desc += DESC_TXRX_SIZE;
		if(desc >= hmac->rx_btm_desc)
			desc = hmac->rx_top_desc;
	}
	return length;
}

/*
 *  ѥåȤμ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 pktp  ǡǼѥåȹ¤(LWIP)
 *  return     E_OKʤСѥåĹ
 */
ER
emac_recv(EMAC_Handle_t *hmac, struct emac_pkt *pktp)
{
	int      num, alllen, actlen, i;
	volatile uint32_t *desc;
	volatile uint8_t  *b, *pdata;
	uint32_t info_word, len, tlen;

	if(hmac == NULL)
		return E_PAR;
	alllen = emac_recv_length(hmac);
	if(pktp != NULL){
		b = pktp->payload;
		len = pktp->len;
	}
	else{
		b = NULL;
		len = 0;
	}

	/*
	 *  ѥåȤγǧʤϥ顼λ
	 */
	if((desc = emac_recv_sop_find(hmac)) == NULL)
		return E_NOMEM;

	for(num = 0 ; num < hmac->Init.rxquecount ; num++){
		info_word = desc[DESC_TXRX_3];

		/*
		 *  ǡʤ硢λ
		 */
		if((info_word & DESC_RXSTS_ROWN) != 0)
			break;

		/*
		 *  ѥåȳǼΰ褬ϼѥåȤ
		 */
		if(b != NULL){
			/* ǡ */
			pdata = (uint8_t *)(desc[DESC_TXRX_BACKUPADDR0]);
			actlen = MIN(alllen, hmac->Init.paketbufsize);
			syslog_5(LOG_DEBUG, "EMAC:emac_recv num(%d) desc[%08x] b[%08x] pdata[%08x] actlen[%08x] !", num, desc, b, pdata, actlen);
			syslog_4(LOG_DEBUG, "  12[%02x] 13[%02x] 14[%02x] 15[%02x]", pdata[12], pdata[13], pdata[14], pdata[15]);
			while(actlen > 0){
				tlen = MIN(len, actlen);
				for(i = 0 ; i < tlen ; i++)
					*b++ = *pdata++;
				alllen -= tlen;
				actlen -= tlen;
				len    -= tlen;
				if(len == 0){
					if((pktp = pktp->next) == NULL){
						b = NULL;
						break;
					}
					b = pktp->payload;
					if((len = pktp->len) == 0){
						b = NULL;
						break;
					}
				}
			}
		}
		/*
		 *  DESCRIPTORμȹ
		 */
		desc = emac_recv_desc_next(hmac);

		/*
		 *  End of Packetξ硢ｪλ
		 */
		if((info_word & DESC_RXSTS_RLAST) != 0){
			sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACRDTPR), desc);
			return E_OK;
		}
	}
	return E_NOMEM;
}

/*
 *  DESCRIPTORΥꥻå
 *  parameter1 hmac  EMACϥɥؤΥݥ
 */
static void
emac_desc_reset(EMAC_Handle_t *hmac)
{
	volatile uint32_t *desc;
	uint8_t  *pdata = hmac->Init.databuffer;
	int      i;

	/*
	 *  ǥץν
	 */
	desc = hmac->rx_top_desc;
	hmac->rx_cur_desc = desc;
	for (i = 0 ; i < hmac->Init.rxquecount ; i++) {
		desc[DESC_TXRX_0] = (uint32_t)pdata;
		desc[DESC_TXRX_3] = DESC_RXSTS_WOWN | DESC_RXSTS_WBUF1V;
		desc[DESC_TXRX_BACKUPADDR0] = (uint32_t)pdata;
		pdata += hmac->Init.paketbufsize;
		desc += DESC_TXRX_SIZE;
	}
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACRDRLR), (hmac->Init.rxquecount-1));
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACRDLAR), (uint32_t)hmac->rx_top_desc);
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACRDTPR),
		(uint32_t)(hmac->rx_top_desc + ((hmac->Init.rxquecount-1) * DESC_TXRX_SIZE)));

	/*
	 *  ǥץν
	 */
	desc = hmac->tx_top_desc;
	hmac->tx_cur_desc = desc;
	for(i = 0 ; i < hmac->Init.txquecount ; i++) {
		desc[DESC_TXRX_0] = (uint32_t)pdata;
		desc[DESC_TXRX_1] = 0;
		desc[DESC_TXRX_2] = 0;
		desc[DESC_TXRX_3] = 0;
		pdata += hmac->Init.paketbufsize;
		desc += DESC_TXRX_SIZE;
	}
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACTDRLR), (hmac->Init.txquecount-1));
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACTDLAR), (uint32_t)hmac->tx_top_desc);
	sil_wrw_mem((uint32_t *)(hmac->base+TOFF_ETH_DMACTDTPR), (uint32_t)hmac->tx_top_desc);
}

/*
 *  ETHERNET̿򳫻Ϥ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 link  ̿⡼
 *  return     E_OKｪλ
 */
ER
emac_start(EMAC_Handle_t *hmac, uint32_t link)
{
	volatile uint32_t *desc;
	uint32_t base, i;

	if(hmac == NULL)
		return E_PAR;
	base = hmac->base;

	/*
	 *  PHY
	 */
	emac_phy_start(hmac, link);

	/*
	 *  ͭ
	 */
	desc = hmac->rx_top_desc;
	for(i = 0 ; i < hmac->Init.rxquecount ; i++){
		desc[DESC_TXRX_3] |= DESC_RXSTS_WIOC;
		desc += DESC_TXRX_SIZE;
	}
	sil_orw_mem((uint32_t *)(base+TOFF_ETH_MACCR), (ETH_MACCR_TE | ETH_MACCR_RE));
	sil_orw_mem((uint32_t *)(base+TOFF_ETH_MTLTQOMR), ETH_MTLTQOMR_FTQ);
	sil_orw_mem((uint32_t *)(base+TOFF_ETH_DMACTCR), ETH_DMACTCR_ST);
	sil_orw_mem((uint32_t *)(base+TOFF_ETH_DMACRCR), ETH_DMACRCR_SR);

	/*
	 *  ߥޥ
	 */
	sil_orw_mem((uint32_t *)(base+TOFF_ETH_DMACIER), DMA_INTR_DEFAULT_MASK);

	/*
	 *  ߵ
	 */
	ena_int(hmac->intno);
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_DMACSR), (ETH_DMACSR_TPS | ETH_DMACSR_RPS));
	return E_OK;
}

/*
 *  ETHERNET̿ߤ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 disable ̵(1̵)
 *  return     E_OKｪλ
 */
ER
emac_stop(EMAC_Handle_t *hmac, int disable)
{
	volatile uint32_t *desc;
	uint32_t base, i;
	ER       ercd = E_OK;

	if(hmac == NULL)
		return E_PAR;
	base = hmac->base;

	/*
	 * 
	 */
	dis_int(hmac->intno);
	sil_andw_mem((uint32_t *)(base+TOFF_ETH_DMACIER), DMA_INTR_NORMAL);

	if(disable == 1) {
		/*
		 *  ̵
		 */
		sil_andw_mem((uint32_t *)(base+TOFF_ETH_DMACTCR), ETH_DMACTCR_ST);
		sil_andw_mem((uint32_t *)(base+TOFF_ETH_DMACRCR), ETH_DMACRCR_SR);
		sil_andw_mem((uint32_t *)(base+TOFF_ETH_MACCR), ETH_MACCR_RE);
		dly_tsk(200);

		/*
		 *  ѤߥѥåȤ˴
		 */
		while(ercd == E_OK){
			ercd = emac_recv(hmac, NULL);
			dly_tsk(1);
			syslog_1(LOG_NOTICE, "EMAC:emac_stop flush result(%d) !", ercd);
		}
		sil_orw_mem((uint32_t *)(base+TOFF_ETH_MTLTQOMR), ETH_MTLTQOMR_FTQ);
		sil_andw_mem((uint32_t *)(base+TOFF_ETH_MACCR), ETH_MACCR_TE);
		desc = hmac->rx_top_desc;
		for(i = 0 ; i < hmac->Init.rxquecount ; i++){
			desc[DESC_TXRX_3] &= ~DESC_RXSTS_WIOC;
			desc += DESC_TXRX_SIZE;
		}
	}
	return E_OK;
}

/*
 *  LINK֤
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  return     LINK(0̤³)
 */
uint32_t
emac_link_detect(EMAC_Handle_t *hmac)
{
	uint32_t link_detect = 0;
	int      bmsr;

	/* ǽ϶ɤ */
	emac_mdio_read(hmac, MII_BMSR);
	bmsr = emac_mdio_read(hmac, MII_BMSR);
	syslog_2(LOG_INFO, "EMAC:phy_link_detect[%08x] phydev->auto_nego(%d)", bmsr, is_autonego(hmac));

	if((bmsr >= 0) && (bmsr & BMSR_LSTATUS)){
		link_detect = is_autonego(hmac)
				? emac_phy_link_autonego(hmac)
				: emac_phy_link_manual(hmac);
	}
	return link_detect;
}

/*
 *  EMACԤ
 *  parameter1 hmac  EMACϥɥؤΥݥ
 *  parameter2 link  EMAC⡼
 *  return     E_OKｪλ
 */
ER
emac_link_mode_set(EMAC_Handle_t *hmac, uint32_t link)
{
	uint32_t base, conf;

	if(hmac == NULL || link == 0)
		return E_PAR;
	base = hmac->base;
	conf = sil_rew_mem((uint32_t *)(base+TOFF_ETH_MACCR));

	if((link & EMAC_SPEED_MASK) != EMAC_SPEED_10BASE)
		conf |= ETH_MACCR_FES;
	else
		conf &= ~ETH_MACCR_FES;

	if((link & EMAC_DUPLEX_MASK) == EMAC_DUPLEX_FULL)
		conf |= ETH_MACCR_DM;
	else
		conf &= ~ETH_MACCR_DM;
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_MACCR), conf);
	return E_OK;
}

/*
 *  EMACꥻåȤ
 *  parameter1 hmac   EMACϥɥؤΥݥ
 *  parameter2 macadr MACɥ쥹ǡؤΥݥ
 *  return     E_OKｪλ
 */
ER
emac_reset(EMAC_Handle_t *hmac, uint8_t *mac_addr)
{
	uint32_t  timeout = 3000;
	uint32_t  base, tmp;
	uint32_t  macid_hi, macid_lo;
	uint8_t   *b = (uint8_t *)&mac_addr[0];

	if(hmac == NULL || mac_addr == NULL)
		return E_PAR;
	base = hmac->base;

	/*
	 *  MACꥻå
	 */
	sil_orw_mem((uint32_t *)(base+TOFF_ETH_DMAMR), ETH_DMAMR_SWR);
	while((sil_rew_mem((uint32_t *)(base+TOFF_ETH_DMAMR)) & ETH_DMAMR_SWR) != 0){
		if(timeout-- == 0)
			break;
		dly_tsk(1);
	}

	/* Get the ETHERNET MACMIIAR value */
	tmp= sil_rew_mem((uint32_t *)(base+TOFF_ETH_MACMDIOAR));
	/* Clear CSR Clock Range CR[2:0] bits */
	tmp &= ~ETH_MACMDIOAR_CR;
	tmp |= emac_ether_clockdiv();
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_MACMDIOAR), tmp);

	/* MAC LPI 1US Tic Counter Configuration */
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_MAC1USTCR), ((SysFreHCLK / ETH_MAC_US_TICK) - 1));

	/*
	 *  
	 */
	emac_stop(hmac, 0);

	/*
	 *  MACɥ쥹Ͽ
	 */
	macid_lo = b[0] + (b[1] << 8) + (b[2] << 16) + (b[3] << 24);
	macid_hi = b[4] + (b[5] << 8);
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_MACA0HR), macid_hi);
	sil_wrw_mem((uint32_t *)(base+TOFF_ETH_MACA0LR), macid_lo);

	/*
	 *  MAC
	 */
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_MACCR), ETH_MACCR_MASK, ETH_MACCR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_MACECR), ETH_MACECR_MASK, ETH_MACECR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_MACWTR), ETH_MACWTR_MASK, ETH_MACWTR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_MACTFCR), ETH_MACTFCR_MASK, ETH_MACTFCR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_MACRFCR), ETH_MACRFCR_MASK, ETH_MACRFCR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_MTLTQOMR), ETH_MTLTQOMR_MASK, ETH_MTLTQOMR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_MTLRQOMR), ETH_MTLRQOMR_MASK, ETH_MTLRQOMR_INIT);

	sil_modw_mem((uint32_t *)(base+TOFF_ETH_DMAMR), ETH_DMAMR_MASK, ETH_DMAMR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_DMASBMR), ETH_DMASBMR_MASK, ETH_DMASBMR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_DMACCR), ETH_DMACCR_MASK, ETH_DMACCR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_DMACTCR), ETH_DMACTCR_MASK, ETH_DMACTCR_INIT);
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_DMACRCR), ETH_DMACRCR_MASK, ETH_DMACRCR_INIT);

	/* DSL to 64 bit */
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_DMACCR), ETH_DMACCR_DSL, ETH_DMACCR_DSL_64BIT);

	/* ХåեĹ */
	sil_modw_mem((uint32_t *)(base+TOFF_ETH_DMACRCR), ETH_DMACRCR_RBSZ, ((hmac->Init.paketbufsize) << 1));

	/*
	 *  DESCRIPTERꥻå
	 */
	emac_desc_reset(hmac);
	return E_OK;
}

/*
 *  EMACΥѥ椹
 *  parameter1 hmac   EMACϥɥؤΥݥ
 *  parameter2 pu     EMACѥ깽¤ΤؤΥݥ󥿡NULLʤ齪λ
 *  return     E_OKｪλ
 */
ER
emac_powercontrol(EMAC_Handle_t *hmac, struct emac_powerconf *pu)
{
	uint32_t base;

	if(hmac == NULL)
		return E_PAR;
	base = hmac->base;
	if(pu == NULL){		/* λ */
		sil_andw_mem((uint32_t *)(base+TOFF_ETH_MACPCSR), ETH_MACPCSR_MASK);
		if((sil_rew_mem((uint32_t *)(base+TOFF_ETH_MACPCSR)) & ETH_MACPCSR_PWRDWN) != 0)
			sil_andw_mem((uint32_t *)(base+TOFF_ETH_MACPCSR), ETH_MACPCSR_PWRDWN);
		sil_andw_mem((uint32_t *)(base+TOFF_ETH_MACIER), ETH_MACIER_PMTIE);
	}
	else{				/*  */
		uint32_t powerconfig = 0;
		if(pu->wakeuppacket)
			powerconfig |= ETH_MACPCSR_RWKPKTEN;
		if(pu->magicpacket)
			powerconfig |= ETH_MACPCSR_MGKPKTEN;
		if(pu->globalunicast)
			powerconfig |= ETH_MACPCSR_GLBLUCAST;
		if(pu->wakeupforward)
			powerconfig |= ETH_MACPCSR_RWKPFE;
		sil_orw_mem((uint32_t *)(base+TOFF_ETH_MACIER), ETH_MACIER_PMTIE);
		sil_modw_mem((uint32_t *)(base+TOFF_ETH_MACPCSR), ETH_MACPCSR_MASK, powerconfig);
		sil_orw_mem((uint32_t *)(base+TOFF_ETH_MACPCSR), ETH_MACPCSR_PWRDWN);
	}
	return E_OK;
}


/*
 *  EMAC DMAѳ߽
 */
static int
emac_dma_interrupt(EMAC_Handle_t *hmac, uint32_t status)
{
	int  event = 0;

	if((status & 0xFFFF) == 0)
		return 0;
	event = 0;

	/*
	 *  ABNORMAL
	 */
	if((status & ETH_DMACSR_AIS) != 0){
		if((status & ETH_DMACSR_TBU) != 0)
			hmac->tx_undeflow_irq++;
		if((status & ETH_DMACSR_CDE) != 0)
			hmac->context_desc_err_irq++;
		if((status & ETH_DMACSR_RBU) != 0)
			hmac->rx_buf_unav_irq++;
		if((status & ETH_DMACSR_RPS) != 0)
			hmac->rx_process_stopped_irq++;
		if((status & ETH_DMACSR_RWT) != 0)
			hmac->rx_watchdog_irq++;
		if((status & ETH_DMACSR_ETI) != 0)
			hmac->tx_early_irq++;
		if((status & ETH_DMACSR_TPS) != 0)
			hmac->tx_process_stopped_irq++;
		if((status & ETH_DMACSR_FBE) != 0){
			hmac->fatal_bus_error_irq++;
			event |= 0x0004;
		}
	}

	/*
	 *  TX/RX NORMAL
	 */
	if((status & ETH_DMACSR_NIS) != 0)
		hmac->normal_irq_n++;
	if((status & ETH_DMACSR_RI) != 0) {
		/* to schedule NAPI on real RIE event. */
		hmac->rx_normal_irq_n++;
		if(hmac->emacevent != NULL)
			hmac->emacevent(hmac, 0, RECV_EVENT_DETECT);
	}
	if((status & ETH_DMACSR_TI) != 0){
		/*
		 * ߤΤ
		 */
		if(hmac->emacevent != NULL)
			hmac->emacevent(hmac, 0, SEND_EVENT_DETECT);
	}
	if((status & ETH_DMACSR_ERI) != 0)
		hmac->rx_early_irq++;
	return event;
}

/*
 *  EMACߥӥ롼
 */
void
emac_hps_isr(intptr_t exinf)
{
	EMAC_Handle_t *hmac = &EMacHandle[INDEX_EMAC((uint32_t)exinf)];
	uint32_t base, dstatus, istatus, mstatus;
	uint32_t event;

	base = hmac->base;
	istatus = sil_rew_mem((uint32_t *)(base+TOFF_ETH_DMACIER));
	dstatus = sil_rew_mem((uint32_t *)(base+TOFF_ETH_DMACSR));
	mstatus = sil_rew_mem((uint32_t *)(base+TOFF_ETH_MACISR));
	syslog_2(LOG_DEBUG, "emac_hps_isr SR[%08x] IER[%08x]", dstatus, istatus);
	if(dstatus != 0){
		event = emac_dma_interrupt(hmac, dstatus & istatus);
		if((dstatus & (ETH_DMACSR_TI | ETH_DMACSR_RI | ETH_DMACSR_FBE)) != 0)
			dstatus |= ETH_DMACSR_NIS;
		sil_wrw_mem((uint32_t *)(base+TOFF_ETH_DMACSR), (dstatus & 0x0000FFFF));
		/*
		 *  DMA顼ä硢
		 */
		if(event != 0){
			syslog_2(LOG_ERROR, "EMAC:emac_isr id(%d) DMA error[%08x] !", (int)exinf, event);
			sil_andw_mem((uint32_t *)(base+TOFF_ETH_DMACIER), (ETH_DMACIER_NIE | ETH_DMACIER_AIE));
			if(hmac->emacevent != NULL)
				hmac->emacevent(hmac, 0, RESET_EVNT_DETECT);
		}
	}
	if((mstatus & ETH_MACIER_RXSTSIE) != 0)
		hmac->rx_mac_err_irq++;
	if((mstatus & ETH_MACIER_TXSTSIE) != 0)
		hmac->tx_mac_err_irq++;
	if((mstatus & ETH_MACIER_PMTIE) != 0){
		event = sil_rew_mem((uint32_t *)(base+TOFF_ETH_MACPCSR)) & (ETH_MACPCSR_RWKPRCVD | ETH_MACPCSR_MGKPRCVD);
		if(hmac->pmtevent != NULL)
			hmac->pmtevent(hmac, event);
	}
}

