/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2019 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: i2c.h 698 2019-08-01 18:43:55Z roi $
 */
/*
 * 
 *  STM32H7xx I2CǥХɥ饤Фγ
 *
 */

#ifndef _I2C_H_
#define _I2C_H_

#ifdef __cplusplus
 extern "C" {
#endif


/*
 *  I2Cݡ
 */
#define I2C1_PORTID             1
#define I2C2_PORTID             2
#define I2C3_PORTID             3
#define I2C4_PORTID             4
#define NUM_I2CPORT             4

/*
 *  I2Cɥå󥰥⡼
 */
#define I2C_ADDRESSINGMODE_7BIT  0x00000001
#define I2C_ADDRESSINGMODE_10BIT 0x00000002

/*
 *  I2Cǥ奢륢ɥå󥰥⡼
 */
#define I2C_DUALADDRESS_DISABLE 0x00000000
#define I2C_DUALADDRESS_ENABLE  I2C_OAR2_OA2EN

/*
 *  I2Cͥ륳륢ɥå󥰥⡼
 */
#define I2C_GENERALCALL_DISABLE 0x00000000
#define I2C_GENERALCALL_ENABLE  I2C_CR1_GCEN

/*
 *  I2CΥȥå⡼
 */
#define I2C_NOSTRETCH_DISABLE   0x00000000
#define I2C_NOSTRETCH_ENABLE    I2C_CR1_NOSTRETCH

/*
 *  I2Cꥢɥ쥹⡼
 */
#define I2C_MEMADD_SIZE_8BIT    0x00000001
#define I2C_MEMADD_SIZE_16BIT   0x00000002

/*
 *  I2Cϡɥ깽¤
 */

typedef struct _I2C_PortControlBlock{
	uint32_t              base;
	uint32_t              gioclockbase;
	uint32_t              gioclockbit1;
	uint32_t              gioclockbit2;
	uint32_t              i2cclockbase;
	uint32_t              i2cclockbit;
	uint32_t              i2cresetbase;
	uint32_t              i2cresetbit;

	uint32_t              giobase1;
	uint32_t              giobase2;
	uint8_t               sclpin;
	uint8_t               sclaf;
	uint8_t               sdapin;
	uint8_t               sdaaf;
} I2C_PortControlBlock;

/*
 *  I2Cե奮졼¤
 */
typedef struct
{
	uint32_t              Timing;			/* I2C I2C_TIMINGR */
	uint32_t              OwnAddress1;		/* I2C ǽΥǥХμʬΥɥ쥹 */
	uint32_t              AddressingMode;	/* I2C ɥå󥰥⡼ */
	uint32_t              DualAddressMode;	/* I2C ɥ쥹ǥ奢⡼ */
	uint32_t              OwnAddress2;		/* I2C ܤΥǥХμʬΥɥ쥹 */
	uint32_t              OwnAddress2Masks;	/* I2C ܤΥǥХɥ쥹Υޥ */
	uint32_t              GeneralCallMode;	/* I2C ͥ롦롦⡼ */
	uint32_t              NoStretchMode;	/* I2C Υ󥹥ȥå⡼ */
	int                   semid;			/* I2C ̿ѥޥե */
	int                   semlock;			/* I2C åޥե */
}I2C_Init_t;

/*
 *  I2C
 */
#define I2C_STATE_RESET     0x00		/* I2C ꥻåȾ */
#define I2C_STATE_READY     0x01		/* I2C ǥ */
#define I2C_STATE_BUSY      0x02		/* I2C ӥ */
#define I2C_STATE_MASTER_BUSY_TX 0x12	/* I2C ޥ */
#define I2C_STATE_MASTER_BUSY_RX 0x22	/* I2C ޥ */
#define I2C_STATE_SLAVE_BUSY_TX  0x32	/* I2C 졼 */
#define I2C_STATE_SLAVE_BUSY_RX  0x42	/* I2C 졼ּ */

/*
 *  I2C顼
 */
#define I2C_ERROR_NONE         0x00000000	/* No error              */
#define I2C_ERROR_BERR         0x00000001	/* BERR error            */
#define I2C_ERROR_ARLO         0x00000002	/* ARLO error            */
#define I2C_ERROR_AF           0x00000004	/* ACKF error            */
#define I2C_ERROR_OVR          0x00000008	/* OVR error             */
#define I2C_ERROR_DMA          0x00000010	/* DMA transfer error    */
#define I2C_ERROR_TIMEOUT      0x00000020	/* Timeout error         */
#define I2C_ERROR_SIZE         0x00000040	/* Size Management error */

/*
 *  I2Cϥɥ
 */
typedef struct _I2C_Handle_t I2C_Handle_t;
struct _I2C_Handle_t {
	uint32_t                   base;		/* IP١ɥ쥹 */
	I2C_Init_t                 Init;		/* I2Cѥ᡼ */
	int                        i2cid;		/* I2C ID */
	uint8_t                    *pBuffPtr;	/* I2C ̿ХåեؤΥݥ */
	uint16_t                   XferSize;	/* I2C ̿ */
	volatile uint16_t          XferCount;	/* I2C ̿ */
	void               (*writecallback)(I2C_Handle_t * hi2c);	/* λХåؿ */
	void               (*readcallback)(I2C_Handle_t * hi2c);	/* λХåؿ */
	void               (*errorcallback)(I2C_Handle_t * hi2c);	/* 顼Хåؿ */
	volatile uint32_t          State;		/* I2C ¹Ծ */
	volatile uint32_t          ErrorCode;	/* I2C Error code */
};

extern I2C_Handle_t *i2c_init(ID port, I2C_Init_t *pini);
extern ER i2c_deinit (I2C_Handle_t *hi2c);
extern ER i2c_slaveread(I2C_Handle_t *hi2c, uint8_t *pData, uint16_t Size);
extern ER i2c_slavewrite(I2C_Handle_t *hi2c, uint8_t *pData, uint16_t Size);
extern ER i2c_memread(I2C_Handle_t *hi2c, uint16_t DevAddress, uint16_t MemAddress, uint16_t MemAddSize, uint8_t *pData, uint16_t Size);
extern ER i2c_memwrite(I2C_Handle_t *hi2c, uint16_t DevAddress, uint16_t MemAddress, uint16_t MemAddSize, uint8_t *pData, uint16_t Size);
extern ER i2c_ready(I2C_Handle_t *pi2chandler, uint16_t DevAddress, uint32_t Trials, uint32_t Timeout);
extern void i2c_ev_handler(I2C_Handle_t *pi2chandler);
extern void i2c_er_handler(I2C_Handle_t *pi2chandler);
extern void i2c_ev_isr(intptr_t exinf);
extern void i2c_er_isr(intptr_t exinf);


#ifdef __cplusplus
}
#endif

#endif	/* _I2C_H_ */

