/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: device.h 699 2020-09-25 14:31:48Z roi $
 */
/*
 * STM32MP1XXѥǥХɥ饤Фγ
 */

#ifndef _DEVICE_H_
#define _DEVICE_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  TOPPERS BASE PLATFORM
 */
#define TOPPERS_BASE_PLATFORM_STMP1
#define SPI_DRIVER_NOSTART

/*
 *  С
 */
#define	TPLATFORM_PRVER 0x1042		/* ץåȥեΥСֹ */

/*
 * ԥ
 */

#define PINPOSITION0    0
#define PINPOSITION1    1
#define PINPOSITION2    2
#define PINPOSITION3    3
#define PINPOSITION4    4
#define PINPOSITION5    5
#define PINPOSITION6    6
#define PINPOSITION7    7
#define PINPOSITION8    8
#define PINPOSITION9    9
#define PINPOSITION10   10
#define PINPOSITION11   11
#define PINPOSITION12   12
#define PINPOSITION13	13
#define PINPOSITION14	14
#define PINPOSITION15	15

#define GPIO_PIN_0      (1<<PINPOSITION0)
#define GPIO_PIN_1      (1<<PINPOSITION1)
#define GPIO_PIN_2      (1<<PINPOSITION2)
#define GPIO_PIN_3      (1<<PINPOSITION3)
#define GPIO_PIN_4      (1<<PINPOSITION4)
#define GPIO_PIN_5      (1<<PINPOSITION5)
#define GPIO_PIN_6      (1<<PINPOSITION6)
#define GPIO_PIN_7      (1<<PINPOSITION7)
#define GPIO_PIN_8      (1<<PINPOSITION8)
#define GPIO_PIN_9      (1<<PINPOSITION9)
#define GPIO_PIN_10     (1<<PINPOSITION10)
#define GPIO_PIN_11     (1<<PINPOSITION11)
#define GPIO_PIN_12     (1<<PINPOSITION12)
#define GPIO_PIN_13     (1<<PINPOSITION13)
#define GPIO_PIN_14     (1<<PINPOSITION14)
#define GPIO_PIN_15     (1<<PINPOSITION15)

/*
 *  GPIO⡼ɥѥ᡼
 */
#define GPIO_MODE_INPUT     0x00000000	/* Input Floating Mode */
#define GPIO_MODE_OUTPUT    0x00000001	/* Output Mode */
#define GPIO_MODE_AF        0x00000002	/* Alternate Function Mode */
#define GPIO_MODE_ANALOG    0x00000003	/* Analog Mode  */
#define GPIO_MODE_ANALOG_AD 0x00000007	/* Analog ADC Mode  */

/*
 *  GPIO-EXTI⡼ɥѥ᡼
 */
#define GPIO_MODE_IT_RISING             0x10110000	/* External Interrupt Mode with Rising edge trigger detection */
#define GPIO_MODE_IT_FALLING            0x10210000	/* External Interrupt Mode with Falling edge trigger detection */
#define GPIO_MODE_IT_RISING_FALLING     0x10310000	/* External Interrupt Mode with Rising/Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING            0x10120000	/* External Event Mode with Rising edge trigger detection */
#define GPIO_MODE_EVT_FALLING           0x10220000	/* External Event Mode with Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING_FALLING    0x10320000	/* External Event Mode with Rising/Falling edge trigger detection */

/*
 *  GPIOȥץåѥ᡼
 */
#define GPIO_OTYPE_PP       0x0
#define GPIO_OTYPE_OD       0x1

/*
 *  GPIOȥץåȺȿѥ᡼
 */
#define GPIO_SPEED_LOW      0x00000000	/* Low speed     */
#define GPIO_SPEED_MEDIUM   0x00000001	/* Medium speed  */
#define GPIO_SPEED_FAST     0x00000002	/* Fast speed    */
#define GPIO_SPEED_HIGH     0x00000003	/* High speed    */

/*
 *  GPIOץ륢åץѥ᡼
 */
#define GPIO_NOPULL         0x00000000	/* No Pull-up or Pull-down activation  */
#define GPIO_PULLUP         0x00000001	/* Pull-up activation                  */
#define GPIO_PULLDOWN       0x00000002	/* Pull-down activation                */

/*
 *  GPIO
 */
typedef struct
{
    uint32_t    mode;		/* specifies the operating mode for the selected pins. */
	uint32_t    pull;		/* specifies the Pull-up or Pull-Down */
	uint32_t    otype;		/* output type */
	uint32_t    speed;		/* speed for the selected pins. */
	uint32_t    alternate;	/* alternate for the selected pins. */
}GPIO_Init_t;

typedef struct {
	uint32_t    base;
	uint32_t    pinmap;
} GPIO_Init_Table;

extern void gpio_setup(uint32_t base, GPIO_Init_t *init, uint32_t pin);


/*
 *  DMAͥID
 */
#define DMA1STM0_SID            (0)
#define DMA1STM1_SID            (1)
#define DMA1STM2_SID            (2)
#define DMA1STM3_SID            (3)
#define DMA1STM4_SID            (4)
#define DMA1STM5_SID            (5)
#define DMA1STM6_SID            (6)
#define DMA1STM7_SID            (7)
#define DMA2STM0_SID            (8+0)
#define DMA2STM1_SID            (8+1)
#define DMA2STM2_SID            (8+2)
#define DMA2STM3_SID            (8+3)
#define DMA2STM4_SID            (8+4)
#define DMA2STM5_SID            (8+5)
#define DMA2STM6_SID            (8+6)
#define DMA2STM7_SID            (8+7)

/*
 *  DMAơ
 */
#define DMA_STATUS_BUSY         0x00000001	/* BUSY */
#define DMA_STATUS_READY_HMEM0  0x00000002	/* DMA Mem0 Half process success */
#define DMA_STATUS_READY_HMEM1  0x00000004	/* DMA Mem1 Half process success */
#define DMA_STATUS_READY_MEM0   0x00000008	/* DMA Mem0 process success      */
#define DMA_STATUS_READY_MEM1   0x00000010	/* DMA Mem0 process success      */
#define DMA_STATUS_READY_ERROR  0x00000100	/* DMA Error end */

/*
 *  DMA顼
 */ 
#define DMA_ERROR_NONE          0x00000000	/* No error */
#define DMA_ERROR_TE            0x00000001	/* Transfer error */
#define DMA_ERROR_FE            0x00000002	/* FIFO error */
#define DMA_ERROR_DME           0x00000004	/* Direct Mode error */
#define DMA_ERROR_TIMEOUT       0x00000020	/* Timeout error */

/*
 *  DMAꥯ
 */
#define DMA_REQUEST_MEM2MEM     0	/* memory to memory transfer */
#define DMA_REQUEST_GENERATOR0  1	/* DMAMUX1 request generator 0 */
#define DMA_REQUEST_GENERATOR1  2	/* DMAMUX1 request generator 1 */
#define DMA_REQUEST_GENERATOR2	3	/* DMAMUX1 request generator 2 */
#define DMA_REQUEST_GENERATOR3  4	/* DMAMUX1 request generator 3 */
#define DMA_REQUEST_GENERATOR4  5	/* DMAMUX1 request generator 4 */
#define DMA_REQUEST_GENERATOR5  6	/* DMAMUX1 request generator 5 */
#define DMA_REQUEST_GENERATOR6  7	/* DMAMUX1 request generator 6 */
#define DMA_REQUEST_GENERATOR7  8	/* DMAMUX1 request generator 7 */

#define DMA_REQUEST_ADC1        9	/* DMAMUX1 ADC1 request */
#define DMA_REQUEST_ADC2        10	/* DMAMUX1 ADC2 request */
#define DMA_REQUEST_TIM1_CH1    11	/* DMAMUX1 TIM1 CH1 request  */
#define DMA_REQUEST_TIM1_CH2    12	/* DMAMUX1 TIM1 CH2 request  */
#define DMA_REQUEST_TIM1_CH3    13	/* DMAMUX1 TIM1 CH3 request  */
#define DMA_REQUEST_TIM1_CH4    14	/* DMAMUX1 TIM1 CH4 request  */
#define DMA_REQUEST_TIM1_UP     15	/* DMAMUX1 TIM1 UP request   */
#define DMA_REQUEST_TIM1_TRIG   16	/* DMAMUX1 TIM1 TRIG request */
#define DMA_REQUEST_TIM1_COM    17	/* DMAMUX1 TIM1 COM request  */
#define DMA_REQUEST_TIM2_CH1    18	/* DMAMUX1 TIM2 CH1 request  */
#define DMA_REQUEST_TIM2_CH2    19	/* DMAMUX1 TIM2 CH2 request  */
#define DMA_REQUEST_TIM2_CH3    20	/* DMAMUX1 TIM2 CH3 request  */
#define DMA_REQUEST_TIM2_CH4    21	/* DMAMUX1 TIM2 CH4 request  */
#define DMA_REQUEST_TIM2_UP     22	/* DMAMUX1 TIM2 UP request   */
#define DMA_REQUEST_TIM3_CH1    23	/* DMAMUX1 TIM3 CH1 request  */
#define DMA_REQUEST_TIM3_CH2    24	/* DMAMUX1 TIM3 CH2 request  */
#define DMA_REQUEST_TIM3_CH3    25	/* DMAMUX1 TIM3 CH3 request  */
#define DMA_REQUEST_TIM3_CH4    26	/* DMAMUX1 TIM3 CH4 request  */
#define DMA_REQUEST_TIM3_UP     27	/* DMAMUX1 TIM3 UP request   */
#define DMA_REQUEST_TIM3_TRIG   28	/* DMAMUX1 TIM3 TRIG request */
#define DMA_REQUEST_TIM4_CH1    29	/* DMAMUX1 TIM4 CH1 request  */
#define DMA_REQUEST_TIM4_CH2    30	/* DMAMUX1 TIM4 CH2 request  */
#define DMA_REQUEST_TIM4_CH3    31	/* DMAMUX1 TIM4 CH3 request  */
#define DMA_REQUEST_TIM4_UP     32	/* DMAMUX1 TIM4 UP request   */
#define DMA_REQUEST_I2C1_RX     33	/* DMAMUX1 I2C1 RX request   */
#define DMA_REQUEST_I2C1_TX     34	/* DMAMUX1 I2C1 TX request   */
#define DMA_REQUEST_I2C2_RX     35	/* DMAMUX1 I2C2 RX request   */
#define DMA_REQUEST_I2C2_TX     36	/* DMAMUX1 I2C2 TX request   */
#define DMA_REQUEST_SPI1_RX     37	/* DMAMUX1 SPI1 RX request   */
#define DMA_REQUEST_SPI1_TX     38	/* DMAMUX1 SPI1 TX request   */
#define DMA_REQUEST_SPI2_RX     39	/* DMAMUX1 SPI2 RX request   */
#define DMA_REQUEST_SPI2_TX     40	/* DMAMUX1 SPI2 TX request   */
#define DMA_REQUEST_USART2_RX   43	/* DMAMUX1 USART2 RX request */
#define DMA_REQUEST_USART2_TX   44	/* DMAMUX1 USART2 TX request */
#define DMA_REQUEST_USART3_RX   45	/* DMAMUX1 USART3 RX request */
#define DMA_REQUEST_USART3_TX   46	/* DMAMUX1 USART3 TX request */
#define DMA_REQUEST_TIM8_CH1    47	/* DMAMUX1 TIM8 CH1 request  */
#define DMA_REQUEST_TIM8_CH2    48	/* DMAMUX1 TIM8 CH2 request  */
#define DMA_REQUEST_TIM8_CH3    49	/* DMAMUX1 TIM8 CH3 request  */
#define DMA_REQUEST_TIM8_CH4    50	/* DMAMUX1 TIM8 CH4 request  */
#define DMA_REQUEST_TIM8_UP     51	/* DMAMUX1 TIM8 UP request   */
#define DMA_REQUEST_TIM8_TRIG   52	/* DMAMUX1 TIM8 TRIG request */
#define DMA_REQUEST_TIM8_COM    53	/* DMAMUX1 TIM8 COM request  */
#define DMA_REQUEST_TIM5_CH1    55	/* DMAMUX1 TIM5 CH1 request  */
#define DMA_REQUEST_TIM5_CH2    56	/* DMAMUX1 TIM5 CH2 request  */
#define DMA_REQUEST_TIM5_CH3    57	/* DMAMUX1 TIM5 CH3 request  */
#define DMA_REQUEST_TIM5_CH4    58	/* DMAMUX1 TIM5 CH4 request  */
#define DMA_REQUEST_TIM5_UP     59	/* DMAMUX1 TIM5 UP request   */
#define DMA_REQUEST_TIM5_TRIG   60	/* DMAMUX1 TIM5 TRIG request */
#define DMA_REQUEST_SPI3_RX     61	/* DMAMUX1 SPI3 RX request   */
#define DMA_REQUEST_SPI3_TX     62	/* DMAMUX1 SPI3 TX request   */
#define DMA_REQUEST_UART4_RX    63	/* DMAMUX1 UART4 RX request */
#define DMA_REQUEST_UART4_TX    64	/* DMAMUX1 UART4 TX request */
#define DMA_REQUEST_UART5_RX    65	/* DMAMUX1 UART5 RX request */
#define DMA_REQUEST_UART5_TX    66	/* DMAMUX1 UART5 TX request */
#define DMA_REQUEST_DAC1        67	/* DMAMUX1 DAC1 request      */
#define DMA_REQUEST_DAC2        68	/* DMAMUX1 DAC2 request      */
#define DMA_REQUEST_TIM6_UP     69	/* DMAMUX1 TIM6 UP request   */
#define DMA_REQUEST_TIM7_UP     70	/* DMAMUX1 TIM7 UP request   */
#define DMA_REQUEST_USART6_RX   71	/* DMAMUX1 USART6 RX request */
#define DMA_REQUEST_USART6_TX   72	/* DMAMUX1 USART6 TX request */
#define DMA_REQUEST_I2C3_RX     73	/* DMAMUX1 I2C3 RX request   */
#define DMA_REQUEST_I2C3_TX     74	/* DMAMUX1 I2C3 TX request   */
#define DMA_REQUEST_DCMI        75	/* DMAMUX1 DCMI request      */
#define DMA_REQUEST_CRYP2_IN    76	/* DMAMUX1 CRYP2 IN request  */
#define DMA_REQUEST_CRYP2_OUT   77	/* DMAMUX1 CRYP2 OUT request */
#define DMA_REQUEST_HASH2_IN    78	/* DMAMUX1 HASH2 IN request  */
#define DMA_REQUEST_UART7_RX    79	/* DMAMUX1 UART7 RX request  */
#define DMA_REQUEST_UART7_TX    80	/* DMAMUX1 UART7 TX request  */
#define DMA_REQUEST_UART8_RX    81	/* DMAMUX1 UART8 RX request  */
#define DMA_REQUEST_UART8_TX    82	/* DMAMUX1 UART8 TX request  */
#define DMA_REQUEST_SPI4_RX     83	/* DMAMUX1 SPI4 RX request   */
#define DMA_REQUEST_SPI4_TX     84	/* DMAMUX1 SPI4 TX request   */
#define DMA_REQUEST_SPI5_RX     85	/* DMAMUX1 SPI5 RX request   */
#define DMA_REQUEST_SPI5_TX     86	/* DMAMUX1 SPI5 TX request   */
#define DMA_REQUEST_SAI1_A      87	/* DMAMUX1 SAI1 A request    */
#define DMA_REQUEST_SAI1_B      88	/* DMAMUX1 SAI1 B request    */
#define DMA_REQUEST_SAI2_A      89	/* DMAMUX1 SAI2 A request    */
#define DMA_REQUEST_SAI2_B      90	/* DMAMUX1 SAI2 B request    */
#define DMA_REQUEST_DFSDM1_FLT4 91	/* DMAMUX1 DFSDM1 Filter4 request   */
#define DMA_REQUEST_DFSDM1_FLT5 92	/* DMAMUX1 DFSDM1 Filter5 request   */
#define DMA_REQUEST_SPDIF_RX_DT 93	/* DMAMUX1 SPDIF RXDT request*/
#define DMA_REQUEST_SPDIF_RX_CS 94	/* DMAMUX1 SPDIF RXCS request*/
#define DMA_REQUEST_SAI4_A      99	/* DMAMUX1 SAI4 A request    */
#define DMA_REQUEST_SAI4_B      100	/* DMAMUX1 SAI4 B request    */
#define DMA_REQUEST_DFSDM1_FLT0 101	/* DMAMUX1 DFSDM Filter0 request */
#define DMA_REQUEST_DFSDM1_FLT1 102	/* DMAMUX1 DFSDM Filter1 request */
#define DMA_REQUEST_DFSDM1_FLT2 103	/* DMAMUX1 DFSDM Filter2 request */
#define DMA_REQUEST_DFSDM1_FLT3 104	/* DMAMUX1 DFSDM Filter3 request */
#define DMA_REQUEST_TIM15_CH1   105	/* DMAMUX1 TIM15 CH1 request  */
#define DMA_REQUEST_TIM15_UP    106	/* DMAMUX1 TIM15 UP request   */
#define DMA_REQUEST_TIM15_TRIG  107	/* DMAMUX1 TIM15 TRIG request */
#define DMA_REQUEST_TIM15_COM   108	/* DMAMUX1 TIM15 COM request  */
#define DMA_REQUEST_TIM16_CH1   109	/* DMAMUX1 TIM16 CH1 request  */
#define DMA_REQUEST_TIM16_UP    110	/* DMAMUX1 TIM16 UP request   */
#define DMA_REQUEST_TIM17_CH1   111	/* DMAMUX1 TIM17 CH1 request  */
#define DMA_REQUEST_TIM17_UP    112	/* DMAMUX1 TIM17 UP request   */
#define DMA_REQUEST_SAI3_A      113	/* DMAMUX1 SAI3 A request  */
#define DMA_REQUEST_SAI3_B      114	/* DMAMUX1 SAI3 B request  */
#define DMA_REQUEST_I2C5_RX     115	/* DMAMUX1 I2C5 RX request     */
#define DMA_REQUEST_I2C5_TX     116	/* DMAMUX1 I2C5 TX request     */


/*
 *  쥬
 */
#define DMA_REQUEST_0           DMA_REQUEST_ADC1

/*
 *  DMAž
 */
#define DMA_PERIPH_TO_MEMORY    0x00000000		/* Peripheral to memory direction */
#define DMA_MEMORY_TO_PERIPH    DMA_SxCR_DIR_0	/* Memory to peripheral direction */
#define DMA_MEMORY_TO_MEMORY    DMA_SxCR_DIR_1	/* Memory to memory direction     */

/*
 *  DMAڥեå⡼
 */
#define DMA_PINC_ENABLE         DMA_CCR_PINC	/* Peripheral increment mode enable  */
#define DMA_PINC_DISABLE        0x00000000		/* Peripheral increment mode disable */

/*
 *  DMAå⡼
 */ 
#define DMA_MINC_ENABLE         DMA_SxCR_MINC	/* Memory increment mode enable  */
#define DMA_MINC_DISABLE        0x00000000		/* Memory increment mode disable */

/*
 *  DMAڥե롦ǡ
 */
#define DMA_PDATAALIGN_BYTE     0x00000000		/* Peripheral data alignment: Byte     */
#define DMA_PDATAALIGN_HALFWORD DMA_SxCR_PSIZE_0	/* Peripheral data alignment: HalfWord */
#define DMA_PDATAALIGN_WORD     DMA_SxCR_PSIZE_1	/* Peripheral data alignment: Word     */

/*
 *  DMAꡦǡ
 */
#define DMA_MDATAALIGN_BYTE     0x00000000		/* Memory data alignment: Byte     */
#define DMA_MDATAALIGN_HALFWORD DMA_SxCR_MSIZE_0	/* Memory data alignment: HalfWord */
#define DMA_MDATAALIGN_WORD     DMA_SxCR_MSIZE_1	/* Memory data alignment: Word     */

/*
 *  DMA⡼
 */
#define DMA_NORMAL              0x00000000		/* Normal mode                  */
#define DMA_CIRCULAR            DMA_SxCR_CIRC	/* Circular mode                */

/*
 *  DMAͥ٥٥
 */
#define DMA_PRIORITY_LOW        0x00000000		/* Priority level: Low       */
#define DMA_PRIORITY_MEDIUM     DMA_SxCR_PL_0	/* Priority level: Medium    */
#define DMA_PRIORITY_HIGH       DMA_SxCR_PL_1	/* Priority level: High      */
#define DMA_PRIORITY_VERY_HIGH  DMA_SxCR_PL		/* Priority level: Very High */

/*
 *  DMA FIFO⡼
 */
#define DMA_FIFOMODE_DISABLE    0x00000000		/* FIFO mode disable */
#define DMA_FIFOMODE_ENABLE     DMA_SxFCR_DMDIS	/* FIFO mode enable  */

/*
 *  DMA FIFOåۡɥ٥
 */
#define DMA_FIFO_THRESHOLD_1QUARTERFULL  0x00000000			/* FIFO threshold 1 quart full configuration  */
#define DMA_FIFO_THRESHOLD_HALFFULL      DMA_SxFCR_FTH_0	/* FIFO threshold half full configuration     */
#define DMA_FIFO_THRESHOLD_3QUARTERSFULL DMA_SxFCR_FTH_1	/* FIFO threshold 3 quarts full configuration */
#define DMA_FIFO_THRESHOLD_FULL          DMA_SxFCR_FTH		/* FIFO threshold full configuration          */

/*
 *  DMAС
 */
#define DMA_MBURST_SINGLE       0x00000000
#define DMA_MBURST_INC4         DMA_SxCR_MBURST_0
#define DMA_MBURST_INC8         DMA_SxCR_MBURST_1
#define DMA_MBURST_INC16        DMA_SxCR_MBURST

/*
 *  DMAڥեС
 */
#define DMA_PBURST_SINGLE       0x00000000
#define DMA_PBURST_INC4         DMA_SxCR_PBURST_0
#define DMA_PBURST_INC8         DMA_SxCR_PBURST_1
#define DMA_PBURST_INC16        DMA_SxCR_PBURST


/*
 *  DMA¤
 */
typedef struct
{
	uint32_t              Request;		/* Specifies the request selected for the specified channel. */
	uint32_t              Direction;	/* Specifies if the data will be transferred from memory to peripheral */
	uint32_t              PeriphInc;	/* Specifies whether the Peripheral address register should be incremented or not. */
	uint32_t              MemInc;		/* Specifies whether the memory address register should be incremented or not. */
	uint32_t              PeriphDataAlignment;	/* Specifies the Peripheral data width. */
	uint32_t              MemDataAlignment;		/* Specifies the Memory data width. */
	uint32_t              Mode;			/* Specifies the operation mode of the DMAy Streamx. */
	uint32_t              Priority;		/* Specifies the software priority for the DMAy Streamx. */
	uint32_t              FIFOMode;		/* Specifies if the FIFO mode or Direct mode will be used for the specified stream. */
	uint32_t              FIFOThreshold;		/* Specifies the FIFO threshold level. */
	uint32_t              MemBurst;		/* Specifies the Burst transfer configuration for the memory transfers. */
	uint32_t              PeriphBurst;	/* Specifies the Burst transfer configuration for the peripheral transfers. */
}DMA_Init_t;

/*
 *  DMAϥɥ鹽¤
 */
typedef struct __DMA_Handle_t DMA_Handle_t;
struct __DMA_Handle_t
{
	uint32_t              base;
	DMA_Init_t            Init;			/* DMA communication parameters */
	uint32_t              sdid;			/* stream dma id */
	volatile uint32_t     status;		/* DMA status */
	uint32_t              muxbase;		/* DMA mutex base address */
	void                  (*xfercallback)(DMA_Handle_t * hdma);		/* DMA transfer complete callback */
	void                  (*xferhalfcallback)(DMA_Handle_t * hdma);	/* DMA Half transfer complete callback */
	void                  (*xferm1callback)(DMA_Handle_t * hdma);	/* DMA transfer complete Memory1 callback */
	void                  (*xferm1halfcallback)(DMA_Handle_t * hdma);	/* DMA Half transfer complete Memory1 callback */
	void                  (*errorcallback)(DMA_Handle_t * hdma);	/* DMA transfer error callback */
	volatile uint32_t     ErrorCode;	/* DMA Error code */
	void                  *localdata;	/* DMA local data */
};

extern ER dma_init(DMA_Handle_t *hdma);
extern ER dma_deinit(DMA_Handle_t *hdma);
extern ER dma_start(DMA_Handle_t *hdma, uint32_t SrcAddress, uint32_t DstAddress, uint32_t DataLength);
extern ER dma_end(DMA_Handle_t *hdma);
extern uintptr_t dma_stream_base(int32_t sid);
extern void dma_inthandler(DMA_Handle_t *hdma);
extern void stream_dma_isr(intptr_t exinf);


/*
 *  WINDOW-WDOGɥ饤
 */
#define WDOG1_PORTID        1
#define NUM_WDOGPORT        1

/*
 *  WDOGץꥹ
 */
#define WWDG_PRESCALER_1    0x00000000								/* WWDG counter clock = (PCLK1/4096)/1 */
#define WWDG_PRESCALER_2    WWDG_CFR_WDGTB_0						/* WWDG counter clock = (PCLK1/4096)/2 */
#define WWDG_PRESCALER_4    WWDG_CFR_WDGTB_1						/* WWDG counter clock = (PCLK1/4096)/4 */
#define WWDG_PRESCALER_8    (WWDG_CFR_WDGTB_1 | WWDG_CFR_WDGTB_0)	/* WWDG counter clock = (PCLK1/4096)/8 */
#define WWDG_PRESCALER_16   WWDG_CFR_WDGTB_2						/* WWDG counter clock = (PCLK1/4096)/16 */
#define WWDG_PRESCALER_32   (WWDG_CFR_WDGTB_2 | WWDG_CFR_WDGTB_0)	/* WWDG counter clock = (PCLK1/4096)/32 */
#define WWDG_PRESCALER_64   (WWDG_CFR_WDGTB_2 | WWDG_CFR_WDGTB_1)	/* WWDG counter clock = (PCLK1/4096)/64 */
#define WWDG_PRESCALER_128  WWDG_CFR_WDGTB							/* WWDG counter clock = (PCLK1/4096)/128 */

typedef struct __WDOG_Init_t
{
	uint32_t              Prescaler;		/* WDOG ץꥹ */
	uint32_t              Window;			/* WDOG Window 0x40-0x7F */
	uint32_t              Counter;			/* WDOG 󥫥 0x40-0x7F 0x7F */
	uint32_t              MCounter;			/* WDOG More Counter */
} WDOG_Init_t;

extern ER wdog_init(ID portid, WDOG_Init_t *hwini);
extern ER wdog_deinit(ID portid);
extern ER wdog_reset(ID portod);
extern void wdog_handler(void);


/*
 *  IPCCɥ饤
 */
/*
 *  IPCCȥ
 */
#define IPCC1_CONTROLID     1
#define IPCC2_CONTROLID     2
#define NUM_IPCCCONTROL     2

#define NUM_IPCC_CH         6

#define IPCC_RX_CHANNEL     0
#define IPCC_TX_CHANNEL     1

/*
 *  IPCCͥ
 */
#define IPCC_CHANNEL_1      0x00000000U
#define IPCC_CHANNEL_2      0x00000001U
#define IPCC_CHANNEL_3      0x00000002U
#define IPCC_CHANNEL_4      0x00000003U
#define IPCC_CHANNEL_5      0x00000004U
#define IPCC_CHANNEL_6      0x00000005U

/*
 *  IPCC¤
 */
typedef struct
{
	uint32_t              controlID;	/* IPCCȥID */
	int32_t               intrx;		/* IPCC RXֹ */
	int32_t               inttx;		/* IPCC TXֹ */
} IPCC_Init_t;

/*
 *  IPCCϥɥ鹽¤
 */
typedef struct __IPCC_Handle_t IPCC_Handle_t;
struct __IPCC_Handle_t
{
	uint32_t              base;			/* IPCC Port base address */
	uint32_t              cbase;		/* IPCC Control base address */
	uint32_t              obase;		/* IPCC other Control base address */
	IPCC_Init_t           Init;			/* IPCC ѥ᡼ */
	uint32_t              rstatus;
	uint8_t               cbmode;
	uint8_t               cbcid;
	void                  (*callback)(void);					/* IPCC special callback */
	void                  (*recvcallback[NUM_IPCC_CH])(IPCC_Handle_t *hipcc, uint32_t cid, uint8_t mode);	/* IPCC receive complete callback */
	void                  (*sendcallback[NUM_IPCC_CH])(IPCC_Handle_t *hipcc, uint32_t cid, uint8_t mode);	/* IPCC send complete callback */
};

extern ER ipcc_init(IPCC_Handle_t *hipcc);
extern ER ipcc_deinit(IPCC_Handle_t *hipcc);
extern ER ipcc_activate_callback(IPCC_Handle_t *hipcc, uint8_t cid, uint8_t mode, void(cb)(IPCC_Handle_t*, uint32_t, uint8_t));
extern ER ipcc_deactivate_callback(IPCC_Handle_t *hipcc, uint8_t cid, uint8_t mode);
extern ER_BOOL ipcc_channel_occupied(IPCC_Handle_t *hipcc, uint8_t cid, uint8_t mode);
extern ER ipcc_notify_cpu(IPCC_Handle_t *hipcc, uint8_t cid, uint8_t mode);
extern void ipcc_rx_isr(intptr_t exinf);
extern void ipcc_tx_isr(intptr_t exinf);


/*
 *  LED³ӥå
 */
#define LED01           (1<<0)
#define LED02           (1<<1)
#define LED03           (1<<2)
#define LED04           (1<<3)

#define LED_MASK        (LED01 | LED02 | LED03 | LED04)

/*
 *  LEDȥåξ֥ޥ
 */
#define ON              1     /* LED䥹åON             */
#define OFF             0     /* LED䥹åOFF            */

/*
 *  DIPSW
 */
#define DSW1             0x01
#define DSW2             0x02
#define DSW3             0x04
#define DSW4             0x08

/*
 *  LED³ݡȽ
 */ 
extern void led_init(intptr_t exinf);

/*
 *  LED³ݡɤ߽Ф
 */
uint_t led_in(void);

/*
 *  LED³ݡȽ񤭹
 */ 
void led_out(unsigned int led_data);

/*
 *  LEDȥåθꡦɤ߹ߴؿ
 */
extern void set_led_state(unsigned int led, unsigned char state);


#define PSW1_PIN         PINPOSITION14
#define PSW2_PIN         PINPOSITION13
#define INHNO_SW1        IRQ_VECTOR_EXTI14	/* ߥϥɥֹ */
#define INTNO_SW1        IRQ_VECTOR_EXTI14	/* ֹ */
#define INHNO_SW2        IRQ_VECTOR_EXTI13	/* ߥϥɥֹ */
#define INTNO_SW2        IRQ_VECTOR_EXTI13	/* ֹ */
#define INTPRI_SW        -1			/* ͥ */
#define INTATR_SW        0			/* ° */

/*
 *  PSW³ӥå
 */
#define PSW1             0x00000001
#define PSW2             0x00000002
#define PSW_MASK         (PSW1 | PSW2)
#define PSW_CHK_INTERVAL 10


/*
 *  PUSHå³ݡȽ
 */
extern void switch_push_init(intptr_t exinf);

/*
 *  PUSHåХåؿ
 */
extern void setup_sw_func(intptr_t exinf);

/*
 *  PUSHåФ
 */
extern uint32_t switch_push_sense(void);

/*
 *  PUSHåӥ
 */
extern void sw_isr(intptr_t exinf);

/*
 *  DIPSWμФ
 */
uint_t switch_dip_sense(void);


extern void device_info_init(intptr_t exinf);

extern uint_t dipsw_value;

#ifdef __cplusplus
}
#endif

#endif

