/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: spi.h 698 2020-08-20 17:31:59Z roi $
 */
/*
 * 
 *  STM32MP1XX SPIfoCXhCo̊O錾
 *
 */

#ifndef _SPI_H_
#define _SPI_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  SPI|[g`
 */
#define SPI1_PORTID             1
#define SPI2_PORTID             2
#define SPI3_PORTID             3
#define SPI4_PORTID             4
#define SPI5_PORTID             5
#define NUM_SPIPORT             5

/*
 *  SPIԒ`
 */
#define SPI_STATUS_RESET        0x00	/* SPIgp */
#define SPI_STATUS_READY        0x01	/* SPIfB */
#define SPI_STATUS_ERROR        0x02	/* SPIG[ */
#define SPI_STATUS_BUSY         0x04	/* SPI */

/*
 *  SPIG[`
 */ 
#define SPI_ERROR_NONE          0x00000000	/* No error */
#define SPI_ERROR_MODF          0x00000001	/* MODF error */
#define SPI_ERROR_CRC           0x00000002	/* CRC error */
#define SPI_ERROR_OVR           0x00000004	/* OVR error */
#define SPI_ERROR_FRE           0x00000008	/* FRE error */
#define SPI_ERROR_UDR           0x00000010	/* UDR error */
#define SPI_ERROR_DMA           0x00000080	/* DMA transfer error */
#define SPI_ERROR_TIMEOUT       0x00000100

/*
 *  SPI][h
 */
#define SPI_XMODE_TX            0x0000		/* M[h */
#define SPI_XMODE_RX            0x0001		/* M[h */
#define SPI_XMODE_TXRX          0x0002		/* M[h */

/*
 *  SPI[h`
 */
#define SPI_MODE_SLAVE          0x00000000
#define SPI_MODE_MASTER         SPI_CFG2_MASTER


/*
 *  SPIf[^TCY`
 */
#define SPI_DATASIZE_4BIT       0x00000003
#define SPI_DATASIZE_5BIT       0x00000004
#define SPI_DATASIZE_6BIT       0x00000005
#define SPI_DATASIZE_7BIT       0x00000006
#define SPI_DATASIZE_8BIT       0x00000007
#define SPI_DATASIZE_9BIT       0x00000008
#define SPI_DATASIZE_10BIT      0x00000009
#define SPI_DATASIZE_11BIT      0x0000000A
#define SPI_DATASIZE_12BIT      0x0000000B
#define SPI_DATASIZE_13BIT      0x0000000C
#define SPI_DATASIZE_14BIT      0x0000000D
#define SPI_DATASIZE_15BIT      0x0000000E
#define SPI_DATASIZE_16BIT      0x0000000F
#define SPI_DATASIZE_17BIT      0x00000010
#define SPI_DATASIZE_18BIT      0x00000011
#define SPI_DATASIZE_19BIT      0x00000012
#define SPI_DATASIZE_20BIT      0x00000013
#define SPI_DATASIZE_21BIT      0x00000014
#define SPI_DATASIZE_22BIT      0x00000015
#define SPI_DATASIZE_23BIT      0x00000016
#define SPI_DATASIZE_24BIT      0x00000017
#define SPI_DATASIZE_25BIT      0x00000018
#define SPI_DATASIZE_26BIT      0x00000019
#define SPI_DATASIZE_27BIT      0x0000001A
#define SPI_DATASIZE_28BIT      0x0000001B
#define SPI_DATASIZE_29BIT      0x0000001C
#define SPI_DATASIZE_30BIT      0x0000001D
#define SPI_DATASIZE_31BIT      0x0000001E
#define SPI_DATASIZE_32BIT      0x0000001F

/*
 *  SPI]NbNɐ`
 */
#define SPI_POLARITY_LOW        0x00000000
#define SPI_POLARITY_HIGH       SPI_CFG2_CPOL

/*
 *  SPINbNʑ`
 */
#define SPI_PHASE_1EDGE         0x00000000
#define SPI_PHASE_2EDGE         SPI_CFG2_CPHA

/*
 *  SPI NSS`
 */
#define SPI_NSS_SOFT            SPI_CFG2_SSM
#define SPI_NSS_HARD_INPUT      0x00000000
#define SPI_NSS_HARD_OUTPUT     SPI_CFG2_SSOE

/*
 *  SPI NSS Pulse Modeݒ
 */
#define SPI_NSS_PULSE_DISABLE   0x00000000
#define SPI_NSS_PULSE_ENABLE    SPI_CFG2_SSOM

/*
 *  SPI NSS[h Polarityݒ
 */
#define SPI_NSS_POLARITY_LOW    0x00000000
#define SPI_NSS_POLARITY_HIGH   SPI_CFG2_SSIOP

/*
 *  SPI MSB/LSB`
 */
#define SPI_DATA_MSB            0x00000000
#define SPI_DATA_LSB            SPI_CFG2_LSBFRST

/*
 *  SPIvXP[ݒ
 */
#define SPI_BAUDRATEPRESCALER_2   0x00000000
#define SPI_BAUDRATEPRESCALER_4   0x10000000
#define SPI_BAUDRATEPRESCALER_8   0x20000000
#define SPI_BAUDRATEPRESCALER_16  0x30000000
#define SPI_BAUDRATEPRESCALER_32  0x40000000
#define SPI_BAUDRATEPRESCALER_64  0x50000000
#define SPI_BAUDRATEPRESCALER_128 0x60000000
#define SPI_BAUDRATEPRESCALER_256 0x70000000

/*
 *  CRC`
 */
#define SPI_CRC_LENGTH_DATASIZE 0x00000000
#define SPI_CRC_LENGTH_4BIT     0x00000003
#define SPI_CRC_LENGTH_5BIT     0x00000004
#define SPI_CRC_LENGTH_6BIT     0x00000005
#define SPI_CRC_LENGTH_7BIT     0x00000006
#define SPI_CRC_LENGTH_8BIT     0x00000007
#define SPI_CRC_LENGTH_9BIT     0x00000008
#define SPI_CRC_LENGTH_10BIT    0x00000009
#define SPI_CRC_LENGTH_11BIT    0x0000000A
#define SPI_CRC_LENGTH_12BIT    0x0000000B
#define SPI_CRC_LENGTH_13BIT    0x0000000C
#define SPI_CRC_LENGTH_14BIT    0x0000000D
#define SPI_CRC_LENGTH_15BIT    0x0000000E
#define SPI_CRC_LENGTH_16BIT    0x0000000F
#define SPI_CRC_LENGTH_17BIT    0x00000001
#define SPI_CRC_LENGTH_18BIT    0x00000011
#define SPI_CRC_LENGTH_19BIT    0x00000012
#define SPI_CRC_LENGTH_20BIT    0x00000013
#define SPI_CRC_LENGTH_21BIT    0x00000014
#define SPI_CRC_LENGTH_22BIT    0x00000015
#define SPI_CRC_LENGTH_23BIT    0x00000016
#define SPI_CRC_LENGTH_24BIT    0x00000017
#define SPI_CRC_LENGTH_25BIT    0x00000018
#define SPI_CRC_LENGTH_26BIT    0x00000019
#define SPI_CRC_LENGTH_27BIT    0x0000001A
#define SPI_CRC_LENGTH_28BIT    0x0000001B
#define SPI_CRC_LENGTH_29BIT    0x0000001C
#define SPI_CRC_LENGTH_30BIT    0x0000001D
#define SPI_CRC_LENGTH_31BIT    0x0000001E
#define SPI_CRC_LENGTH_32BIT    0x0000001F

/*
 *  SPI TI[hݒ`
 */
#define SPI_TIMODE_DISABLE      0x00000000
#define SPI_TIMODE_ENABLE       SPI_CFG2_SP_0

/*
 *  SPICݒ
 */
#define SPI_DIRECTION_2LINES                    0x00000000
#define SPI_DIRECTION_2LINES_TXONLY             SPI_CFG2_COMM_0
#define SPI_DIRECTION_2LINES_RXONLY             SPI_CFG2_COMM_1
#define SPI_DIRECTION_1LINE                     SPI_CFG2_COMM

/*
 *  SPI CRCݒ`
 */
#define SPI_CRC_DISABLE         0x00000000
#define SPI_CRC_ENABLE          SPI_CFG1_CRCEN

/*
 *  SPI FIFOXbhxl
 */
#define SPI_FIFO_THRESHOLD_01DATA               0x00000000
#define SPI_FIFO_THRESHOLD_02DATA               0x00000020
#define SPI_FIFO_THRESHOLD_03DATA               0x00000040
#define SPI_FIFO_THRESHOLD_04DATA               0x00000060
#define SPI_FIFO_THRESHOLD_05DATA               0x00000080
#define SPI_FIFO_THRESHOLD_06DATA               0x000000A0
#define SPI_FIFO_THRESHOLD_07DATA               0x000000C0
#define SPI_FIFO_THRESHOLD_08DATA               0x000000E0
#define SPI_FIFO_THRESHOLD_09DATA               0x00000100
#define SPI_FIFO_THRESHOLD_10DATA               0x00000120
#define SPI_FIFO_THRESHOLD_11DATA               0x00000140
#define SPI_FIFO_THRESHOLD_12DATA               0x00000160
#define SPI_FIFO_THRESHOLD_13DATA               0x00000180
#define SPI_FIFO_THRESHOLD_14DATA               0x000001A0
#define SPI_FIFO_THRESHOLD_15DATA               0x000001C0
#define SPI_FIFO_THRESHOLD_16DATA               0x000001E0

/*
 *  SPI CRCp^[ݒ
 */
#define SPI_CRC_INITIALIZATION_ALL_ZERO_PATTERN 0x00000000
#define SPI_CRC_INITIALIZATION_ALL_ONE_PATTERN  0x00000001

/*
 *  SPI}X^[ KEEP IO STATEݒ
 */
#define SPI_MASTER_KEEP_IO_STATE_DISABLE        0x00000000
#define SPI_MASTER_KEEP_IO_STATE_ENABLE         SPI_CFG2_AFCNTR

/*
 *  SPI IO SWAPݒ
 */
#define SPI_IO_SWAP_DISABLE     0x00000000
#define SPI_IO_SWAP_ENABLE      SPI_CFG2_IOSWP

/*
 *  SPI}X^[f[^AChNbNݒl
 */
#define SPI_MASTER_SS_IDLENESS_00CYCLE          0x00000000
#define SPI_MASTER_SS_IDLENESS_01CYCLE          0x00000001
#define SPI_MASTER_SS_IDLENESS_02CYCLE          0x00000002
#define SPI_MASTER_SS_IDLENESS_03CYCLE          0x00000003
#define SPI_MASTER_SS_IDLENESS_04CYCLE          0x00000004
#define SPI_MASTER_SS_IDLENESS_05CYCLE          0x00000005
#define SPI_MASTER_SS_IDLENESS_06CYCLE          0x00000006
#define SPI_MASTER_SS_IDLENESS_07CYCLE          0x00000007
#define SPI_MASTER_SS_IDLENESS_08CYCLE          0x00000008
#define SPI_MASTER_SS_IDLENESS_09CYCLE          0x00000009
#define SPI_MASTER_SS_IDLENESS_10CYCLE          0x0000000A
#define SPI_MASTER_SS_IDLENESS_11CYCLE          0x0000000B
#define SPI_MASTER_SS_IDLENESS_12CYCLE          0x0000000C
#define SPI_MASTER_SS_IDLENESS_13CYCLE          0x0000000D
#define SPI_MASTER_SS_IDLENESS_14CYCLE          0x0000000E
#define SPI_MASTER_SS_IDLENESS_15CYCLE          0x0000000F

/*
 *  SPI}X^[MAChNbNݒl
 */
#define SPI_MASTER_INTERDATA_IDLENESS_00CYCLE   0x00000000
#define SPI_MASTER_INTERDATA_IDLENESS_01CYCLE   0x00000010
#define SPI_MASTER_INTERDATA_IDLENESS_02CYCLE   0x00000020
#define SPI_MASTER_INTERDATA_IDLENESS_03CYCLE   0x00000030
#define SPI_MASTER_INTERDATA_IDLENESS_04CYCLE   0x00000040
#define SPI_MASTER_INTERDATA_IDLENESS_05CYCLE   0x00000050
#define SPI_MASTER_INTERDATA_IDLENESS_06CYCLE   0x00000060
#define SPI_MASTER_INTERDATA_IDLENESS_07CYCLE   0x00000070
#define SPI_MASTER_INTERDATA_IDLENESS_08CYCLE   0x00000080
#define SPI_MASTER_INTERDATA_IDLENESS_09CYCLE   0x00000090
#define SPI_MASTER_INTERDATA_IDLENESS_10CYCLE   0x000000A0
#define SPI_MASTER_INTERDATA_IDLENESS_11CYCLE   0x000000B0
#define SPI_MASTER_INTERDATA_IDLENESS_12CYCLE   0x000000C0
#define SPI_MASTER_INTERDATA_IDLENESS_13CYCLE   0x000000D0
#define SPI_MASTER_INTERDATA_IDLENESS_14CYCLE   0x000000E0
#define SPI_MASTER_INTERDATA_IDLENESS_15CYCLE   0x000000F0

/*
 *  SPI}X^[M AUTOSUSPENDݒ
 */
#define SPI_MASTER_RX_AUTOSUSP_DISABLE          0x00000000
#define SPI_MASTER_RX_AUTOSUSP_ENABLE           SPI_CR1_MASRX

/*
 *  SPI1NbN\[X`
 */
#define RCC_SPI1CLKSOURCE_PLL4      RCC_SPI2S1CKSELR_SPI1SRC_0
#define RCC_SPI1CLKSOURCE_PLL3_Q    RCC_SPI2S1CKSELR_SPI1SRC_1
#define RCC_SPI1CLKSOURCE_I2SCKIN   RCC_SPI2S1CKSELR_SPI1SRC_2
#define RCC_SPI1CLKSOURCE_PER       RCC_SPI2S1CKSELR_SPI1SRC_3
#define RCC_SPI1CLKSOURCE_PLL3_R    RCC_SPI2S1CKSELR_SPI1SRC_4

/*
 *  SPI2,3NbN\[X`
 */
#define RCC_SPI23CLKSOURCE_PLL4     RCC_SPI2S23CKSELR_SPI23SRC_0
#define RCC_SPI23CLKSOURCE_PLL3_Q   RCC_SPI2S23CKSELR_SPI23SRC_1
#define RCC_SPI23CLKSOURCE_I2SCKIN  RCC_SPI2S23CKSELR_SPI23SRC_2
#define RCC_SPI23CLKSOURCE_PER      RCC_SPI2S23CKSELR_SPI23SRC_3
#define RCC_SPI23CLKSOURCE_PLL3_R   RCC_SPI2S23CKSELR_SPI23SRC_4


/*
 *  SPIn[hEFAݒ\
 */

typedef struct _SPI_PortControlBlock{
	uint32_t              base;
	uint32_t              spiint;
	uint32_t              spiclocksrcbase;
	uint32_t              spiclocksrcmask;
	uint32_t              spiclocksrc;
	uint32_t              spiclockbase;
	uint32_t              spiclockbit;

	uint32_t              giobase1;
	uint32_t              giobase2;
	uint32_t              giobase3;
	uint8_t               sckpin;
	uint8_t               misopin;
	uint8_t               mosipin;
	uint8_t               apvalue;
	uint32_t              dmatxrequest;
	uint32_t              dmarxrequest;
} SPI_PortControlBlock;

/*
 *  SPI ݒ菉ݒ\
 */
typedef struct
{
	uint32_t              Mode;				/* SPI}X^[X[uݒ */
	uint32_t              Direction;		/* SPI] */
    uint32_t              DataSize;			/* SPI]f[^TCY */
	uint32_t              CLKPolarity;		/* SPI]NbN̋ɐ */
	uint32_t              CLKPhase;			/* SPINbNʑ */
	uint32_t              NSS;				/* SPI NSS */
	uint32_t              NSSPMode;			/* SPI NSS [hݒ:NSSL */
	uint32_t              NSSPolarity;		/* SPI NSS Polarityݒ:NSSL */
	uint32_t              Prescaler;		/* SPINbNݒ */
	uint32_t              SignBit;			/* SPI MSB/LSBݒ */
	uint32_t              TIMode;			/* SPI TI[h */
	uint32_t              CRC;				/* SPI CRCZݒ */
	uint32_t              CRCPolynomial;	/* SPI CRCݒ:CRCL */
	uint32_t              CRCLength;		/* SPI CRC:CRCL */
	uint32_t              TxCRCInitializationPattern;	/* SPI MCRCp^[ݒ:CRCL */
	uint32_t              RxCRCInitializationPattern;	/* SPI MCRCp^[ݒ:CRCL */
	uint32_t              MasterSSIdleness;	/* SPI }X^[ SS AChNbNݒ */
	uint32_t              MasterInterDataIdleness;	/* SPI }X^[f[^AChNbNݒ */
	uint32_t              MasterKeepIOState;	/* SPI }X^[ Keep IOԐݒ */
	uint32_t              IOSwap;			/* SPI IO swapݒ */
	int32_t               GpioClkPull;		/* SPI SCK GPIO pullup mode */
	int32_t               GpioDataPull;		/* SPI DATA GPIO pullup mode */
	int32_t               TxDMAStream;		/* SPI TxDMAXg[ */
	int32_t               RxDMAStream;		/* SPI RxDMAXg[ */
	int                   semid;			/* SPI ʐMpZ}tHl */
	int                   semlock;			/* SPI bNZ}tHl */
}SPI_Init_t;

/*
 *  SPInh
 */
typedef struct _SPI_Handle_t
{
	uint32_t              base;				/* SPI registers base address */
	SPI_Init_t            Init;				/* SPI communication parameters */
	uint8_t               *pTxBuffPtr;		/* Pointer to SPI Tx transfer Buffer */
	uint16_t              TxXferSize;		/* SPI Tx transfer size */
	uint16_t              TxXferCount;		/* SPI Tx Transfer Counter */
	uint8_t               *pRxBuffPtr;		/* Pointer to SPI Rx transfer Buffer */
	uint16_t              RxXferSize;		/* SPI Rx transfer size */
	uint16_t              RxXferCount;		/* SPI Rx Transfer Counter */
	DMA_Handle_t          *hdmatx;			/* SPI Tx DMA handle parameters */
	DMA_Handle_t          *hdmarx;			/* SPI Rx DMA handle parameters */
	void                  (*txxfercallback)(DMA_Handle_t *hdma);	/* DMA tx transfer complete callback */
	void                  (*rxxfercallback)(DMA_Handle_t *hdma);	/* DMA rx transfer complete callback */
	uint16_t              xmode;			/* SPI transfar mode */
	uint16_t              port;				/* SPI port ID */
	uint32_t              intno;			/* SPI interrupt # */
	volatile uint32_t     status;			/* SPI communication state */
	volatile uint32_t     ErrorCode;		/* SPI Error code */
}SPI_Handle_t;



extern SPI_Handle_t *spi_init(ID port, SPI_Init_t *spii);
extern ER spi_deinit(SPI_Handle_t *hspi);
extern ER spi_reset(SPI_Handle_t *hspi);
extern ER spi_dmacirclarmode(SPI_Handle_t *hspi, uint8_t no);
extern ER spi_transmit(SPI_Handle_t *hspi, uint8_t *pdata, uint16_t length);
extern ER spi_receive(SPI_Handle_t *hspi, uint8_t *pdata, uint16_t length);
extern ER spi_transrecv(SPI_Handle_t *hspi, uint8_t *ptxData, uint8_t *prxData, uint16_t length);
extern ER spi_wait(SPI_Handle_t *hspi, uint32_t timeout);
extern void spi_handler(SPI_Handle_t *hspi);
extern void spi_isr(intptr_t exinf);

#ifdef __cplusplus
}
#endif

#endif	/* _SPI_H_ */

