/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: device.h 698 2020-08-20 20:21:45Z roi $
 */
/*
 * STM32WBXXѥǥХɥ饤Фγ
 */

#ifndef _DEVICE_H_
#define _DEVICE_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  TOPPERS BASE PLATFORM
 */
#define TOPPERS_BASE_PLATFORM_STWB
#define SPI_DRIVER_NOSTART

/*
 *  С
 */
#define	TPLATFORM_PRVER 0x1042		/* ץåȥեΥСֹ */

/*
 *  ԥ
 */

#define PINPOSITION0    0
#define PINPOSITION1    1
#define PINPOSITION2    2
#define PINPOSITION3    3
#define PINPOSITION4    4
#define PINPOSITION5    5
#define PINPOSITION6    6
#define PINPOSITION7    7
#define PINPOSITION8    8
#define PINPOSITION9    9
#define PINPOSITION10   10
#define PINPOSITION11   11
#define PINPOSITION12   12
#define PINPOSITION13	13
#define PINPOSITION14	14
#define PINPOSITION15	15

#define GPIO_PIN_0      (1<<PINPOSITION0)
#define GPIO_PIN_1      (1<<PINPOSITION1)
#define GPIO_PIN_2      (1<<PINPOSITION2)
#define GPIO_PIN_3      (1<<PINPOSITION3)
#define GPIO_PIN_4      (1<<PINPOSITION4)
#define GPIO_PIN_5      (1<<PINPOSITION5)
#define GPIO_PIN_6      (1<<PINPOSITION6)
#define GPIO_PIN_7      (1<<PINPOSITION7)
#define GPIO_PIN_8      (1<<PINPOSITION8)
#define GPIO_PIN_9      (1<<PINPOSITION9)
#define GPIO_PIN_10     (1<<PINPOSITION10)
#define GPIO_PIN_11     (1<<PINPOSITION11)
#define GPIO_PIN_12     (1<<PINPOSITION12)
#define GPIO_PIN_13     (1<<PINPOSITION13)
#define GPIO_PIN_14     (1<<PINPOSITION14)
#define GPIO_PIN_15     (1<<PINPOSITION15)

/*
 *  GPIO⡼ɥѥ᡼
 */
#define GPIO_MODE_INPUT     0x00000000	/* Input Floating Mode */
#define GPIO_MODE_OUTPUT    0x00000001	/* Output Mode */
#define GPIO_MODE_AF        0x00000002	/* Alternate Function Mode */
#define GPIO_MODE_ANALOG    0x00000003	/* Analog Mode  */

/*
 *  GPIO-EXTI⡼ɥѥ᡼
 */
#define GPIO_MODE_IT_RISING             0x10110000	/* External Interrupt Mode with Rising edge trigger detection */
#define GPIO_MODE_IT_FALLING            0x10210000	/* External Interrupt Mode with Falling edge trigger detection */
#define GPIO_MODE_IT_RISING_FALLING     0x10310000	/* External Interrupt Mode with Rising/Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING            0x10120000	/* External Event Mode with Rising edge trigger detection */
#define GPIO_MODE_EVT_FALLING           0x10220000	/* External Event Mode with Falling edge trigger detection */
#define GPIO_MODE_EVT_RISING_FALLING    0x10320000	/* External Event Mode with Rising/Falling edge trigger detection */

/*
 *  GPIOȥץåѥ᡼
 */
#define GPIO_OTYPE_PP       0x0
#define GPIO_OTYPE_OD       0x1

/*
 *  GPIOȥץåȺȿѥ᡼
 */
#define GPIO_SPEED_LOW      0x00000000	/* Low speed     */
#define GPIO_SPEED_MEDIUM   0x00000001	/* Medium speed  */
#define GPIO_SPEED_FAST     0x00000002	/* Fast speed    */
#define GPIO_SPEED_HIGH     0x00000003	/* High speed    */

/*
 *  GPIOץ륢åץѥ᡼
 */
#define GPIO_NOPULL         0x00000000	/* No Pull-up or Pull-down activation  */
#define GPIO_PULLUP         0x00000001	/* Pull-up activation                  */
#define GPIO_PULLDOWN       0x00000002	/* Pull-down activation                */

/*
 *  GPIO
 */
typedef struct
{
    uint32_t    mode;		/* specifies the operating mode for the selected pins. */
	uint32_t    pull;		/* specifies the Pull-up or Pull-Down */
	uint32_t    otype;		/* output type */
	uint32_t    speed;		/* speed for the selected pins. */
	uint32_t    alternate;	/* alternate for the selected pins. */
}GPIO_Init_t;

typedef struct {
	uint32_t    base;
	uint32_t    pinmap;
} GPIO_Init_Table;


extern void gpio_setup(uint32_t base, GPIO_Init_t *init, uint32_t pin);

/*
 *  SYSCLOCK
 */
#define SYSCLOCK_MSI    (RCC_CFGR_SWS_MSI >> 2)
#define SYSCLOCK_HSI    (RCC_CFGR_SWS_HSI >> 2)
#define SYSCLOCK_HSE    (RCC_CFGR_SWS_HSE >> 2)
#define SYSCLOCK_PLL    (RCC_CFGR_SWS_PLL >> 2)

/*
 *  ƥ९å֤
 */
extern uint32_t get_sysclock(uint8_t *sws);


/*
 *  DMAͥID
 */
#define DMA1CH1_ID              (0)
#define DMA1CH2_ID              (1)
#define DMA1CH3_ID              (2)
#define DMA1CH4_ID              (3)
#define DMA1CH5_ID              (4)
#define DMA1CH6_ID              (5)
#define DMA1CH7_ID              (6)
#define DMA2CH1_ID              (7+0)
#define DMA2CH2_ID              (7+1)
#define DMA2CH3_ID              (7+2)
#define DMA2CH4_ID              (7+3)
#define DMA2CH5_ID              (7+4)
#define DMA2CH6_ID              (7+5)
#define DMA2CH7_ID              (7+6)

/*
 *  DMAơ
 */
#define DMA_STATUS_BUSY         0x00000001	/* BUSY */
#define DMA_STATUS_READY_HMEM0  0x00000002	/* DMA Mem0 Half process success */
#define DMA_STATUS_READY_HMEM1  0x00000004	/* DMA Mem1 Half process success */
#define DMA_STATUS_READY_MEM0   0x00000008	/* DMA Mem0 process success      */
#define DMA_STATUS_READY_ERROR  0x00000100	/* DMA Error end */

/*
 *  DMA顼
 */ 
#define DMA_ERROR_NONE          0x00000000	/* No error */
#define DMA_ERROR_TE            0x00000001	/* Transfer error */
#define DMA_ERROR_FE            0x00000002	/* FIFO error */
#define DMA_ERROR_DME           0x00000004	/* Direct Mode error */
#define DMA_ERROR_TIMEOUT       0x00000020	/* Timeout error */

/*
 *  DMAꥯ
 */
#define DMA_REQUEST_MEM2MEM     0	/* memory to memory transfer */
#define DMA_REQUEST_GENERATOR0  1	/* DMAMUX1 request generator 0 */
#define DMA_REQUEST_GENERATOR1  2	/* DMAMUX1 request generator 1 */
#define DMA_REQUEST_GENERATOR2	3	/* DMAMUX1 request generator 2 */
#define DMA_REQUEST_GENERATOR3  4	/* DMAMUX1 request generator 3 */

#define DMA_REQUEST_ADC1        5	/* DMAMUX1 ADC1 request */
#define DMA_REQUEST_SPI1_RX     6	/* DMAMUX SPI1 RX request */
#define DMA_REQUEST_SPI1_TX     7	/* DMAMUX SPI1 TX request */
#define DMA_REQUEST_SPI2_RX     8	/* DMAMUX SPI2 RX request */
#define DMA_REQUEST_SPI2_TX     9	/* DMAMUX SPI2 TX request */
#define DMA_REQUEST_I2C1_RX     10	/* DMAMUX I2C1 RX request */
#define DMA_REQUEST_I2C1_TX     11	/* DMAMUX I2C1 TX request */
#define DMA_REQUEST_I2C3_RX     12	/* DMAMUX I2C2 RX request */
#define DMA_REQUEST_I2C3_TX     13	/* DMAMUX I2C2 TX request */
#define DMA_REQUEST_USART1_RX   14	/* DMAMUX USART1 RX request */
#define DMA_REQUEST_USART1_TX   15	/* DMAMUX USART1 TX request */
#define DMA_REQUEST_LPUART1_RX  16	/* DMAMUX LPUART1 RX request */
#define DMA_REQUEST_LPUART1_TX  17	/* DMAMUX LPUART1 TX request */
#define DMA_REQUEST_SAI1_A      18	/* DMAMUX SAI1 A request */
#define DMA_REQUEST_SAI1_B      19	/* DMAMUX SAI1 B request */
#define DMA_REQUEST_QUADSPI     20	/* DMAMUX QUADSPI request */
#define DMA_REQUEST_TIM1_CH1    21	/* DMAMUX TIM1 CH1 request */
#define DMA_REQUEST_TIM1_CH2    22	/* DMAMUX TIM1 CH2 request */
#define DMA_REQUEST_TIM1_CH3    23	/* DMAMUX TIM1 CH3 request */
#define DMA_REQUEST_TIM1_CH4    24	/* DMAMUX TIM1 CH4 request */
#define DMA_REQUEST_TIM1_UP     25	/* DMAMUX TIM1 UP request */
#define DMA_REQUEST_TIM1_TRIG   26	/* DMAMUX TIM1 TRIG request */
#define DMA_REQUEST_TIM1_COM    27	/* DMAMUX TIM1 COM request */
#define DMA_REQUEST_TIM2_CH1    28	/* DMAMUX TIM2 CH1 request */
#define DMA_REQUEST_TIM2_CH2    29	/* DMAMUX TIM2 CH2 request */
#define DMA_REQUEST_TIM2_CH3    30	/* DMAMUX TIM2 CH3 request */
#define DMA_REQUEST_TIM2_CH4    31	/* DMAMUX TIM2 CH4 request */
#define DMA_REQUEST_TIM2_UP     32	/* DMAMUX TIM2 UP request */
#define DMA_REQUEST_TIM16_CH1   33	/* DMAMUX TIM16 CH1 request */
#define DMA_REQUEST_TIM16_UP    34	/* DMAMUX TIM16 UP request */
#define DMA_REQUEST_TIM17_CH1   35	/* DMAMUX TIM17 CH1 request */
#define DMA_REQUEST_TIM17_UP    36	/* DMAMUX TIM17 UP request */
#define DMA_REQUEST_AES1_IN     37	/* DMAMUX AES1 IN request */
#define DMA_REQUEST_AES1_OUT    38	/* DMAMUX AES1 OUT request */
#define DMA_REQUEST_AES2_IN     39	/* DMAMUX AES2 IN request */
#define DMA_REQUEST_AES2_OUT    40	/* DMAMUX AES2 OUT request */

/*
 *  쥬
 */
#define DMA_REQUEST_0           DMA_REQUEST_ADC1

/*
 *  DMAž
 */
#define DMA_PERIPH_TO_MEMORY    0x00000000		/* Peripheral to memory direction */
#define DMA_MEMORY_TO_PERIPH    DMA_CCR_DIR		/* Memory to peripheral direction */
#define DMA_MEMORY_TO_MEMORY    DMA_CCR_MEM2MEM	/* Memory to memory direction     */

/*
 *  DMAڥեå⡼
 */
#define DMA_PINC_ENABLE         DMA_CCR_PINC	/* Peripheral increment mode enable  */
#define DMA_PINC_DISABLE        0x00000000		/* Peripheral increment mode disable */

/*
 *  DMAå⡼
 */ 
#define DMA_MINC_ENABLE         DMA_CCR_MINC	/* Memory increment mode enable  */
#define DMA_MINC_DISABLE        0x00000000		/* Memory increment mode disable */

/*
 *  DMAڥե롦ǡ
 */
#define DMA_PDATAALIGN_BYTE     0x00000000		/* Peripheral data alignment: Byte     */
#define DMA_PDATAALIGN_HALFWORD DMA_CCR_PSIZE_0	/* Peripheral data alignment: HalfWord */
#define DMA_PDATAALIGN_WORD     DMA_CCR_PSIZE_1	/* Peripheral data alignment: Word     */

/*
 *  DMAꡦǡ
 */
#define DMA_MDATAALIGN_BYTE     0x00000000		/* Memory data alignment: Byte     */
#define DMA_MDATAALIGN_HALFWORD DMA_CCR_MSIZE_0	/* Memory data alignment: HalfWord */
#define DMA_MDATAALIGN_WORD     DMA_CCR_MSIZE_1	/* Memory data alignment: Word     */

/*
 *  DMA⡼
 */
#define DMA_NORMAL              0x00000000		/* Normal mode                  */
#define DMA_CIRCULAR            DMA_CCR_CIRC	/* Circular mode                */

/*
 *  DMAͥ٥٥
 */
#define DMA_PRIORITY_LOW        0x00000000		/* Priority level: Low       */
#define DMA_PRIORITY_MEDIUM     DMA_CCR_PL_0	/* Priority level: Medium    */
#define DMA_PRIORITY_HIGH       DMA_CCR_PL_1	/* Priority level: High      */
#define DMA_PRIORITY_VERY_HIGH  DMA_CCR_PL		/* Priority level: Very High */

/*
 *  DMA¤
 */
typedef struct
{
	uint32_t              Request;		/* Specifies the request selected for the specified channel. */
	uint32_t              Direction;	/* Specifies if the data will be transferred from memory to peripheral */
	uint32_t              PeriphInc;	/* Specifies whether the Peripheral address register should be incremented or not. */
	uint32_t              MemInc;		/* Specifies whether the memory address register should be incremented or not. */
	uint32_t              PeriphDataAlignment;	/* Specifies the Peripheral data width. */
	uint32_t              MemDataAlignment;		/* Specifies the Memory data width. */
	uint32_t              Mode;			/* Specifies the operation mode of the DMAy Streamx. */
	uint32_t              Priority;		/* Specifies the software priority for the DMAy Streamx. */
}DMA_Init_t;

/*
 *  DMAϥɥ鹽¤
 */
typedef struct __DMA_Handle_t DMA_Handle_t;
struct __DMA_Handle_t
{
	uint32_t              base;			/* DMA Port base address */
	uint32_t              cbase;		/* DMA Channel Port address */
	DMA_Init_t            Init;			/* DMA communication parameters */
	uint8_t               chid;			/* channel id */
	uint8_t               chid2;		/* channel id2 */
	uint8_t               chnum;		/* channel number */
	int8_t                genreqno;		/* request GEN number */
	volatile uint32_t     status;		/* DMA status */
	void                  (*xfercallback)(DMA_Handle_t * hdma);		/* DMA transfer complete callback */
	void                  (*xferhalfcallback)(DMA_Handle_t * hdma);	/* DMA Half transfer complete callback */
	void                  (*xferm1callback)(DMA_Handle_t * hdma);	/* DMA transfer complete Memory1 callback */
	void                  (*errorcallback)(DMA_Handle_t * hdma);	/* DMA transfer error callback */
	volatile uint32_t     ErrorCode;	/* DMA Error code */
	void                  *localdata;	/* DMA local data */
};

extern ER dma_init(DMA_Handle_t *hdma);
extern ER dma_deinit(DMA_Handle_t *hdma);
extern ER dma_start(DMA_Handle_t *hdma, uint32_t SrcAddress, uint32_t DstAddress, uint32_t DataLength);
extern ER dma_end(DMA_Handle_t *hdma);
extern uintptr_t dma_channel_base(int32_t chid);
extern void dma_inthandler(DMA_Handle_t *hdma);
extern void channel_dma_isr(intptr_t exinf);


/*
 *  WINDOW-WDOGɥ饤
 */
#define WDOG1_PORTID        1
#define NUM_WDOGPORT        1

/*
 *  WDOG PRESCALER
 */
#define WWDG_PRESCALER_1        0x00000000			/* WWDG counter clock = (PCLK1/4096)/1 */
#define WWDG_PRESCALER_2        WWDG_CFR_WDGTB0		/* WWDG counter clock = (PCLK1/4096)/2 */
#define WWDG_PRESCALER_4        WWDG_CFR_WDGTB1		/* WWDG counter clock = (PCLK1/4096)/4 */
#define WWDG_PRESCALER_8        (WWDG_CFR_WDGTB1 | WWDG_CFR_WDGTB0)	/* WWDG counter clock = (PCLK1/4096)/8 */
#define WWDG_PRESCALER_16       WWDG_CFR_WDGTB2		/* WWDG counter clock = (PCLK1/4096)/16 */
#define WWDG_PRESCALER_32       (WWDG_CFR_WDGTB2 | WWDG_CFR_WDGTB0)	/* WWDG counter clock = (PCLK1/4096)/32 */
#define WWDG_PRESCALER_64       (WWDG_CFR_WDGTB2 | WWDG_CFR_WDGTB1)	/* WWDG counter clock = (PCLK1/4096)/64 */
#define WWDG_PRESCALER_128      WWDG_CFR_WDGTB		/* WWDG counter clock = (PCLK1/4096)/128 */

typedef struct __WDOG_Init_t
{
	uint32_t              Window;			/* WDOG Window 0x40-0x7F */
	uint32_t              Counter;			/* WDOG 󥫥 0x40-0x7F 0x7F */
	uint32_t              Prescaler;		/* WDOG ץ쥹顼 */
	uint32_t              MCounter;			/* WDOG More Counter */
} WDOG_Init_t;

extern ER wdog_init(ID portid, WDOG_Init_t *hwini);
extern ER wdog_deinit(ID portid);
extern ER wdog_reset(ID portod);
extern void wdog_handler(void);


/*
 *  IPCCɥ饤
 */
#define NUM_IPCC_CH         6

#define IPCC_RX_CHANNEL     0
#define IPCC_TX_CHANNEL     1


#define INHNO_IPCCRX    IRQ_VECTOR_IPCC_C1_RX	/* ߥϥɥֹ */
#define INTNO_IPCCRX    IRQ_VECTOR_IPCC_C1_RX	/* ֹ */
#define INTPRI_IPCCRX   -7			/* ͥ */
#define INTATR_IPCCRX   TA_EDGE 	/* ° */

#define INHNO_IPCCTX    IRQ_VECTOR_IPCC_C1_TX	/* ߥϥɥֹ */
#define INTNO_IPCCTX    IRQ_VECTOR_IPCC_C1_TX	/* ֹ */
#define INTPRI_IPCCTX   -7			/* ͥ */
#define INTATR_IPCCTX   TA_EDGE 	/* ° */

/*
 *  IPCCϥɥ鹽¤
 */
typedef struct __IPCC_Handle_t IPCC_Handle_t;
struct __IPCC_Handle_t
{
	uint32_t              base;			/* IPCC Port base address */
	uint16_t              rstatus;
	uint8_t               cbmode;
	uint8_t               cbcid;
	void                  (*callback)(void);					/* IPCC special callback */
	void                  (*recvcallback[NUM_IPCC_CH])(void);	/* IPCC receive complete callback */
	void                  (*sendcallback[NUM_IPCC_CH])(void);	/* IPCC send complete callback */
};

extern void ipcc_init(IPCC_Handle_t *hipcc);
extern void ipcc_enable(void);
extern void ipcc_enable_channel(uint8_t mode, uint8_t cid, bool_t flag);
extern void ipcc_enable_channel2(uint8_t mode, uint8_t cid1, uint8_t cid2);
extern void ipcc_setflag_channel(uint8_t mode, uint8_t cld);
extern void ipcc_callback_channel(uint8_t mode, uint8_t cid, void(*cb)(void));
extern void ipcc_rx_handler(void);
extern void ipcc_tx_handler(void);


/*
 *  LPMɥ饤
 */
#define LPM_SLEEPMODE   0
#define LPM_STOPMODE0   1
#define LPM_STOPMODE1   2
#define LPM_STOPMODE2   3
#define LPM_STANDBYMODE 4
#define LPM_SHUTDOWN    5

extern void lpm_changemode(uint8_t config);


/*
 *  EUI64ΰ軲
 */
extern uint32_t get_eui64data(uint8_t off);


/*
 *  FLASHɥ饤
 */

/*
 *  FLASH WRPΰ
 */
#define OB_WRPAREA_BANK1_AREAA  0x00000000	/* Flash Area A */
#define OB_WRPAREA_BANK1_AREAB  0x00000001	/* Flash Area B */

/*
 *  FLASH-ERASE
  */
#define FLASH_TYPEERASE_PAGES   FLASH_CR_PER	/* ڡõ */
#define FLASH_TYPEERASE_MASS    FLASH_CR_MER	/* ޥ졼 */

/*
 *  FLASH񤭹ߥ
 */
#define FLASH_TYPEPROGRAM_DOUBLEWORD FLASH_CR_PG	/* Program a double-word (64-bit) at a specified address.*/
#define FLASH_TYPEPROGRAM_FAST  FLASH_CR_FSTPG		/* Fast program a 64 row double-word (64-bit) at a specified address.*/

/*
 *  FLASH 񤭹߶ػ߾¤
 */
typedef struct __FLASH_WRPAREA_t
{
	uint32_t WRPArea;		/* WRPȥꥢ */
	uint32_t WRPStartOffset;/* WRPȥեå */
	uint32_t WRPEndOffset;	/* WRPɥեå */
} FLASH_WRPAREA_t;

/*
 *  FLASH Erase¤
 */
typedef struct __FLASH_Erase_t
{
	uint32_t TypeErase;		/* ǡõ */
	uint32_t Page;			/* õƬڡ */
	uint32_t NbPages;		/* õڡ */
} FLASH_Erase_t;


extern ER flash_getwrparea(FLASH_WRPAREA_t *pwrp);
extern ER flash_unlock(void);
extern ER flash_lock(void);
extern ER flash_erase(FLASH_Erase_t *pErase, uint32_t *PageError);
extern ER flash_program(uint32_t type, uint32_t addr, uint64_t data);


/*
 *  LED³ӥå
 */
#define LED01           (1<<0)
#define LED02           (1<<1)
#define LED03           (1<<2)
#define LED04           (1<<3)

#define LED_MASK        (LED01 | LED02 | LED03 | LED04)

/*
 *  LEDȥåξ֥ޥ
 */
#define ON              1     /* LED䥹åON             */
#define OFF             0     /* LED䥹åOFF            */

/*
 *  DIPSW
 */
#define DSW1             0x01
#define DSW2             0x02
#define DSW3             0x04
#define DSW4             0x08

/*
 *  LED³ݡȽ
 */ 
extern void led_init(intptr_t exinf);

/*
 *  LED³ݡɤ߽Ф
 */
uint_t led_in(void);

/*
 *  LED³ݡȽ񤭹
 */ 
void led_out(unsigned int led_data);

/*
 *  LEDȥåθꡦɤ߹ߴؿ
 */
extern void set_led_state(unsigned int led, unsigned char state);

#define EXTI5_BASENO     5
#define EXTI5_MASK       0x000003E0
#define EXTI10_BASENO    10
#define EXTI10_MASK      0x0000FC00
#define NUM_EXTI_FUNC    16

#define INTPRI_SW1      -1			/* ͥ */
#define INTATR_SW1       0			/* ° */

#if BOARDNO == 1
#define INHNO_SW1  IRQ_VECTOR_EXTI15_10	/* ߥϥɥֹ */
#define INTNO_SW1  IRQ_VECTOR_EXTI15_10	/* ֹ */
#else
#define INHNO_SW1  IRQ_VECTOR_EXTI4	/* ߥϥɥֹ */
#define INTNO_SW1  IRQ_VECTOR_EXTI4	/* ֹ */
#endif
#define sw_handler       exti_handler

#define INHNO_SW2  IRQ_VECTOR_EXTI0	/* ߥϥɥֹ */
#define INTNO_SW2  IRQ_VECTOR_EXTI0	/* ֹ */
#define INHNO_SW3  IRQ_VECTOR_EXTI1	/* ߥϥɥֹ */
#define INTNO_SW3  IRQ_VECTOR_EXTI1	/* ֹ */

extern void (*exti_func[NUM_EXTI_FUNC])(void);

/*
 *  PSW³ӥå
 */
#define PSW1             0x00000001
#define PSW2             0x00000002
#define PSW3             0x00000004
#define PSW_MASK         (PSW1 | PSW2 | PSW3)
#define PSW_CHK_INTERVAL 10


/*
 *  PUSHå³ݡȽ
 */
extern void switch_push_init(intptr_t exinf);

/*
 *  PUSHåХåؿ
 */
extern void setup_sw_func(intptr_t exinf);

/*
 *  PUSHåФ
 */
extern uint32_t switch_push_sense(void);

/*
 *  EXTIߥϥɥ
 */
extern void exti_handler(void);

#define exti0_handler  exti_handler

/*
 *  DIPSWμФ
 */
uint_t switch_dip_sense(void);


extern void device_info_init(intptr_t exinf);

extern uint_t dipsw_value;

#ifdef __cplusplus
}
#endif

#endif

