/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2021 by TOPPERS PROJECT Educational Working Group.
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: pwm.h 699 2021-01-24 16:54:27Z roi $
 */
/*
 * 
 *  STM32WBXX PWMfoCXhCo̊O錾
 *
 */

#ifndef _PWM_H_
#define _PWM_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  TIM|[g`
 */
#define TIM1_PORTID             1
#define TIM2_PORTID             2
#define NUM_TIMPORT             2


/*
 *  TIM`lID`
 */
#define TIM_CHANNEL1_ID                    0				/* Capture/compare channel 1 identifier      */
#define TIM_CHANNEL2_ID                    1				/* Capture/compare channel 2 identifier      */
#define TIM_CHANNEL3_ID                    2				/* Capture/compare channel 3 identifier      */
#define TIM_CHANNEL4_ID                    3				/* Capture/compare channel 4 identifier      */
#define TIM_CHANNEL5_ID                    4				/* Compare channel 5 identifier              */
#define TIM_CHANNEL6_ID                    5				/* Compare channel 6 identifier              */
#define TIM_CHANNELID_ALL                  0x07				/* Global Capture/compare channel identifier  */
#define NUM_TIM_CHANNEL                    6

/*
 *  TIMJE^[[h`
 */
#define TIM_COUNTERMODE_UP                 0x00000000U		/* Counter used as up-counter */
#define TIM_COUNTERMODE_DOWN               TIM_CR1_DIR		/* Counter used as down-counter */
#define TIM_COUNTERMODE_CENTERALIGNED1     TIM_CR1_CMS_0	/* Center-aligned mode 1 */
#define TIM_COUNTERMODE_CENTERALIGNED2     TIM_CR1_CMS_1	/* Center-aligned mode 2 */
#define TIM_COUNTERMODE_CENTERALIGNED3     TIM_CR1_CMS		/* Center-aligned mode 3 */

/*
 *  TIMNbNfrW`
 */
#define TIM_CLOCKDIVISION_DIV1             0x00000000U		/* Clock division: tDTS=tCK_INT   */
#define TIM_CLOCKDIVISION_DIV2             TIM_CR1_CKD_0	/* Clock division: tDTS=2*tCK_INT */
#define TIM_CLOCKDIVISION_DIV4             TIM_CR1_CKD_1	/* Clock division: tDTS=4*tCK_INT */

/*
 *  TIMI[g[hEv[h`
 */
#define TIM_AUTORELOAD_PRELOAD_DISABLE     0x00000000U		/* TIMx_ARR register is not buffered */
#define TIM_AUTORELOAD_PRELOAD_ENABLE      TIM_CR1_ARPE		/* TIMx_ARR register is buffered */


/*
 *  TIM CHANNEL STATE VALUE
  */
#define TIM_CHANNEL_STATE_RESET            0x00U			/* TIM Channel initial state */
#define TIM_CHANNEL_STATE_READY            0x01U			/* TIM Channel ready for use */
#define TIM_CHANNEL_STATE_BUSY             0x02U			/* An internal process is ongoing on the TIM channel */


/*
 *  TIM Output Compare PWM[hݒ`
 */
#define TIM_OCMODE_TIMING                  0x00000000U			/* Frozen */
#define TIM_OCMODE_ACTIVE                  TIM_CCMR1_OC1M_0		/* Set channel to active level on match   */
#define TIM_OCMODE_INACTIVE                TIM_CCMR1_OC1M_1		/* Set channel to inactive level on match */
#define TIM_OCMODE_TOGGLE                  (TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1M_0)	/* Toggle */
#define TIM_OCMODE_PWM1                    (TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1)	/* PWM mode 1 */
#define TIM_OCMODE_PWM2                    (TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1M_0)	/* PWM mode 2 */
#define TIM_OCMODE_FORCED_ACTIVE           (TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_0)	/* Force active level */
#define TIM_OCMODE_FORCED_INACTIVE         TIM_CCMR1_OC1M_2		/* Force inactive level */
#define TIM_OCMODE_RETRIGERRABLE_OPM1      TIM_CCMR1_OC1M_3		/* Retrigerrable OPM mode 1 */
#define TIM_OCMODE_RETRIGERRABLE_OPM2      (TIM_CCMR1_OC1M_3 | TIM_CCMR1_OC1M_0)	/* Retrigerrable OPM mode 2 */
#define TIM_OCMODE_COMBINED_PWM1           (TIM_CCMR1_OC1M_3 | TIM_CCMR1_OC1M_2)	/* Combined PWM mode 1 */
#define TIM_OCMODE_COMBINED_PWM2           (TIM_CCMR1_OC1M_3 | TIM_CCMR1_OC1M_0 | TIM_CCMR1_OC1M_2)	/* Combined PWM mode 2 */
#define TIM_OCMODE_ASSYMETRIC_PWM1         (TIM_CCMR1_OC1M_3 | TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC1M_2)	/* Asymmetric PWM mode 1 */
#define TIM_OCMODE_ASSYMETRIC_PWM2     	   TIM_CCMR1_OC1M		/* Asymmetric PWM mode 2 */

/*
 *  TIM Output Compare Polarityݒ`
 */
#define TIM_OCPOLARITY_HIGH                0x00000000U                          /*!< Capture/Compare output polarity  */
#define TIM_OCPOLARITY_LOW                 TIM_CCER_CC1P                        /*!< Capture/Compare output polarity  */

/*
 *  TIM Output Compare Output Fast Stateݒ`
 */
#define TIM_OCFAST_DISABLE                 0x00000000U                          /*!< Output Compare fast disable */
#define TIM_OCFAST_ENABLE                  TIM_CCMR1_OC1FE                      /*!< Output Compare fast enable  */


/*
 *  TIMn[hEFAݒ\
 */

typedef struct _SPI_PortControlBlock{
	uint32_t              base;
	uint32_t              timclockbase;
	uint32_t              timclockbit;
} TIM_PortControlBlock;

/*
 *  ^C}[\̒`
 */
typedef struct
{
	uint32_t              Prescaler; 			/* TIM clock prescaler */
	uint32_t              CounterMode;			/* TIM counter mode */
	uint32_t              Period;				/* TIM Auto-Reload period value */
	uint32_t              ClockDivision;		/* TIM clock division */
	uint32_t              RepetitionCounter;	/* TIM repetition counter value */
	uint32_t              AutoReloadPreload;	/* TIM auto-reload preload value */
} TIM_Init_t;

/*
 *  PWM^C}[nh`
 */
typedef struct
{
	uint32_t              base;					/* TIM registers base address */
	TIM_Init_t            Init;					/* TIM Time Base required parameters */
	uint16_t              ActChannel;			/* TIM Active channel map */
	uint8_t               ChannelState[NUM_TIM_CHANNEL];	/* TIM channel operation state */
} TIM_Handle_t;

/*
 *  TIM Output Compareݒ\
 */
typedef struct
{
	uint32_t              OCMode;				/* TIM output pwm mode. */
	uint32_t              Pulse;				/* TIM pulse value to be loaded into the Capture Compare Register. */
	uint32_t              OCPolarity;			/* TIM Specifies the output polarity. */
	uint32_t              OCFastMode;			/* TIM Specifies the Fast mode state. */
} TIM_OC_Init_t;



extern ER pwm_init(ID port, TIM_Handle_t *htim);
#if 0
extern SPI_Handle_t *spi_init(ID port, SPI_Init_t *spii);
extern ER spi_deinit(SPI_Handle_t *hspi);
#endif
extern ER pwm_gpio_channel(TIM_Handle_t *htim, uint32_t Channel, uint32_t gbase, uint8_t pin);
extern ER pwm_start(TIM_Handle_t *htim, TIM_OC_Init_t *sConfig, uint32_t Channel);
extern ER pwm_stop(TIM_Handle_t *htim, uint32_t Channel);

#ifdef __cplusplus
}
#endif

#endif	/* _PWM_H_ */

