/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: wifiuart.h,v 1.0 2020/04/18 10:26:29 roi Exp $
 */
/*
 *  STM32F7XX WIFIǥХɥ饤Х󥯥롼ɥե
 */

#ifndef _WIFI_H_
#define _WIFI_H_

#ifdef __cplusplus
 extern "C" {
#endif

#include "wifiuart.h"

/*
 *  MACݡ
 */
#define WIFI1_PORTID            1
#define WIFIDEF_PORTID          WIFI1_PORTID
#define NUM_WIFI_PORT           1

/*
 *  ܡ졼
 */
#define WIFIUART_115200BPS      1
#define WIFIUART_460800BPS      0

/*
 *  MAC EVENT
 */
#define PHY_EVENT_DETECT        (1<<0)
#define SEND_EVENT_DETECT       (1<<1)
#define RECV_EVENT_DETECT       (1<<2)
#define START_EVENT_DETECT      (1<<6)
#define RESET_EVENT_DETECT      (1<<7)

/*
 *  ETHERNETɥ쥹Ĺ
 */
#define	ADLEN_ETHER	6
#define ETHER_HDR_SIZE	((ADLEN_ETHER*2)+2)

/*
 *  LINK
 */
#define LINK_SPEED_OF_YOUR_NETIF_IN_BPS  100000000

#define MODULE_READY            0
#define WIFI_START              1
#define WIFI_CONNECT            2
#define WIFI_DISCONNECT         3
#define WIFI_STOP               4

#define BLE_START               8
#define BLE_CONNECT             9
#define BLE_DISCONNECT          10
#define BLE_RECV                11

#define LINK_READY              (1<<15)
#define LINK_BLE_START          (1<<9)
#define LINK_BLE_CONNECT        (1<<8)
#define LINK_START              (1<<1)
#define LINK_CONNECT            (1<<0)

#define DESC_RX_ACTIVE          (1<<15)

#define EMAC_DATA_ATTRIBUTE     (section(".ethDataSection"))

typedef struct
{
	uint16_t              status;
	uint16_t              length;
}WIFI_Head_t;

/*
 *  EMACե奮졼¤
 */
typedef struct
{
	uint32_t              paketbufsize;		/* WIFI ѥåȥХåե */
	uint32_t              wbufcount;		/* WIFI Хåե */
	void                  *databuffer;		/* WIFI ǡΰƬɥ쥹 */
	const char            *ssid;			/* WIFI SSID */
	const char            *password;		/* WIFI PASSWORD */
	const char            *bledevice;		/* BLE DEVICE NAME */
    uint8_t               *blebuffer;		/* BLE Хåե */
	uint32_t              bps_select;		/* ܡ졼 */
	int_t                 rst_pin;			/* ꥻåȥԥֹ */
	int_t                 bps_pin;			/* ܡ졼ȥԥֹ */
	int_t                 rts_pin;			/* RTSԥֹ */
	int_t                 cts_pin;			/* CTSԥֹ */
	uint32_t              pull;				/* GPIO pull mode */
	uint32_t              otype;			/* GPIO output type */
}WIFI_Init_t;

/*
 *  EMACϥɥ
 */
typedef struct WIFI_Handle WIFI_Handle_t;
struct WIFI_Handle {
	WIFIUART_Handle_t *huart;
	WIFI_Init_t  Init;
	uint8_t      tx_wait;
	uint8_t      rx_top;
	uint8_t      rx_tail;
	uint8_t      rx_count;
	uint8_t      hwaddr[8];
	uint32_t     linkvalue;
	uint8_t      version[2];
	uint16_t     blecount;
	ID           macid;
	void         (*wifievent)(WIFI_Handle_t *hwifi, uint32_t);
	void         (*uartevent)(WIFI_Handle_t *hwifi, int);

	uint32_t     ifShortPkts;
	uint32_t     wifi_tx_count;
	uint32_t     wifi_rx_count;
	uint32_t     wifi_connect_count;
};

/*
 *  LWIPѥѥåȥХåե¤
 */
struct wifi_pkt {
	struct wifi_pkt *next;					/* next pbuf chain */
	void         *payload;					/* pointer to the data buffer */
	uint16_t     tot_len;					/* total length of this buffer and all next buffers in chain */
	uint16_t     len;						/* length of this buffer */
};


extern WIFI_Handle_t *wifi_init(ID portid, WIFI_Init_t *ini);
extern ER   wifi_deinit(WIFI_Handle_t *hwifi);
extern ER   wifi_send(WIFI_Handle_t *hwifi, struct wifi_pkt *pktp);
extern int  wifi_recv_length(WIFI_Handle_t *hwifi);
extern ER   wifi_recv(WIFI_Handle_t *hwifi, struct wifi_pkt *pktp);
extern uint32_t wifi_link_detect(WIFI_Handle_t *hwifi);
extern ER   wifi_reset(WIFI_Handle_t *hwifi);
extern WIFI_Handle_t *wifi_gethandler(ID portid);
extern ER wifi_ble_send(WIFI_Handle_t *hwifi, uint8_t *pdata, uint32_t length);
extern void wifi_dispatch(WIFI_Handle_t *hwifi);

#ifdef __cplusplus
}
#endif

#endif /* _WIFI_H_ */

