/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: wifiuart.h,v 1.0 2020/06/23 09:19:55 roi Exp $
 */
/*
 *  STM32WBXX WIFI-UARTɥ饤Х󥯥롼ɥե
 */

#ifndef _WIFIUART_H_
#define _WIFIUART_H_

#include "pinmode.h"
#include "target_serial.h"

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  WIFIUARTݡ
 */
#define WIFIUART1_PORTID        1
#define NUM_WIFIUARTPORT        1


#define INHNO_WIFIUART1  INHNO_SIO2	/* ߥϥɥֹ */
#define INTNO_WIFIUART1  INTNO_SIO2	/* ֹ */
#define INTPRI_WIFIUART1 INTPRI_SIO	/* ͥ */
#define INTATR_WIFIUART1 INTATR_SIO	/* ° */


#ifndef TOPPERS_MACRO_ONLY

/*
 *  WIFIUART 깽¤
 */
typedef struct
{
	uint32_t              bps;
	int32_t               rtspin;			/* UART RTS pin# */
	int32_t               ctspin;			/* UART CTS pin# */
	uint32_t              pull;
	uint32_t              otype;
}WIFIUART_Init_t;

/*
 *  QUEUEХåե
 */
typedef struct _queue_s {
	uint16_t    size;
	uint16_t    top;
	uint16_t    tail;
	uint16_t    limit;
	uint8_t     *buffer;
} queue_t;

/*
 *  ĥUARTϥɥ
 */
typedef struct wifiuart_struct WIFIUART_Handle_t;
struct wifiuart_struct {
	uintptr_t   base;
	const WIFIUART_Init_t Init;
	uint32_t    no;
	queue_t     *rque;
	queue_t     *tque;
	void        (*rxcallback)(WIFIUART_Handle_t * huart);	/* λХåؿ */
};

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ĥUARTؿΥץȥ
 */
#ifndef TOPPERS_MACRO_ONLY

extern WIFIUART_Handle_t *wifiuart_init(ID portid, WIFIUART_Init_t *ini);
extern ER   wifiuart_deinit(WIFIUART_Handle_t *uart);
extern int  wifiuart_recev(WIFIUART_Handle_t *uart, unsigned char *buf, int len);
extern int  wifiuart_send(WIFIUART_Handle_t *uart, unsigned char *buf, int len);
extern int  wifiuart_recsize(WIFIUART_Handle_t *uart);
extern bool_t wifiuart_cts_sens(WIFIUART_Handle_t *huart);
extern void wifiuart_isr(intptr_t exinf);
extern void wifipinMode(uint8_t no, uint32_t mode, uint32_t pull, uint32_t otype);


#endif /* TOPPERS_MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif	/* _WIFIUART_H_ */

