
#ifndef _HW_IF_H_
#define _HW_IF_H_

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

#define RCC_STOP_WAKEUPCLOCK_MSI        0x00000000U             /* MSI selection after wake-up from STOP */
#define RCC_STOP_WAKEUPCLOCK_HSI        RCC_CFGR_STOPWUCK       /* HSI selection after wake-up from STOP */

#define LL_RCC_STOP_WAKEUPCLOCK_HSI     RCC_STOP_WAKEUPCLOCK_HSI
#define LL_PWR_MODE_SHUTDOWN            PWR_CR1_LPMS_2
#define LL_PWR_MODE_STOP2               PWR_CR1_LPMS_1
#define LL_PWR_MODE_STANDBY             (PWR_CR1_LPMS_1 | PWR_CR1_LPMS_0)
#define LL_EXTI_LINE_48                 EXTI_IMR2_IM48

#define RCC_RFWKP_CLKSOURCE_LSE         RCC_CSR_RFWKPSEL_0	/* LSE oscillator clock used as RF Wakeup clock */
#define EXTI_LINE_IPCC                  EXTI_IMR2_IM36		/* Extended line 36 */
#define EXTI_LINE_HSEM                  EXTI_IMR2_IM38		/* Extended line 38 */

#define RTC_HandleTypeDef int


#define LL_PWR_IsActiveFlag_C2DS()          ((sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_EXTSCR)) & PWR_EXTSCR_C2DS) != 0)
#define LL_PWR_ClearFlag_WU()               sil_wrw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_SCR), PWR_SCR_CWUF)
#define LL_LPM_EnableDeepSleep()            dly_tsk(1)
#define LL_LPM_EnableSleep()                dly_tsk(1)
#define BSP_LED_Init(a)
#define BSP_PB_Init(a, b)
#define HAL_SuspendTick()
#define HAL_ResumeTick()

#define LL_RCC_SetClkAfterWakeFromStop(a)   sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_STOPWUCK, (a))
#define LL_C2_PWR_SetPowerMode(a)           sil_modw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_C2CR1), PWR_C2CR1_LPMS, (a))
#define LL_PWR_SetPowerMode(a)              sil_modw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_LPMS, (a))
#define LL_EXTI_EnableIT_32_63(a)           sil_orw_mem((uint32_t *)(TADR_EXTI_BASE+TOFF_EXTI_IMR2), (a))
#define HAL_PWREx_EnableVddUSB()            sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR2), PWR_CR2_USV)
#define HAL_DBGMCU_EnableDBGSleepMode()     sil_orw_mem((uint32_t *)(TADR_DBGMCU_BASE+TOFF_DBGMCU_CR), DBGMCU_CR_DBG_SLEEP)
#define HAL_DBGMCU_EnableDBGStopMode()      sil_orw_mem((uint32_t *)(TADR_DBGMCU_BASE+TOFF_DBGMCU_CR), DBGMCU_CR_DBG_STOP)
#define HAL_DBGMCU_DisableDBGSleepMode()    sil_andw_mem((uint32_t *)(TADR_DBGMCU_BASE+TOFF_DBGMCU_CR), DBGMCU_CR_DBG_SLEEP)
#define HAL_DBGMCU_DisableDBGStopMode()     sil_andw_mem((uint32_t *)(TADR_DBGMCU_BASE+TOFF_DBGMCU_CR), DBGMCU_CR_DBG_STOP)
#define HAL_DBGMCU_DisableDBGStandbyMode()  sil_andw_mem((uint32_t *)(TADR_DBGMCU_BASE+TOFF_DBGMCU_CR), DBGMCU_CR_DBG_STANDBY)

#define __WFI()

#endif	/* _HW_IF_H_ */

