/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2018 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tusbh_bluetooth.h 699 2018-07-05 18:00:40Z roi $
 */
/*
 *  USB Host Middleware BLUETOOTH
 */

#ifndef _HUSBH_BLUETOOTH_H_
#define _HUSBH_BLUETOOTH_H_

#include "tusbh_base.h"

#ifdef __cplusplus
 extern "C" {
#endif


#define BLUETOOTH_DATA_TYPE             (USB_HOST_TO_DEVICE | USB_REQUEST_TYPE_CLASS | USB_RECIPIENT_DEVICE)


#define HCI_COMMAND_DATA_PACKET         0x01
#define HCI_ACL_DATA_PACKET             0x02
#define HCI_SCO_DATA_PACKET             0x03
#define HCI_EVENT_PACKET                0x04

/*
 *  BLUETOOTH饹ξ
 */
#define BT_INTERRUPT_REQUEST            (1<<0)
#define BT_CTLWRITE_REQUEST             (1<<1)
#define BT_BLKREAD_REQUEST              (1<<2)
#define BT_BLKWRITE_REQUEST             (1<<3)

#define BT_INTERRUPT_ORDER              (1<<8)
#define BT_CTLWRITE_ORDER               (1<<9)
#define BT_BLKREAD_ORDER                (1<<10)
#define BT_BLKWRITE_ORDER               (1<<11)
#define BT_INTERRUPT_STOP               (1<<12)

#ifndef BT_MIN_POLL
#define BT_MIN_POLL                     20
#endif

#define BT_CONTROL_SIZE                 64

/*
 *  BLUETOOTHץξ
 */
enum
{
	BLUETOOTH_PROCESS_INIT = 0,
	BLUETOOTH_PROCESS_IDLE,
	BLUETOOTH_PROCESS_SEND,
	BLUETOOTH_PROCESS_RECEIVE,
	BLUETOOTH_PROCESS_ERROR
};

/*
 *  BLUTOOTHϥɥ
 */
typedef struct
{
	TUSBH_Device_t            *pDev;

	uint8_t                   state;
	uint8_t                   poll;
	uint16_t                  ifstate;

	uint8_t                   CommInPipe;
	uint8_t                   CommInEp;
	uint16_t                  CommInEpSize;
	uint8_t                   InPipe;
	uint8_t                   OutPipe;
	uint8_t                   OutEp;
	uint8_t                   InEp;
	uint16_t                  OutEpSize;
	uint16_t                  InEpSize;
	uint16_t                  CTrnSize;
	uint16_t                  BTrnSize;
	uint16_t                  BTrnLen;
	uint16_t                  BTrnCLen;
	uint16_t                  BRecvSize;
	uint16_t                  dummy;

	uint8_t                   CommInBuf[BT_CONTROL_SIZE];
	uint8_t                   *pBRecvBuff;
	uint8_t                   *pBTrnBuff;
	uint8_t                   *pCTrnBuff;
	uint32_t                  timer;
} BLUETOOTH_Handle_t;


void         tusbhLinkBLUETOOTH(TUSBH_Handle_t *phost);
bool_t       tusbhBluetoothTransfarReady(TUSBH_Handle_t *phost, uint8_t unit, uint8_t mode);
TUSBH_ERCODE tusbhBluetoothInterruptPollTiming(TUSBH_Handle_t *phost, uint8_t unit, uint32_t timing);
TUSBH_ERCODE tusbhBluetoothSend(TUSBH_Handle_t *phost, uint8_t unit, uint8_t mode, uint8_t *pbuf, uint16_t length);
TUSBH_ERCODE tusbhBluetoothReceiveBulk(TUSBH_Handle_t *phost, uint8_t unit, uint8_t *pbuf, uint16_t length);
void tusbhSetBluetoothCallBack(TUSBH_Handle_t *phost, void (*func)(TUSBH_Device_t *p, uint8_t, int16_t, uint8_t *));


#ifdef __cplusplus
}
#endif

#endif /* _HUSBH_BLUETOOTH_H_ */

