/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2017 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tusbh_rtos.c 698 2017-09-20 18:35:20Z roi $
 */
/*
 *  USB Middleware RTOS¸
 */

#include "tusb_rtos.h"
#include "kernel_cfg.h"


/*
 *  ֤ǤΥå
 */
ER
tusbSendData(ID qid, uint8_t evt, uint8_t prm1, uint8_t prm2, uint8_t prm3)
{
	intptr_t data;
	ER       ercd;

	data = (evt << 24) | (prm1 << 16) | (prm2 << 8) | prm3;
	ercd = psnd_dtq(qid, data);
	if(ercd != E_OK){
		syslog_5(LOG_ERROR, "tusbSendData send(%d) error [%02x][%02x][%02x][%02x]", qid, evt, prm1, prm2, prm3);
	}
	return ercd;
}

/*
 *  󥿥֤ǤΥå
 */
ER
tusbiSendData(ID qid, uint8_t evt, uint8_t prm1, uint8_t prm2, uint8_t prm3)
{
	intptr_t data;
	ER       ercd;

	data = (evt << 24) | (prm1 << 16) | (prm2 << 8) | prm3;
	ercd = ipsnd_dtq(qid, data);
	if(ercd != E_OK){
		syslog_5(LOG_ERROR, "tusbiSendData send(%d) error [%02x][%02x][%02x][%02x]", qid, evt, prm1, prm2, prm3);
	}
	return ercd;
}

/*
 *  ֤ǤΥå
 */
ER
tusbRecvData(ID qid, uint8_t *pmes, uint32_t timeout)
{
	intptr_t data;
	ER       ercd;

	if(timeout == 0)
		ercd = rcv_dtq(qid, &data);
	else
		ercd = trcv_dtq(qid, &data, timeout);
	if(ercd != E_OK){
		syslog_1(LOG_ERROR, "tusbRecvData(%d) error !", qid);
	}
	else{
		pmes[0] = (data >> 24) & 0xff;
		pmes[1] = (data >> 16) & 0xff;
		pmes[2] = (data >> 8) & 0xff;
		pmes[3] = data & 0xff;
	}
	return ercd;
}

/*
 *  IDФ
 */
int32_t
tusbGetTaskID(void)
{
	ER ercd;
	ID tid = 0;

	ercd = get_tid(&tid);
	if(ercd != E_OK){
		syslog_1(LOG_ERROR, "tusbhGetTaskID get fail(%d) !", ercd);
		return 0;
	}
	else
		return (int32_t)tid;
}

/*
 *  ư
 */
ER
tusbStartTask(ID taskid)
{
	ER ercd = act_tsk(taskid);

	if(ercd != E_OK)
		syslog_2(LOG_ERROR, "tusbStartTask actvate error id(%d) error(%d) !", taskid, ercd);
	return ercd;
}

/*
 *  ޡ
 */
ER
tusbTimerControl(uint8_t activate)
{
	ER ercd;

	if(activate == 0)
		ercd = stp_cyc(TUSBH_CYC_HDR);
	else
		ercd = sta_cyc(TUSBH_CYC_HDR);
	return ercd;
}

/*
 *  memsetؿ
 */
void
tusbmemset(void *d, const char val, int len)
{
	char *dd = d;
	int i;
	for(i = 0 ; i < len ; i++){
		*dd++ = val;
	}
}

/*
 *  memcpyؿ
 */
void
tusbmemcpy(void *d, void *s, int len)
{
	uint8_t *dd = d;
	uint8_t *ss = s;
	int i;
	for(i = 0 ; i < len ; i++){
		*dd++ = *ss++;
	}
}

